//*******************************************************************
//			    	IRISj^vO
//*******************************************************************
#include "IrisMon.h"


//----------------------------------------------------------------------
//     					C[`
//----------------------------------------------------------------------
extern void intr_main(void);

extern void RegisterRamReset32(u32 resetFlags);
extern void CpuSet32(const void *srcp, void *destp, u32 dmaCntData);
extern void CpuFastSet32(const void *srcp, void *destp, u32 dmaCntData);


void IrisMonMain()
{
	NotifySubpIntf(0);										// u[gEnhVFCN
	WaitSubpIntf(0);

#ifdef NDEBUG

	NotifySubpIntf(1);
	WaitSubpIntf(1);

#endif  // NDEBUG

	InitReg();												// WX^
	InitRam();												// 

#ifdef DISP_BIOS_VERSION
	if ((*(vu8 *)REG_KEYINPUT ^ 0xff) & (START_BUTTON|SELECT_BUTTON)) {
		DispTegCheck("      070", "");						// TEGpo[W`FbN\
		while(1)	;
	}
#endif

    *(vu16 *)REG_EXMEMCNT = CARD_ACCESS_SUBP				// 10-6ANZX
						  | CTRDG_ACCESS_SUBP  | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC
						  | MMEM_PRIORITY_SUBP | MMEM_INTF_SYNC | MMEM_CE2_OUT;
	*(vu32 *)REG_CARDCNT = CARD_RESET_HI;					// [UJ[hoX؂芷̈Ŝ

	NotifySubpIntf(2);										// ̒ʒm

#ifndef NDEBUG

	WaitSubpIntf(2);										// ARM7 ҂
	NotifySubpIntf(15);										// fobOʐM

#endif  // NDEBUG

	// ARM7ɂROMwb_ƎsC[W̃_E[h

	while (1) {
		u32 subpIntfData = RecvSubpIntf();

		if (subpIntfData == 3)			break;

#ifdef TEST_AGB_MODE

		else if (subpIntfData == 7)		Iris2Agb();			// AGB[hJ

#endif	// TEST_AGB_MODE

#ifdef DISP_AGB_HEADER_ERROR

		else if (subpIntfData == 8) {
			DispTegCheck("CARTRIDGE ERROR", " PUSH A BUTTON"); // AGBwb_G[ `FbN\
			while (!((*(vu8 *)REG_KEYINPUT ^ 0xff) & A_BUTTON))	;
			NotifySubpIntf(8);								// AGBwb_G[̉
			reset_cp15(C1_DTCM_ENABLE  | C1_EXCEPT_VEC_UPPER | C1_SB1_BITSET);
			Iris2Agb();										// AGB[hJ
		}

#endif	// DISP_AGB_HEADER_ERROR

#ifdef DISP_READY_CARD_4_IPL2

		else if (subpIntfData == 9) {
			DispTegCheck("     READY", "");
			reset_cp15(C1_DTCM_ENABLE  | C1_EXCEPT_VEC_UPPER | C1_SB1_BITSET);
			*(u8 *)REG_PAUSE = 2;							// JTAGCl[u
			WaitSubpIntf(3);
			break;
		}

#endif	// DISP_READY_CARD_4_IPL2

	}

    *(vu32 *)REG_IME = 0;									// IME NA
    *(vu32 *)REG_IE = 0;									// IE  NA
    *(vu32 *)REG_IF = -1;									// IF  NA

	WaitSubpIntf(3);
	NotifySubpIntf(3);

	// ʏ͂ŏI


#ifdef TEST_CARD_BY_MAINP
														// J[hoX؂芷
	WaitSubpIntf(5);

    *(vu16 *)REG_EXMEMCNT = CTRDG_ACCESS_MAINP				// MAINPJ[hANZX
						  | CTRDG_ACCESS_SUBP  | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC
						  | MMEM_PRIORITY_SUBP | MMEM_INTF_SYNC | MMEM_CE2_OUT;

	ReadCard4Game((void *)MROM_GAME_AREA, (void *)0x027ff400,// GAME[hǂݍ
   					MROM_PAGE_SIZE, 0xa1586000);

    *(vu16 *)REG_EXMEMCNT = CARD_ACCESS_SUBP				// SUBPJ[hANZX
						  | CTRDG_ACCESS_SUBP  | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC
						  | MMEM_PRIORITY_SUBP | MMEM_INTF_SYNC | MMEM_CE2_OUT;

	NotifySubpIntf(5);

	WaitSubpIntf(6);

    *(vu16 *)REG_EXMEMCNT = CTRDG_ACCESS_MAINP				// MAINPJ[hANZX
						  | CTRDG_ACCESS_SUBP  | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC
						  | MMEM_PRIORITY_SUBP | MMEM_INTF_SYNC | MMEM_CE2_OUT;

	ReadCard4Game((void *)(MROM_GAME_AREA+0x200), (void *)0x027ff600,// GAME[hǂݍ
   					MROM_PAGE_SIZE, 0xa1586000);
	ReadCardID4Game();										// IDǂݍ

    *(vu16 *)REG_EXMEMCNT = CARD_ACCESS_SUBP				// SUBPJ[hANZX
						  | CTRDG_ACCESS_SUBP  | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC
						  | MMEM_PRIORITY_SUBP | MMEM_INTF_SYNC | MMEM_CE2_OUT;

	NotifySubpIntf(6);

#endif	// TEST_CARD_BY_MAINP

}


//----------------------------------------------------------------------
//     					TuvZbTEC^tF[Xʒm
//----------------------------------------------------------------------

void NotifySubpIntf(u32 param)
{
	*(vu16 *)REG_SUBPINTF = param <<SUBP_SEND_STATUS_SHIFT;
}

//----------------------------------------------------------------------
//     					TuvZbTEC^tF[XM҂
//----------------------------------------------------------------------

void WaitSubpIntf(u32 param)
{
	while (RecvSubpIntf() != param)	;
}


