//======================================================================
//          IrisDefine.h
//            IRIS W萔
//
//          Copyright (C) 2002-2004 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_DEFINE_H
#define _IRIS_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>


//----------------------------------------------------------------------
//                      eŒ菬_ʒu
//----------------------------------------------------------------------

#define G_SFT                   12              // WIgGWiύXsj
#define GS_SFT                  6               //      VertexShortpi   V   j

// V_SFTASIN_SFTAACOS_SFT  12`14 ͈̔͂ŕύX\ 
//iAASIN_SFT >= V_SFTj

#define V_SFT                   12              // WxNg̕ϐ
#define M_SFT                   V_SFT           // s

#define N_SFT                   9               // @xNg  iύXsj
#define L_SFT                   9               // CgxNgi   V   j

#define T_SFT                   4               // eNX`WiύXsj
#define TEXMTX_SFT             (T_SFT + M_SFT)  // eNX`s

#define SIN_SFT                 12              // Sine[uiV_SFT ȏɐݒj
#define ACOS_SFT                15              // ArcCose[u


#define VG_SFT_DF              (V_SFT - G_SFT)  // xNg_ʒu | WIgGW_ʒu
#define MG_SFT_DF              (M_SFT - G_SFT)  // s񏬐_ʒu     | WIgGW_ʒu

#define GN_SFT_DF              (G_SFT - N_SFT)  // WIgGW_ʒu | @xNg_ʒu
#define GL_SFT_DF              (G_SFT - L_SFT)  // WIgGW_ʒu | CgxNg_ʒu

#define SIN_SFT_CT             (SIN_SFT_MAX  - SIN_SFT) // Sine[u_ʒu␳
#define ACOS_SFT_CT            (ACOS_SFT_MAX - ACOS_SFT)// ArcCose[u_ʒu␳


// ݒ͈̓G[o

#define V_SFT_MAX               14              // V_SFT őliύXsj
#define V_SFT_MIN               12              //       ŏli   V   j

#if   (V_SFT < V_SFT_MIN) || (V_SFT > V_SFT_MAX)
    #error V_SFT is out of range.
#endif

#define SIN_SFT_MAX             14              // SIN_SFT  őliύXsj
#define SIN_SFT_MIN             12              //          ŏli   V   j
#define ACOS_SFT_MAX            15              // ACOS_SFT őli   V   j
#define ACOS_SFT_MIN            12              //          ŏli   V   j

#if   (SIN_SFT < SIN_SFT_MIN)   || (SIN_SFT > SIN_SFT_MAX) || (SIN_SFT < V_SFT)
    #error SIN_SFT is out of range.
#endif

#if   (ACOS_SFT < ACOS_SFT_MIN) || (ACOS_SFT > ACOS_SFT_MAX)
    #error ACOS_SFT is out of range.
#endif


//  1

#define G_ONE                  (1<<G_SFT)
#define GS_ONE                 (1<<GS_SFT)
#define V_ONE                  (1<<V_SFT)
#define M_ONE                  (1<<M_SFT)

#define N_ONE                  (1<<N_SFT)
#define L_ONE                  (1<<L_SFT)

#define SIN_ONE                (1<<SIN_SFT)
#define ACOS_ONE               (1<<ACOS_SFT)

#define T_ONE                  (1<<T_SFT)
#define TEXMTX_ONE             (1<<TEXMTX_SFT)


// ő召

#define G_DECI_MAX             (G_ONE - 1)
#define GS_DECI_MAX            (GS_ONE - 1)
#define V_DECI_MAX             (V_ONE - 1)
#define M_DECI_MAX             (M_ONE - 1)

#define N_DECI_MAX             (N_ONE - 1)
#define L_DECI_MAX             (L_ONE - 1)

#define SIN_DECI_MAX           (SIN_ONE - 1)
#define ACOS_DECI_MAX          (ACOS_ONE - 1)

#define T_DECI_MAX             (T_ONE - 1)
#define TEXMTX_DECI_MAX        (TEXMTX_ONE - 1)


//----------------------------------------------------------------------
//                            萔
//----------------------------------------------------------------------

#define SYSTEM_CLOCK            33513982    // VXeNbN

#define MAINP                   0           // CvZbT
#define SUBP                    1           // TuvZbT


#define ON                      1
#define OFF                     0
#define ENABLE                  1
#define DISABLE                 0
#define TRUE                    1
#define FALSE                   0


#define LCD_WIDTH               256         // ʕ
#define LCD_HEIGHT              192         // ʍ


#define POLYGON_ID_MAX          63          // |Shcől


//----------------------------------------------------------------------
//                      J[f[^
//----------------------------------------------------------------------

#define RED5_MASK               0x001f      // 
#define GREEN5_MASK             0x03e0      // 
#define BLUE5_MASK              0x7c00      // 
#define ALPHA1_MASK             0x8000      // sx
#define ALPHA5_MASK             0x001f0000

#define RED5_SHIFT              0
#define GREEN5_SHIFT            5
#define BLUE5_SHIFT             10
#define ALPHA1_SHIFT            15
#define ALPHA5_SHIFT            16


#define RED8_MASK               0x000000ff  // 
#define GREEN8_MASK             0x0000ff00  // 
#define BLUE8_MASK              0x00ff0000  // 
#define ALPHA8_MASK             0xff000000  // sx

#define RED8_SHIFT              0
#define GREEN8_SHIFT            8
#define BLUE8_SHIFT             16
#define ALPHA8_SHIFT            24


//----------------------------------------------------------------------
//                      W
//----------------------------------------------------------------------

#define X16_MASK                0x0000ffff  // w
#define Y16_MASK                0xffff0000  // x
#define Z16_MASK                0x0000ffff  // y

#define X16_SHIFT               0
#define Y16_SHIFT               16
#define Z16_SHIFT               0


#define X10_MASK                0x000003ff  // w
#define Y10_MASK                0x000ffc00  // x
#define Z10_MASK                0x3ff00000  // y

#define X10_SHIFT               0
#define Y10_SHIFT               10
#define Z10_SHIFT               20

//----------------------------------------------------------------------
//                      eNX`W
//----------------------------------------------------------------------

#define TEX_S_MASK              0x0000ffff  // r
#define TEX_T_MASK              0xffff0000  // s

#define TEX_S_SHIFT             0
#define TEX_T_SHIFT             16


//----------------------------------------------------------------------
//                        AtBϊ
//----------------------------------------------------------------------

#define AFFINE_REG_SHIFT        8


//----------------------------------------------------------------------
//                    afXN[f[^
//----------------------------------------------------------------------

#define BG_SC_CHAR_NO_MASK      0x03ff      // LN^m
#define BG_SC_FLIP_MASK         0x0c00      // tbv
#define BG_SC_PLTT_MASK         0xf000      // J[pbgm

#define BG_SC_CHAR_NO_SHIFT     0
#define BG_SC_FLIP_SHIFT        10
#define BG_SC_PLTT_SHIFT        12

#define BG_SC_H_FLIP            0x0400      // gtbv
#define BG_SC_V_FLIP            0x0800      // utbv


//----------------------------------------------------------------------
//                        n`lf[^
//----------------------------------------------------------------------

#define OAM_V_POS_MASK          0x000000ff  // nai xW
#define OAM_H_POS_MASK          0x01ff0000  // nai wW
#define OAM_SHAPE_MASK          0x0000c000  // nai`
#define OAM_SIZE_MASK           0xc0000000  // naiTCY
#define OAM_OBJ_MODE_MASK       0x00000c00  // nai[h
#define OAM_AFFINE_MODE_MASK    0x00000300  // AtB[h
#define OAM_AFFINE_NO_MASK      0x3e000000  // AtB p[^m
#define OAM_FLIP_MASK           0x30000000  // tbv
#define OAM_CHAR_NO_MASK        0x000003ff  // LN^m
#define OAM_PRIORITY_MASK       0x00000c00  // afΗD揇
#define OAM_PLTT_MASK           0x0000f000  // J[pbgm
#define OAM_ALPHA_MASK          0x0000f000  // naiAt@l
#define OAM_AFFINE_PARAM_MASK   0xffff0000  // AtB p[^

#define OAM_V_POS_SHIFT         0
#define OAM_H_POS_SHIFT         16
#define OAM_SHAPE_SHIFT         14
#define OAM_SIZE_SHIFT          30
#define OAM_AFFINE_MODE_SHIFT   8
#define OAM_OBJ_MODE_SHIFT      10
#define OAM_AFFINE_NO_SHIFT     25
#define OAM_FLIP_SHIFT          28
#define OAM_CHAR_NO_SHIFT       0
#define OAM_PRIORITY_SHIFT      10
#define OAM_PLTT_SHIFT          12
#define OAM_ALPHA_SHIFT         12
#define OAM_AFFINE_PARAM_SHIFT  16

#define OAM_OBJ_ON              0x00000000  // nai nm
#define OAM_OBJ_OFF             0x00000200  // nai nee
#define OAM_OBJ_NORMAL          0x00000000  // naim[}[h
#define OAM_OBJ_BLEND           0x00000400  // nai[h
#define OAM_OBJ_WINDOW          0x00000800  // naiEChE[h
#define OAM_OBJ_BMP             0x00000c00  // nairbg}bv[h
#define OAM_AFFINE_NONE         0x00000000  // AtB[h
#define OAM_AFFINE_NORMAL       0x00000100  // AtBm[}[h
#define OAM_AFFINE_TWICE        0x00000300  // AtBQ{p[h
#define OAM_AFFINE_ERASE        0x00000200  // AtB\[h
#define OAM_MOS_ON              0x00001000  // UCN nm
#define OAM_MOS_OFF             0x00000000  // UCN nee
#define OAM_COLOR_16            0x00000000  // PU     I
#define OAM_COLOR_256           0x00002000  // QTUF I
#define OAM_H_FLIP              0x10000000  // gtbv
#define OAM_V_FLIP              0x20000000  // utbv
#define OAM_SQUARE              0x00000000  // `nai
#define OAM_H_RECTANGLE         0x00004000  // `nai
#define OAM_V_RECTANGLE         0x00008000  // c`nai
#define OAM_SIZE_NO_0           0x00000000  // nai TCYm O
#define OAM_SIZE_NO_1           0x40000000  // nai TCYm P
#define OAM_SIZE_NO_2           0x80000000  // nai TCYm Q
#define OAM_SIZE_NO_3           0xc0000000  // nai TCYm R
#define OAM_SIZE_8x8            0x00000000  // nai   W  Whbg
#define OAM_SIZE_16x16          0x40000000  // nai PUPUhbg
#define OAM_SIZE_32x32          0x80000000  // nai RQRQhbg
#define OAM_SIZE_64x64          0xc0000000  // nai USUShbg
#define OAM_SIZE_16x8           0x00004000  // nai PU  Whbg
#define OAM_SIZE_32x8           0x40004000  // nai RQ  Whbg
#define OAM_SIZE_32x16          0x80004000  // nai RQPUhbg
#define OAM_SIZE_64x32          0xc0004000  // nai USRQhbg
#define OAM_SIZE_8x16           0x00008000  // nai   WPUhbg
#define OAM_SIZE_8x32           0x40008000  // nai   WRQhbg
#define OAM_SIZE_16x32          0x80008000  // nai PURQhbg
#define OAM_SIZE_32x64          0xc0008000  // nai RQUShbg

// \̃op萔

#define ST_OAM_OBJ_NORMAL       0           // naim[}[h
#define ST_OAM_OBJ_BLEND        1           // nai[h
#define ST_OAM_OBJ_WINDOW       2           // naiEChE[h
#define ST_OAM_AFFINE_NONE      0           // AtB[h
#define ST_OAM_AFFINE_NORMAL    1           // AtBm[}[h
#define ST_OAM_AFFINE_TWICE     3           // AtBQ{p[h
#define ST_OAM_AFFINE_ERASE     2           // AtB\[h
#define ST_OAM_COLOR_16         0           // PU     I
#define ST_OAM_COLOR_256        1           // QTUF I
#define ST_OAM_SQUARE           0           // `nai
#define ST_OAM_H_RECTANGLE      1           // `nai
#define ST_OAM_V_RECTANGLE      2           // c`nai



//**********************************************************************
//              hqhrWX^ERg[rbg
//**********************************************************************

//----------------------------------------------------------------------
//                  vOXe[^XWX^
//----------------------------------------------------------------------

#define PSR_CPU_MODE_MASK       0x1f        // bot[h

#define PSR_USER_MODE           0x10        // [U
#define PSR_FIQ_MODE            0x11        // ehp
#define PSR_IRQ_MODE            0x12        // hqp
#define PSR_SVC_MODE            0x13        // X[poCU
#define PSR_ABORT_MODE          0x17        // A{[givtFb`^f[^j
#define PSR_UNDEF_MODE          0x1b        // `
#define PSR_SYS_MODE            0x1f        // VXe

#define PSR_THUMB_STATE         0x20        // sgtlaXe[g
#define PSR_FIQ_DISABLE         0x40        // ehps
#define PSR_IRQ_DISABLE         0x80        // hqps
#define PSR_IRQ_FIQ_DISABLE     0xc0        // hqpehps

#define PSR_Q_FLAG              0x08000000  // XeBbL[I[o[t[
#define PSR_V_FLAG              0x10000000  // I[o[t[
#define PSR_C_FLAG              0x20000000  // L[^{[^g
#define PSR_Z_FLAG              0x40000000  // [
#define PSR_N_FLAG              0x80000000  // ^

// \̃op萔

#define ST_PSR_USER_MODE        0x10        // [U
#define ST_PSR_FIQ_MODE         0x11        // ehp
#define ST_PSR_IRQ_MODE         0x12        // hqp
#define ST_PSR_SVC_MODE         0x13        // X[poCU
#define ST_PSR_ABORT_MODE       0x17        // A{[givtFb`^f[^j
#define ST_PSR_UNDEF_MODE       0x1b        // `
#define ST_PSR_SYS_MODE         0x1f        // VXe


//----------------------------------------------------------------------
//                  VXeRg[RvZbT
//----------------------------------------------------------------------

// WX^Pi}X^Rg[j

#define C1_SB1_BITSET           0x00000078  // WX^PpPŒrbg

#define C1_ITCM_LOAD_MODE       0x00080000  //   ߂sbl [h[h
#define C1_DTCM_LOAD_MODE       0x00020000  // f[^sbl [h[h
#define C1_ITCM_ENABLE          0x00040000  //   ߂sbl Cl[u
#define C1_DTCM_ENABLE          0x00010000  // f[^sbl Cl[u
#define C1_LD_INTERWORK_DISABLE 0x00008000  // [h߂ɂC^[[LO fBZ[u
#define C1_CACHE_ROUND_ROBIN    0x00004000  // LbVuASY Ehriň̃qbgj
#define C1_CACHE_PSEUDO_RANDOM  0x00000000  //                            [_
#define C1_EXCEPT_VEC_UPPER     0x00002000  // OxN^ ʃAhXiɐݒ肵ĉj
#define C1_EXCEPT_VEC_LOWER     0x00000000  //            ʃAhX
#define C1_ICACHE_ENABLE        0x00001000  //   ߃LbV Cl[u
#define C1_DCACHE_ENABLE        0x00000004  // f[^LbV Cl[u
#define C1_LITTLE_ENDIAN        0x00000000  // gGfBA
#define C1_BIG_ENDIAN           0x00000080  // rbOGfBA
#define C1_PROTECT_UNIT_ENABLE  0x00000001  // veNVjbg Cl[u


// WX^QiveNV[WELbVݒj

#define C2_PR0_SFT              0           // veNV[WO
#define C2_PR1_SFT              1           //                         P
#define C2_PR2_SFT              2           //                         Q
#define C2_PR3_SFT              3           //                         R
#define C2_PR4_SFT              4           //                         S
#define C2_PR5_SFT              5           //                         T
#define C2_PR6_SFT              6           //                         U
#define C2_PR7_SFT              7           //                         V


// WX^RiveNV[WECgobt@ݒj

#define C3_PR0_SFT              0           // veNV[WO
#define C3_PR1_SFT              1           //                         P
#define C3_PR2_SFT              2           //                         Q
#define C3_PR3_SFT              3           //                         R
#define C3_PR4_SFT              4           //                         S
#define C3_PR5_SFT              5           //                         T
#define C3_PR6_SFT              6           //                         U
#define C3_PR7_SFT              7           //                         V


// WX^TiveNV[WEANZXj

#define C5_PERMIT_MASK          0xf         // veNV[W ANZX}XN

#define C5_PERMIT_NA            0           //                          ANZXs
#define C5_PERMIT_RW            1           //                          [hCg
#define C5_PERMIT_RO            5           //                          [hI[

#define C5_PR0_SFT              0           // veNV[WO
#define C5_PR1_SFT              4           //                         P
#define C5_PR2_SFT              8           //                         Q
#define C5_PR3_SFT              12          //                         R
#define C5_PR4_SFT              16          //                         S
#define C5_PR5_SFT              20          //                         T
#define C5_PR6_SFT              24          //                         U
#define C5_PR7_SFT              28          //                         V


// WX^UiveNV[WEx[XAhX^TCYj

#define C6_PR_SIZE_MASK         0x0000003e  // veNV[W TCY
#define C6_PR_BASE_MASK         0xfffff000  //                          x[XAhX

#define C6_PR_SIZE_SHIFT        1
#define C6_PR_BASE_SHIFT        12

#define C6_PR_ENABLE            1           // veNV[W Cl[u
#define C6_PR_DISABLE           0           //                          fBZ[u

#define C6_PR_4KB               0x16        // [WTCY Sja
#define C6_PR_8KB               0x18        //                  Wja
#define C6_PR_16KB              0x1a        //                PUja
#define C6_PR_32KB              0x1c        //                RQja
#define C6_PR_64KB              0x1e        //                USja
#define C6_PR_128KB             0x20        //              PQWja
#define C6_PR_256KB             0x22        //              QTUja
#define C6_PR_512KB             0x24        //              TPQja
#define C6_PR_1MB               0x26        //                  Pla
#define C6_PR_2MB               0x28        //                  Qla
#define C6_PR_4MB               0x2a        //                  Sla
#define C6_PR_8MB               0x2c        //                  Wla
#define C6_PR_16MB              0x2e        //                PUla
#define C6_PR_32MB              0x30        //                RQla
#define C6_PR_64MB              0x32        //                USla
#define C6_PR_128MB             0x34        //              PQWla
#define C6_PR_256MB             0x36        //              QTUla
#define C6_PR_512MB             0x38        //              TPQla
#define C6_PR_1GB               0x3a        //                  Pfa
#define C6_PR_2GB               0x3c        //                  Qfa
#define C6_PR_4GB               0x3e        //                  Sfa


// WX^V.PRi߃LbVEvtFb`j

#define C7_ICACHE_PREFCHP_MASK  0xffffffe0  //   ߃LbV vtFb`AhX


// WX^V.POAV.PSiLbVCfbNXj

#define C7_ICACHE_INDEX_MASK    0x00000fe0  //   ߃LbV CfbNX
#define C7_DCACHE_INDEX_MASK    0x000003e0  // f[^LbV CfbNX
#define C7_CACHE_SET_NO_MASK    0xc0000000  //       LbV Zbgm

#define C7_CACHE_INDEX_SHIFT    5
#define C7_CACHE_SET_NO_SHIFT   30


// WX^X.OiLbVbN_Ej

#define C9_LOCKDOWN_SET_NO_MASK 0x00000003  // LbVbN_E Zbgm

#define C9_LOCKDOWN_SET_NO_SHIFT 0

#define C9_LOCKDOWN_LOAD_MODE   0x80000000  // LbVbN_E [h[h


// WX^X.Pisblx[XAhX^TCYj

#define C9_TCMR_SIZE_MASK       0x0000003e  // sbl[W TCY
#define C9_TCMR_BASE_MASK       0xfffff000  //                  x[XAhX

#define C9_TCMR_SIZE_SHIFT      1
#define C9_TCMR_BASE_SHIFT      12

#define C9_TCMR_4KB             0x06        // [WTCY Sja
#define C9_TCMR_8KB             0x08        //                  Wja
#define C9_TCMR_16KB            0x0a        //                PUja
#define C9_TCMR_32KB            0x0c        //                RQja
#define C9_TCMR_64KB            0x0e        //                USja
#define C9_TCMR_128KB           0x10        //              PQWja
#define C9_TCMR_256KB           0x12        //              QTUja
#define C9_TCMR_512KB           0x14        //              TPQja
#define C9_TCMR_1MB             0x16        //                  Pla
#define C9_TCMR_2MB             0x18        //                  Qla
#define C9_TCMR_4MB             0x1a        //                  Sla
#define C9_TCMR_8MB             0x1c        //                  Wla
#define C9_TCMR_16MB            0x1e        //                PUla
#define C9_TCMR_32MB            0x20        //                RQla
#define C9_TCMR_64MB            0x22        //                USla
#define C9_TCMR_128MB           0x24        //              PQWla
#define C9_TCMR_256MB           0x26        //              QTUla
#define C9_TCMR_512MB           0x28        //              TPQla
#define C9_TCMR_1GB             0x2a        //                  Pfa
#define C9_TCMR_2GB             0x2c        //                  Qfa
#define C9_TCMR_4GB             0x2e        //                  Sfa



//----------------------------------------------------------------------
//                  荞ݗv^tO
//----------------------------------------------------------------------

#define V_BLANK_INTR_FLAG       0x00000001  // uuN荞
#define H_BLANK_INTR_FLAG       0x00000002  // guN荞
#define V_COUNT_INTR_FLAG       0x00000004  // uJE^v荞
#define TIMER0_INTR_FLAG        0x00000008  // ^C}[O荞
#define TIMER1_INTR_FLAG        0x00000010  // ^C}[P荞
#define TIMER2_INTR_FLAG        0x00000020  // ^C}[Q荞
#define TIMER3_INTR_FLAG        0x00000040  // ^C}[R荞
#define SIO_INTR_FLAG           0x00000080  // VAʐM荞
#define DMA0_INTR_FLAG          0x00000100  // cl`O荞
#define DMA1_INTR_FLAG          0x00000200  // cl`P荞
#define DMA2_INTR_FLAG          0x00000400  // cl`Q荞
#define DMA3_INTR_FLAG          0x00000800  // cl`R荞
#define KEY_INTR_FLAG           0x00001000  // L[荞
#define CARTRIDGE_INTR_FLAG     0x00002000  // J[gbW荞

#define SUBP_INTR_FLAG          0x00010000  // TuvZbT荞
#define SPFIFO_SEND_INTR_FLAG   0x00020000  // TuvZbTԑMehenGveB荞
#define SPFIFO_RECV_INTR_FLAG   0x00040000  // TuvZbTԎMehenmbgGveB荞
#define CARD_DATA_INTR_FLAG     0x00080000  // J[hf[^]I荞
#define CARD_IREQ_INTR_FLAG     0x00100000  // J[hhqdp荞
#define GXFIFO_INTR_FLAG        0x00200000  // WIgR}hehen荞


//----------------------------------------------------------------------
//                  TuvZbT C^tF[X
//----------------------------------------------------------------------

#define SUBP_RECV_STATUS_MASK   0x000f      // MXe[^X
#define SUBP_SEND_STATUS_MASK   0x0f00      // MXe[^X

#define SUBP_RECV_STATUS_SHIFT  0
#define SUBP_SEND_STATUS_SHIFT  8

#define SUBP_SEND_IF            0x2000      // 荞ݗvM
#define SUBP_RECV_IF_ENABLE     0x4000      // 荞ݗvM 
#define SUBP_ENABLE             0x8000      // TuvZbT Cl[ui폜\j

//----------------------------------------------------------------------
//                  TuvZbTʐMehen Rg[
//----------------------------------------------------------------------

#define SPFIFO_SEND_EMPTY       0x0001      // Mehen GveB
#define SPFIFO_SEND_FULL        0x0002      //              t
#define SPFIFO_SEND_IF_ENABLE   0x0004      //              荞ݗv 
#define SPFIFO_SEND_CLEAR       0x0008      //              NA
#define SPFIFO_RECV_EMPTY       0x0100      // Mehen GveB
#define SPFIFO_RECV_FULL        0x0200      //              t
#define SPFIFO_RECV_IF_ENABLE   0x0400      //              荞ݗv 
#define SPFIFO_ENABLE           0x8000      // ehenCl[u



//----------------------------------------------------------------------
//                      p[Rg[
//----------------------------------------------------------------------

#define POW_LCDC_ON             0x0001      // kbcRg[ nm
#ifdef IRIS_TS
#define POW_2D_ON               0x0202      // QcGW`a nm
#define POW_2D_A_ON             0x0002      // QcGW` nm
#define POW_2D_B_ON             0x0200      // QcGWa nm
#define POW_EXCHANGE_LCD        0x8000      // \ť
#else
#define POW_2D_ON               0x0002      // QcGW nm
#endif
#define POW_RENDER_ON           0x0004      // _OGW nm
#define POW_GEOMETRY_ON         0x0008      // WIgGW nm
#define POW_ALL_ON              0x000f      // S nm


//----------------------------------------------------------------------
//                      Z
//----------------------------------------------------------------------

#define DIV_MODE_MASK           0x0003      // Z[h

#define DIV_MODE_SHIFT          0

#define DIV_32_32BIT_MODE       0x0000      // RQ^RQ [h
#define DIV_64_32BIT_MODE       0x0001      // US^RQ [h
#define DIV_64_64BIT_MODE       0x0002      // US^US [h
#define DIV_ERROR               0x4000      // OG[
#define DIV_BUSY                0x8000      // rW[

//----------------------------------------------------------------------
//                      
//----------------------------------------------------------------------

#define SQRT_32BIT_MODE         0x0000      // RQ [h
#define SQRT_64BIT_MODE         0x0001      // US [h
#define SQRT_BUSY               0x8000      // rW[



//----------------------------------------------------------------------
//                      uq`l[Nq`l Rg[
//----------------------------------------------------------------------

#define VRAM_MODE_MASK          0x07        // uq`l[h
#define VRAM_OFFSET_MASK        0x18        //         ItZbg

#define VRAM_MODE_SHIFT         0
#define VRAM_OFFSET_SHIFT       3

#define VRAM_LCDC_MODE          0x00        //           kbcb [h
#define VRAM_BG_MODE            0x01        //               af [h
#define VRAM_OBJ_MODE           0x02        //             nai [hi`CaCd`f̂݉j
#define VRAM_SUBP_MODE          0x02        //     TuvZbT [hibCĉ݉j
#define VRAM_TEX_MODE           0x03        //         eNX` [hi``ĉ݉j
#define VRAM_TEXPLTT_MODE       0x03        // eNX`pbg [hid`f̂݉j
#define VRAM_BGPLTT_MODE        0x04        //       afpbg [hid`f̂݉j
#define VRAM_OBJPLTT_MODE       0x05        //     naipbg [hieCf̂݉j

#define VRAM_TEX_SLOT_0         0x00        //         eNX` XbgO
#define VRAM_TEX_SLOT_1         0x08        //                            P
#define VRAM_TEX_SLOT_2         0x10        //                            Q
#define VRAM_TEX_SLOT_3         0x18        //                            R
#define VRAM_TEXPLTT_SLOT_0_3   0x00        // eNX`pbg XbgO|R
#define VRAM_TEXPLTT_SLOT_0     0x00        //                            O
#define VRAM_TEXPLTT_SLOT_1     0x08        //                            P
#define VRAM_TEXPLTT_SLOT_4     0x10        //                            S
#define VRAM_TEXPLTT_SLOT_5     0x18        //                            T
#define VRAM_BGPLTT_SLOT_0_3    0x00        //       afpbg XbgO|R
#define VRAM_BGPLTT_SLOT_0_1    0x00        //                            O|P
#define VRAM_BGPLTT_SLOT_2_3    0x08        //                            Q|R

#define VRAM_DISABLE            0x00        // uq`lfBZ[u
#define VRAM_ENABLE             0x80U       //         Cl[u


#define WRAM_MAINP_ALL          0x00        // L[Nq`lubNOEP  CvZbT
#define WRAM_MAINP_B1_SUBP_B0   0x01        //                     ubNP  CvZbT
                                            //                     ubNO  TuvZbT
#define WRAM_MAINP_B0_SUBP_B1   0x02        //                     ubNO  CvZbT
                                            //                     ubNP  TuvZbT
#define WRAM_SUBP_ALL           0x03        //                     ubNOEP  TuvZbT


#define VRAM_A_CNT_SHIFT        0           // uq`l ` Rg[
#define VRAM_B_CNT_SHIFT        8           //          a
#define VRAM_C_CNT_SHIFT        16          //          b
#define VRAM_D_CNT_SHIFT        24          //          c
#define VRAM_E_CNT_SHIFT        0           //          d
#define VRAM_F_CNT_SHIFT        8           //          e
#define VRAM_G_CNT_SHIFT        16          //          f
#define VRAM_H_CNT_SHIFT        0           //          g
#define VRAM_I_CNT_SHIFT        8           //          h
#define WRAM_CNT_SHIFT          24          // [Nq`l
#define VRAM_AB_CNT_SHIFT       0           // uq`l `a
#define VRAM_CD_CNT_SHIFT       16          //          bc
#define VRAM_EF_CNT_SHIFT       0           //          de
#define VRAM_G_W_CNT_SHIFT      16          //          f { [Nq`l
#define VRAM_HI_CNT_SHIFT       0           //          gh


// \̃op萔

#define ST_VRAM_LCDC_MODE         0         //           kbcb [h
#define ST_VRAM_BG_MODE           1         //               af [h
#define ST_VRAM_OBJ_MODE          2         //             nai [hi`CaCd`f̂݉j
#define ST_VRAM_SUBP_MODE         2         //     TuvZbT [hibCĉ݉j
#define ST_VRAM_TEX_MODE          3         //         eNX` [hi``ĉ݉j
#define ST_VRAM_TEXPLTT_MODE      3         // eNX`pbg [hid`f̂݉j
#define ST_VRAM_BGPLTT_MODE       4         //       afpbg [hid`f̂݉j
#define ST_VRAM_OBJPLTT_MODE      5         //     naipbg [hieCf̂݉j

#define ST_VRAM_TEX_SLOT_0        0         //         eNX` XbgO
#define ST_VRAM_TEX_SLOT_1        1         //                            P
#define ST_VRAM_TEX_SLOT_2        2         //                            Q
#define ST_VRAM_TEX_SLOT_3        3         //                            R
#define ST_VRAM_TEXPLTT_SLOT_0_3  0         // eNX`pbg XbgO|R
#define ST_VRAM_TEXPLTT_SLOT_0    0         //                            O
#define ST_VRAM_TEXPLTT_SLOT_1    1         //                            P
#define ST_VRAM_TEXPLTT_SLOT_4    2         //                            S
#define ST_VRAM_TEXPLTT_SLOT_5    3         //                            T
#define ST_VRAM_BGPLTT_SLOT_0_3   0         //       afpbg XbgO|R
#define ST_VRAM_BGPLTT_SLOT_0_1   0         //                            O|P
#define ST_VRAM_BGPLTT_SLOT_2_3   1         //                            Q|R


#define ST_WRAM_MAINP_ALL         0         // L[Nq`lubNOEP  CvZbT
#define ST_WRAM_MAINP_B1_SUBP_B0  1         //                     ubNP  CvZbT
                                            //                     ubNO  TuvZbT
#define ST_WRAM_MAINP_B0_SUBP_B1  2         //                     ubNO  CvZbT
                                            //                     ubNP  TuvZbT
#define ST_WRAM_SUBP_ALL          3         //                     ubNOEP  TuvZbT


//----------------------------------------------------------------------
//                      \Rg[
//----------------------------------------------------------------------

#define DISP_BG_MODE_MASK       0x00000007  // af[h
#define DISP_ON_MASK            0x00001f00  // naiEaf nm
#define DISP_WIN_MASK           0x00006000  // EChE nm
#define DISP_OBJ_BMP_MAP_MASK   0x00000060  // nairbg}bvf[^ }bsO^Cv
#define DISP_MODE_MASK          0x00030000  // \[h
#define DISP_VRAM_MASK          0x000c0000  // \uq`lI
#define DISP_OBJ_VRAM_SIZE_MASK 0x00700000  // naipuq`lTCY
#define DISP_BGCHBASE_OFS_MASK  0x07000000  // afLN^f[^x[XAhXEItZbg
#define DISP_BGSCBASE_OFS_MASK  0x38000000  // afXN[f[^x[XAhXEItZbg

#define DISP_BG_MODE_SHIFT        0
#define DISP_ON_SHIFT             8
#define DISP_WIN_SHIFT            13
#define DISP_MODE_SHIFT           16
#define DISP_OBJ_BMP_MAP_SHIFT    5
#define DISP_VRAM_SHIFT           18
#define DISP_OBJ_VRAM_SIZE_SHIFT  20
#define DISP_BGCHBASE_OFS_SHIFT   24
#define DISP_BGSCBASE_OFS_SHIFT   27

#define DISP_BG_MODE_0          0x00000000  // af[hOim[}Sj
#define DISP_BG_MODE_N4         0x00000000
#define DISP_BG_MODE_1          0x00000001  // af[hPim[}RAAtBPj
#define DISP_BG_MODE_N3A1       0x00000001
#define DISP_BG_MODE_2          0x00000002  // af[hQim[}QAAtBQj
#define DISP_BG_MODE_N2A2       0x00000002
#define DISP_BG_MODE_3          0x00000003  // af[hRim[}RAAtBgPj
#define DISP_BG_MODE_N3E1       0x00000003
#define DISP_BG_MODE_4          0x00000004  // af[hSim[}QAAtBPAAtBgPj
#define DISP_BG_MODE_N2A1E1     0x00000004
#define DISP_BG_MODE_5          0x00000005  // af[hTim[}QAAtBgQj
#define DISP_BG_MODE_N2E2       0x00000005
#define DISP_BG_MODE_6          0x00000006  // af[hUiRcŒ肘PAʃrbg}bvPj
#define DISP_BG_MODE_3D1W1      0x00000006
#define DISP_BG0_3D_ON          0x00000008  // afOւRc\
#define DISP_OBJ_CHAR_2D_MAP    0x00000000  // naiLN^f[^ Qc}bsO
#define DISP_OBJ_CHAR_1D_MAP    0x00000010  // naiLN^f[^ Pc}bsO
#define DISP_OBJ_BMP_H128_MAP   0x00000000  // nairbg}bvf[^ PQWhbgQc}bsO
#define DISP_OBJ_BMP_H256_MAP   0x00000020  // nairbg}bvf[^ QTUhbgQc}bsO
#define DISP_OBJ_BMP_1D_MAP     0x00000040  // nairbg}bvf[^ Pc}bsO
#define DISP_OBJ_BMP_VRAM_128KB 0x00000000  // nairbg}bvf[^uq`lPQWja
#define DISP_OBJ_BMP_VRAM_256KB 0x00400000  //                                 QTUja
#define DISP_OBJ_HOFF           0x00800000  // guNnai nee
#define DISP_LCDC_OFF           0x00000080  // kbcb nee
#define DISP_BG0_ON             0x00000100  // afO nm
#define DISP_BG1_ON             0x00000200  // afP nm
#define DISP_BG2_ON             0x00000400  // afQ nm
#define DISP_BG3_ON             0x00000800  // afR nm
#define DISP_BG_ALL_ON          0x00000f00  // afS nm
#define DISP_OBJ_ON             0x00001000  // nai nm
#define DISP_OBJ_BG_ALL_ON      0x00001f00  // naiEafS nm
#define DISP_WIN0_ON            0x00002000  // EChEO nm
#define DISP_WIN1_ON            0x00004000  // EChEP nm
#define DISP_WIN01_ON           0x00006000  // EChEOEP nm
#define DISP_OBJWIN_ON          0x00008000  // naiEChE nm
#define DISP_WIN_ALL_ON         0x0000e000  // EChES nm
#define DISP_ALL_ON             0x00007f00  // S nm

#define DISP_OFF_MODE           0x00000000  // \nee
#define DISP_GFX_MODE           0x00010000  // OtBbNX\[h
#define DISP_VRAM_MODE          0x00020000  // uq`l\[h
#define DISP_MMEM_MODE          0x00030000  // C\[h
#define DISP_VRAM_A             0x00000000  // uq`l|`\
#define DISP_VRAM_B             0x00040000  // uq`l|a\
#define DISP_VRAM_C             0x00080000  // uq`l|b\
#define DISP_VRAM_D             0x000c0000  // uq`l|c\
#define DISP_OBJ_CHAR_VRAM_32KB  0x00000000 // naipuq`lRQja
#define DISP_OBJ_CHAR_VRAM_64KB  0x00100000 //                 USja
#define DISP_OBJ_CHAR_VRAM_128KB 0x00200000 //               PQWja
#define DISP_OBJ_CHAR_VRAM_256KB 0x00300000 //               QTUja
#define DISP_BGPLTT_EX          0x40000000  //   afpbgg
#define DISP_OBJPLTT_EX         0x80000000  // naipbgg

// \̃op萔

#define ST_DISP_OBJ_CHAR_2D_MAP   0         // naiLN^f[^ Qc}bsO
#define ST_DISP_OBJ_CHAR_1D_MAP   1         // naiLN^f[^ Pc}bsO
#define ST_DISP_OBJ_BMP_H128_MAP  0         // nairbg}bvf[^ PQWhbgQc}bsO
#define ST_DISP_OBJ_BMP_H256_MAP  1         // nairbg}bvf[^ QTUhbgQc}bsO
#define ST_DISP_OBJ_BMP_1D_MAP    2         // nairbg}bvf[^ Pc}bsO

#define ST_DISP_OFF_MODE          0         // \nee
#define ST_DISP_GFX_MODE          1         // OtBbNX\[h
#define ST_DISP_VRAM_MODE         2         // uq`l\[h
#define ST_DISP_MMEM_MODE         3         // C\[h

#define ST_DISP_VRAM_A            0         // uq`l|`\
#define ST_DISP_VRAM_B            1         // uq`l|a\
#define ST_DISP_VRAM_C            2         // uq`l|b\
#define ST_DISP_VRAM_D            3         // uq`l|c\


//----------------------------------------------------------------------
//                      \Xe[^X
//----------------------------------------------------------------------

#define DPSTAT_V_SET_LO_MASK     0xff00     // uJE^rlݒ
#define DPSTAT_V_SET_D8          0x0080     // uJE^rlݒWrbg

#define DPSTAT_V_SET_LO_SHIFT    8

#define DPSTAT_V_BLANK           0x0001     // uuNԒ
#define DPSTAT_H_BLANK           0x0002     // guNԒ
#define DPSTAT_V_COUNT           0x0004     // uJE^v
#define DPSTAT_V_BLANK_IF_ENABLE 0x0008     // uuN荞ݗv 
#define DPSTAT_H_BLANK_IF_ENABLE 0x0010     // guN荞ݗv 
#define DPSTAT_V_COUNT_IF_ENABLE 0x0020     // uJE^v荞ݗv 


//----------------------------------------------------------------------
//                      Rc\Rg[
//----------------------------------------------------------------------

#define DISP3D_FOG_INDEX_MASK   0x00000f00  // tHO CfbNX͈

#define DISP3D_FOG_INDEX_SHIFT  8

#define DISP3D_TEX_MASTER_ON    0x00000001  // eNX`}X^ nm
#define DISP3D_SHADING_EX       0x00000002  // gVF[fBO[hݒ
#define DISP3D_TOON_MODE        0x00000000  // gD[VF[fBO[h
#define DISP3D_HIGHLIGHT_MODE   0x00000002  // nCCgVF[fBO[h
#define DISP3D_ALPHA_TEST_ON    0x00000004  // At@eXg nm
#define DISP3D_ALPHA_BLEND_ON   0x00000008  // At@uh nm
#define DISP3D_ANTI_ALIASING_ON 0x00000010  // A`GAVO nm
#define DISP3D_EDGE_MARKING_ON  0x00000020  // GbW}[LO nm
#define DISP3D_FOG_MODE         0x00000040  // tHO[h
#define DISP3D_RGBA_FOG_MODE    0x00000000  // qfa`tHO[h
#define DISP3D_ALPHA_FOG_MODE   0x00000040  // tHO[h
#define DISP3D_FOG_MASTER_ON    0x00000080  // tHO}X^ nm
#define DISP3D_CLEAR_IMAGE_ON   0x00004000  // NAC[W nm

#define DISP3D_RENDER_OVER      0x00001000  // _O I[o[t[
#define DISP3D_GEOMETRY_OVER    0x00002000  // WIg I[o[t[

// \̃op萔

#define ST_DISP3D_TOON_MODE       0         // gD[VF[fBO[h
#define ST_DISP3D_HIGHLIGHT_MODE  1         // nCCgVF[fBO[h

#define ST_DISP3D_RGBA_FOG_MODE   0         // qfa`tHO[h
#define ST_DISP3D_ALPHA_FOG_MODE  1         // tHO[h


//----------------------------------------------------------------------
//                      \Lv`
//----------------------------------------------------------------------

#define DPCAP_GFX_WEIGHT_MASK   0x0000001f  // OtBbNX̃uhW
#define DPCAP_RAM_WEIGHT_MASK   0x00001f00  // q`l̃uhW
#define DPCAP_DEST_OFFSET_MASK  0x000c0000  // ݂uq`lAhXEItZbg
#define DPCAP_SIZE_MASK         0x00300000  // Lv`TCY
#define DPCAP_SRC_OFFSET_MASK   0x0c000000  // ǂݍ݂uq`lAhXEItZbg
#define DPCAP_BLEND_MODE_MASK   0x60000000  // uh[h

#define DPCAP_GFX_WEIGHT_SHIFT    0
#define DPCAP_RAM_WEIGHT_SHIFT    8
#define DPCAP_DEST_OFFSET_SHIFT   18
#define DPCAP_SIZE_SHIFT          20
#define DPCAP_SRC_OFFSET_SHIFT    26
#define DPCAP_BLEND_MODE_SHIFT    29

#define DPCAP_DEST_VRAM_MASK    0x00030000  // Lv`f[^݂uq`lI

#define DPCAP_DEST_VRAM_SHIFT     16

#define DPCAP_DEST_VRAM_A       0x00000000  // uq`l|`
#define DPCAP_DEST_VRAM_B       0x00010000  // uq`l|a
#define DPCAP_DEST_VRAM_C       0x00020000  // uq`l|b
#define DPCAP_DEST_VRAM_D       0x00030000  // uq`l|c
#define DPCAP_SIZE_128x128      0x00000000  // PQWPQWhbg
#define DPCAP_SIZE_256x64       0x00100000  // QTU  UShbg
#define DPCAP_SIZE_256x128      0x00200000  // QTUPQWhbg
#define DPCAP_SIZE_256x192      0x00300000  // QTUQTUhbg
#define DPCAP_GFXSRC_FULL       0x00000000  // QcRcOtBbNXǂݍ
#define DPCAP_GFXSRC_3D         0x01000000  // RcOtBbNX̂ݓǂݍ
#define DPCAP_RAMSRC_VRAM       0x00000000  // uq`lǂݍ
#define DPCAP_RAMSRC_MMEM       0x02000000  // Cǂݍ
#define DPCAP_BLEND_GFX         0x00000000  // OtBbNX̂݃Lv`
#define DPCAP_BLEND_RAM         0x20000000  // q`l̂݃Lv`
#define DPCAP_BLEND_GFX_RAM     0x40000000  // OtBbNXƂq`lufBOăLv`
#define DPCAP_ENABLE            0x80000000  // \Lv` Cl[u


//----------------------------------------------------------------------
//                      }X^[Px Rg[
//----------------------------------------------------------------------

#define MSBRT_VALUE_MASK        0x001f      // PxW
#define MSBRT_MODE_MASK         0xc000      // Px[h

#define MSBRT_VALUE_SHIFT       0
#define MSBRT_MODE_SHIFT        14

#define MSBRT_NORMAL_MODE       0x0000      // m[}[h
#define MSBRT_UP_MODE           0x4000      // Pxto[h
#define MSBRT_DOWN_MODE         0x8000      // Pxcnvm[h


//----------------------------------------------------------------------
//                      uh Rg[
//----------------------------------------------------------------------

#define BLD_PIXEL_MASK          0x003f      // sNZI
#define BLD_1ST_PIXEL_MASK      0x003f      // PsNZI
#define BLD_MODE_MASK           0x00c0      // uh[h
#define BLD_2ND_PIXEL_MASK      0x3f00      // QsNZI

#define BLD_1ST_PIXEL_SHIFT     0
#define BLD_MODE_SHIFT          6
#define BLD_2ND_PIXEL_SHIFT     8

#define BLD_BG0                 0x0001      // afO sNZI
#define BLD_BG1                 0x0002      // afP sNZI
#define BLD_BG2                 0x0004      // afQ sNZI
#define BLD_BG3                 0x0008      // afR sNZI
#define BLD_OBJ                 0x0010      // nai sNZI
#define BLD_BD                  0x0020      // wiF sNZI
#define BLD_ALL                 0x003f      //        sNZSI
#define BLD_BG0_1ST             0x0001      // afO PsNZI
#define BLD_BG1_1ST             0x0002      // afP PsNZI
#define BLD_BG2_1ST             0x0004      // afQ PsNZI
#define BLD_BG3_1ST             0x0008      // afR PsNZI
#define BLD_OBJ_1ST             0x0010      // nai PsNZI
#define BLD_BD_1ST              0x0020      // wiF PsNZI
#define BLD_1ST_ALL             0x003f      //        PsNZSI
#define BLD_NORMAL_MODE         0x0000      // m[}[h
#define BLD_A_BLEND_MODE        0x0040      // [h
#define BLD_UP_MODE             0x0080      // Pxto[h
#define BLD_DOWN_MODE           0x00c0      // Pxcnvm[h
#define BLD_BG0_2ND             0x0100      // afO QsNZI
#define BLD_BG1_2ND             0x0200      // afP QsNZI
#define BLD_BG2_2ND             0x0400      // afQ QsNZI
#define BLD_BG3_2ND             0x0800      // afR QsNZI
#define BLD_OBJ_2ND             0x1000      // nai QsNZI
#define BLD_BD_2ND              0x2000      // wiF QsNZI
#define BLD_2ND_ALL             0x3f00      //        QsNZSI


#define BLD_A_MASK              0x001f      // uhW `
#define BLD_B_MASK              0x1f00      // uhW a
#define BLD_Y_MASK              0x001f      // uhW x

#define BLD_A_SHIFT             16
#define BLD_B_SHIFT             24
#define BLD_Y_SHIFT             0

// \̃op萔

#define ST_BLD_NORMAL_MODE      0           // m[}[h
#define ST_BLD_A_BLEND_MODE     1           // [h
#define ST_BLD_UP_MODE          2           // Pxto[h
#define ST_BLD_DOWN_MODE        3           // Pxcnvm[h


//----------------------------------------------------------------------
//                      EChE Rg[
//----------------------------------------------------------------------

#define WIN_END_POS_MASK        0x00ff      // EChEI_
#define WIN_START_POS_MASK      0xff00      // EChEJn_

#define WIN_END_POS_SHIFT       0
#define WIN_START_POS_SHIFT     8

#define WIN_BG0_ON              0x0001      // afO nm
#define WIN_BG1_ON              0x0002      // afP nm
#define WIN_BG2_ON              0x0004      // afQ nm
#define WIN_BG3_ON              0x0008      // afR nm
#define WIN_OBJ_ON              0x0010      // nai nm
#define WIN_BLEND_ON            0x0020      // uh nm
#define WIN_ALL_ON              0x003f      // S nm

//----------------------------------------------------------------------
//                      UCN Rg[
//----------------------------------------------------------------------

#define MOS_H_SIZE_MASK         0x000f      //       UCN
#define MOS_V_SIZE_MASK         0x00f0      //       UCN
#define MOS_BG_H_SIZE_MASK      0x000f      //   afUCN
#define MOS_BG_V_SIZE_MASK      0x00f0      //   afUCN
#define MOS_OBJ_H_SIZE_MASK     0x000f      // naiUCN
#define MOS_OBJ_V_SIZE_MASK     0x00f0      // naiUCN

#define MOS_H_SIZE_SHIFT        0
#define MOS_V_SIZE_SHIFT        4
#define MOS_BG_H_SIZE_SHIFT     0
#define MOS_BG_V_SIZE_SHIFT     4
#define MOS_OBJ_H_SIZE_SHIFT    8
#define MOS_OBJ_V_SIZE_SHIFT    12



//----------------------------------------------------------------------
//                      afRg[
//----------------------------------------------------------------------

#define BG_PRIORITY_MASK        0x0003      // afԗD揇
#define BG_CHAR_BASE_MASK       0x003c      // LN^ x[XAhX
#define BG_SCREEN_BASE_MASK     0x1f00      // XN[ x[XAhX
#define BG_SCREEN_SIZE_MASK     0xc000      // XN[TCYiQTU^TPQj

#define BG_PRIORITY_SHIFT       0
#define BG_CHAR_BASE_SHIFT      2
#define BG_SCREEN_BASE_SHIFT    8
#define BG_SCREEN_SIZE_SHIFT    14

#define BG_PRIORITY_0           0x0000      // afOD
#define BG_PRIORITY_1           0x0001      // afPD
#define BG_PRIORITY_2           0x0002      // afQD
#define BG_PRIORITY_3           0x0003      // afRD
#define BG_MOS_ON               0x0040      // UCN nm
#define BG_MOS_OFF              0x0000      // UCN nee
#define BG_COLOR_16             0x0000      // PUF   I
#define BG_COLOR_256            0x0080      // QTUF I
#define BG_CHAR_16              0x0000      // PUFLN^af
#define BG_CHAR_256             0x0080      // QTUFLN^af
#define BGE_CHAR_256x16         0x0000      // QTUFPUpbgLN^af
#define BGE_BMP_256             0x0080      // QTUFrbg}bvaf
#define BGE_BMP_DIRECT          0x0084      // _CNgJ[rbg}bvaf
#define BG_LOOP_ON              0x2000      // [v nm
#define BG_LOOP_OFF             0x0000      // [v nee
#define BG_EXPLTT_SLOT_0        0x0000      // gpbgXbgO֊蓖
#define BG_EXPLTT_SLOT_1        0x0000      //             XbgP
#define BG_EXPLTT_SLOT_2        0x2000      //             XbgQ
#define BG_EXPLTT_SLOT_3        0x2000      //             XbgR
#define BG_SCREEN_SIZE_0        0x0000      // XN[TCYiQTUQTUj
#define BG_SCREEN_SIZE_1        0x4000      // XN[TCYiTPQQTUj
#define BG_SCREEN_SIZE_2        0x8000      // XN[TCYiQTUTPQj
#define BG_SCREEN_SIZE_3        0xc000      // XN[TCYiTPQTPQj

// \̃op萔

#define ST_BG_COLOR_16          0           // PUF   I
#define ST_BG_COLOR_256         1           // QTUF I



//----------------------------------------------------------------------
//                      r[|[g
//----------------------------------------------------------------------

#define VIEWPORT_START_X_MASK   0x000000ff  // X^[g wW
#define VIEWPORT_START_Y_MASK   0x0000ff00  //          xW
#define VIEWPORT_END_X_MASK     0x00ff0000  // Gh   wW
#define VIEWPORT_END_Y_MASK     0xff000000  //          xW

#define VIEWPORT_START_X_SHIFT  0
#define VIEWPORT_START_Y_SHIFT  8
#define VIEWPORT_END_X_SHIFT    16
#define VIEWPORT_END_Y_SHIFT    24


//----------------------------------------------------------------------
//                      Cobt@ NA
//----------------------------------------------------------------------

#define CLR_ID_MASK             0x3f000000  // hc

#define CLR_ID_SHIFT            24

#define CLR_FOG_ON              0x00008000  // tHOtO nm
#define CLR_FOG_OFF             0x00000000  // tHOtO nee


//----------------------------------------------------------------------
//                      WIgR}h
//----------------------------------------------------------------------

#define GXOP_NOP                0x00        // mno

#define GXOP_MTX_MODE           0x10        // s񃂁[h
#define GXOP_MTX_PUSH           0x11        // svbV
#define GXOP_MTX_POP            0x12        // s|bv
#define GXOP_MTX_STORE          0x13        // sXgA
#define GXOP_MTX_RESTORE        0x14        // s񃊃XgA
#define GXOP_MTX_IDENTITY       0x15        // Pʍs 
#define GXOP_MTX_LOAD_4x4       0x16        // s񃍁[hiSSj
#define GXOP_MTX_LOAD_4x3       0x17        //           iSRj
#define GXOP_MTX_MULT_4x4       0x18        // sZ    iSSj
#define GXOP_MTX_MULT_4x3       0x19        //             iSRj
#define GXOP_MTX_MULT_3x3       0x1a        //             iRRj
#define GXOP_MTX_SCALE          0x1b        // XP[sZiPRj
#define GXOP_MTX_TRANS          0x1c        // ړsZiPRj

#define GXOP_POLYGON_ATTR       0x29        // |S

#define GXOP_COLOR              0x20        // _J[
#define GXOP_NORMAL             0x21        // _@
#define GXOP_TEXCOORD           0x22        // _eNX`W
#define GXOP_VTX_16             0x23        // _16bitW
#define GXOP_VTX_10             0x24        // _10bitW
#define GXOP_VTX_XY             0x25        // _16bitXYW
#define GXOP_VTX_XZ             0x26        // _16bitXZW
#define GXOP_VTX_YZ             0x27        // _16bitYZW
#define GXOP_VTX_DIFF           0x28        // _16bitWl
#define GXOP_TEX_PARAM          0x2a        // eNX`p[^
#define GXOP_TEXIMAGE_PARAM     0x2a
#define GXOP_TEXPLTT_BASE       0x2b

#define GXOP_BOX_TEST           0x70        // {bNXeXg
#define GXOP_POS_TEST           0x71        // ʒueXg
#define GXOP_VEC_TEST           0x72        // xNgeXg

#define GXOP_MATERIAL_COLOR_0   0x30        // }eAJ[
#define GXOP_MATERIAL_COLOR_1   0x31
#define GXOP_DIF_AMB            0x30        // gU  
#define GXOP_SPE_EMI            0x31        // ˌ  ˌ
#define GXOP_LIGHT_VECTOR       0x32        // CgxNg
#define GXOP_LIGHT_COLOR        0x33        // CgJ[
#define GXOP_SHININESS          0x34        // ʔˋPx

#define GXOP_BEGIN              0x40        // WIg X^[g
#define GXOP_END                0x41        // WIg Gh

#define GXOP_SWAP_BUFFERS       0x50        // _OGWQƃf[^Q̃Xbv

#define GXOP_VIEWPORT           0x60        // r[|[g


//----------------------------------------------------------------------
//                  WIgR}h p[^
//----------------------------------------------------------------------

#define GXOP_NPARAMS_MAX                32  // ő吔

#define GXOP_NOP_NPARAMS                0   // mno

#define GXOP_MTX_MODE_NPARAMS           1   // s񃂁[h
#define GXOP_MTX_PUSH_NPARAMS           0   // svbV
#define GXOP_MTX_POP_NPARAMS            1   // s|bv
#define GXOP_MTX_STORE_NPARAMS          1   // sXgA
#define GXOP_MTX_RESTORE_NPARAMS        1   // s񃊃XgA
#define GXOP_MTX_IDENTITY_NPARAMS       0   // Pʍs 
#define GXOP_MTX_LOAD_4x4_NPARAMS       16  // s񃍁[hiSSj
#define GXOP_MTX_LOAD_4x3_NPARAMS       12  //           iSRj
#define GXOP_MTX_MULT_4x4_NPARAMS       16  // sZ    iSSj
#define GXOP_MTX_MULT_4x3_NPARAMS       12  //             iSRj
#define GXOP_MTX_MULT_3x3_NPARAMS       9   //             iRRj
#define GXOP_MTX_SCALE_NPARAMS          3   // XP[sZiPRj
#define GXOP_MTX_TRANS_NPARAMS          3   // ړsZiPRj

#define GXOP_POLYGON_ATTR_NPARAMS       1   // |S

#define GXOP_COLOR_NPARAMS              1   // _J[
#define GXOP_NORMAL_NPARAMS             1   // _@
#define GXOP_TEXCOORD_NPARAMS           1   // _eNX`W
#define GXOP_VTX_16_NPARAMS             2   // _16bitW
#define GXOP_VTX_10_NPARAMS             1   // _10bitW
#define GXOP_VTX_XY_NPARAMS             1   // _16bitXYW
#define GXOP_VTX_XZ_NPARAMS             1   // _16bitXZW
#define GXOP_VTX_YZ_NPARAMS             1   // _16bitYZW
#define GXOP_VTX_DIFF_NPARAMS           1   // _16bitWl

#define GXOP_TEX_PARAM_NPARAMS          1   // eNX`p[^
#define GXOP_TEXIMAGE_PARAM_NPARAMS     1
#define GXOP_TEXPLTT_BASE_NPARAMS       1

#define GXOP_BOX_TEST_NPARAMS           3   // {bNXeXg
#define GXOP_POS_TEST_NPARAMS           2   // ʒueXg
#define GXOP_VEC_TEST_NPARAMS           1   // xNgeXg

#define GXOP_MATERIAL_COLOR_0_NPARAMS   1   // }eAJ[
#define GXOP_MATERIAL_COLOR_1_NPARAMS   1
#define GXOP_DIF_AMB_NPARAMS            1   // gU  
#define GXOP_SPE_EMI_NPARAMS            1   // ˌ  ˌ
#define GXOP_LIGHT_VECTOR_NPARAMS       1   // CgxNg
#define GXOP_LIGHT_COLOR_NPARAMS        1   // CgJ[
#define GXOP_SHININESS_NPARAMS          32  // ʔˋPx

#define GXOP_BEGIN_NPARAMS              1   // WIg X^[g
#define GXOP_END_NPARAMS                0   // WIg Gh

#define GXOP_SWAP_BUFFERS_NPARAMS       1   // _OGWQƃf[^Q̃Xbv

#define GXOP_VIEWPORT_NPARAMS           1   // r[|[g


//----------------------------------------------------------------------
//                      WIgXe[^X Rg[
//----------------------------------------------------------------------

#define GXSTAT_POSVEC_STACK_MASK 0x00001f00 // ʒuxNg}gbNX X^bNx
#define GXSTAT_FIFO_COUNT_MASK   0x00ff0000 // R}hehen c
#define GXSTAT_FIFO_INTR_MASK    0xc0000000 //                  荞݃^Cv

#define GXSTAT_POSVEC_STACK_SHIFT  8
#define GXSTAT_FIFO_COUNT_SHIFT    16
#define GXSTAT_FIFO_INTR_SHIFT     30

#define GXSTAT_TEST_BUSY        0x00000001  // anw^_^xN^eXg rW[
#define GXSTAT_BOX_IN_VIEW      0x00000002  // anẅꕔ̐ϓ
#define GXSTAT_PROJ_STACK_LEVEL 0x00002000  // vWFNV}gbNX X^bNx
#define GXSTAT_MTX_STACK_BUSY   0x00004000  // }gbNXX^bN rW[
#define GXSTAT_MTX_STACK_ERROR  0x00008000  // }gbNXX^bN G[

#define GXSTAT_GEOMETRY_BUSY    0x08000000  // WIgGW rW[
#define GXSTAT_FIFO_FULL        0x01000000  // R}hehen t
#define GXSTAT_FIFO_UNDER_HALF  0x02000000  //                  n[tȉ
#define GXSTAT_FIFO_EMPTY       0x04000000  //                  GveB
#define GXSTAT_FIFO_FULL_INTR   0x00000000  //                  tŊ荞
#define GXSTAT_FIFO_HALF_INTR   0x40000000  //                  n[tȉŊ荞
#define GXSTAT_FIFO_EMPTY_INTR  0x80000000  //                  GveBŊ荞


//----------------------------------------------------------------------
//                      WIgq`lXbv Rg[
//----------------------------------------------------------------------

#define SWPBF_XLU_AUTO_YSORT    0x00000000  // |S I[gx\[g
#define SWPBF_XLU_MANUAL_SORT   0x00000001  //                }jA\[g
#define SWPBF_Z_BUFFERING       0x00000000  // yobt@O
#define SWPBF_W_BUFFERING       0x00000002  // vobt@O


//----------------------------------------------------------------------
//                      s񃂁[h Rg[
//----------------------------------------------------------------------

#define MTX_MODE_MASK            0x00000003 // s񃂁[h

#define MTX_MODE_SHIFT           0

#define MTX_PROJECTION_MODE      0x00000000 // vWFNVs
#define MTX_POSITION_MODE        0x00000001 // ʒuWs
#define MTX_POSITION_VECTOR_MODE 0x00000002 // ʒuWxNgs ݒ
#define MTX_TEXTURE_MODE         0x00000003 // eNX`s

// \̃op萔

#define ST_MTX_PROJECTION_MODE       0      // vWFNVs
#define ST_MTX_POSITION_MODE         1      // ʒuWs
#define ST_MTX_POSITION_VECTOR_MODE  2      // ʒuWxNgs ݒ
#define ST_MTX_TEXTURE_MODE          3      // eNX`s


//----------------------------------------------------------------------
//                      Cg
//----------------------------------------------------------------------

#define LIGHT_ID_MASK           0xc0000000  // hc

#define LIGHT_ID_SHIFT          30

//----------------------------------------------------------------------
//                      }eAJ[
//----------------------------------------------------------------------

#define DIFFUSE_SET_COLOR_OFF   0x0000      // fBt[YJ[̒_J[ւ̃Zbg nee
#define DIFFUSE_SET_COLOR_ON    0x8000      //                                          nm

#define DIFFUSE_SET_COLOR_SHIFT 15

#define SHININESS_TABLE_OFF     0x0000      // ʔˋPxe[u nee
#define SHININESS_TABLE_ON      0x8000      //                      nm

#define SHININESS_TABLE_SHIFT   15


//----------------------------------------------------------------------
//                      |S
//----------------------------------------------------------------------

#define POLYATTR_LIGHT_ON_MASK  0x0000000f  // Cgnm
#define POLYATTR_RD_MODE_MASK   0x00000030  // _O[h
#define POLYATTR_ALPHA_MASK     0x001f0000  // l
#define POLYATTR_ID_MASK        0x3f000000  // hc

#define POLYATTR_LIGHT_ON_SHIFT 0
#define POLYATTR_RD_MODE_SHIFT  4
#define POLYATTR_ALPHA_SHIFT    16
#define POLYATTR_ID_SHIFT       24

#define POLYATTR_LIGHT0_ON      0x00000001  // CgO nm
#define POLYATTR_LIGHT1_ON      0x00000002  // CgP nm
#define POLYATTR_LIGHT2_ON      0x00000004  // CgQ nm
#define POLYATTR_LIGHT3_ON      0x00000008  // CgR nm
#define POLYATTR_LIGHT_ALL_ON   0x0000000f  // SCg nm

#define POLYATTR_MODULATE       0x00000000  // W[V[h
#define POLYATTR_DECAL          0x00000010  // fJ[[h
#define POLYATTR_TOON           0x00000020  // gD[^nCCgVF[fBO[h
#define POLYATTR_HIGHLIGHT      0x00000020
#define POLYATTR_SHADOW         0x00000030  // VhE|S[h

#define POLYATTR_BACK_OFF       0x00000000  //  nee
#define POLYATTR_BACK_ON        0x00000040  //      nm
#define POLYATTR_FRONT_OFF      0x00000000  // \ nee
#define POLYATTR_FRONT_ON       0x00000080  //      nm
#define POLYATTR_XLU_DEPTH_OFF  0x00000000  // |S̃fvXobt@XV nee
#define POLYATTR_XLU_DEPTH_ON   0x00000800  //                                    nm
#define POLYATTR_FAR_REJECT     0x00000000  // e`qWFNg
#define POLYATTR_FAR_CLIPPING   0x00001000  // e`qNbsO
#define POLYATTR_DISP_1DOT      0x00002000  // Phbg\
#define POLYATTR_DEPTH_LESS     0x00000000  // fvXobt@l菬`
#define POLYATTR_DEPTH_EQUAL    0x00004000  // fvXobt@lƓ`
#define POLYATTR_FOG_OFF        0x00000000  // tHO nee
#define POLYATTR_FOG_ON         0x00008000  //        nm

// \̃op萔

#define ST_POLYATTR_MODULATE    0           // W[V[h
#define ST_POLYATTR_DECAL       1           // fJ[[h
#define ST_POLYATTR_TOON        2           // gD[^nCCg[h
#define ST_POLYATTR_HIGHLIGHT   2
#define ST_POLYATTR_SHADOW      3           // VhE|S[h

#define ST_POLYATTR_DEPTH_LESS  0           // fvXobt@l菬`
#define ST_POLYATTR_DEPTH_EQUAL 1           // fvXobt@lƓ`


//----------------------------------------------------------------------
//                      adfhm Rg[
//----------------------------------------------------------------------

#define BEGIN_PRIM_TYPE_MASK    0x00000003  // v~eBu^Cv

#define BEGIN_PRIM_TYPE_SHIFT   0

#define BEGIN_TRIANGLES         0x00000000  // Op`|S
#define BEGIN_QUADS             0x00000001  // lp`|S
#define BEGIN_TRIANGLE_STRIP    0x00000002  // AOp`|S
#define BEGIN_QUAD_STRIP        0x00000003  // Alp`|S

// \̃op萔

#define ST_BEGIN_TRIANGLES      0           // Op`|S
#define ST_BEGIN_QUADS          1           // lp`|S
#define ST_BEGIN_TRIANGLE_STRIP 2           // AOp`|S
#define ST_BEGIN_QUAD_STRIP     3           // Alp`|S


//----------------------------------------------------------------------
//                      eNX` p[^
//----------------------------------------------------------------------

#define TEX_IMAGE_BASE_MASK     0x0000ffff  // C[Wx[XAhX
#define TEX_S_SIZE_MASK         0x00700000  // rTCY
#define TEX_T_SIZE_MASK         0x03800000  // sTCY
#define TEX_FORMAT_MASK         0x1c000000  // tH[}bg
#define TEX_GEN_MODE_MASK       0xc0000000  // eNX`Wϊ[h

#define TEX_ADDR_SHIFT          0
#define TEX_S_SIZE_SHIFT        20
#define TEX_T_SIZE_SHIFT        23
#define TEX_FORMAT_SHIFT        26
#define TEX_GEN_MODE_SHIFT      30

#define TEX_IMAGE_BASE_SHIFT    3

#define TEX_ST_REPEAT_ON        0x00030000  // rss[g nm
#define TEX_ST_REPEAT_OFF       0x00000000  //              nee
#define TEX_S_REPEAT_ON         0x00010000  // rs[g   nm
#define TEX_S_REPEAT_OFF        0x00000000  //              nee
#define TEX_T_REPEAT_ON         0x00020000  // ss[g   nm
#define TEX_T_REPEAT_OFF        0x00000000  //              nee
#define TEX_ST_FLIP_ON          0x000c0000  // rstbv nm
#define TEX_ST_FLIP_OFF         0x00000000  //              nee
#define TEX_S_FLIP_ON           0x00040000  // rtbv   nm
#define TEX_S_FLIP_OFF          0x00000000  //              nee
#define TEX_T_FLIP_ON           0x00080000  // stbv   nm
#define TEX_T_FLIP_OFF          0x00000000  //              nee
#define TEX_S_SIZE_8            0x00000000  // rTCY   WeNZ
#define TEX_S_SIZE_16           0x00100000  //          PUeNZ
#define TEX_S_SIZE_32           0x00200000  //          RQeNZ
#define TEX_S_SIZE_64           0x00300000  //          USeNZ
#define TEX_S_SIZE_128          0x00400000  //        PQWeNZ
#define TEX_S_SIZE_256          0x00500000  //        QTUeNZ
#define TEX_S_SIZE_512          0x00600000  //        TPQeNZ
#define TEX_S_SIZE_1024         0x00700000  //      POQSeNZ
#define TEX_T_SIZE_8            0x00000000  // sTCY   WeNZ
#define TEX_T_SIZE_16           0x00800000  //          PUeNZ
#define TEX_T_SIZE_32           0x01000000  //          RQeNZ
#define TEX_T_SIZE_64           0x01800000  //          USeNZ
#define TEX_T_SIZE_128          0x02000000  //        PQWeNZ
#define TEX_T_SIZE_256          0x02800000  //        QTUeNZ
#define TEX_T_SIZE_512          0x03000000  //        TPQeNZ
#define TEX_T_SIZE_1024         0x03800000  //      POQSeNZ

#define TEX_FORMAT_NONE         0x00000000  // eNX`
#define TEX_FORMAT_4PLTT        0x08000000  //     SFpbgeNX`
#define TEX_FORMAT_16PLTT       0x0c000000  //   PUFpbgeNX`
#define TEX_FORMAT_256PLTT      0x10000000  // QTUFpbgeNX`
#define TEX_FORMAT_4x4COMP      0x14000000  // SSkeNX`
#ifdef IRIS_TS
#define TEX_FORMAT_ALPHA3       0x04000000  // ReNX`
#endif
#define TEX_FORMAT_ALPHA5       0x18000000  // TeNX`
#define TEX_FORMAT_DIRECT       0x1c000000  // J[_CNgeNX`

#define TEX_PLTT0_OFF           0x20000000  // J[pbgO nee
#define TEX_PLTT0_ON            0x00000000  //                  nm
#define TEX_PLTT0_XLU           0x20000000  //                  iOj

#define TEX_GEN_DIRECT          0x00000000  // Wϊ
#define TEX_GENSRC_TEXCOORD     0x40000000  // Wϊ\[X sb
#define TEX_GENSRC_NORMAL       0x80000000  //                m
#define TEX_GENSRC_VERTEX       0xc0000000  //                u


// \̃op萔

#define ST_TEX_SIZE_8           0           // eNX`TCY WeNZ
#define ST_TEX_SIZE_16          1           //                PUeNZ
#define ST_TEX_SIZE_32          2           //                RQeNZ
#define ST_TEX_SIZE_64          3           //                USeNZ
#define ST_TEX_SIZE_128         4           //              PQWeNZ
#define ST_TEX_SIZE_256         5           //              QTUeNZ
#define ST_TEX_SIZE_512         6           //              TPQeNZ
#define ST_TEX_SIZE_1024        7           //            POQSeNZ

#define ST_TEX_FORMAT_NONE      0           // eNX`
#define ST_TEX_FORMAT_4PLTT     2           //     SFpbgeNX`
#define ST_TEX_FORMAT_16PLTT    3           //   PUFpbgeNX`
#define ST_TEX_FORMAT_256PLTT   4           // QTUFpbgeNX`
#define ST_TEX_FORMAT_4x4COMP   5           // SSkeNX`
#ifdef IRIS_TS
#define ST_TEX_FORMAT_ALPHA3    1           // ReNX`
#endif
#define ST_TEX_FORMAT_ALPHA5    6           // TeNX`
#define ST_TEX_FORMAT_DIRECT    7           // J[_CNgeNX`

#define ST_TEX_GEN_DIRECT       0           // Wϊ
#define ST_TEX_GENSRC_TEXCOORD  1           // Wϊ\[X sb
#define ST_TEX_GENSRC_NORMAL    2           //                m
#define ST_TEX_GENSRC_VERTEX    3           //                u


//----------------------------------------------------------------------
//                      eNX`pbgx[X
//----------------------------------------------------------------------

#define TEX_PLTT_BASE_MASK      0x00001fff  // pbgx[XAhX
#define TEXPLT_BASE_MASK        TEX_PLTT_BASE_MASK

#define TEXPLT_FORMAT_NONE          0       // eNX`pbg
#define TEXPLT_FORMAT_4PLTT         2       //     SFpbgeNX`
#define TEXPLT_FORMAT_16PLTT        3       //   PUFpbgeNX`
#define TEXPLT_FORMAT_256PLTT       4       // QTUFpbgeNX`
#define TEXPLT_FORMAT_4x4COMP       5       // SSkeNX`
#ifdef IRIS_TS
#define TEXPLT_FORMAT_ALPHA3        1       // ReNX`
#endif
#define TEXPLT_FORMAT_ALPHA5        6       // TeNX`

#define TEXPLT_FORMAT_NONE_SHIFT    0
#define TEXPLT_FORMAT_4PLTT_SHIFT   3
#define TEXPLT_FORMAT_16PLTT_SHIFT  4
#define TEXPLT_FORMAT_256PLTT_SHIFT 4
#define TEXPLT_FORMAT_4x4COMP_SHIFT 4
#ifdef IRIS_TS
#define TEXPLT_FORMAT_ALPHA3_SHIFT  4
#endif
#define TEXPLT_FORMAT_ALPHA5_SHIFT  4

//----------------------------------------------------------------------
//                      keNX` pbgCfbNX
//----------------------------------------------------------------------

#define TEX4X4_PLTT_INDEX_MASK  0x00003fff  // pbgCfbNX

#define TEX4X4_PLTT_INDEX_SHIFT 0

#define TEX4X4_DIRECT_PLTT      0x00000000  // Spbg
#define TEX4X4_LINER_PLTT       0x00008000  // QpbgSԃpbg
#define TEX4X4_INDEX_3          0x00000000  // RCfbNX{
#define TEX4X4_INDEX_4          0x00004000  // SCfbNX



//----------------------------------------------------------------------
//                      cl`Rg[
//----------------------------------------------------------------------

#define DMA_ENABLE              0x80000000  // cl`
#define DMA_IF_ENABLE           0x40000000  // 荞ݗv 

#define DMA_TIMMING_MASK        0x38000000  // Jn^C~O
#define DMA_COUNT_MASK          0x001fffff  // ]

#define DMA_TIMMING_SHIFT       27
#define DMA_COUNT_SHIFT         0

#define DMA_TIMMING_IMM         0x00000000  // ɋN
#define DMA_TIMMING_V_BLANK     0x08000000  // uuNN
#define DMA_TIMMING_H_BLANK     0x10000000  // guNN
#define DMA_TIMMING_DISP        0x18000000  // \
#define DMA_TIMMING_DISP_MMEM   0x20000000  // C\
#define DMA_TIMMING_CARD        0x28000000  // J[h
#define DMA_TIMMING_CARTRIDGE   0x30000000  // J[gbW
#define DMA_TIMMING_GXFIFO      0x38000000  // WIgehen
#define DMA_16BIT_BUS           0x00000000  // oXTCYPUaI
#define DMA_32BIT_BUS           0x04000000  // oXTCYRQaI
#define DMA_CONTINUOUS_ON       0x02000000  // ReBjAX[h nm
#define DMA_SRC_INC             0x00000000  // ] CNg I
#define DMA_SRC_DEC             0x00800000  // ] fNg   I
#define DMA_SRC_FIX             0x01000000  // ] Œ I
#define DMA_DEST_INC            0x00000000  // ] CNg I
#define DMA_DEST_DEC            0x00200000  // ] fNg   I
#define DMA_DEST_FIX            0x00400000  // ] Œ I
#define DMA_DEST_RELOAD         0x00600000  // ] CNg/[h I

// \̃op萔

#define ST_DMA_TIMMING_IMM        0         // ɋN
#define ST_DMA_TIMMING_V_BLANK    1         // uuNN
#define ST_DMA_TIMMING_H_BLANK    2         // guNN
#define ST_DMA_TIMMING_DISP       3         // \N
#define ST_DMA_TIMMING_DISP_MMEM  4         // C\
#define ST_DMA_TIMMING_CARD       5         // J[h
#define ST_DMA_TIMMING_CARTRIDGE  6         // J[gbW
#define ST_DMA_TIMMING_GXFIFO     7         // WIgehen
#define ST_DMA_16BIT_BUS          0         // oXTCYPUaI
#define ST_DMA_32BIT_BUS          1         // oXTCYRQaI
#define ST_DMA_INC                0         // AhXECNg I
#define ST_DMA_DEC                1         // AhXEfNg   I
#define ST_DMA_FIX                2         // AhXŒ I
#define ST_DMA_RELOAD             3         // AhXECNg/[h I


//----------------------------------------------------------------------
//                      ^C}[ Rg[
//----------------------------------------------------------------------

#define TMR_PRESCALER_MASK      0x00030000  // vXP[ NbN

#define TMR_PRESCALER_SHIFT     16

#define TMR_PRESCALER_1CK       0x00000000  // vXP[ P
#define TMR_PRESCALER_64CK      0x00010000  //            US
#define TMR_PRESCALER_256CK     0x00020000  //          QTU
#define TMR_PRESCALER_1024CK    0x00030000  //        POQS
#define TMR_CONNECT             0x00040000  // ʃ^C}[ڑ
#define TMR_IF_ENABLE           0x00400000  // 荞ݗv 
#define TMR_ENABLE              0x00800000  // ^C}[N

// \̃op萔

#define ST_TMR_PRESCALER_1CK    0           // vXP[ P
#define ST_TMR_PRESCALER_64CK   1           //            US
#define ST_TMR_PRESCALER_256CK  2           //          QTU
#define ST_TMR_PRESCALER_1024CK 3           //        POQS


//----------------------------------------------------------------------
//                          L[
//----------------------------------------------------------------------

#define BUTTON_MASK             0x030f      // {^
#define PLUS_KEY_MASK           0x00f0      // \L[
#define ALL_KEY_MASK            0x03ff      // SẴL[

#define A_BUTTON                0x0001      // `{^
#define B_BUTTON                0x0002      // a{^
#define SELECT_BUTTON           0x0004      // ZNg{^
#define START_BUTTON            0x0008      // X^[g{^
#define R_KEY                   0x0010      // E{^
#define L_KEY                   0x0020      // {^
#define U_KEY                   0x0040      // {^
#define D_KEY                   0x0080      // {^
#define R_BUTTON                0x0100      // q{^
#define L_BUTTON                0x0200      // k{^
#define KEY_IF_ENABLE           0x4000      // 荞ݗv 
#define KEY_OR_INTR             0x0000      //   ʏL[荞
#define KEY_AND_INTR            0x8000      // `mcL[荞

// \̃op萔

#define ST_KEY_OR_INTR          0           //   ʏL[荞
#define ST_KEY_AND_INTR         1           // `mcL[荞


//----------------------------------------------------------------------
//                      O Rg[
//----------------------------------------------------------------------

#define CTRDG_DT8_10CYC         0x0000      // J[gbW Wf[^oX  POTCN
#define CTRDG_DT8_8CYC          0x0001      //                                    WTCN
#define CTRDG_DT8_6CYC          0x0002      //                                    UTCN
#define CTRDG_DT8_18CYC         0x0003      //                                  PWTCN
#define CTRDG_AD16_1ST_10CYC    0x0000      // J[gbW `cPUoX P POTCN
#define CTRDG_AD16_1ST_8CYC     0x0004      //                                    WTCN
#define CTRDG_AD16_1ST_6CYC     0x0008      //                                    UTCN
#define CTRDG_AD16_1ST_18CYC    0x000c      //                                  PWTCN
#define CTRDG_AD16_2ND_6CYC     0x0000      //                           Q   UTCN
#define CTRDG_AD16_2ND_4CYC     0x0010      //                                    STCN

#define CTRDG_PHI_OUT_NONE      0x0000      // Ӓ[qo̓NbN kŒ
#define CTRDG_PHI_OUT_4MCK      0x0020      //                    Slg
#define CTRDG_PHI_OUT_8MCK      0x0040      //                    Wlg
#define CTRDG_PHI_OUT_16MCK     0x0060      //                  PUlg

#define CTRDG_ACCESS            0x0080      // J[gbWANZXI
#define CTRDG_ACCESS_MAINP      0x0000      //           CvZbT
#define CTRDG_ACCESS_SUBP       0x0080      //           TuvZbT

#define CARD_ACCESS             0x0800      // J[hANZXI
#define CARD_ACCESS_MAINP       0x0000      //           CvZbT
#define CARD_ACCESS_SUBP        0x0800      //           TuvZbT

#define MMEM_CE2_OUT            0x2000      //             bdQMo

#define MMEM_INTF               0x4000      // CC^tF[Xisdfł͏ɃZbgē[hɂj
#define MMEM_INTF_ASYNC         0x0000      //                           񓯊[h
#define MMEM_INTF_SYNC          0x4000      //                             [h

#define MMEM_PRIORITY           0x8000      // CD挠I
#define MMEM_PRIORITY_MAINP     0x0000      //           CvZbT
#define MMEM_PRIORITY_SUBP      0x8000      //           TuvZbT

// \̃op萔

#define ST_CTRDG_DT8_10CYC      0           // J[gbW Wf[^oX  POTCN
#define ST_CTRDG_DT8_8CYC       1           //                                    WTCN
#define ST_CTRDG_DT8_6CYC       2           //                                    UTCN
#define ST_CTRDG_DT8_18CYC      3           //                                  PWTCN
#define ST_CTRDG_AD16_1ST_10CYC 0           // J[gbW `cPUoX P POTCN
#define ST_CTRDG_AD16_1ST_8CYC  1           //                                    WTCN
#define ST_CTRDG_AD16_1ST_6CYC  2           //                                    UTCN
#define ST_CTRDG_AD16_1ST_18CYC 3           //                                  PWTCN
#define ST_CTRDG_AD16_2ND_6CYC  0           //                           Q   UTCN
#define ST_CTRDG_AD16_2ND_4CYC  1           //                                    STCN

#define ST_CTRDG_PHI_OUT_NONE   0           // Ӓ[qo̓NbN kŒ
#define ST_CTRDG_PHI_OUT_4MCK   1           //                    Slg
#define ST_CTRDG_PHI_OUT_8MCK   2           //                    Wlg
#define ST_CTRDG_PHI_OUT_16MCK  3           //                  PUlg


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_DEFINE_H
