//======================================================================
//          IrisGX.h
//            IRIS 3DOtBbNXGWCu
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_GX_H
#define _IRIS_GX_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisMemoryMap.h>
#include <IrisMacro.h>
#include <IrisSinTable.h>


//----------------------------------------------------------------------
//          fBXvCXgcl`]
//
//EWIgR}hFIFO̗vMɂDMA]s܂B
//EDMÃCl[utO|[OďI܂ő҂܂B
//
//EF
//  dmaNo   DMAԍ
//  listp   fBXvCXg̃|C^
//  length  fBXvCXg̒i[hPʁj
//
//E߂lFȂ
//
//TCM̃fBXvCXgDMA]ł܂B
//----------------------------------------------------------------------

#define GX_DmaList(dmaNo, listp, length)                            \
{                                                                   \
    GX_Dma(dmaNo, listp, length);                                   \
    WaitDma(dmaNo);                                                 \
}

//----------------------------------------------------------------------
//          fBXvCXgcl`]
//
//EI܂ŃVXeoXCPURA֊JȂƂɂ
//  DMA]s܂B
//
//EF
//  dmaNo   DMAԍ
//  listp   fBXvCXg̃|C^
//  length  fBXvCXg̒i[hPʁj
//
//E߂lFȂ
//
//TCM̃fBXvCXgDMA]ł܂B
//----------------------------------------------------------------------

#define GX_DmaListFast(dmaNo, listp, length)                        \
                                                                    \
    GX_DmaFast(dmaNo, listp, length)


//----------------------------------------------------------------------
//          fBXvCXgcl`񓯊]
//
//EWIgR}hFIFO̗vMɂDMA]s܂B
//EDMȀI`FbN͍s܂BDMA]̑O GX_WaitDma() 
//  ŏI`FbNĉB
//
//EF
//  dmaNo   DMAԍ
//  listp   fBXvCXg̃|C^
//  length  fBXvCXg̒i[hPʁj
//
//E߂lFȂ
//
//TCM̃fBXvCXgDMA]ł܂B
//----------------------------------------------------------------------

#define GX_DmaListAsync(dmaNo, listp, length)                       \
                                                                    \
    GX_Dma(dmaNo, listp, length)


//----------------------------------------------------------------------
//          fBXvCXgcl`]I҂
//
//EDMÃCl[utO|[OďÎ҂܂B
//
//EF
//  dmaNo   DMAԍ
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_WaitDma(dmaNo)                   WaitDma(dmaNo)



//----------------------------------------------------------------------
//     WIg_OGW̃I[o[t[Ă邩H
//
//E_OGW̓_OGW̃I[o[t[
//  Ă邩ǂԂ܂B
//
//EF  Ȃ
//
//E߂lF
//  0     I[o[t[
//  0       I[o[t[
//----------------------------------------------------------------------

#define GX_IsOverflows()					(((vu8 *)REG_DISP3DCNT)[1] & ((DISP3D_GEOMETRY_OVER | DISP3D_RENDER_OVER)>>8))
#define GX_IsGeometryOverflow()				(((vu8 *)REG_DISP3DCNT)[1] &  (DISP3D_GEOMETRY_OVER>>8))
#define GX_IsRenderingOverflow()			(((vu8 *)REG_DISP3DCNT)[1] &  (DISP3D_RENDER_OVER>>8))


//----------------------------------------------------------------------
//     WIg_OGW̃I[o[t[tÕNA
//
//E_OGW̓_OGW̃I[o[t[tO
//  NA܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ClearOverflows()					(((vu8 *)REG_DISP3DCNT)[1] |=((DISP3D_GEOMETRY_OVER | DISP3D_RENDER_OVER)>>8))
#define GX_ClearGeometryOverflow()			(((vu8 *)REG_DISP3DCNT)[1] |= (DISP3D_GEOMETRY_OVER>>8))
#define GX_ClearRenderingOverflow()			(((vu8 *)REG_DISP3DCNT)[1] |= (DISP3D_RENDER_OVER>>8))


//----------------------------------------------------------------------
//          WIgGWEXe[^Xǂݍ
//
//EWIgGWEXe[^XWX^̒lԂ܂B
//
//EF  Ȃ
//
//E߂lFWIgGWEXe[^X
//----------------------------------------------------------------------

#define GX_GetGeometryStatus()				(*(vu32 *)REG_GXSTAT))


//----------------------------------------------------------------------
//          WIgGW͓쒆H
//
//EWIgGW쒆ǂԂ܂B
//
//EF  Ȃ
//
//E߂lF
//  0     쒆
//  0       ~
//----------------------------------------------------------------------

#define GX_IsGeometryBusy()					(((vu8 *)REG_GXSTAT)[3] & (GXSTAT_GEOMETRY_BUSY>>24))

//----------------------------------------------------------------------
//          WIgGW~҂
//
//EWIgGW~̂҂܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_WaitGeometry()														\
{											while (GX_IsGeometryBusy())  ;		\
}

//----------------------------------------------------------------------
//          WIgeheñNA
//
//EWIgR}hFIFONA܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

void GX_ClearFifo(void);

//----------------------------------------------------------------------
//          WIgehenJE^ǂݍ
//
//EWIgR}hFIFOJE^lԂ܂B
//
//EF  Ȃ
//
//E߂lFJE^l
//----------------------------------------------------------------------

#define GX_GetFifoCount()					(((vGxStat *)REG_GXSTAT)->fifoCount)

//----------------------------------------------------------------------
//          WIgehen`FbNit^ȉ^j
//
//EWIgR}hFIFȌ[Ux`FbN܂B
//
//EF  Ȃ
//
//E߂lF
//  0     e𖞂Ă
//  0       e𖞂ĂȂ
//----------------------------------------------------------------------

#define GX_IsFifoFull()						(((vu8 *)REG_GXSTAT)[3] & (GXSTAT_FIFO_FULL>>24))
#define GX_IsFifoUnderHalf()				(((vu8 *)REG_GXSTAT)[3] & (GXSTAT_FIFO_UNDER_HALF>>24))
#define GX_IsFifoEmpty()					(((vu8 *)REG_GXSTAT)[3] & (GXSTAT_FIFO_EMPTY>>24))
#define GX_WaitFifoNotFull()													\
{											while (GX_IsFifoFull())  ;			\
}
#define GX_WaitFifoUnderHalf()													\
{											while (!GX_IsFifoUnderHalf())  ;	\
}
#define GX_WaitFifoEmpty()														\
{											while (!GX_IsFifoEmpty())  ;		\
}


//----------------------------------------------------------------------
//          r[|[gݒ
//
//EBG0ʏɂr[|[g̍WƉEWݒ肵܂B
//
//EF
//  startX  XWi8bitj
//  startY  YWi V j
//  endX    EXWi V j
//  endY    EYWi V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Viewport(startX, startY, endX, endY)                         \
{                                                                       \
    *(vu32 *)REG_VIEWPORT = (u32 )(startX) << VIEWPORT_START_X_SHIFT    \
                          | (u32 )(startY) << VIEWPORT_START_Y_SHIFT    \
                          | (u32 )(endX)   << VIEWPORT_END_X_SHIFT      \
                          | (u32 )(endY)   << VIEWPORT_END_Y_SHIFT;     \
}


//======================================================================
//          sR}hQ
//======================================================================

//----------------------------------------------------------------------
//          s񃂁[hݒ
//
//EsR}hő삷Jgsw肵܂B
//
//EF
//  mode    s񃂁[h
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_MtxMode(mode)		(*(vu32 *)REG_MTX_MODE = (mode))

//----------------------------------------------------------------------
//          Jgs̃vbV
//
//EJgssX^bN֑ޔ܂B
//EsX^bN|C^͂Pi݂܂B
//
//EF  Ȃ
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PushMtx()			(*(vs32 *)REG_MTX_PUSH = 0)

//----------------------------------------------------------------------
//          Jgs̃|bv
//
//EJgssX^bN畜܂B
//EsX^bN|C^͎w肵Έʒuֈړ܂B
//
//EF
//  relPos  Έʒui-30 ` 31j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PopMtx(relPos)		(*(vs32 *)REG_MTX_POP  = (relPos))

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒu֊i[܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_StoreMtx(index)		(*(vs32 *)REG_MTX_STORE = (index))

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒuo܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_RestoreMtx(index)	(*(vs32 *)REG_MTX_RESTORE = (index))


//----------------------------------------------------------------------
//          sX^bN|C^̃NA
//
//EsX^bN|C^NA܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

void GX_ClearMtxStackPtr(void);


//----------------------------------------------------------------------
//          sX^bNR}h҂
//
//EsX^bNR}h̊҂܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_WaitMtxStackCmd()													\
{											while (GX_IsMtxStackCmdBusy())  ;	\
}

//----------------------------------------------------------------------
//     sX^bÑI[o[t[^A_[t[Ă邩H
//
//EsX^bÑI[o[t[^A_[t[Ă邩ǂԂ܂B
//
//EF  Ȃ
//
//E߂lF
//  0     I[o[t[^A_[t[
//  0       I[o[t[^A_[t[
//----------------------------------------------------------------------

#define GX_IsMtxStackError()				(((vu8 *)REG_GXSTAT)[1] & (GXSTAT_MTX_STACK_ERROR>>8))


//----------------------------------------------------------------------
//     sX^bNR}hWIgehen֎cĂ邩H
//
//EsX^bNR}hWIgehen֎cĂ邩ǂԂ܂B
//
//EF  Ȃ
//
//E߂lF
//  0     ssX^bNR}h
//  0       ssX^bNR}hȂ
//----------------------------------------------------------------------

#define GX_IsMtxStackCmdBusy()				(((vu8 *)REG_GXSTAT)[1] & (GXSTAT_MTX_STACK_BUSY>>8))


//----------------------------------------------------------------------
//          sX^bNxǂݍ
//
//EsX^bNxԂ܂B
//EsX^bNR}h̊҂Ăǂݍ݂܂B
//
//EF  Ȃ
//
//E߂lFsX^bNx
//----------------------------------------------------------------------

__inline static u8 GX_GetProjStackLevel(void)
{
    GX_WaitMtxStackCmd();    return  ((vGxStat *)REG_GXSTAT)->projStackLevel;
}
__inline static u8 GX_GetPosVecStackLevel(void)
{
    GX_WaitMtxStackCmd();    return  ((vGxStat *)REG_GXSTAT)->posvecStackLevel;
}


//----------------------------------------------------------------------
//          Pʍsւ̏
//
//EJgsPʍsɏ܂B
//
//EF  Ȃ
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Identity()			(*(vu32 *)REG_MTX_IDENTITY = 0)

//----------------------------------------------------------------------
//          sړs̓Kp
//
//EJgsɕsړsZ܂B
//
//EF
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate(x, y, z)											\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_TRANS;									\
																		\
    *mp = (x);															\
    *mp = (y);															\
    *mp = (z);															\
}

// ԃ}NiL̃}N͒ڎgpȂŉj

#define _GX_TranslateBefore(mp, x, y, z)								\
{																		\
    *mp = (x);															\
    *mp = (y);															\
    *mp = (z);															\
}

//----------------------------------------------------------------------
//          Jgsւ̃[h
//
//EJgsɎw肵sݒ肵܂B
//
//EF
//  srcp    [hs̃|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LoadMtx(srcp)				_GX_SetMtx(  (vs32 *)REG_MTX_LOAD_4x3, srcp)
#define GX_LoadMtx44(srcp)				_GX_SetMtx44((vs32 *)REG_MTX_LOAD_4x4, srcp)
#define GX_LoadMtx33(x, y, z, srcp)										\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_LOAD_4x3;								\
																		\
    _GX_SetMtx33(mp, srcp);												\
    *mp = 0;															\
    *mp = 0;															\
    *mp = 0;															\
}

void _GX_SetMtx(  vs32 *mp, const Mtx   *srcp);
void _GX_SetMtx33(vs32 *mp, const Mtx33 *srcp);
void _GX_SetMtx44(vs32 *mp, const Mtx44 *srcp);

//----------------------------------------------------------------------
//          ʍsƃJgs̏Z
//
//EJgsɎw肵sZ܂B
//
//EF
//  srcp    Kps̃|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_MultMtx(srcp)				_GX_SetMtx(  (vs32 *)REG_MTX_MULT_4x3, srcp)
#define GX_MultMtx33(srcp)				_GX_SetMtx33((vs32 *)REG_MTX_MULT_3x3, srcp)
#define GX_MultMtx44(srcp)				_GX_SetMtx44((vs32 *)REG_MTX_MULT_4x4, srcp)

//----------------------------------------------------------------------
//          sړsKpɈʍsZ
//
//EJgs֕sړsƈʍšsZ܂B
//
//EGX_Translate(){GX_MultMtx33() WIgGWׂ̕点܂B
//
//EF
//  x       X
//  y       Y
//  z       Z
//  srcp    Kp3x3s̃|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2MultMtx33(x, y, z, srcp)							\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_SetMtx33(mp, srcp);												\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          ]us̓Kp
//
//EJgsɎw肵s̓]usZ܂B
//
//EF
//  srcp    ]uO̍s̃|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_TransposeMtx(  const Mtx   *srcp);
void GX_TransposeMtx44(const Mtx44 *srcp);
#define GX_TransposeMtx33(srcp)				_GX_TransposeMtx33((vs32 *)REG_MTX_MULT_3x3, srcp)

void _GX_TransposeMtx33(vs32 *mp, const Mtx33 *srcp);

//----------------------------------------------------------------------
//          sړsKpɓ]usKp
//
//EJgs֕sړsƓ]ušsZ܂B
//
//EGX_Translate(){GX_TransposeMtx33() WIgGWׂ̕点܂B
//
//EF
//  x       sړX
//  y       sړY
//  z       sړZ
//  srcp    ]uO3x3s̃|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2TransposeMtx33(x, y, z, srcp)						\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_TransposeMtx33(mp, srcp);										\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          XP[s̓KpiʒuWŝ݁j
//
//EJgsɃXP[sZ܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇł
//  ʒuWŝ݂ɓKp܂B
//
//EF
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Scale(x, y, z)												\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_SCALE;									\
																		\
    *mp = (x) >>VG_SFT_DF;												\
    *mp = (y) >>VG_SFT_DF;												\
    *mp = (z) >>VG_SFT_DF;												\
}

//----------------------------------------------------------------------
//          XP[s̓KpiʒuWs񁕕xNgsj
//
//EJgsɃXP[sZ܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EF
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_ScaleWithVector(x, y, z)			_GX_ScaleWithVector((vs32 *)REG_MTX_MULT_3x3, x, y, z)

void _GX_ScaleWithVector(vs32 *mp, s32 x, s32 y, s32 z);

//----------------------------------------------------------------------
//          sړsKp
//          XP[sKpiʒuWs񁕕xNgsj
//
//EJgs֕sړsƃXP[šsZ܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EGX_Translate(){GX_ScaleWithVector() WIgGWׂ̕点܂B
//
//EF
//  xT      sړX
//  yT      sړY
//  zT      sړZ
//  xS      XP[X
//  yS      XP[Y
//  zS      XP[Z
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2ScaleWithVector(xT, yT, zT, xS, yS, zS)			\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_ScaleWithVector(mp, xS, yS, zS);								\
    _GX_TranslateBefore(mp, xT, yT, zT)									\
}


//----------------------------------------------------------------------
//          厲]s̓Kp
//
//EJgsɊe厲ɉ]sZ܂B
//
//EF
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_RotateX(theta)				GX_RotatePriv(X, SIN_NDIV_DEFAULT, theta)
#define GX_RotateY(theta)				GX_RotatePriv(Y, SIN_NDIV_DEFAULT, theta)
#define GX_RotateZ(theta)				GX_RotatePriv(Z, SIN_NDIV_DEFAULT, theta)

#define GX_RotateX256(theta)			GX_RotatePriv(X, 256,  theta)
#define GX_RotateY256(theta)			GX_RotatePriv(Y, 256,  theta)
#define GX_RotateZ256(theta)			GX_RotatePriv(Z, 256,  theta)
#define GX_RotateX1024(theta)			GX_RotatePriv(X, 1024, theta)
#define GX_RotateY1024(theta)			GX_RotatePriv(Y, 1024, theta)
#define GX_RotateZ1024(theta)			GX_RotatePriv(Z, 1024, theta)
#define GX_RotateX4096(theta)			GX_RotatePriv(X, 4096, theta)
#define GX_RotateY4096(theta)			GX_RotatePriv(Y, 4096, theta)
#define GX_RotateZ4096(theta)			GX_RotatePriv(Z, 4096, theta)

void _GX_RotateX256(vs32 *mp, u32 theta);
void _GX_RotateY256(vs32 *mp, u32 theta);
void _GX_RotateZ256(vs32 *mp, u32 theta);
void _GX_RotateX1024(vs32 *mp, u32 theta);
void _GX_RotateY1024(vs32 *mp, u32 theta);
void _GX_RotateZ1024(vs32 *mp, u32 theta);
void _GX_RotateX4096(vs32 *mp, u32 theta);
void _GX_RotateY4096(vs32 *mp, u32 theta);
void _GX_RotateZ4096(vs32 *mp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_RotatePriv(axis, ndiv, theta)	GX_RotateNDiv(axis, ndiv, theta)
#define GX_RotateNDiv(axis, ndiv, theta)	_GX_Rotate##axis##ndiv((vs32 *)REG_MTX_MULT_3x3, theta)

//----------------------------------------------------------------------
//          sړsKpɎ厲]sKp
//
//EJgs֕sړsƎ厲]šsZ܂B
//
//EGX_Translate(){GX_Rotate[X|Y|Z][256|1024|4096]() 
//  WIgGWׂ̕点܂B
//
//EF
//  x       sړX
//  y       sړY
//  z       sړZ
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2RotateX(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, X, SIN_NDIV_DEFAULT, theta)
#define GX_Translate2RotateY(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, Y, SIN_NDIV_DEFAULT, theta)
#define GX_Translate2RotateZ(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, Z, SIN_NDIV_DEFAULT, theta)

#define GX_Translate2RotateX256(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, X, 256,  theta)
#define GX_Translate2RotateY256(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, Y, 256,  theta)
#define GX_Translate2RotateZ256(x, y, z, theta)		GX_Translate2RotatePriv(x, y, z, Z, 256,  theta)
#define GX_Translate2RotateX1024(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, X, 1024, theta)
#define GX_Translate2RotateY1024(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, Y, 1024, theta)
#define GX_Translate2RotateZ1024(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, Z, 1024, theta)
#define GX_Translate2RotateX4096(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, X, 4096, theta)
#define GX_Translate2RotateY4096(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, Y, 4096, theta)
#define GX_Translate2RotateZ4096(x, y, z, theta)	GX_Translate2RotatePriv(x, y, z, Z, 4096, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_Translate2RotatePriv(x, y, z, axis, ndiv, theta)				\
		GX_Translate2RotateNDiv(x, y, z, axis, ndiv, theta)
#define GX_Translate2RotateNDiv(x, y, z, axis, ndiv, theta)				\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_Rotate##axis##ndiv(mp, theta);									\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          厲]siOp֐ɂ]pwj̓Kp
//
//EJgsɊe厲ɉ]sZ܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EF
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_RotateXSinCos(sinA, cosA)		_GX_RotateXSinCos((vs32 *)REG_MTX_MULT_3x3, sinA, cosA)
#define GX_RotateYSinCos(sinA, cosA)		_GX_RotateYSinCos((vs32 *)REG_MTX_MULT_3x3, sinA, cosA)
#define GX_RotateZSinCos(sinA, cosA)		_GX_RotateZSinCos((vs32 *)REG_MTX_MULT_3x3, sinA, cosA)

void _GX_RotateXSinCos(vs32 *mp, s32 sinA, s32 cosA);
void _GX_RotateYSinCos(vs32 *mp, s32 sinA, s32 cosA);
void _GX_RotateZSinCos(vs32 *mp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          sړsKp
//          厲]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƎ厲]šsZ܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EGX_Translate(){GX_Rotate[X|Y|Z]SinCos() 
//  WIgGWׂ̕点܂B
//
//EF
//  x       sړX
//  y       sړY
//  z       sړZ
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2RotateXSinCos(x, y, z, sinA, cosA)		GX_Translate2RotateSinCosPriv(x, y, z, X, sinA, cosA)
#define GX_Translate2RotateYSinCos(x, y, z, sinA, cosA)		GX_Translate2RotateSinCosPriv(x, y, z, Y, sinA, cosA)
#define GX_Translate2RotateZSinCos(x, y, z, sinA, cosA)		GX_Translate2RotateSinCosPriv(x, y, z, Z, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_Translate2RotateSinCosPriv(x, y, z, axis, sinA, cosA)		\
		GX_Translate2RotateSinCosNDiv(x, y, z, axis, sinA, cosA)
#define GX_Translate2RotateSinCosNDiv(x, y, z, axis, sinA, cosA)		\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_Rotate##axis##SinCos(mp, theta);								\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          Cӎ]s̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_RotateAxis(    axisp, theta)			GX_RotateAxisPriv(    SIN_NDIV_DEFAULT, axisp, theta)
#define GX_RotateAxisFast(axisp, theta)			GX_RotateAxisPrivFast(SIN_NDIV_DEFAULT, axisp, theta)

#define GX_RotateAxis256(    axisp, theta)		GXB_RotateAxisPriv(    256,  axisp, theta)
#define GX_RotateAxis256Fast(axisp, theta)		GXB_RotateAxisPrivFast(256,  axisp, theta)
#define GX_RotateAxis1024(    axisp, theta)		GXB_RotateAxisPriv(    1024, axisp, theta)
#define GX_RotateAxis1024Fast(axisp, theta)		GXB_RotateAxisPrivFast(1024, axisp, theta)
#define GX_RotateAxis4096(    axisp, theta)		GXB_RotateAxisPriv(    4096, axisp, theta)
#define GX_RotateAxis4096Fast(axisp, theta)		GXB_RotateAxisPrivFast(4096, axisp, theta)

void _GX_RotateAxis256(    vs32 *mp, const Vec *axisp, u32 theta);
void _GX_RotateAxis256Fast(vs32 *mp, const Vec *axisp, u32 theta);
void _GX_RotateAxis1024(    vs32 *mp, const Vec *axisp, u32 theta);
void _GX_RotateAxis1024Fast(vs32 *mp, const Vec *axisp, u32 theta);
void _GX_RotateAxis4096(    vs32 *mp, const Vec *axisp, u32 theta);
void _GX_RotateAxis4096Fast(vs32 *mp, const Vec *axisp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_RotateAxisPriv(    ndiv, axisp, theta)	GX_RotateAxisNDiv(    ndiv, axisp, theta)
#define GX_RotateAxisPrivFast(ndiv, axisp, theta)	GX_RotateAxisNDivFast(ndiv, axisp, theta)
#define GX_RotateAxisNDiv(    ndiv, axisp, theta)	_GX_RotateAxis##ndiv(      (vs32 *)REG_MTX_MULT_3x3, axisp, theta)
#define GX_RotateAxisNDivFast(ndiv, axisp, theta)	_GX_RotateAxis##ndiv##Fast((vs32 *)REG_MTX_MULT_3x3, axisp, theta)

//----------------------------------------------------------------------
//          sړsKpɔCӎ]sKp
//
//EJgs֕sړsƔCӎ]šsZ܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGX_Translate(){GX_RotateAxis[256|1024|4096][Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2RotateAxis(    x, y, z, axisp, theta)		GX_Translate2RotateAxisPriv(    x, y, z, SIN_NDIV_DEFAULT, axisp, theta)
#define GX_Translate2RotateAxisFast(x, y, z, axisp, theta)		GX_Translate2RotateAxisPrivFast(x, y, z, SIN_NDIV_DEFAULT, axisp, theta)

#define GX_Translate2RotateAxis256(    x, y, z, axisp, theta)	GX_Translate2RotateAxisPriv(    x, y, z, 256,  axisp, theta)
#define GX_Translate2RotateAxis256Fast(x, y, z, axisp, theta)	GX_Translate2RotateAxisPrivFast(x, y, z, 256,  axisp, theta)
#define GX_Translate2RotateAxis1024(    x, y, z, axisp, theta)	GX_Translate2RotateAxisPriv(    x, y, z, 1024, axisp, theta)
#define GX_Translate2RotateAxis1024Fast(x, y, z, axisp, theta)	GX_Translate2RotateAxisPrivFast(x, y, z, 1024, axisp, theta)
#define GX_Translate2RotateAxis4096(    x, y, z, axisp, theta)	GX_Translate2RotateAxisPriv(    x, y, z, 4096, axisp, theta)
#define GX_Translate2RotateAxis4096Fast(x, y, z, axisp, theta)	GX_Translate2RotateAxisPrivFast(x, y, z, 4096, axisp, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_Translate2RotateAxisPriv(    x, y, z, ndiv, axisp, theta)	\
		GX_Translate2RotateAxisNDiv(    x, y, z, ndiv, axisp, theta)
#define GX_Translate2RotateAxisNDiv(x, y, z, ndiv, axisp, theta)		\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_RotateAxis##ndiv(mp, axisp, theta);								\
    _GX_TranslateBefore(mp, x, y, z)									\
}
#define GX_Translate2RotateAxisPrivFast(x, y, z, ndiv, axisp, theta)	\
		GX_Translate2RotateAxisNDivFast(x, y, z, ndiv, axisp, theta)
#define GX_Translate2RotateAxisNDivFast(x, y, z, ndiv, axisp, theta)	\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_RotateAxis##ndiv##Fast(mp, axisp, theta);						\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          Cӎ]siOp֐ɂ]pwj̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_RotateAxisSinCos(    axisp, sinA, cosA)			_GX_RotateAxisSinCos(    (vs32 *)REG_MTX_MULT_3x3, axisp, sinA, cosA)
#define GX_RotateAxisSinCosFast(axisp, sinA, cosA)			_GX_RotateAxisSinCosFast((vs32 *)REG_MTX_MULT_3x3, axisp, sinA, cosA)

void _GX_RotateAxisSinCos(    vs32 *mp, const Vec *axisp, s32 sinA, s32 cosA);
void _GX_RotateAxisSinCosFast(vs32 *mp, const Vec *axisp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          sړsKp
//          Cӎ]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƔCӎ]šsZ܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGX_Translate(){GX_RotateAxisSinCos[Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------


#define GX_Translate2RotateAxisSinCos(    x, y, z, axisp, sinA, cosA)		GX_Translate2RotateAxisSinCosPriv(    x, y, z, axisp, sinA, cosA)
#define GX_Translate2RotateAxisSinCosFast(x, y, z, axisp, sinA, cosA)		GX_Translate2RotateAxisSinCosPrivFast(x, y, z, axisp, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_Translate2RotateAxisSinCosPriv(    x, y, z, axisp, sinA, cosA)	\
		GX_Translate2RotateAxisSinCosNDiv(    x, y, z, axisp, sinA, cosA)
#define GX_Translate2RotateAxisSinCosNDiv(    x, y, z, axisp, sinA, cosA)	\
{																			\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;									\
																			\
    _GX_RotateAxisSinCos(mp, axisp, sinA, cosA);							\
    _GX_TranslateBefore(mp, x, y, z)										\
}
#define GX_Translate2RotateAxisSinCosPrivFast(x, y, z, axisp, sinA, cosA)	\
		GX_Translate2RotateAxisSinCosNDivFast(x, y, z, axisp, sinA, cosA)
#define GX_Translate2RotateAxisSinCosNDivFast(x, y, z, axisp, sinA, cosA)	\
{																			\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;									\
																			\
    _GX_RotateAxisSinCosFast(mp, axisp, sinA, cosA);						\
    _GX_TranslateBefore(mp, x, y, z)										\
}


//----------------------------------------------------------------------
//          yɃACg]s̓Kp
//
//EJgsɔCӎZ̐ƈv]ssZ܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//
//EF
//  vLookInvp   Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_AlignZ(vLookInvp)				_GX_AlignZ((vs32 *)REG_MTX_MULT_3x3, vLookInvp)

void _GX_AlignZ(vs32 *mp, const Vec *vLookInvp);

//----------------------------------------------------------------------
//          sړsKp
//          yɃACg]sKp
//
//EJgs֕sړsƔCӎZ̐ƈv]ss
//  Ƃ̌sZ܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//EGX_Translate(){GX_AlignZ() WIgGWׂ̕点܂B
//
//EF
//  x           sړX
//  y           sړY
//  z           sړZ
//  vLookInvp   Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2AlignZ(x, y, z, vLookInvp)							\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_AlignZ(mp, vLookInvp);											\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          NH[^jIϊ]s̓Kp
//
//EJgsփNH[^jIϊ]sKp܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//
//EF
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_QuatMtx(quatp)						_GX_QuatMtx(    (vs32 *)REG_MTX_MULT_3x3, quatp)
#define GX_QuatMtxFast(quatp)					_GX_QuatMtxFast((vs32 *)REG_MTX_MULT_3x3, quatp)

void _GX_QuatMtx(vs32 *mp, const Quat *quatp);
void _GX_QuatMtxFast(vs32 *mp, const Quat *quatp);

//----------------------------------------------------------------------
//          sړsKp
//          NH[^jIϊ]sKp
//
//EJgs֕sړsƃNH[^jIϊ]s
//  ̌sZ܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//EGX_Translate(){GX_QuatMtx[Fast]() WIgGWׂ̕点܂B
//
//EF
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Translate2QuatMtx(    x, y, z, quatp)			GX_Translate2QuatMtxPriv(    x, y, z, quatp)
#define GX_Translate2QuatMtxFast(x, y, z, quatp)			GX_Translate2QuatMtxPrivFast(x, y, z, quatp)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_Translate2QuatMtxPriv(    x, y, z, quatp)					\
		GX_Translate2QuatMtxNDiv(    x, y, z, quatp)
#define GX_Translate2QuatMtxNDiv(    x, y, z, quatp)					\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_QuatMtx(mp, quatp);												\
    _GX_TranslateBefore(mp, x, y, z)									\
}
#define GX_Translate2QuatMtxPrivFast(x, y, z, quatp)					\
		GX_Translate2QuatMtxNDivFast(x, y, z, quatp)
#define GX_Translate2QuatMtxNDivFast(x, y, z, quatp)					\
{																		\
    vs32 *mp = (vs32 *)REG_MTX_MULT_4x3;								\
																		\
    _GX_QuatMtxFast(mp, quatp);											\
    _GX_TranslateBefore(mp, x, y, z)									\
}


//----------------------------------------------------------------------
//          EΏ̂̓ˉes̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z܂B
//
//E֐ŏZgp܂B
//
//EF
//  fovy    c̎pxm256b1024b4096iKn
//  aspect  ̎m肷ci /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Perspective(fovy, aspect, near, far, scaleW)			GX_PerspectivePriv(SIN_NDIV_DEFAULT, fovy, aspect, near, far, scaleW)

void GX_Perspective256( u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
void GX_Perspective1024(u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
void GX_Perspective4096(u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GX_PerspectivePriv(ndiv, fovy, aspect, near, far, scaleW)	\
		GX_PerspectiveNDiv(ndiv, fovy, aspect, near, far, scaleW)
#define GX_PerspectiveNDiv(ndiv, fovy, aspect, near, far, scaleW)	\
		GX_Perspective##ndiv(    fovy, aspect, near, far, scaleW)

//----------------------------------------------------------------------
//          EΏ̂̓ˉesiOp֐ɂ鎋pwj̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z܂B
//Epx̓TCƃRTCɂĎw肵܂B
//
//E֐ŏZgp܂B
//
//EF
//  sinA    c̎px̃TC
//  cosA    c̎px̃RTCiʊ֐̌ĂяôߍŌɓnj
//  aspect  ̎Em肷ci /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_PerspectiveSinCos(s32 sinA, s32 aspect, s32 near, s32 far, s32 scaleW, s32 cosA);

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//E@̍s쐬AJgs֏Z܂B
//
//E֐ŏZgp܂B
//
//EF
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iɐj
//  f       _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_Frustum(s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//Eˉe̕s̐ς̍s쐬AJgs֏Z܂B
//
//E֐ŏZgp܂B
//
//EF
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iǂłj
//  f       _farNbvʂ܂ł̋ iǂłj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_Ortho(s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);

//----------------------------------------------------------------------
//          Es̓Kp
//
//EEs쐬AJgs֏Z܂B
//
//E֐ŃxNg̐K̂߂ɕZƏZgp܂B
//
//EF
//  eye     _
//  at      _
//  vUp     xNg
//  vDst    0iNULL|C^jȊOnƁAtxNgԂ܂
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_LookAt(    const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);
void GX_LookAtFast(const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);



//----------------------------------------------------------------------
//          JgNbvWs̎擾
//
//EJg̃NbvWs̎擾܂B
//
//E֐ŃWIgGW~̂҂Ăǂݍ݂܂B
//
//EF
//  dstp    si[obt@̃|C^
//
//E߂lFJgNbvWs
//----------------------------------------------------------------------

void GX_GetClipMtx(  Mtx   *dstp);
void GX_GetClipMtx33(Mtx33 *dstp);
void GX_GetClipMtx44(Mtx44 *dstp);


//----------------------------------------------------------------------
//          JgxNgs̎擾
//
//EJg̕xNgs̎擾܂B
//
//E֐ŃWIgGW~̂҂Ăǂݍ݂܂B
//
//EF
//  dstp    si[obt@̃|C^
//
//E߂lFJgxNgs
//----------------------------------------------------------------------

void GX_GetVectorMtx33(Mtx33 *dstp);


//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂̍\̂ݒ肵܂B
//
//EF
//  box     eXg{bNXiXYZWHD161616161616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_BoxTest1(box)																	\
{											*(vs32 *)REG_BOX_TEST = *(vs32 *)&((box).x);	\
											*(vs32 *)REG_BOX_TEST = *(vs32 *)&((box).z);	\
											*(vs32 *)REG_BOX_TEST = *(vs32 *)&((box).h);	\
}

//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂Ɋep[^ݒ肵܂B
//
//EF
//  x       eXg{bNXXWi16bitj
//  y       eXg{bNXYWi V  j
//  z       eXg{bNXZWi V  j
//  w       eXg{bNX       i V  j
//  h       eXg{bNX     i V  j
//  d       eXg{bNXs   i V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_BoxTest6(x, y, z, w, h, d)														\
{											*(vs32 *)REG_BOX_TEST = XY1616(x, y);			\
											*(vs32 *)REG_BOX_TEST = ZW1616(z, w);			\
											*(vs32 *)REG_BOX_TEST = HD1616(h, d);			\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̍\̂ݒ肵܂B
//
//EF
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PositionTest1(pos)																\
{											*(vs32 *)REG_POS_TEST = *(vs32 *)&((pos).x);	\
											*(vs32 *)REG_POS_TEST = *(vs16 *)&((pos).z);	\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̊evfݒ肵܂B
//
//EF
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PositionTest3(x, y, z)															\
{											*(vs32 *)REG_POS_TEST = XY1616(x, y);			\
											*(vs32 *)REG_POS_TEST = (z);					\
}

//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg\̂ݒ肵܂B
//
//EF
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define  GX_VectorTest1(vector)				(*(vVec10 *)REG_VEC_TEST = (vector))


//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg̊evfݒ肵܂B
//
//EF
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define  GX_VectorTest3(x, y, z)			(*(vu32 *)REG_VEC_TEST = XYZ101010(x, y, z))



//----------------------------------------------------------------------
//          WIgeXgErW[`FbN
//
//EWIgeXgǂԂ܂B
//
//EF  Ȃ
//
//E߂lF
//  0     rW[
//  0       fB
//----------------------------------------------------------------------

// MWsΉ

#define GX_IsTestBusy()						((vu8 )*(vu8 *)REG_GXSTAT & GXSTAT_TEST_BUSY)

//----------------------------------------------------------------------
//          WIgeXgI҂
//
//EWIgeXg̏I҂܂B
//
//EF  Ȃ
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_WaitTest()														\
{											while (GX_IsTestBusy())  ;		\
}

//----------------------------------------------------------------------
//          WIgeXg
//
//EWIgeXgʂ擾܂B
//Eʏł̓eXgR}h̊҂Ă猋ʂԂ܂A
//  Immł͊`FbNs܂B
//
//EF  Ȃ
//
//E߂lFeXg
//----------------------------------------------------------------------

// MWsΉ

#define GX_BoxResultImm()					((vu8 )*(vu8 *)REG_GXSTAT & GXSTAT_BOX_IN_VIEW)
#define GX_PositionResultImm()				(*(vPos32 *)REG_POS_RESULT)
#define GX_VectorResultImm()				(*(vVec16 *)REG_VEC_RESULT)
__inline static u8 GX_BoxResult(void)
{
    GX_WaitTest();    return  GX_BoxResultImm();
}

__inline static Pos32 GX_PositionResult(void)
{
    GX_WaitTest();    return  GX_PositionResultImm();
}

__inline static Vec16 GX_VectorResult(void)
{
    GX_WaitTest();    return  GX_VectorResultImm();
}


//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgxNg\̂ݒ肵܂B
//
//EF
//  lightVector CgxNgiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightVector1(lightVector)		(*(vLightVector *)REG_LIGHT_VECTOR = (lightVector))


//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgJ[\̂ݒ肵܂B
//
//EF
//  lightColor  CgJ[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightColor1(lightColor)			(*(vLightColor *)REG_LIGHT_COLOR  = (lightColor))


//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNgݒ肵܂B
//
//EF
//  no      Cgԍ
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightVector2(no, vector)			(*(vu32 *)REG_LIGHT_VECTOR = ((no)<<LIGHT_ID_SHIFT | *(u32 *)&(vector)))


//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[ݒ肵܂B
//
//EF
//  no      Cgԍ
//  color   J[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightColor2(no, color)			(*(vu32 *)REG_LIGHT_COLOR  = ((no)<<LIGHT_ID_SHIFT | *(u16 *)&(color)))


//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNg̊evfݒ肵܂B
//
//EF
//  no      Cgԍ
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightVector4(no, x, y, z)		(*(vu32 *)REG_LIGHT_VECTOR = LIGHT_VECTOR(no, x, y, z))


//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[̊evfݒ肵܂B
//
//EF
//  no      Cgԍ
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_LightColor4(no, r, g, b)			(*(vu32 *)REG_LIGHT_COLOR  = LIGHT_COLOR(no, r, g, b))



//----------------------------------------------------------------------
//          ʔˋPxe[u̐ݒ
//
//E8bit128vfȂ鋾ʔˋPxe[uݒ肵܂B
//ESvf܂Ƃ߂ē]Kv܂B
//Ẽe[u邱ƂɂāA1V[ɕ
//  ʔˌʂ|S\邱Ƃł܂BB
//
//EF
//  srcp    ʔˋPxe[ũ|C^
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void    GX_ShininessTable(void *srcp);



//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//ES}eAJ[Ɗ֘AtO܂Ƃ߂64bitf[^ݒ肵܂B
//
//EF
//  colors  S}eAJ[f[^iRGB555 | _J[XVtOAʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_MaterialColor1(colors)			(*(vu64 *)REG_MATERIAL_COLOR = (*(u64 *)&(colors)))


//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[ƂɊ֘AtOݒ肵܂B
//
//EF
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_MaterialColor4(dif, amb, spe, emi)														\
{											GX_DiffuseAmbient2(  dif, amb);							\
											GX_SpecularEmission2(spe, emi);							\
}

//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[̊evfƊ֘AtOݒ肵܂B
//
//EF
//  setCol  _J[XVtO
//  tbl     ʔˋPxe[uLtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//  sr      XyLJ[  Ԑi V j
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_MaterialColor14(setCol, tbl, dr, dg, db, ar, ag, ab, sr, sg, sb, er, eg, eb)				\
{											GX_DiffuseAmbient7(setCol, dr, dg, db, ar, ag, ab);		\
											GX_SpecularEmission7(tbl, sr, sg, sb, er, eg, eb);		\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[܂Ƃ߂32bitf[^ݒ肵܂B
//
//EF
//  colors  fBt[YArGgJ[iRGB555 | _J[XVtO܂ށj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_DiffuseAmbient1(colors)			(*(vu32 *)REG_DIF_AMB = (colors))


//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[܂Ƃ߂32bitf[^ݒ肵܂B
//
//EF
//  colors  XyLG~bVJ[iRGB555 | ʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_SpecularEmission1(colors)		(*(vu32 *)REG_SPE_EMI = (colors))


//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[ݒ肵܂B
//
//EF
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_DiffuseAmbient2(dif, amb)		(*(vu32 *)REG_DIF_AMB = (*(u16 *)&(dif) | (*(u16 *)&(amb))<<16))


//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[ݒ肵܂B
//
//EF
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_SpecularEmission2(spe, emi)		(*(vu32 *)REG_SPE_EMI = (*(u16 *)&(spe) | (*(u16 *)&(emi))<<16))


//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[̊evf
//  _J[XVtOݒ肵܂B
//
//EF
//  setCol  _J[XVtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_DiffuseAmbient7(setCol, dr, dg, db, ar, ag, ab)												\
											(*(vu32 *)REG_DIF_AMB = ((setCol) | RGB555(dr, dg, db)		\
																			  | RGB555(ar, ag, ab)<<16))

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[̊evf
//  ʔˋPxe[uLtOݒ肵܂B
//
//EF
//  tbl     ʔˋPxe[uLtO
//  sr      XyLJ[  Ԑi5bitj
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_SpecularEmission7(tbl, sr, sg, sb, er, eg, eb)												\
											(*(vu32 *)REG_SPE_EMI = ((tbl) | RGB555(sr, sg, sb)			\
																		   | RGB555(er, eg, eb)<<16))


//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|S܂Ƃ߂32bitf[^ݒ肵܂B
//
//EF
//  attr    |S
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PolygonAttr1(attr)				(*(vu32 *)REG_POLYGON_ATTR = (attr))


//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|SIDƃAt@lƑ̑ݒ肵܂B
//
//EF
//  id      ID        i6bitj
//  alpha   At@li5bitj
//  attr    ̃|S
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_PolygonAttr3(id, alpha, attr)	(*(vu32 *)REG_POLYGON_ATTR = (id)   <<POLYATTR_ID_SHIFT	\
																	   | (alpha)<<POLYATTR_ALPHA_SHIFT	\
																	   | (attr))


//----------------------------------------------------------------------
//          eNX`p[^ݒ
//
//EeNX`̃p[^܂Ƃ߂64bitf[^ݒ肵܂B
//
//EF
//  param   eNX`p[^i64bitj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexParam(param)					(*(vu64 *)REG_TEX_PARAM = (param))


//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgj
//
//EeNX`B[W̃p[^܂Ƃ߂32bitf[^ݒ肵܂B
//EeNX`C[Wx[Xl̓VtglnĉB
//
//EF
//  param   eNX`C[Wp[^i32bitj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexImageParam1(param)			(*(vu32 *)REG_TEXIMAGE_PARAM = (param))


//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgLj
//
//EeNX`B[W̃p[^ݒ肵܂B
//EeNX`C[Wx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  basep   eNX`C[Wx[X̃|C^
//  param   eNX`C[Wp[^i16bitj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexImageParam2(basep, param)		(*(vu32 *)REG_TEXIMAGE_PARAM = Addr2TexImageBase(basep) | (param))	


//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgj
//
//EeNX`pbgx[X̃p[^܂Ƃ߂32bitf[^ݒ肵܂B
//EeNX`pbgx[Xl̓VtglnĉB
//
//EF
//  base    eNX`pbgx[X
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexPlttBase1(base)				(*(vu32 *)REG_TEXPLTT_BASE = ((u32 )(base)))


//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgLj
//
//EeNX`pbgx[X̃p[^ݒ肵܂B
//EeNX`pbgx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  basep   eNX`pbgx[X̃|C^
//  mode    eNX`[h
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexPlttBase2(basep, mode)		(*(vu32 *)REG_TEXPLTT_BASE = Addr2TexPlttBase(basep, mode))



//----------------------------------------------------------------------
//          v~eBu̒_XgJn
//
//Ev~eBu̒_Xg̊Jn錾܂B
//
//EF
//  primType    v~eBu^Cv
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Begin(primType)					(*(vu32 *)REG_BEGIN_VTXS = (primType))


//----------------------------------------------------------------------
//          v~eBu̒_XgI
//
//Ev~eBu̒_Xg̏I錾܂B
//
//EF  Ȃ
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_End()							(*(vu32 *)REG_END_VTXS = 0)



//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[𒼐ڐݒ肵܂B
//
//EF
//  color   J[iRGB555j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Color1(color)					(*(vu32 *)REG_COLOR = (*(u16 *)&(color)))


//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[̊evf𒼐ڐݒ肵܂B
//
//EF
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Color3(r, g, b)					(*(vu32 *)REG_COLOR = RGB555(r, g, b))


//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNg\̂ݒ肵܂B
//
//EF
//  normal  xNgiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Normal1(normal)					(*(vVec10 *)REG_NORMAL = (normal))


//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNgtH[}bg̊evfݒ肵܂B
//
//EF
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Normal3(x, y, z)					(*(vs32 *)REG_NORMAL = XYZ101010(x, y, z))


//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`WփeNX`W\̂ݒ肵܂B
//
//EF
//  coord   eNX`WiST1616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexCoord1(coord)					(*(vTexCoord *)REG_TEXCOORD = (coord))


//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`W֊evfݒ肵܂B
//
//EF
//  s       eNX`WSi16bitj
//  t                     Ti V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_TexCoord2(s,t)					(*(vs32 *)REG_TEXCOORD = ST1616(s, t))


//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg\̂ݒ肵܂B
//
//EF
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Vertex1(pos)																		\
{											*(vs32 *)REG_VTX_16 = *(vs32 *)&((pos).x);		\
											*(vs32 *)REG_VTX_16 = *(vs16 *)&((pos).z);		\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg̊evfݒ肵܂B
//
//EF
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_Vertex3(x, y, z)																	\
{											*(vs32 *)REG_VTX_16 = XY1616(x, y);				\
											*(vs32 *)REG_VTX_16 = (z);						\
}

//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg\̂ݒ肵܂B
//
//EF
//  pos     ʒuWiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexShort1(pos)				(*(vPos10 *)REG_VTX_10 = (pos))


//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg̊evfݒ肵܂B
//
//EF
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexShort3(x, y, z)			(*(vs32 *)REG_VTX_10 = XYZ101010(x, y, z))


//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYW܂Ƃ߂32bitf[^ݒ肵܂iZW͍Ō̐ݒlgpjB
//
//EF
//  pos     ʒuWiXY1616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexXY1(pos)					(*(vPos2D16 *)REG_VTX_XY = (pos))


//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYWݒ肵܂iZW͍Ō̐ݒlgpjB
//
//EF
//  x       ʒuWXi16bitj
//  y               Yi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexXY2(x, y)					(*(vs32 *)REG_VTX_XY = XY1616(x, y))


//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZW܂Ƃ߂32bitf[^ݒ肵܂iYW͍Ō̐ݒlgpjB
//
//EF
//  pos     ʒuWiXZ1616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexXZ1(pos)					(*(vPos2D16 *)REG_VTX_XZ = (pos))


//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZWݒ肵܂iYW͍Ō̐ݒlgpjB
//
//EF
//  x       ʒuWXi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexXZ2(x, z)					(*(vs32 *)REG_VTX_XZ = XY1616(x, z))


//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZW܂Ƃ߂32bitf[^ݒ肵܂iXW͍Ō̐ݒlgpjB
//
//EF
//  pos     ʒuWiYZ1616j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexYZ1(pos)					(*(vPos2D16 *)REG_VTX_YZ = (pos))


//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZWݒ肵܂iXW͍Ō̐ݒlgpjB
//
//EF
//  y       ʒuWYi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexYZ2(y, z)					(*(vs32 *)REG_VTX_YZ = XY1616(y, z))


//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l܂Ƃ߂32bitf[^ݒ肵܂B
//
//EF
//  diff    ʒuWiXYZ101010j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexDiff1(diff)				(*(vPos10 *)REG_VTX_DIFF = (diff))


//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l̊evfݒ肵܂B
//
//EF
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_VertexDiff3(x, y, z)				(*(vs32 *)REG_VTX_DIFF = XYZ101010(x, y, z))


//----------------------------------------------------------------------
//          _OGWQƃf[^Q̃Xbv
//
//ẼR}h𔭍sVuNԊJnɁA
//  |SXgRAMA_RAMA_O֘AWX^A
//  _OGWQƂf[^؂ւ܂B
//E񂾃OtBbNXf[^`֔f̂
//  ̃R}h𔭍s̃t[ɂȂ܂
//
//EF
//  flags   tO
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

#define GX_SwapBuffers(flags)				(*(vu32 *)REG_SWAP_BUFFERS = (flags))


//----------------------------------------------------------------------
//          Phbg|S\EfvXl̐ݒ
//
//E|S̑S_XYWBGXN[W1hbgȉ
//  ͈͓̔֍WϊꍇAłWlifvXlj
//  ̃WX^ݒl傫΁A|SXgRAMђ_RAM
//  Ƀ|Sf[^܂ȂȂ܂B
//  A̋@\LƂȂ邽߂ɂ́APolygonAttrR}h
//  1hbg|S\w肪'0'łKv܂B
//
//EF
//  depth  NbvWłWlifvXlj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_Disp1DotDepth(depth)				(*(vu32 *)REG_DISP_1DOT_DEPTH = (depth))



//======================================================================
//          _OGW
//======================================================================

//----------------------------------------------------------------------
//          fvXobt@̃NAl̐ݒ
//
//EfvXobt@NAliljݒ肵܂B
//
//EF
//  depth  fvXli15bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ClearDepth(depth)				(*(vu16 *)REG_CLEAR_DEPTH = (depth))

//----------------------------------------------------------------------
//          J[obt@̃NAl̐ݒ
//
//EJ[obt@ƃAgr[gobt@NAlilj
//  ܂Ƃ߂32bitf[^ݒ肵܂B
//
//EF
//  param   p[^i32bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ClearColorAttr1(param)			(*(vu32 *)REG_CLEAR_COLOR_ATTR = (param))

//----------------------------------------------------------------------
//          J[obt@̃NAl̐ݒ
//
//EJ[obt@ƃAgr[gobt@NAlilj
//  ݒ肵܂B
//
//EF
//  id      ID        i6bitj
//  r       Ԑ    i5bitj
//  g       ΐ    i V j
//  b           i V j
//  a           i V j
//  f       tHOCl[utO
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ClearColorAttr6(id, r, g, b, a, f)	(*(vu32 *)REG_CLEAR_COLOR_ATTR = (RGB555(r, g, b) | (a)<<ALPHA5_SHIFT | (id)<<CLR_ID_SHIFT | (f)))


//----------------------------------------------------------------------
//          NAC[W̃ItZbgʒu̐ݒ
//
//E_Oobt@ɓǂݍރNAC[Wɑ΂
//  ItZbg^܂B
//Eʂ̓r256~256̃f[^̈𒴂Ɖ荞œǂݍ܂܂B
//
//EF
//  x       XWItZbgli8bitj
//  x       YWItZbgli V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ClearImageOffset(x, y)			(*(vu16 *)REG_CLRIMAGE_OFFSET = (y)<<8 | (u8 )(x))



//----------------------------------------------------------------------
//          tHOJ[ݒ
//
//EtHOƂăufBOJ[ݒ肵܂B
//
//EF
//  color   tHOJ[iRGBA5555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_FogColor1(color)					(*(vu32 *)REG_FOG_COLOR = (color))


//----------------------------------------------------------------------
//          tHOJ[ݒ
//
//EtHOƂăufBOJ[̊evfݒ肵܂B
//
//EF
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//  a       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_FogColor4(r, g, b, a)			(*(vu32 *)REG_FOG_COLOR = (RGB555(r, g, b) | (a)<<ALPHA5_SHIFT))


//----------------------------------------------------------------------
//          tHOItZbgݒ
//
//EtHOZxvZ̊ƂȂfvXlݒ肵܂B
//
//EF
//  offset  tHOJnItZbgl
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_FogOffset(offset)				(*(vu32 *)REG_FOG_OFFSET = (offset))


//----------------------------------------------------------------------
//          tHOe[uݒ
//
//EtHOZxvZŎQƂ32iK̔Zxe[uݒ肵܂B
//
//EF
//  srcp    tHOe[ũ|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void    GX_FogTable(void *srcp);

//----------------------------------------------------------------------
//          tHOe[uvf̐ݒ
//
//EtHOZxvZŎQƂ32iK̔Zxe[ůevfݒ肵܂B
//
//EF
//  idx     vf̃CfbNX
//  param   evf̔Zxi1`4vf̒lj
//  bits    ݒ肷rbg
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_FogTableElement(idx, param, bits)	(((vu##bits *)REG_FOG_TABLE)[idx] = (param))



//----------------------------------------------------------------------
//     gD[i̓nCCgjtOgJ[e[uݒ
//
//EgD[VF[fBOnCCgVF[fBOɂ
//  tOgJ[ƂĎQƂe[uݒ肵܂B
//
//EF
//  srcp    gD[e[ũ|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void    GX_ToonTable(void *srcp);

//----------------------------------------------------------------------
//     gD[i̓nCCgjtOgJ[e[uvf̐ݒ
//
//EgD[VF[fBOnCCgVF[fBOɂ
//  tOgJ[ƂĎQƂe[ůevfݒ肵܂B
//
//EF
//  idx     vf̃CfbNX
//  color   evf̔ZxiRGB555A1`2vf̒lj
//  bits    ݒ肷rbg
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_ToonTableElement(idx, color, bits)	(((vu##bits *)REG_TOON_TABLE)[idx] = (color))



//----------------------------------------------------------------------
//          GbW}[LOJ[ݒ
//
//EGbW}[LOɃGbWJ[ƂĎQƂlݒ肵܂B
//E|SID8PʂœO[vƂ݂Ȃ8̃O[v̂A
//  ǂ̃O[vw肵ăJ[ݒ肵܂B
//
//EF
//  idGrp   IDO[vi8IDPʁA8O[vj
//  color   J[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_EdgeColor2(idGrp, color)			(((vu16 *)REG_EDGE_COLOR)[idGrp] = (color))

//----------------------------------------------------------------------
//          GbW}[LOJ[ݒ
//
//EGbW}[LOɃGbWJ[ƂĎQƂevfݒ肵܂B
//E|SID8PʂœO[vƂ݂Ȃ8̃O[v̂A
//  ǂ̃O[vw肵ăJ[ݒ肵܂B
//
//EF
//  idGrp   IDO[vi8IDPʁA8O[vj
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_EdgeColor4(idGrp, r, g, b)		(((vu16 *)REG_EDGE_COLOR)[idGrp] = RGB555(r, g, b))



//----------------------------------------------------------------------
//          At@eXgQƒl̐ݒ
//
//EAt@eXgɂĎQƂlݒ肵܂B
//
//EF
//  ref    At@Qƒli5bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GX_AlphaTestRef(ref)				(*(vu32 *)REG_ALPHA_TEST_REF = (ref))



//----------------------------------------------------------------------
//          |SXgq`lJE^l̓ǂݍ
//
//E݃|SXgRAMɊi[Ăs|S{|S
//  ̐ǂݍ݂܂B
//
//EF  Ȃ
//
//E߂lFJE^l
//----------------------------------------------------------------------

#define GX_GetListRamCount()				(*(vu16 *)REG_LISTRAM_COUNT)


//----------------------------------------------------------------------
//          _q`lJE^̓ǂݍ
//
//Eݒ_RAMɊi[Ă钸_̐ǂݍ݂܂B
//
//EF  Ȃ
//
//E߂lFJE^l
//----------------------------------------------------------------------

#define GX_GetVtxRamCount()					(*(vu16 *)REG_VTXRAM_COUNT)


//----------------------------------------------------------------------
//          _Oς݃CJE^̓ǂݍ
//
//EO̕`t[ɃJ[obt@ŒችC܂łɂȂ
//  ǂݍ݂܂B
//
//EF  Ȃ
//
//E߂lFJE^l
//----------------------------------------------------------------------

#define GX_GetRenderLinesCount()			(*(vu8 *)REG_RDLINES_COUNT)



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_GX_H
