//======================================================================
//          IrisGXB.h
//            IRISfBXvCXgobt@(Ƀf[^TCM)֐
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_GXB_H
#define _IRIS_GXB_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisMacro.h>
#include <IrisSinTable.h>


//----------------------------------------------------------------------
//          fBXvCXgbot]
//
//EfBXvCXgCPUɂăWIgR}hFIFO֓]܂B
//
//EF
//  startp  fBXvCXgobt@̐擪|C^
//  endp    fBXvCXgobt@̏I|C^
//
//E߂lFȂ
//
//TCM̃fBXvCXgDMA]ł܂B
//----------------------------------------------------------------------

void GXB_CallList(u32 *startp, u32 *endp);


//----------------------------------------------------------------------
//          r[|[gݒ
//
//EBG0ʏɂr[|[g̍WƉEWݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  startX  XWi8bitj
//  startY  YWi V j
//  endX    EXWi V j
//  endY    EYWi V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Viewport(bufp, startX, startY, endX, endY)		\
{															\
	(bufp)[0] = GXOP_VIEWPORT;								\
	(bufp)[1] = (u32 )(startX) << VIEWPORT_START_X_SHIFT	\
			  | (u32 )(startY) << VIEWPORT_START_Y_SHIFT	\
			  | (u32 )(endX)   << VIEWPORT_END_X_SHIFT		\
			  | (u32 )(endY)   << VIEWPORT_END_Y_SHIFT;		\
															\
	(bufp) += (1 + GXOP_VIEWPORT_NPARAMS);					\
}


//======================================================================
//          sR}hQ
//======================================================================

//----------------------------------------------------------------------
//          s񃂁[hݒ
//
//EsR}hő삷Jgsw肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  mode    s񃂁[h
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_MtxMode(bufp, mode)								\
{															\
	(bufp)[0] = GXOP_MTX_MODE;								\
	(bufp)[1] = (mode);										\
															\
	(bufp) += (1 + GXOP_MTX_MODE_NPARAMS);					\
}

//----------------------------------------------------------------------
//          Jgs̃vbV
//
//EJgssX^bN֑ޔ
//  fBXvCXg𐶐܂B
//EsX^bN|C^͂Pi݂܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PushMtx(bufp)									\
{															\
	(bufp)[0] = GXOP_MTX_PUSH;								\
															\
	(bufp) += (1 + GXOP_MTX_PUSH_NPARAMS);					\
}

//----------------------------------------------------------------------
//          Jgs̃|bv
//
//EJgssX^bN畜
//  fBXvCXg𐶐܂B
//EsX^bN|C^͎w肵Έʒuֈړ܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  relPos  Έʒui-30 ` 31j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PopMtx(bufp, relPos)							\
{															\
	(bufp)[0] = GXOP_MTX_POP;								\
	(bufp)[1] = (relPos);									\
															\
	(bufp) += (1 + GXOP_MTX_POP_NPARAMS);					\
}

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒu֊i[
//  fBXvCXg𐶐܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_StoreMtx(bufp, index)							\
{															\
	(bufp)[0] = GXOP_MTX_STORE;								\
	(bufp)[1] = (index);									\
															\
	(bufp) += (1 + GXOP_MTX_STORE_NPARAMS);					\
}

//----------------------------------------------------------------------
//          Jgs̃XgA
//
//EJgssX^bN̎wʒuo
//  fBXvCXg𐶐܂B
//EsX^bN|C^͈ړ܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  index   CfbNXi0 ` 30j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_RestoreMtx(bufp, index)							\
{															\
	(bufp)[0] = GXOP_MTX_RESTORE;							\
	(bufp)[1] = (index);									\
															\
	(bufp) += (1 + GXOP_MTX_RESTORE_NPARAMS);				\
}


//----------------------------------------------------------------------
//          Pʍsւ̏
//
//EJgsPʍsɏ
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Identity(bufp)									\
{															\
	(bufp)[0] = GXOP_MTX_IDENTITY;							\
															\
	(bufp) += (1 + GXOP_MTX_IDENTITY_NPARAMS);				\
}

//----------------------------------------------------------------------
//          sړs̓Kp
//
//EJgsɕsړsZ
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate(bufp, x, y, z)						\
{															\
    (bufp)[0] = GXOP_MTX_TRANS;								\
															\
    (bufp)[1] = (x);										\
    (bufp)[2] = (y);										\
    (bufp)[3] = (z);										\
															\
    (bufp) += (1 + GXOP_MTX_TRANS_NPARAMS);					\
}

// ԃ}NiL̃}N͒ڎgpȂŉj

#define _GXB_TranslateBefore(bufp, x, y, z)					\
{															\
    (bufp)[0] = (x);										\
    (bufp)[1] = (y);										\
    (bufp)[2] = (z);										\
															\
    (bufp) += GXOP_MTX_TRANS_NPARAMS;						\
}


//----------------------------------------------------------------------
//          Jgsւ̃[h
//
//EJgsɎw肵sݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  srcp    [hs̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LoadMtx(bufp, srcp)                             \
{															\
	(bufp)[0] = GXOP_MTX_LOAD_4x3;							\
															\
	(bufp) = _GXB_SetMtx(&(bufp)[1], srcp);					\
}
#define GXB_LoadMtx33(bufp, srcp)                           \
{															\
	(bufp)[0] = GXOP_MTX_LOAD_4x3;							\
															\
	(bufp) = _GXB_SetMtx33(&(bufp)[1], srcp);				\
	*(bufp)++ = 0;											\
	*(bufp)++ = 0;											\
	*(bufp)++ = 0;											\
}
#define GXB_LoadMtx44(bufp, srcp)                           \
{															\
	(bufp)[0] = GXOP_MTX_LOAD_4x4;							\
															\
	(bufp) = _GXB_SetMtx44(&(bufp)[1], srcp);				\
}

u32 *_GXB_SetMtx(  u32 *bufp, const Mtx   *srcp);
u32 *_GXB_SetMtx33(u32 *bufp, const Mtx33 *srcp);
u32 *_GXB_SetMtx44(u32 *bufp, const Mtx44 *srcp);

//----------------------------------------------------------------------
//          ʍsƃJgs̏Z
//
//EJgsɎw肵sZ
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  srcp    Kps̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_MultMtx(bufp, srcp)                             \
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x3;							\
															\
	(bufp) = _GXB_SetMtx(&(bufp)[1], srcp);					\
}
#define GXB_MultMtx33(bufp, srcp)                           \
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_SetMtx33(&(bufp)[1], srcp);				\
}
#define GXB_MultMtx44(bufp, srcp)                           \
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x4;							\
															\
	(bufp) = _GXB_SetMtx44(&(bufp)[1], srcp);				\
}

//----------------------------------------------------------------------
//          sړsKpɈʍsZ
//
//EJgs֕sړsƈʍšsZ
//  fBXvCXg𐶐܂B
//
//EGXB_Translate(){GXB_MultMtx33() WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//  srcp    Kp3x3s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate2MultMtx33(bufp, x, y, z, srcp)		\
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x3;							\
															\
	(bufp) = _GXB_SetMtx33(&(bufp)[1], srcp);				\
    _GXB_TranslateBefore(bufp, x, y, z);					\
}


//----------------------------------------------------------------------
//          ]us̓Kp
//
//EJgsɎw肵s̓]usZ
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  srcp    ]uO̍s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TransposeMtx(bufp, srcp)						\
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x3;							\
															\
	(bufp) = _GXB_TransposeMtx(&(bufp)[1], srcp);			\
}
#define GXB_TransposeMtx33(bufp, srcp)						\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_TransposeMtx33(&(bufp)[1], srcp);			\
}
#define GXB_TransposeMtx44(bufp, srcp)						\
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x4;							\
															\
	(bufp) = _GXB_TransposeMtx44(&(bufp)[1], srcp);			\
}

u32 *_GXB_TransposeMtx(  u32 *bufp, const Mtx   *srcp);
u32 *_GXB_TransposeMtx33(u32 *bufp, const Mtx33 *srcp);
u32 *_GXB_TransposeMtx44(u32 *bufp, const Mtx44 *srcp);

//----------------------------------------------------------------------
//          sړsKpɓ]usKp
//
//EJgs֕sړsƓ]ušsZ
//  fBXvCXg𐶐܂B
//
//EGXB_Translate(){GXB_TransposeMtx33() WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  srcp    ]uO3x3s̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate2TransposeMtx33(bufp, x, y, z, srcp)	\
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x3;							\
															\
	(bufp) = _GXB_TransposeMtx33(&(bufp)[1], srcp);			\
    _GXB_TranslateBefore(bufp, x, y, z);					\
}


//----------------------------------------------------------------------
//          XP[s̓KpiʒuWŝ݁j
//
//EJgsɃXP[sZ
//  fBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇł
//  ʒuWŝ݂ɓKp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Scale(bufp, x, y, z)							\
{															\
    (bufp)[0] = GXOP_MTX_SCALE;								\
															\
    (bufp)[1] = (x) >>VG_SFT_DF;							\
    (bufp)[2] = (y) >>VG_SFT_DF;							\
    (bufp)[3] = (z) >>VG_SFT_DF;							\
															\
    (bufp) += (1 + GXOP_MTX_SCALE_NPARAMS);					\
}

//----------------------------------------------------------------------
//          XP[s̓KpiʒuWs񁕕xNgsj
//
//EJgsɃXP[sZ
//  fBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       X
//  y       Y
//  z       Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_ScaleWithVector(bufp, x, y, z)					\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_ScaleWithVector(&(bufp)[1], x, y, z);		\
}

u32 *_GXB_ScaleWithVector(u32 *bufp, s32 x, s32 y, s32 z);

//----------------------------------------------------------------------
//          sړsKp
//          XP[sKpiʒuWs񁕕xNgsj
//
//EJgs֕sړsƃXP[šsZ
//  fBXvCXg𐶐܂B
//Es񃂁[h PositionEVector ݒ胂[h̏ꍇɂ
//  ʒuWsƕxNgs̗ɓKp܂B
//
//EGXB_Translate(){GXB_ScaleWithVector() WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  xT      sړX
//  yT      sړY
//  zT      sړZ
//  xS      XP[X
//  yS      XP[Y
//  zS      XP[Z
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate2ScaleWithVector(bufp, xT, yT, zT, xS, yS, zS)	\
{																	\
	(bufp)[0] = GXOP_MTX_MULT_4x3;									\
																	\
	(bufp) = _GXB_ScaleWithVector(&(bufp)[1], xS, yS, zS);			\
    _GXB_TranslateBefore(bufp, xT, yT, zT);							\
}


//----------------------------------------------------------------------
//          厲]s̓Kp
//
//EJgsɊe厲ɉ]sZ
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_RotateX(bufp, theta)				GXB_RotatePriv(bufp, X, SIN_NDIV_DEFAULT, theta)
#define GXB_RotateY(bufp, theta)				GXB_RotatePriv(bufp, Y, SIN_NDIV_DEFAULT, theta)
#define GXB_RotateZ(bufp, theta)				GXB_RotatePriv(bufp, Z, SIN_NDIV_DEFAULT, theta)

#define GXB_RotateX256(bufp, theta)				GXB_RotatePriv(bufp, X, 256,  theta)
#define GXB_RotateY256(bufp, theta)				GXB_RotatePriv(bufp, Y, 256,  theta)
#define GXB_RotateZ256(bufp, theta)				GXB_RotatePriv(bufp, Z, 256,  theta)
#define GXB_RotateX1024(bufp, theta)			GXB_RotatePriv(bufp, X, 1024, theta)
#define GXB_RotateY1024(bufp, theta)			GXB_RotatePriv(bufp, Y, 1024, theta)
#define GXB_RotateZ1024(bufp, theta)			GXB_RotatePriv(bufp, Z, 1024, theta)
#define GXB_RotateX4096(bufp, theta)			GXB_RotatePriv(bufp, X, 4096, theta)
#define GXB_RotateY4096(bufp, theta)			GXB_RotatePriv(bufp, Y, 4096, theta)
#define GXB_RotateZ4096(bufp, theta)			GXB_RotatePriv(bufp, Z, 4096, theta)

u32 *_GXB_RotateX256(u32 *bufp, u32 theta);
u32 *_GXB_RotateY256(u32 *bufp, u32 theta);
u32 *_GXB_RotateZ256(u32 *bufp, u32 theta);
u32 *_GXB_RotateX1024(u32 *bufp, u32 theta);
u32 *_GXB_RotateY1024(u32 *bufp, u32 theta);
u32 *_GXB_RotateZ1024(u32 *bufp, u32 theta);
u32 *_GXB_RotateX4096(u32 *bufp, u32 theta);
u32 *_GXB_RotateY4096(u32 *bufp, u32 theta);
u32 *_GXB_RotateZ4096(u32 *bufp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_RotatePriv(bufp, axis, ndiv, theta)				\
		GXB_RotateNDiv(bufp, axis, ndiv, theta)
#define GXB_RotateNDiv(bufp, axis, ndiv, theta)				\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_Rotate##axis##ndiv(&(bufp)[1], theta);	\
}

//----------------------------------------------------------------------
//          sړsKpɎ厲]sKp
//
//EJgs֕sړsƎ厲]šsZ
//  fBXvCXg𐶐܂B
//
//EGXB_Translate(){GXB_Rotate[X|Y|Z][256|1024|4096]() 
//  WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate2RotateX(bufp, x, y, z, theta)			GXB_Translate2RotatePriv(bufp, x, y, z, X, SIN_NDIV_DEFAULT, theta)
#define GXB_Translate2RotateY(bufp, x, y, z, theta)			GXB_Translate2RotatePriv(bufp, x, y, z, Y, SIN_NDIV_DEFAULT, theta)
#define GXB_Translate2RotateZ(bufp, x, y, z, theta)			GXB_Translate2RotatePriv(bufp, x, y, z, Z, SIN_NDIV_DEFAULT, theta)

#define GXB_Translate2RotateX256(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, X, 256,  theta)
#define GXB_Translate2RotateY256(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Y, 256,  theta)
#define GXB_Translate2RotateZ256(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Z, 256,  theta)
#define GXB_Translate2RotateX1024(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, X, 1024, theta)
#define GXB_Translate2RotateY1024(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Y, 1024, theta)
#define GXB_Translate2RotateZ1024(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Z, 1024, theta)
#define GXB_Translate2RotateX4096(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, X, 4096, theta)
#define GXB_Translate2RotateY4096(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Y, 4096, theta)
#define GXB_Translate2RotateZ4096(bufp, x, y, z, theta)		GXB_Translate2RotatePriv(bufp, x, y, z, Z, 4096, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_Translate2RotatePriv(bufp, x, y, z, axis, ndiv, theta)		\
		GXB_Translate2RotateNDiv(bufp, x, y, z, axis, ndiv, theta)
#define GXB_Translate2RotateNDiv(bufp, x, y, z, axis, ndiv, theta)		\
{																		\
	(bufp)[0] = GXOP_MTX_MULT_4x3;										\
																		\
	(bufp) = _GXB_Rotate##axis##ndiv(&(bufp)[1], theta);				\
    _GXB_TranslateBefore(bufp, x, y, z);								\
}

//----------------------------------------------------------------------
//          厲]siOp֐ɂ]pwj̓Kp
//
//EJgsɊe厲ɉ]sZ
//  fBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_RotateXSinCos(bufp, sinA, cosA)					\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_RotateXSinCos(&(bufp)[1], sinA, cosA);	\
}
#define GXB_RotateYSinCos(bufp, sinA, cosA)					\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_RotateYSinCos(&(bufp)[1], sinA, cosA);	\
}
#define GXB_RotateZSinCos(bufp, sinA, cosA)					\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_RotateZSinCos(&(bufp)[1], sinA, cosA);	\
}

u32 *_GXB_RotateXSinCos(u32 *bufp, s32 sinA, s32 cosA);
u32 *_GXB_RotateYSinCos(u32 *bufp, s32 sinA, s32 cosA);
u32 *_GXB_RotateZSinCos(u32 *bufp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          sړsKp
//          厲]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƎ厲]šsZ
//  fBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//EGXB_Translate(){GXB_Rotate[X|Y|Z]SinCos() 
//  WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Translate2RotateXSinCos(bufp, x, y, z, sinA, cosA)		GXB_Translate2RotateSinCosPriv(bufp, x, y, z, X, sinA, cosA)
#define GXB_Translate2RotateYSinCos(bufp, x, y, z, sinA, cosA)		GXB_Translate2RotateSinCosPriv(bufp, x, y, z, Y, sinA, cosA)
#define GXB_Translate2RotateZSinCos(bufp, x, y, z, sinA, cosA)		GXB_Translate2RotateSinCosPriv(bufp, x, y, z, Z, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_Translate2RotateSinCosPriv(bufp, x, y, z, axis, sinA, cosA)		\
		GXB_Translate2RotateSinCosNDiv(bufp, x, y, z, axis, sinA, cosA)
#define GXB_Translate2RotateSinCosNDiv(bufp, x, y, z, axis, sinA, cosA)		\
{																			\
	(bufp)[0] = GXOP_MTX_MULT_4x3;											\
																			\
	(bufp) = _GXB_RotateZSinCos(&(bufp)[1], sinA, cosA);					\
    _GXB_TranslateBefore(bufp, x, y, z);									\
}


//----------------------------------------------------------------------
//          Cӎ]s̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ
//  fBXvCXg𐶐܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_RotateAxis(    bufp, axisp, theta)			GXB_RotateAxisPriv(    bufp, SIN_NDIV_DEFAULT, axisp, theta)
#define GXB_RotateAxisFast(bufp, axisp, theta)			GXB_RotateAxisPrivFast(bufp, SIN_NDIV_DEFAULT, axisp, theta)

#define GXB_RotateAxis256(    bufp, axisp, theta)		GXB_RotateAxisPriv(    bufp, 256,  axisp, theta)
#define GXB_RotateAxis256Fast(bufp, axisp, theta)		GXB_RotateAxisPrivFast(bufp, 256,  axisp, theta)
#define GXB_RotateAxis1024(    bufp, axisp, theta)		GXB_RotateAxisPriv(    bufp, 1024, axisp, theta)
#define GXB_RotateAxis1024Fast(bufp, axisp, theta)		GXB_RotateAxisPrivFast(bufp, 1024, axisp, theta)
#define GXB_RotateAxis4096(    bufp, axisp, theta)		GXB_RotateAxisPriv(    bufp, 4096, axisp, theta)
#define GXB_RotateAxis4096Fast(bufp, axisp, theta)		GXB_RotateAxisPrivFast(bufp, 4096, axisp, theta)

u32 *_GXB_RotateAxis256(    u32 *bufp, const Vec *axisp, u32 theta);
u32 *_GXB_RotateAxis256Fast(u32 *bufp, const Vec *axisp, u32 theta);
u32 *_GXB_RotateAxis1024(    u32 *bufp, const Vec *axisp, u32 theta);
u32 *_GXB_RotateAxis1024Fast(u32 *bufp, const Vec *axisp, u32 theta);
u32 *_GXB_RotateAxis4096(    u32 *bufp, const Vec *axisp, u32 theta);
u32 *_GXB_RotateAxis4096Fast(u32 *bufp, const Vec *axisp, u32 theta);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_RotateAxisPriv(    bufp, ndiv, axisp, theta)			\
		GXB_RotateAxisNDiv(    bufp, ndiv, axisp, theta)
#define GXB_RotateAxisNDiv(    bufp, ndiv, axisp, theta)			\
{																	\
	(bufp)[0] = GXOP_MTX_MULT_3x3;									\
																	\
	(bufp) = _GXB_RotateAxis##ndiv(&(bufp)[1], axisp, theta);		\
}
#define GXB_RotateAxisPrivFast(bufp, ndiv, axisp, theta)			\
		GXB_RotateAxisNDivFast(bufp, ndiv, axisp, theta)
#define GXB_RotateAxisNDivFast(bufp, ndiv, axisp, theta)			\
{																	\
	(bufp)[0] = GXOP_MTX_MULT_3x3;									\
																	\
	(bufp) = _GXB_RotateAxis##ndiv##Fast(&(bufp)[1], axisp, theta);	\
}

//----------------------------------------------------------------------
//          sړsKpɔCӎ]sKp
//
//EJgs֕sړsƔCӎ]šsZ
//  fBXvCXg𐶐܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGXB_Translate(){GXB_RotateAxis[256|1024|4096][Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Translate2RotateAxis(    bufp, x, y, z, axisp, theta)		GXB_Translate2RotateAxisPriv(    bufp, x, y, z, SIN_NDIV_DEFAULT, axisp, theta)
#define GXB_Translate2RotateAxisFast(bufp, x, y, z, axisp, theta)		GXB_Translate2RotateAxisPrivFast(bufp, x, y, z, SIN_NDIV_DEFAULT, axisp, theta)

#define GXB_Translate2RotateAxis256(    bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPriv(    bufp, x, y, z, 256,  axisp, theta)
#define GXB_Translate2RotateAxis256Fast(bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPrivFast(bufp, x, y, z, 256,  axisp, theta)
#define GXB_Translate2RotateAxis1024(    bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPriv(    bufp, x, y, z, 1024, axisp, theta)
#define GXB_Translate2RotateAxis1024Fast(bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPrivFast(bufp, x, y, z, 1024, axisp, theta)
#define GXB_Translate2RotateAxis4096(    bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPriv(    bufp, x, y, z, 4096, axisp, theta)
#define GXB_Translate2RotateAxis4096Fast(bufp, x, y, z, axisp, theta)	GXB_Translate2RotateAxisPrivFast(bufp, x, y, z, 4096, axisp, theta)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_Translate2RotateAxisPriv(    bufp, x, y, z, ndiv, axisp, theta)	\
		GXB_Translate2RotateAxisNDiv(    bufp, x, y, z, ndiv, axisp, theta)
#define GXB_Translate2RotateAxisNDiv(    bufp, x, y, z, ndiv, axisp, theta)	\
{																			\
	(bufp)[0] = GXOP_MTX_MULT_4x3;											\
																			\
	(bufp) = _GXB_RotateAxis##ndiv(&(bufp)[1], axisp, theta);				\
    _GXB_TranslateBefore(bufp, x, y, z);									\
}
#define GXB_Translate2RotateAxisPrivFast(bufp, x, y, z, ndiv, axisp, theta)	\
		GXB_Translate2RotateAxisNDivFast(bufp, x, y, z, ndiv, axisp, theta)
#define GXB_Translate2RotateAxisNDivFast(bufp, x, y, z, ndiv, axisp, theta)	\
{																			\
	(bufp)[0] = GXOP_MTX_MULT_4x3;											\
																			\
	(bufp) = _GXB_RotateAxis##ndiv##Fast(&(bufp)[1], axisp, theta);			\
    _GXB_TranslateBefore(bufp, x, y, z);									\
}


//----------------------------------------------------------------------
//          Cӎ]siOp֐ɂ]pwj̓Kp
//
//EJgsɔCӂ̃xNgƂĉ]sZ
//  fBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_RotateAxisSinCos(bufp, axisp, sinA, cosA)					\
{																		\
	(bufp)[0] = GXOP_MTX_MULT_3x3;										\
																		\
	(bufp) = _GXB_RotateAxisSinCos(&(bufp)[1], axisp, sinA, cosA);		\
}
#define GXB_RotateAxisSinCosFast(bufp, axisp, sinA, cosA)				\
{																		\
	(bufp)[0] = GXOP_MTX_MULT_3x3;										\
																		\
	(bufp) = _GXB_RotateAxisSinCosFast(&(bufp)[1], axisp, sinA, cosA);	\
}

u32 *_GXB_RotateAxisSinCos(u32 *bufp, const Vec *axisp, s32 sinA, s32 cosA);
u32 *_GXB_RotateAxisSinCosFast(u32 *bufp, const Vec *axisp, s32 sinA, s32 cosA);

//----------------------------------------------------------------------
//          sړsKp
//          Cӎ]siOp֐ɂ]pwjKp
//
//EJgs֕sړsƔCӎ]šsZ
//  fBXvCXg𐶐܂B
//E]px̓TCƃRTCɂĎw肵܂B
//
//Eʏł͊֐ŕZƏZgp܂Ał͎gp܂
//  iłɂ͒PʃxNgnĉjB
//EGXB_Translate(){GXB_RotateAxisSinCos[Fast]() 
//  WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       sړX
//  y       sړY
//  z       sړZ
//  axisp   ]xNg̃|C^
//  sinA    ]px̃TC
//  cosA    ]px̃RTC
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Translate2RotateAxisSinCos(    bufp, x, y, z, axisp, sinA, cosA)		GXB_Translate2RotateAxisSinCosPriv(    bufp, x, y, z, axisp, sinA, cosA)
#define GXB_Translate2RotateAxisSinCosFast(bufp, x, y, z, axisp, sinA, cosA)		GXB_Translate2RotateAxisSinCosPrivFast(bufp, x, y, z, axisp, sinA, cosA)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_Translate2RotateAxisSinCosPriv(    bufp, x, y, z, axisp, sinA, cosA)	\
		GXB_Translate2RotateAxisSinCosNDiv(    bufp, x, y, z, axisp, sinA, cosA)
#define GXB_Translate2RotateAxisSinCosNDiv(    bufp, x, y, z, axisp, sinA, cosA)	\
{																					\
	(bufp)[0] = GXOP_MTX_MULT_4x3;													\
																					\
	(bufp) = _GXB_RotateAxisSinCos(&(bufp)[1], axisp, sinA, cosA);					\
    _GXB_TranslateBefore(bufp, x, y, z);											\
}
#define GXB_Translate2RotateAxisSinCosPrivFast(bufp, x, y, z, axisp, sinA, cosA)	\
		GXB_Translate2RotateAxisSinCosNDivFast(bufp, x, y, z, axisp, sinA, cosA)
#define GXB_Translate2RotateAxisSinCosNDivFast(bufp, x, y, z, axisp, sinA, cosA)	\
{																					\
	(bufp)[0] = GXOP_MTX_MULT_4x3;													\
																					\
	(bufp) = _GXB_RotateAxisSinCosFast(&(bufp)[1], axisp, sinA, cosA);				\
    _GXB_TranslateBefore(bufp, x, y, z);											\
}


//----------------------------------------------------------------------
//          yɃACg]s̓Kp
//
//EJgsɔCӎZ̐ƈv]ssZ
//  fBXvCXg𐶐܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//
//EF
//  bufp       fBXvCXgobt@̃|C^
//  vLookInvp  Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_AlignZ(bufp, vLookInvp)							\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_AlignZ(&(bufp)[1], vLookInvp);			\
}

u32 *_GXB_AlignZ(u32 *bufp, const Vec *vLookInvp);

//----------------------------------------------------------------------
//          sړsKp
//          yɃACg]sKp
//
//EJgs֕sړsƔCӎZ̐ƈv]ss
//  Ƃ̌sZAfBXvCXg𐶐܂B
//
// H = sqrt (X*X + Z*Z)
//
//            [ 1            ]  [ Z/H    -X/H ]                [   Z/H      -X/H ]
// [   v   ]  [    H/1  -Y/1 ]  [      1      ]  =  [   v   ]  [ -YX/H  H  -YZ/H ]
//            [    Y/1   H/1 ]  [ X/H     Z/H ]                [   X    Y    Z   ]
//
//E֐ŕZƏZgp܂B
//EGXB_Translate(){GXB_AlignZ() WIgGWׂ̕点܂B
//
//EF
//  bufp       fBXvCXgobt@̃|C^
//  x           sړX
//  y           sړY
//  z           sړZ
//  vLookInvp   Ƌt̒PʃxNgi*_LookAt*() œ܂j
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Translate2AlignZ(bufp, x, y, z, vLookInvp)		\
{															\
	(bufp)[0] = GXOP_MTX_MULT_4x3;							\
															\
	(bufp) = _GXB_AlignZ(&(bufp)[1], vLookInvp);			\
    _GXB_TranslateBefore(bufp, x, y, z);					\
}


//----------------------------------------------------------------------
//          NH[^jIϊ]s̓Kp
//
//EJgsփNH[^jIϊ]sKp
//  fBXvCXg𐶐܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//ʏł͏Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_QuatMtx(bufp, quatp)							\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_QuatMtx(&(bufp)[1], quatp);				\
}
#define GXB_QuatMtxFast(bufp, quatp)						\
{															\
	(bufp)[0] = GXOP_MTX_MULT_3x3;							\
															\
	(bufp) = _GXB_QuatMtxFast(&(bufp)[1], quatp);			\
}

u32 *_GXB_QuatMtx(u32 *bufp, const Quat *quatp);
u32 *_GXB_QuatMtxFast(u32 *bufp, const Quat *quatp);

//----------------------------------------------------------------------
//          sړsKp
//          NH[^jIϊ]sKp
//
//EJgs֕sړsƃNH[^jIϊ]s
//  ̌sZAfBXvCXg𐶐܂B
//
//Eʏł͏Zgp܂Ał͎gp܂
//  iłɂ͐KNH[^jInĉjB
//EGXB_Translate(){GXB_QuatMtx[Fast]() WIgGWׂ̕点܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  quatp   NH[^jĨ|C^
//
//E߂lFȂ
//
//ʏł͏Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Translate2QuatMtx(    bufp, x, y, z, quatp)			GXB_Translate2QuatMtxPriv(    bufp, x, y, z, quatp)
#define GXB_Translate2QuatMtxFast(bufp, x, y, z, quatp)			GXB_Translate2QuatMtxPrivFast(bufp, x, y, z, quatp)

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_Translate2QuatMtxPriv(    bufp, x, y, z, quatp)		\
		GXB_Translate2QuatMtxNDiv(    bufp, x, y, z, quatp)
#define GXB_Translate2QuatMtxNDiv(    bufp, x, y, z, quatp)		\
{																\
	(bufp)[0] = GXOP_MTX_MULT_4x3;								\
																\
	(bufp) = _GXB_QuatMtx(&(bufp)[1], quatp);					\
    _GXB_TranslateBefore(bufp, x, y, z);						\
}
#define GXB_Translate2QuatMtxPrivFast(bufp, x, y, z, quatp)		\
		GXB_Translate2QuatMtxNDivFast(bufp, x, y, z, quatp)
#define GXB_Translate2QuatMtxNDivFast(bufp, x, y, z, quatp)		\
{																\
	(bufp)[0] = GXOP_MTX_MULT_4x3;								\
																\
	(bufp) = _GXB_QuatMtxFast(&(bufp)[1], quatp);				\
    _GXB_TranslateBefore(bufp, x, y, z);						\
}


//----------------------------------------------------------------------
//          EΏ̂̓ˉes̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z
//  fBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  opp     fBXvCXgobt@̃R}ḧ̃|C^
//  prmp    fBXvCXgobt@̃p[^̈̃|C^
//  fovy    c̎pxm256b1024b4096iKn
//  aspect  ̎m肷ciEł /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Perspective(bufp, fovy, aspect, near, far, scaleW)			GXB_PerspectivePriv(SIN_NDIV_DEFAULT, bufp, fovy, aspect, near, far, scaleW)

#define GXB_Perspective256( bufp, fovy, aspect, near, far, scaleW)		GXB_PerspectivePriv(256,  bufp, fovy, aspect, near, far, scaleW)
#define GXB_Perspective1024(bufp, fovy, aspect, near, far, scaleW)		GXB_PerspectivePriv(1024, bufp, fovy, aspect, near, far, scaleW)
#define GXB_Perspective4096(bufp, fovy, aspect, near, far, scaleW)		GXB_PerspectivePriv(4096, bufp, fovy, aspect, near, far, scaleW)

u32 *_GXB_Perspective256(u32 *bufp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
u32 *_GXB_Perspective1024(u32 *bufp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);
u32 *_GXB_Perspective4096(u32 *bufp, u32 fovy, s32 aspect, s32 near, s32 far, s32 scaleW);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define GXB_PerspectivePriv(ndiv, bufp, fovy, aspect, near, far, scaleW)			\
		GXB_PerspectiveNDiv(ndiv, bufp, fovy, aspect, near, far, scaleW)
#define GXB_PerspectiveNDiv(ndiv, bufp, fovy, aspect, near, far, scaleW)			\
{																					\
	(bufp)[0] = GXOP_MTX_MULT_4x4;													\
																					\
	(bufp) = _GXB_Perspective##ndiv(&(bufp)[1], fovy, aspect, near, far, scaleW);	\
}

//----------------------------------------------------------------------
//          EΏ̂̓ˉesiOp֐ɂ鎋pwj̓Kp
//
//EEΏ̂̓@̍s쐬AJgs֏Z
//  fBXvCXg𐶐܂B
//Epx̓TCƃRTCɂĎw肵܂B
//
//E֐ŏZgp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  sinA    c̎px̃TC
//  cosA    c̎px̃RTCiʊ֐̌ĂяôߍŌɓnj
//  aspect  ̎m肷ci /j 
//  near    _nearNbvʂ܂ł̋iɐj
//  far     _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_PerspectiveSinCos(bufp, sinA, fovy, aspect, near, far, scaleW, cosA)				\
{																								\
	(bufp)[0] = GXOP_MTX_MULT_4x4;																\
																								\
	(bufp) = _GXB_PerspectiveSinCos(&(bufp)[1], sinA, fovy, aspect, near, far, scaleW, cosA);	\
}

u32 *_GXB_PerspectiveSinCos(u32 *bufp, s32 sinA, s32 aspect, s32 near, s32 far, s32 scaleW, s32 cosA);

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//E@̍s쐬AJgs֏Z
//  fBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iɐj
//  f       _farNbvʂ܂ł̋ iɐj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Frustum(bufp, t, b, l, r, n, f, scaleW)					\
{																	\
	(bufp)[0] = GXOP_MTX_MULT_4x4;									\
																	\
	(bufp) = _GXB_Frustum(&(bufp)[1], t, b, l, r, n, f, scaleW);	\
}

u32 *_GXB_Frustum(u32 *bufp, s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);

//----------------------------------------------------------------------
//          ˉes̓Kp
//
//Eˉe̕s̐ς̍s쐬AJgs֏Z
//  fBXvCXg𐶐܂B
//
//E֐ŏZgp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  t       nearNbvʏӂyW
//  b       nearNbvʉӂyW
//  l       nearNbvʍӂxW 
//  r       nearNbvʉEӂxW 
//  n       _nearNbvʂ܂ł̋iǂłj
//  f       _farNbvʂ܂ł̋ iǂłj
//  scaleW  NbvWWl̃XP[p[^iWϊ̐xj
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Ortho(bufp, t, b, l, r, n, f, scaleW)					\
{																	\
	(bufp)[0] = GXOP_MTX_MULT_4x4;									\
																	\
	(bufp) = _GXB_Ortho(&(bufp)[1], t, b, l, r, n, f, scaleW);		\
}

u32 *_GXB_Ortho(u32 *bufp, s32 t, s32 b, s32 l, s32 r, s32 n, s32 f, s32 scaleW);

//----------------------------------------------------------------------
//          Es̓Kp
//
//EEs쐬AJgs֏Z
//  fBXvCXg𐶐܂B
//
//E֐ŃxNg̐K̂߂ɕZƏZgp܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  eye     _
//  at      _
//  vUp     xNg
//  vDst    0iNULL|C^jȊOnƁAtxNgԂ܂
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_LookAt(    bufp, eye, at, vUp, vDst)						\
{																		\
	(bufp)[0] = GXOP_MTX_MULT_4x3;										\
																		\
	(bufp) = _GXB_LookAt(&(bufp)[1], eye, at, vUp, vDst);				\
}
#define GXB_LookAtFast(bufp, eye, at, vUp, vDst)						\
{																		\
	(bufp)[0] = GXOP_MTX_MULT_4x3;										\
																		\
	(bufp) = _GXB_LookAtFast(&(bufp)[1], eye, at, vUp, vDst);			\
}

u32 *_GXB_LookAt(    u32 *bufp, const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);
u32 *_GXB_LookAtFast(u32 *bufp, const Pos *eye, const Pos *at, const Vec *vUp, Vec *vDst);


//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂̍\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  box     eXg{bNXiXYZWHD161616161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_BoxTest1(bufp, box)								\
{															\
	(bufp)[0] = GXOP_BOX_TEST;								\
	*(TestBox *)&(bufp)[1] = (box);							\
															\
	(bufp) += (1 + GXOP_BOX_TEST_NPARAMS);					\
}

//----------------------------------------------------------------------
//          {bNXeXg
//
//Ê̐ςɓ邩ǂeXg߂Ɋep[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       eXg{bNXXWi16bitj
//  y       eXg{bNXYWi V  j
//  z       eXg{bNXZWi V  j
//  w       eXg{bNX       i V  j
//  h       eXg{bNX     i V  j
//  d       eXg{bNXs   i V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_BoxTest6(bufp, x, y, z, w, h, d)				\
{															\
	(bufp)[0] = GXOP_BOX_TEST;								\
	(bufp)[1] = XY1616(x, y);								\
	(bufp)[2] = ZW1616(z, w);								\
	(bufp)[3] = HD1616(h, d);								\
															\
	(bufp) += (1 + GXOP_BOX_TEST_NPARAMS);					\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̍\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PositionTest1(bufp, pos)						\
{															\
	(bufp)[0] = GXOP_POS_TEST;								\
	*(Pos16 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_POS_TEST_NPARAMS);					\
}

//----------------------------------------------------------------------
//          ʒuWeXg
//
//EeXgp̈ʒuW̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PositionTest3(bufp, x, y, z)					\
{															\
	(bufp)[0] = GXOP_POS_TEST;								\
	(bufp)[1] = XY1616(x, y);								\
	(bufp)[2] = (z);										\
															\
	(bufp) += (1 + GXOP_POS_TEST_NPARAMS);					\
}

//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VectorTest1(bufp, vector)						\
{															\
	(bufp)[0] = GXOP_VEC_TEST;								\
	*(Vec10 *)&(bufp)[1] = (vector);						\
															\
	(bufp) += (1 + GXOP_VEC_TEST_NPARAMS);					\
}

//----------------------------------------------------------------------
//          xNgeXg
//
//EeXgp̕xNg̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VectorTest3(bufp, x, y, z)						\
{															\
	(bufp)[0] = GXOP_VEC_TEST;								\
	(bufp)[1] = XYZ101010(x, y, z);							\
															\
	(bufp) += (1 + GXOP_VEC_TEST_NPARAMS);					\
}


//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgxNg\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  lightVector CgxNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightVector1(bufp, lightVector)					\
{															\
	(bufp)[0] = GXOP_LIGHT_VECTOR;							\
	*(LightVector *)&(bufp)[1] = (lightVector);				\
															\
	(bufp) += (1 + GXOP_LIGHT_VECTOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgJ[\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  lightColor  CgJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightColor1(bufp, lightColor)					\
{															\
	(bufp)[0] = GXOP_LIGHT_COLOR;							\
	*(LightColor *)&(bufp)[1] = (lightColor);				\
															\
	(bufp) += (1 + GXOP_LIGHT_COLOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNgݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  no      Cgԍ
//  vector  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightVector2(bufp, no, vector)					\
{															\
	(bufp)[0] = GXOP_LIGHT_VECTOR;							\
	(bufp)[1] = ((no)<<LIGHT_ID_SHIFT | *(u32 *)&(vector));	\
															\
	(bufp) += (1 + GXOP_LIGHT_VECTOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  no      Cgԍ
//  color   J[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightColor2(bufp, no, color)					\
{															\
	(bufp)[0] = GXOP_LIGHT_COLOR;							\
	(bufp)[1] = ((no)<<LIGHT_ID_SHIFT | *(u16 *)&(color));	\
															\
	(bufp) += (1 + GXOP_LIGHT_COLOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          CgxNgݒ
//
//ECgxNgփCgԍƕxNg̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  no      Cgԍ
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightVector4(bufp, no, x, y, z)					\
{															\
	(bufp)[0] = GXOP_LIGHT_VECTOR;							\
	(bufp)[1] = LIGHT_VECTOR(no, x, y, z);					\
															\
	(bufp) += (1 + GXOP_LIGHT_VECTOR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          CgJ[ݒ
//
//ECgJ[փCgԍƃJ[̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  no      Cgԍ
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_LightColor4(bufp, no, r, g, b)					\
{															\
	(bufp)[0] = GXOP_LIGHT_COLOR;							\
	(bufp)[1] = LIGHT_COLOR(no, r, g, b);					\
															\
	(bufp) += (1 + GXOP_LIGHT_COLOR_NPARAMS);				\
}


//----------------------------------------------------------------------
//          ʔˋPxe[u̐ݒ
//
//E8bit128vfȂ鋾ʔˋPxe[uݒ肷
//  fBXvCXg𐶐܂B
//ESvf܂Ƃ߂ē]Kv܂B
//Ẽe[u邱ƂɂāA1V[ɕ
//  ʔˌʂ|S\邱Ƃł܂BB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  srcp    ʔˋPxe[ũ|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_ShininessTable(bufp, srcp)						\
{															\
	(bufp)[0] = GXOP_SHININESS;								\
															\
	(bufp) = _GXB_ShininessTable(bufp, srcp);				\
}

u32 *_GXB_ShininessTable(u32 *bufp, void *srcp);


//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//ES}eAJ[Ɗ֘AtO܂Ƃ߂64bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  colors  S}eAJ[f[^iRGB555 | _J[XVtOAʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_MaterialColor1(bufp, colors)					\
{	GXB_DiffuseAmbient1(  bufp, ((u32 *)&(colors))[0]);		\
	GXB_SpecularEmission1(bufp, ((u32 *)&(colors))[1]);		\
}

//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[ƂɊ֘AtOݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_MaterialColor4(bufp, dif, amb, spe, emi)		\
{	GXB_DiffuseAmbient2(  bufp, dif, amb);					\
	GXB_SpecularEmission2(bufp, spe, emi);					\
}

//----------------------------------------------------------------------
//          S}eAJ[ݒ
//
//Ee}eAJ[̊evfƊ֘AtOݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  setCol  _J[XVtO
//  tbl     ʔˋPxe[uLtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//  sr      XyLJ[  Ԑi V j
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_MaterialColor14(bufp, setCol, tbl, dr, dg, db, ar, ag, ab, sr, sg, sb, er, eg, eb)	\
{	GXB_DiffuseAmbient7(bufp, setCol, dr, dg, db, ar, ag, ab);	\
	GXB_SpecularEmission7(bufp, tbl, sr, sg, sb, er, eg, eb);	\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  colors  fBt[YArGgJ[iRGB555 | _J[XVtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_DiffuseAmbient1(bufp, colors)					\
{															\
	(bufp)[0] = GXOP_DIF_AMB;								\
	(bufp)[1] = (colors);									\
															\
	(bufp) += (1 + GXOP_DIF_AMB_NPARAMS);					\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  colors  XyLG~bVJ[iRGB555 | ʔˋPxe[uLtO܂ށj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_SpecularEmission1(bufp, colors)					\
{															\
	(bufp)[0] = GXOP_SPE_EMI;								\
	(bufp)[1] = (colors);									\
															\
	(bufp) += (1 + GXOP_SPE_EMI_NPARAMS);					\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  dif     fBt[YJ[iRGB555 | _J[XVtO܂ށj
//  amb     ArGgJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_DiffuseAmbient2(bufp, dif, amb)					\
{															\
	(bufp)[0] = GXOP_DIF_AMB;								\
	(bufp)[1] = (*(u16 *)&(dif) | (*(u16 *)&(amb))<<16);	\
															\
	(bufp) += (1 + GXOP_DIF_AMB_NPARAMS);					\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  spe     XyLJ[  iRGB555 | ʔˋPxe[uLtO܂ށj
//  emi     G~bVJ[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_SpecularEmission2(bufp, spe, emi)				\
{															\
	(bufp)[0] = GXOP_SPE_EMI;								\
	(bufp)[1] = (*(u16 *)&(spe) | (*(u16 *)&(emi))<<16);	\
															\
	(bufp) += (1 + GXOP_SPE_EMI_NPARAMS);					\
}

//----------------------------------------------------------------------
//          fBt[YArGgJ[ݒ
//
//EfBt[YJ[ƃArGgJ[̊evf
//  _J[XVtOݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  setCol  _J[XVtO
//  dr      fBt[YJ[Ԑi5bitj
//  dg                        ΐi V j
//  db                        i V j
//  ar      ArGgJ[Ԑi V j
//  ag                        ΐi V j
//  ab                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_DiffuseAmbient7(bufp, setCol, dr, dg, db, ar, ag, ab)	\
{															\
	(bufp)[0] = GXOP_DIF_AMB;								\
	(bufp)[1] = ((setCol) | RGB555(dr, dg, db)				\
						  | RGB555(ar, ag, ab)<<16);		\
															\
	(bufp) += (1 + GXOP_DIF_AMB_NPARAMS);					\
}

//----------------------------------------------------------------------
//          XyLG~bVJ[ݒ
//
//EXyLJ[ƃG~bVJ[̊evf
//  ʔˋPxe[uLtOݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  tbl     ʔˋPxe[uLtO
//  sr      XyLJ[  Ԑi5bitj
//  sg                        ΐi V j
//  sb                        i V j
//  er      G~bVJ[Ԑi V j
//  eg                        ΐi V j
//  eb                        i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_SpecularEmission7(bufp, tbl, sr, sg, sb, er, eg, eb)	\
{															\
	(bufp)[0] = GXOP_SPE_EMI;								\
	(bufp)[1] = ((tbl) | RGB555(sr, sg, sb)					\
					   | RGB555(er, eg, eb)<<16);			\
															\
	(bufp) += (1 + GXOP_SPE_EMI_NPARAMS);					\
}


//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|S܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  attr    |S
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PolygonAttr1(bufp, attr)						\
{															\
	(bufp)[0] = GXOP_POLYGON_ATTR;							\
	(bufp)[1] = (attr);										\
															\
	(bufp) += (1 + GXOP_POLYGON_ATTR_NPARAMS);				\
}

//----------------------------------------------------------------------
//          |S̐ݒ
//
//E|SIDƃAt@lƑ̑ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  id      ID        i6bitj
//  alpha   At@li5bitj
//  attr    ̃|S
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_PolygonAttr3(bufp, id, alpha, attr)				\
{															\
	(bufp)[0] = GXOP_POLYGON_ATTR;							\
	(bufp)[1] = (id)   <<POLYATTR_ID_SHIFT					\
			   | (alpha)<<POLYATTR_ALPHA_SHIFT				\
			   | (attr);									\
															\
	(bufp) += (1 + GXOP_POLYGON_ATTR_NPARAMS);				\
}


//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgj
//
//EeNX`B[W̃p[^܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//EeNX`C[Wx[Xl̓VtglnĉB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  param   eNX`C[Wp[^i32bitj
//
//EeNX`C[Wx[X̓VtglnĉB
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexImageParam1(bufp, param)						\
{															\
	(bufp)[0] = GXOP_TEXIMAGE_PARAM;						\
	(bufp)[1] = (param);									\
															\
	(bufp) += (1 + GXOP_TEXIMAGE_PARAM_NPARAMS);			\
}

//----------------------------------------------------------------------
//          eNX`C[Wp[^ݒiVtgLj
//
//EeNX`B[W̃p[^ݒ肷
//  fBXvCXg𐶐܂B
//EeNX`C[Wx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  basep   eNX`C[Wx[X̃|C^
//  param   eNX`C[Wp[^i16bitj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexImageParam2(bufp, basep, param)				\
{															\
	(bufp)[0] = GXOP_TEXIMAGE_PARAM;						\
	(bufp)[1] = Addr2TexImageBase(basep) | (param);			\
															\
	(bufp) += (1 + GXOP_TEXIMAGE_PARAM_NPARAMS);			\
}

//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgj
//
//EeNX`pbgx[X̃p[^܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//EeNX`pbgx[Xl̓VtglnĉB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  base    eNX`pbgx[X
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexPlttBase1(bufp, base)						\
{															\
	(bufp)[0] = GXOP_TEXPLTT_BASE;							\
	(bufp)[1] = (u32 )(base);								\
															\
	(bufp) += (1 + GXOP_TEXPLTT_BASE_NPARAMS);				\
}

//----------------------------------------------------------------------
//          eNX`pbgx[XݒiVtgLj
//
//EeNX`pbgx[X̃p[^ݒ肷
//  fBXvCXg𐶐܂B
//EeNX`pbgx[Xl̃Vtgs܂̂ŁA
//  AhX̂܂ܓnĉB
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  basep   eNX`pbgx[X̃|C^
//  mode    eNX`[h
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexPlttBase2(bufp, basep, mode)					\
{															\
	(bufp)[0] = GXOP_TEXPLTT_BASE;							\
	(bufp)[1] = Addr2TexPlttBase(basep, mode);				\
															\
	(bufp) += (1 + GXOP_TEXPLTT_BASE_NPARAMS);				\
}


//----------------------------------------------------------------------
//          v~eBu̒_XgJn
//
//Ev~eBu̒_Xg̊Jn錾
//  fBXvCXg𐶐܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  primType    v~eBu^Cv
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Begin(bufp, primType)							\
{															\
	(bufp)[0] = GXOP_BEGIN;									\
	(bufp)[1] = (primType);									\
															\
	(bufp) += (1 + GXOP_BEGIN_NPARAMS);						\
}

//----------------------------------------------------------------------
//          v~eBu̒_XgI
//
//Ev~eBu̒_Xg̏I錾
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_End(bufp)										\
{															\
	(bufp)[0] = GXOP_END;									\
															\
	(bufp) += (1 + GXOP_END_NPARAMS);						\
}

//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[𒼐ڐݒ肷AfBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  color   J[iRGB555j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Color1(bufp, color)								\
{															\
	(bufp)[0] = GXOP_COLOR;									\
	(bufp)[1] = *(u16 *)&(color);							\
															\
	(bufp) += (1 + GXOP_COLOR_NPARAMS);						\
}

//----------------------------------------------------------------------
//          _J[̒ڐݒ
//
//E_J[̊evf𒼐ڐݒ肷AfBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  r       Ԑi5bitj
//  g       ΐi V j
//  b       i V j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Color3(bufp, r, g, b)							\
{															\
	(bufp)[0] = GXOP_COLOR;									\
	(bufp)[1] = RGB555(r, g, b);							\
															\
	(bufp) += (1 + GXOP_COLOR_NPARAMS);						\
}

//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNg\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  normal  xNgiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Normal1(bufp, normal)							\
{															\
	(bufp)[0] = GXOP_NORMAL;								\
	*(Vec10 *)&(bufp)[1] = (normal);						\
															\
	(bufp) += (1 + GXOP_NORMAL_NPARAMS);					\
}

//----------------------------------------------------------------------
//          @xNg
//
//E@xNg10bitxNgtH[}bg̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       xNgXi10bitj
//  y                   Yi V  j
//  z                   Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Normal3(bufp, x, y, z)							\
{															\
	(bufp)[0] = GXOP_NORMAL;								\
	(bufp)[1] = XYZ101010(x, y, z);							\
															\
	(bufp) += (1 + GXOP_NORMAL_NPARAMS);					\
}

//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`WփeNX`W\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  coord   eNX`WiST1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexCoord1(bufp, coord)							\
{															\
	(bufp)[0] = GXOP_TEXCOORD;								\
	*(TexCoord *)&(bufp)[1] = (coord);						\
															\
	(bufp) += (1 + GXOP_TEXCOORD_NPARAMS);					\
}

//----------------------------------------------------------------------
//          eNX`W
//
//EeNX`W֊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  s       eNX`WSi16bitj
//  t                     Ti V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_TexCoord2(bufp, s,t)							\
{															\
	(bufp)[0] = GXOP_TEXCOORD;								\
	(bufp)[1] = ST1616(s, t);								\
															\
	(bufp) += (1 + GXOP_TEXCOORD_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiXYZ161616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Vertex1(bufp, pos)								\
{															\
	(bufp)[0] = GXOP_VTX_16;								\
	*(Pos16 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_VTX_16_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W16bittH[}bg̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_Vertex3(bufp, x, y, z)							\
{															\
	(bufp)[0] = GXOP_VTX_16;								\
	(bufp)[1] = XY1616(x, y);								\
	(bufp)[2] = (z);										\
															\
	(bufp) += (1 + GXOP_VTX_16_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg\̂ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexShort1(bufp, pos)							\
{															\
	(bufp)[0] = GXOP_VTX_10;								\
	*(Pos10 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_VTX_10_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _Wi10bitj̐ݒƒ_̐
//
//E_W10bittH[}bg̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexShort3(bufp, x, y, z)						\
{															\
	(bufp)[0] = GXOP_VTX_10;								\
	(bufp)[1] = XYZ101010(x, y, z);							\
															\
	(bufp) += (1 + GXOP_VTX_10_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYW܂Ƃ߂32bitf[^ݒiZW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiXY1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexXY1(bufp, pos)							\
{															\
	(bufp)[0] = GXOP_VTX_XY;								\
	*(Pos2D16 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_VTX_XY_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _XYW̐ݒƒ_̐
//
//E_XWYWݒiZW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi16bitj
//  y               Yi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexXY2(bufp, x, y)							\
{															\
	(bufp)[0] = GXOP_VTX_XY;								\
	(bufp)[1] = XY1616(x, y);								\
															\
	(bufp) += (1 + GXOP_VTX_XY_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZW܂Ƃ߂32bitf[^ݒiYW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiXZ1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexXZ1(bufp, pos)							\
{															\
	(bufp)[0] = GXOP_VTX_XZ;								\
	*(Pos2D16 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_VTX_XZ_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _XZW̐ݒƒ_̐
//
//E_XWZWݒiYW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexXZ2(bufp, x, z)							\
{															\
	(bufp)[0] = GXOP_VTX_XZ;								\
	(bufp)[1] = XY1616(x, z);								\
															\
	(bufp) += (1 + GXOP_VTX_XZ_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZW܂Ƃ߂32bitf[^ݒiXW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  pos     ʒuWiYZ1616j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexYZ1(bufp, pos)							\
{															\
	(bufp)[0] = GXOP_VTX_YZ;								\
	*(Pos2D16 *)&(bufp)[1] = (pos);							\
															\
	(bufp) += (1 + GXOP_VTX_YZ_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _YZW̐ݒƒ_̐
//
//E_YWZWݒiXW͍Ō̐ݒlgpj
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  y       ʒuWYi16bitj
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexYZ2(bufp, y, z)							\
{															\
	(bufp)[0] = GXOP_VTX_YZ;								\
	(bufp)[1] = XY1616(y, z);								\
															\
	(bufp) += (1 + GXOP_VTX_YZ_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l܂Ƃ߂32bitf[^ݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  diff    ʒuWiXYZ101010j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexDiff1(bufp, diff)							\
{															\
	(bufp)[0] = GXOP_VTX_DIFF;								\
	*(Pos10 *)&(bufp)[1] = (diff);							\
															\
	(bufp) += (1 + GXOP_VTX_DIFF_NPARAMS);					\
}

//----------------------------------------------------------------------
//          _W̐ݒƒ_̐
//
//E_W̍l̊evfݒ肷
//  fBXvCXg𐶐܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  x       ʒuWXi10bitj
//  y               Yi V  j
//  z               Zi V  j
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_VertexDiff3(bufp, x, y, z)						\
{															\
	(bufp)[0] = GXOP_VTX_DIFF;								\
	(bufp)[1] = XYZ101010(x, y, z);							\
															\
	(bufp) += (1 + GXOP_VTX_DIFF_NPARAMS);					\
}


//----------------------------------------------------------------------
//          _OGWQƃf[^Q̃Xbv
//
//ẼR}h𔭍sVuNԊJnɁA
//  |SXgRAMA_RAMA_O֘AWX^A
//  _OGWQƂf[^؂ւ
//  fBXvCXg𐶐܂B
//E񂾃OtBbNXf[^`֔f̂
//  ̃R}h𔭍s̃t[ɂȂ܂
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  flags   tO
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_SwapBuffers(bufp, flags)						\
{															\
	(bufp)[0] = GXOP_SWAP_BUFFERS;							\
	(bufp)[1] = (flags);									\
															\
	(bufp) += (1 + GXOP_SWAP_BUFFERS_NPARAMS);				\
}


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_GXB_H
