//====================================================================
//          IrisGXB_Primitive.h
//            IRISv~eBu`fBXvCXgobt@֐
//
//          Copyright (C) 2003 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_GXB_PRIMITIVE_H
#define _IRIS_GXB_PRIMITIVE_H


#include <IrisTarget.h>
#include <IrisTypes.h>
#include <IrisGX_Primitive.h>


#ifdef __cplusplus
extern "C" {
#endif



//----------------------------------------------------------------------
//                      ̂̕`
//
//Ê`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  width       ӂ̒
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//----------------------------------------------------------------------

#define GXB_DrawCube(bufp, width, texParamp)							\
																		\
	((bufp) = _GXB_DrawCube(bufp, width, texParamp))

u32 *_GXB_DrawCube(u32 *bufp, u16 width, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ̂̕`
//
//Ê`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  width       
//  height      
//  depth       s
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//----------------------------------------------------------------------

#define GXB_DrawBox(bufp, width, height, depth, texParamp)				\
																		\
	((bufp) = _GXB_DrawBox(bufp, width, height, depth, texParamp))

u32 *_GXB_DrawBox(u32 *bufp, u16 width, u16 height, u16 depth, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ̕`
//
//E`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  radius      a
//  numMajor    ܓx(latitude)̕
//  numMinor    ox(longitude)̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//----------------------------------------------------------------------

#define GXB_DrawSphere(bufp, radius, numMajor, numMinor, texParamp)		\
																		\
	((bufp) = _GXB_DrawSphere(bufp, radius, numMajor, numMinor, texParamp))

u32 *_GXB_DrawSphere(u32 *bufp, s16 radius, s16 numMajor, s16 numMinor, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      \ʑ̂ċAIɕ̕`
//
//E\ʑ̂ċAIɕ`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  radius      a
//  numLevel    ו̃x
//
//E߂lF    Ȃ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  DMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_DrawSphereHedron(bufp, radius, numLevel)					\
																		\
	((bufp) = _GXB_DrawSphereHedron(bufp, radius, numLevel))

u32 *_GXB_DrawSphereHedron(u32 *bufp, s16 radius, s16 numLevel);


//----------------------------------------------------------------------
//                      ~̕`
//
//E~`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  radius      a
//  height      
//  numEdges    ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//----------------------------------------------------------------------

#define GXB_DrawCylinder(bufp, radius, height, numEdges, texParamp) 	\
																		\
	((bufp) = _GXB_DrawCylinder(bufp, radius, height, numEdges, texParamp))

u32 *_GXB_DrawCylinder(u32 *bufp, s16 radius, u16 height, s16 numEdges, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ~̕`
//
//E~`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  radius      ʂ̔a
//  height      
//  numEdges    ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  DMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_DrawCone(bufp, radius, height, numEdges, texParamp)			\
																		\
	((bufp) = _GXB_DrawCone(bufp, radius, height, numEdges, texParamp))

u32 *_GXB_DrawCone(u32 *bufp, s16 radius, u16 height, s16 numEdges, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      g[Xi~j̕`
//
//Eg[Xi~j`悵܂B
//
//EF
//  bufp        fBXvCXgobt@̃|C^
//  size        g[X̒S]~̒S܂ł̋
//  rc          sizeƉ]~̔a̔䗦
//  numc        ]~̕
//  numt        ]ɂ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lFȂ
//----------------------------------------------------------------------

#define GXB_DrawTorus(bufp, size, rc, numc, numt, texParamp)			\
																		\
	((bufp) = _GXB_DrawTorus(bufp, size, rc, numc, numt, texParamp))

u32 *_GXB_DrawTorus(u32 *bufp, s16 size, s16 rc, s16 numc, s16 numt, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ʑ̂̕`
//
//Eʑ̂`悵܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  radius  a
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  DMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Draw8Hedron(bufp, radius)									\
																		\
	((bufp) = _GXB_Draw8Hedron(bufp, radius))

u32 *_GXB_Draw8Hedron(u32 *bufp, s16 radius);


//----------------------------------------------------------------------
//                      \ʑ̂̕`
//
//E\ʑ̂`悵܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  radius  a
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  DMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Draw12Hedron(bufp, radius)									\
																		\
	((bufp) = _GXB_Draw12Hedron(bufp, radius))

u32 *_GXB_Draw12Hedron(u32 *bufp, s16 radius);


//----------------------------------------------------------------------
//                      \ʑ̂̕`
//
//E\ʑ̂`悵܂B
//
//EF
//  bufp    fBXvCXgobt@̃|C^
//  radius  a
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  DMA]ƃVXeoXŏՓ˂ꍇɂ
//  CPŨXg[Ă܂܂B
//----------------------------------------------------------------------

#define GXB_Draw20Hedron(bufp, radius)									\
																		\
	((bufp) = _GXB_Draw20Hedron(bufp, radius))

u32 *_GXB_Draw20Hedron(u32 *bufp, s16 radius);



#ifdef __cplusplus
}
#endif

#endif // _IRIS_GXB_PRIMITIVE_H

