//====================================================================
//          IrisGX_Primitive.h
//            IRISv~eBu`fBXvCXg
//
//          Copyright (C) 2003 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_GX_PRIMITIVE_H
#define _IRIS_GX_PRIMITIVE_H


#include <IrisTarget.h>
#include <IrisTypes.h>


#ifdef __cplusplus
extern "C" {
#endif



// v~eBu`֐peNX`p[^\
typedef struct {
    TexImageParamCnt    img;           // eNX`C[WR}h̃p[^
    TexPlttBaseCnt      plt;           // eNX`pbgx[XR}h̃p[^

    TexCoord            texStart;      // eNX`X^[gW
    TexCoord            texEnd;        // eNX`GhW
} PrimTexParam;



//----------------------------------------------------------------------
//                      ̂̕`
//
//Ê`悵܂B
//
//EF
//  width       ӂ̒
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawCube(u16 width, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ̂̕`
//
//Ê`悵܂B
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//EF
//  width       
//  height      
//  depth       s
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawBox(u16 width, u16 height, u16 depth, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ̕`
//
//E`悵܂B
//
//EF
//  radius      a
//  numMajor    ܓx(latitude)̕
//  numMinor    ox(longitude)̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawSphere(s16 radius, s16 numMajor, s16 numMinor, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      \ʑ̂ċAIɕ̕`
//
//E\ʑ̂ċAIɕ`悵܂B
//
//EF
//  radius      a
//  numLevel    ו̃x
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawSphereHedron(s16 radius, s16 numLevel);


//----------------------------------------------------------------------
//                      ~̕`
//
//E~`悵܂B
//
//EF
//  radius      a
//  height      
//  numEdges    ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawCylinder(s16 radius, u16 height, s16 numEdges, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ~̕`
//
//E~`悵܂B
//
//EF
//  radius      ʂ̔a
//  height      
//  numEdges    ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lF    Ȃ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawCone(s16 radius, u16 height, s16 numEdges, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      g[Xi~j̕`
//
//Eg[Xi~j`悵܂B
//
//EF
//  size        g[X̒S]~̒S܂ł̋
//  rc          sizeƉ]~̔a̔䗦
//  numc        ]~̕
//  numt        ]ɂ~̕
//  texParamp   eNX`p[^ւ̃|C^
//              itH[}bgPrimTexParam\̂QƂĉj
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_DrawTorus(s16 size, s16 rc, s16 numc, s16 numt, const u32 (* texParamp)[4]);


//----------------------------------------------------------------------
//                      ʑ̂̕`
//
//Eʑ̂`悵܂B
//
//EF
//  radius  a
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_Draw8Hedron(s16 radius);


//----------------------------------------------------------------------
//                      \ʑ̂̕`
//
//E\ʑ̂`悵܂B
//
//EF
//  radius  a
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_Draw12Hedron(s16 radius);


//----------------------------------------------------------------------
//                      \ʑ̂̕`
//
//E\ʑ̂`悵܂B
//
//EF
//  radius  a
//
//E߂lFȂ
//
//I/OWX^oRŃWIgFIFO֒ڏނ߁A
//  fBXvCXg]ɂ͎sȂŉB
//----------------------------------------------------------------------

void GX_Draw20Hedron(s16 radius);



#ifdef __cplusplus
}
#endif

#endif // _IRIS_GX_PRIMITIVE_H

