//======================================================================
//          IrisMemoryMap.h
//            IRIS }bv萔
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_MEMORY_MAP_H
#define _IRIS_MEMORY_MAP_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>


//----------------------------------------------------------------------
//                      E}bv
//----------------------------------------------------------------------

#define SHARED_WORK             0x027ff000          // botԋL[N̈
#define SHARED_WORK_END         0x02800000

#if     defined(NDEBUG)
#define SUBP_PRV                0x02380000          // TuvZbTL̈i[Xo[Wj
#elif   defined(MMEM_4M) 
#define SUBP_PRV                0x02300000          //                       ifobOo[WCSl{́j
#else
#define SUBP_PRV                0x02600000          //                       ifobOo[WCWl{́j
#endif
#define SUBP_PRV_END            SHARED_WORK


#if     defined(IRIS_TEG) | defined(IRIS_TS) 
#define ITCM                    0x01ff8000          // ߂sbl
#define ITCM_END                (ITCM + 0x8000)
#define DTCM                    SUBP_PRV            // f[^sblisdf{[hȍ~j
#else
#define DTCM                    0x8000              //             iubh{[hpj
#endif
#define DTCM_END                (DTCM + 0x4000)

#define INTR_VECTOR_BUF         (DTCM_END - 0x4)    // 荞ݕAhX
#define INTR_CHECK_BUF          (DTCM_END - 0x8)    // 荞݃`FbN

#define SEND_FIFO_LOCK_BUF      (DTCM_END - 0x10)   // botԑMehenEbNobt@
#define TIMER3_LOCK_BUF         (DTCM_END - 0x12)   // ^C}[REbNobt@
#define TIMER2_LOCK_BUF         (DTCM_END - 0x14)   // ^C}[Q
#define TIMER1_LOCK_BUF         (DTCM_END - 0x16)   // ^C}[P
#define TIMER0_LOCK_BUF         (DTCM_END - 0x18)   // ^C}[O
#define DMA3_LOCK_BUF           (DTCM_END - 0x1a)   // cl`REbNobt@
#define DMA2_LOCK_BUF           (DTCM_END - 0x1c)   // cl`Q
#define DMA1_LOCK_BUF           (DTCM_END - 0x1e)   // cl`P
#define DMA0_LOCK_BUF           (DTCM_END - 0x20)   // cl`O


#define MAIN_MEM                0x02000000          // C
#define MAIN_MEM_END            (MAIN_MEM + 0x400000)
#define MAIN_MEM_EX_END         (MAIN_MEM + 0x800000) //ig̍ŏIAhXj

#define MAIN_MEM_CMD_AREA       (MAIN_MEM_EX_END - 0x2)  // CR}hsGAigp֎~GAj

#define SHARED_LOCK_BUF         (MAIN_MEM_EX_END - 0x40) // L\[XEbNobt@
#define SHARED_LOCK_BUF_END     (MAIN_MEM_EX_END - 0x10)

#define INIT_LOCK_BUF           (MAIN_MEM_EX_END - 0x10) // bNobt@
#define CARTRIDGE_LOCK_BUF      (MAIN_MEM_EX_END - 0x18) // J[gbWEbNobt@
#define CARD_LOCK_BUF           (MAIN_MEM_EX_END - 0x20) // J[hEbNobt@
#define WRAM_BLOCK1_LOCK_BUF    (MAIN_MEM_EX_END - 0x28) // bot[Nq`lEubNPEbNobt@
#define WRAM_BLOCK0_LOCK_BUF    (MAIN_MEM_EX_END - 0x30) //                         ubNOEbNobt@
#define VRAM_D_LOCK_BUF         (MAIN_MEM_EX_END - 0x38) // uq`l|cEbNobt@
#define VRAM_C_LOCK_BUF         (MAIN_MEM_EX_END - 0x40) //           bEbNobt@

#define FROM_SUBP_IF_BUF        (MAIN_MEM_EX_END - 0x50) // TuCvZbT荞ݗvtOiQa~Wj
#define WM_FROM_SUBP_IF_BUF     (MAIN_MEM_EX_END - 0x50) //     CX}l[W\
#define TO_SUBP_IF_BUF          (MAIN_MEM_EX_END - 0x60) // CTuvZbT荞ݗvtOiQa~Wj
#define WM_TO_SUBP_IF_BUF       (MAIN_MEM_EX_END - 0x60) //     CX}l[W\

#define ROM_HEADER_BUF          (MAIN_MEM_EX_END - 0x200)// qnlo^GAf[^Eobt@

#define DMA_CLEAR_DATA_BUF      (MAIN_MEM_EX_END - 0x210)// cl`NAf[^Eobt@ibΉAp~\j


#define CPU_WRAM                0x037f8000          // bot[Nq`l
#define CPU_WRAM_END            (CPU_WRAM + 0x8000)
#define CPU_WRAM_BLOCK0         0x037f8000          //                        ubNO
#define CPU_WRAM_BLOCK0_END     (CPU_WRAM_BLOCK0 + 0x4000)
#define CPU_WRAM_BLOCK1         0x037fc000          //                        ubNP
#define CPU_WRAM_BLOCK1_END     (CPU_WRAM_BLOCK1 + 0x4000)


#define REG_BASE                0x04000000          // WX^Q
#define PLTT                    0x05000000          // pbgq`l
#define PLTT_END                (PLTT +      0x400)
#define BG_PLTT                 (PLTT +        0x0) //   afpbgq`l
#define BG_PLTT_END             (PLTT +      0x200)
#define OBJ_PLTT                (PLTT +      0x200) // naipbgq`l
#define OBJ_PLTT_END            (PLTT +      0x400)
#define VRAM                    0x06000000          // uq`l
#define BG_VRAM                 (VRAM +        0x0) // afLN^/XN[q`l
#define BG_VRAM_END             (VRAM +    0x80000)
#define OBJ_VRAM                (VRAM +   0x400000) // naiLN^q`l
#define OBJ_VRAM_END            (VRAM +   0x440000)
#define LCDC_VRAM               (VRAM +   0x800000) // kbcb|uq`l
#define LCDC_VRAM_A             (VRAM +   0x800000)
#define LCDC_VRAM_B             (VRAM +   0x820000)
#define LCDC_VRAM_C             (VRAM +   0x840000)
#define LCDC_VRAM_D             (VRAM +   0x860000)
#define LCDC_VRAM_E             (VRAM +   0x880000)
#define LCDC_VRAM_F             (VRAM +   0x890000)
#define LCDC_VRAM_G             (VRAM +   0x894000)
#define LCDC_VRAM_END           (VRAM +   0x898000)
#define OAM                     0x07000000          // n`l
#define OAM_END                 (OAM +       0x400)

#define CARTRIDGE               0x08000000          // J[gbW
#define CTRDG_AD16_BANK0        0x08000000          // J[gbW `cPUoX oNO
#define CTRDG_AD16_BANK0_END    0x0a000000
#define CTRDG_AD16_BANK1        0x0a000000          //                           oNP
#define CTRDG_AD16_BANK1_END    0x0c000000
#define CTRDG_AD16_BANK2        0x0c000000          //                           oNQ
#define CTRDG_AD16_BANK2_END    0x0e000000
#define CTRDG_DT8               0x0e000000          // J[gbW Wf[^oX
#define CTRDG_DT8_END           0x10000000

#define BIOS                    0xffff0000          // ahnr
#define BIOS_END                (BIOS + 0x8000)


//----------------------------------------------------------------------
//                      ETCY
//----------------------------------------------------------------------

#define SHARED_WORK_SIZE        (SHARED_WORK_END - SHARED_WORK) // botԋL[N̈iSjaȏAQׂ̂TCYj
#define SUBP_PRV_SIZE           (SUBP_PRV_END - SUBP_PRV)       // TuvZbTL̈iRQjaȏAQׂ̂TCYj

#define SHARED_LOCK_BUF_SIZE    (SHARED_LOCK_BUF_END - SHARED_LOCK_BUF) // L\[XEbNobt@


#define ITCM_SIZE               0x8000              //   ߂sbl
#define DTCM_SIZE               0x4000              // f[^sbl
#define ICACHE_SIZE             0x2000              //   ߃LbV
#define DCACHE_SIZE             0x1000              // f[^LbV

#define CACHE_LINE_SIZE         32                  // LbVC

#define MAIN_MEM_SIZE           0x400000            // C
#define MAIN_MEM_EX_SIZE        0x800000            // igj

#define CPU_WRAM_SIZE           0x8000              // bot[Nq`l v
#define CPU_WRAM_BLOCK0_SIZE    0x4000              //                        ubNO
#define CPU_WRAM_BLOCK1_SIZE    0x4000              //                        ubNP

#define MROM_PAGE_SIZE          512                 // }XNqnlEy[W

#define PLTT_SIZE               (2*256*2)           // pbgq`l
#define BG_PLTT_SIZE            (2*256)             //   afpbgq`l
#define OBJ_PLTT_SIZE           (2*256)             // naipbgq`l
#define BG_VRAM_SIZE            0x80000             //     af|uq`l
#define OBJ_VRAM_SIZE           0x40000             //   nai|uq`l
#define LCDC_VRAM_SIZE          0x98000             // kbcb|uq`l
#define VRAM_A_SIZE             0x20000             // uq`l|`
#define VRAM_B_SIZE             0x20000             //           a
#define VRAM_C_SIZE             0x20000             //           b
#define VRAM_D_SIZE             0x20000             //           c
#define VRAM_E_SIZE             0x10000             //           d
#define VRAM_F_SIZE             0x4000              //           e
#define VRAM_G_SIZE             0x4000              //           f
#define OAM_SIZE                (8*128)             // n`l

#define CARTRIDGE_SIZE          0x02000000          // J[gbW
#define CTRDG_AD16_BANK_SIZE    0x02000000          // J[gbW `cPUoX oN
#define CTRDG_AD16_BANK0_SIZE   0x02000000          //                           oNO
#define CTRDG_AD16_BANK1_SIZE   0x02000000          //                           oNP
#define CTRDG_AD16_BANK2_SIZE   0x02000000          //                           oNQ
#define CTRDG_DT8_SIZE          0x02000000          // J[gbW Wf[^oX

#define BIOS_SIZE               0x8000              // ahnr


//----------------------------------------------------------------------
//                      WX^EAhX
//----------------------------------------------------------------------

#define REG_IME             (REG_BASE + 0x208)  // 荞݃}X^Cl[u
#define REG_IE              (REG_BASE + 0x210)  // 荞݋
#define REG_IF              (REG_BASE + 0x214)  // 荞ݗv


#define REG_SUBPINTF        (REG_BASE + 0x180)  // TuvZbTC^tF[X
#define REG_SUBP_FIFO_CNT   (REG_BASE + 0x184)  // botԂehenRg[
#define REG_SEND_FIFO       (REG_BASE + 0x188)      // Mehen
#define REG_RECV_FIFO       (REG_BASE + 0x100000)   // Mehen

#define REG_EXMEMCNT        (REG_BASE + 0x204)  // ORg[

#define REG_POWCNT          (REG_BASE + 0x304)  // p[Rg[


#define REG_DIVCNT          (REG_BASE + 0x280)  // Z Rg[
#define REG_DIV_NUMER       (REG_BASE + 0x290)  // 폜
#define REG_DIV_DENOM       (REG_BASE + 0x298)  // 
#define REG_DIV_RESULT      (REG_BASE + 0x2a0)  // 
#define REG_DIVREM_RESULT   (REG_BASE + 0x2a8)  // ]

#define REG_SQRTCNT         (REG_BASE + 0x2b0)  // Z Rg[
#define REG_SQRT_RESULT     (REG_BASE + 0x2b4)  // 
#define REG_SQRT_PARAM      (REG_BASE + 0x2b8)  // p[^


#define REG_DISPCNT         (REG_BASE + 0x0)    // \Rg[
#define REG_DISPCNT_L       (REG_BASE + 0x0)
#define REG_DISPCNT_H       (REG_BASE + 0x2)
#define REG_DISP2DCNT       (REG_BASE + 0x0)    // Qc\Rg[
#define REG_DISP3DCNT       (REG_BASE + 0x60)   // Rc\Rg[

#define REG_DISPSTAT        (REG_BASE + 0x4)    // \Xe[^X
#define REG_VCOUNT          (REG_BASE + 0x6)    // uJE^
#define REG_GXSTAT          (REG_BASE + 0x600)  // WIgGWXe[^X


#define REG_VRAMCNT         (REG_BASE + 0x240)  // uq`lRg[
#define REG_WRAMCNT         (REG_BASE + 0x247)  // [Nq`lRg[
#define REG_WVRAMCNT        (REG_BASE + 0x244)  // uq`l d`f { [Nq`l Rg[
#define REG_VRAM_A_CNT      (REG_BASE + 0x240)  // uq`l `
#define REG_VRAM_B_CNT      (REG_BASE + 0x241)  // uq`l a
#define REG_VRAM_C_CNT      (REG_BASE + 0x242)  // uq`l b
#define REG_VRAM_D_CNT      (REG_BASE + 0x243)  // uq`l c
#define REG_VRAM_E_CNT      (REG_BASE + 0x244)  // uq`l d
#define REG_VRAM_F_CNT      (REG_BASE + 0x245)  // uq`l e
#define REG_VRAM_G_CNT      (REG_BASE + 0x246)  // uq`l f
#define REG_VRAM_H_CNT      (REG_BASE + 0x248)  // uq`l g
#define REG_VRAM_I_CNT      (REG_BASE + 0x249)  // uq`l h
#define REG_VRAM_AB_CNT     (REG_BASE + 0x240)  // uq`l `a
#define REG_VRAM_CD_CNT     (REG_BASE + 0x242)  // uq`l bc
#define REG_VRAM_EF_CNT     (REG_BASE + 0x244)  // uq`l de
#define REG_VRAM_G_W_CNT    (REG_BASE + 0x246)  // uq`l f     { [Nq`l
#define REG_VRAM_ABCD_CNT   (REG_BASE + 0x240)  // uq`l ``c
#define REG_VRAM_EFG_W_CNT  (REG_BASE + 0x244)  // uq`l d`f { [Nq`l
#define REG_VRAM_HI_CNT     (REG_BASE + 0x248)  // uq`l gh



#define REG_MASTER_BRIGHT   (REG_BASE + 0x6c)   // }X^[Px Rg[
#define REG_DISPCAPCNT      (REG_BASE + 0x64)   // \Lv` Rg[
#define REG_DISP_MMEM_FIFO  (REG_BASE + 0x68)   // C\ehen


#define REG_MOSAIC          (REG_BASE + 0x4c)   // UCN TCY

#define REG_BLDCNT          (REG_BASE + 0x50)   // uh[h Rg[
#define REG_BLDALPHA        (REG_BASE + 0x52)   //    p[^
#define REG_BLDY            (REG_BASE + 0x54)   // PxύX p[^

#define REG_WINCNT          (REG_BASE + 0x40)   // EChE  Rg[
#define REG_WIN0H           (REG_BASE + 0x40)   // EChEÖ
#define REG_WIN1H           (REG_BASE + 0x42)   // EChEP̈
#define REG_WIN0V           (REG_BASE + 0x44)   // EChEÖ
#define REG_WIN1V           (REG_BASE + 0x46)   // EChEP̈
#define REG_WININ           (REG_BASE + 0x48)   // EChERg[
#define REG_WIN0            (REG_BASE + 0x48)   // EChEORg[
#define REG_WIN1            (REG_BASE + 0x49)   // EChEPRg[
#define REG_WIN01           (REG_BASE + 0x48)   // EChEOEPRg[
#define REG_WINOUT          (REG_BASE + 0x4a)   // EChEORg[
#define REG_OBJWIN          (REG_BASE + 0x4b)   // naiEChERg[
#define REG_WINOUTOBJ       (REG_BASE + 0x4a)   // EChEOEnaiEChERg[


#define REG_BGCNT           (REG_BASE + 0x8)    // afRg[
#define REG_BG0CNT          (REG_BASE + 0x8)    // afORg[
#define REG_BG1CNT          (REG_BASE + 0xa)    // afPRg[
#define REG_BG2CNT          (REG_BASE + 0xc)    // afQRg[
#define REG_BG3CNT          (REG_BASE + 0xe)    // afRRg[
#define REG_BGOFS           (REG_BASE + 0x10)   // afItZbg
#define REG_BG0HOFS         (REG_BASE + 0x10)   // afOgItZbg
#define REG_BG0VOFS         (REG_BASE + 0x12)   // afOuItZbg
#define REG_BG1HOFS         (REG_BASE + 0x14)   // afPgItZbg
#define REG_BG1VOFS         (REG_BASE + 0x16)   // afPuItZbg
#define REG_BG2HOFS         (REG_BASE + 0x18)   // afQgItZbg
#define REG_BG2VOFS         (REG_BASE + 0x1a)   // afQuItZbg
#define REG_BG3HOFS         (REG_BASE + 0x1c)   // afRgItZbg
#define REG_BG3VOFS         (REG_BASE + 0x1e)   // afRuItZbg
#define REG_BG2AFFINE       (REG_BASE + 0x20)   // afQAtBϊp[^Q
#define REG_BG2PA           (REG_BASE + 0x20)   // afQCwW
#define REG_BG2PB           (REG_BASE + 0x22)   // afQ  wW
#define REG_BG2PC           (REG_BASE + 0x24)   // afQCxW
#define REG_BG2PD           (REG_BASE + 0x26)   // afQ  xW
#define REG_BG2X            (REG_BASE + 0x28)   // afQX^[gwW
#define REG_BG2Y            (REG_BASE + 0x2c)   // afQX^[gxW
#define REG_BG3AFFINE       (REG_BASE + 0x30)   // afRAtBϊp[^Q
#define REG_BG3PA           (REG_BASE + 0x30)   // afRCwW
#define REG_BG3PB           (REG_BASE + 0x32)   // afR  wW
#define REG_BG3PC           (REG_BASE + 0x34)   // afRCxW
#define REG_BG3PD           (REG_BASE + 0x36)   // afR  xW
#define REG_BG3X            (REG_BASE + 0x38)   // afRX^[gwW
#define REG_BG3Y            (REG_BASE + 0x3c)   // afRX^[gxW



#define REG_GXFIFO          (REG_BASE + 0x400)  // WIgehen

#define REG_LISTRAM_COUNT   (REG_BASE + 0x604)  // |SXgq`lJE^
#define REG_VTXRAM_COUNT    (REG_BASE + 0x606)  // _q`lJE^
#define REG_RDLINES_COUNT   (REG_BASE + 0x320)  // _Oς݃CJE^


#define REG_SWAP_BUFFERS    (REG_BASE + 0x540)  // _OGWQƃf[^Q̃Xbv

#define REG_VIEWPORT        (REG_BASE + 0x580)  // E

#define REG_MTX_MODE        (REG_BASE + 0x440)  // s񃂁[h

#define REG_MTX_PUSH        (REG_BASE + 0x444)  // svbV
#define REG_MTX_POP         (REG_BASE + 0x448)  // s|bv
#define REG_MTX_STORE       (REG_BASE + 0x44c)  // sXgA
#define REG_MTX_RESTORE     (REG_BASE + 0x450)  // s񃊃XgA

#define REG_MTX_IDENTITY    (REG_BASE + 0x454)  // Pʍs 
#define REG_MTX_LOAD_4x4    (REG_BASE + 0x458)  // s񃍁[hiSSj
#define REG_MTX_LOAD_4x3    (REG_BASE + 0x45c)  //           iSRj
#define REG_MTX_MULT_4x4    (REG_BASE + 0x460)  // sZ    iSSj
#define REG_MTX_MULT_4x3    (REG_BASE + 0x464)  //             iSRj
#define REG_MTX_MULT_3x3    (REG_BASE + 0x468)  //             iRRj
#define REG_MTX_SCALE       (REG_BASE + 0x46c)  // XP[sZiPRj
#define REG_MTX_TRANS       (REG_BASE + 0x470)  // ړsZiPRj

#define REG_CLIPMTX_RESULT  (REG_BASE + 0x640)  // JgNbvWs ǂݍ
#define REG_VECMTX_RESULT   (REG_BASE + 0x680)  // JgxNgs ǂݍ


#define REG_LIGHT_VECTOR    (REG_BASE + 0x4c8)  // CgxNg
#define REG_LIGHT_COLOR     (REG_BASE + 0x4cc)  // CgJ[

#define REG_MATERIAL_COLOR  (REG_BASE + 0x4c0)  // }eAJ[
#define REG_DIF_AMB         (REG_BASE + 0x4c0)  // gU  
#define REG_SPE_EMI         (REG_BASE + 0x4c4)  // ˌ  ˌ
#define REG_SHININESS       (REG_BASE + 0x4d0)  // ʔˋPx


#define REG_POLYGON_ATTR    (REG_BASE + 0x4a4)  // |S

#define REG_TEX_PARAM       (REG_BASE + 0x4a8)  // eNX`p[^
#define REG_TEXIMAGE_PARAM  (REG_BASE + 0x4a8)
#define REG_TEXPLTT_BASE    (REG_BASE + 0x4ac)

#define REG_BEGIN_VTXS      (REG_BASE + 0x500)  // _Xg X^[g
#define REG_END_VTXS        (REG_BASE + 0x504)  // _Xg Gh

#define REG_COLOR           (REG_BASE + 0x480)  // _J[
#define REG_NORMAL          (REG_BASE + 0x484)  // _@
#define REG_TEXCOORD        (REG_BASE + 0x488)  // _eNX`W
#define REG_VTX_16          (REG_BASE + 0x48c)  // _16bitW
#define REG_VTX_10          (REG_BASE + 0x490)  // _10bitW
#define REG_VTX_XY          (REG_BASE + 0x494)  // _16bitXYW
#define REG_VTX_XZ          (REG_BASE + 0x498)  // _16bitXZW
#define REG_VTX_YZ          (REG_BASE + 0x49c)  // _16bitYZW
#define REG_VTX_DIFF        (REG_BASE + 0x4a0)  // _16bitWl

#define REG_BOX_TEST        (REG_BASE + 0x5c0)  // {bNXeXg
#define REG_POS_TEST        (REG_BASE + 0x5c4)  // ʒueXg
#define REG_VEC_TEST        (REG_BASE + 0x5c8)  // xNgeXg

#define REG_POS_RESULT      (REG_BASE + 0x620)  // ʒueXg
#define REG_VEC_RESULT      (REG_BASE + 0x630)  // xNgeXg


#define REG_CLEAR_COLOR_ATTR (REG_BASE +0x350)  // J[obt@ NAl
#define REG_CLEAR_DEPTH     (REG_BASE + 0x354)  // yobt@ NAl
#define REG_CLRIMAGE_OFFSET (REG_BASE + 0x356)  // NAC[W ItZbg

#define REG_EDGE_COLOR      (REG_BASE + 0x330)  // GbWJ[

#define REG_FOG_COLOR       (REG_BASE + 0x358)  // tHO J[
#define REG_FOG_OFFSET      (REG_BASE + 0x35c)  // tHO ItZbg
#define REG_FOG_TABLE       (REG_BASE + 0x360)  // tHOZxe[u

#define REG_TOON_TABLE      (REG_BASE + 0x380)  // gD[VF[fBOEe[u

#define REG_ALPHA_TEST_REF  (REG_BASE + 0x340)  // At@eXgQƒl

#define REG_DISP_1DOT_DEPTH (REG_BASE + 0x610)  // Phbg|S`Jnyl



#define REG_DMA0            (REG_BASE + 0xb0)   // cl`O
#define REG_DMA0SAD         (REG_BASE + 0xb0)
#define REG_DMA0DAD         (REG_BASE + 0xb4)
#define REG_DMA0CNT         (REG_BASE + 0xb8)
#define REG_DMA0CNT_L       (REG_BASE + 0xb8)
#define REG_DMA0CNT_H       (REG_BASE + 0xba)
#define REG_DMA1            (REG_BASE + 0xbc)   // cl`P
#define REG_DMA1SAD         (REG_BASE + 0xbc)
#define REG_DMA1DAD         (REG_BASE + 0xc0)
#define REG_DMA1CNT         (REG_BASE + 0xc4)
#define REG_DMA1CNT_L       (REG_BASE + 0xc4)
#define REG_DMA1CNT_H       (REG_BASE + 0xc6)
#define REG_DMA2            (REG_BASE + 0xc8)   // cl`Q
#define REG_DMA2SAD         (REG_BASE + 0xc8)
#define REG_DMA2DAD         (REG_BASE + 0xcc)
#define REG_DMA2CNT         (REG_BASE + 0xd0)
#define REG_DMA2CNT_L       (REG_BASE + 0xd0)
#define REG_DMA2CNT_H       (REG_BASE + 0xd2)
#define REG_DMA3            (REG_BASE + 0xd4)   // cl`R
#define REG_DMA3SAD         (REG_BASE + 0xd4)
#define REG_DMA3DAD         (REG_BASE + 0xd8)
#define REG_DMA3CNT         (REG_BASE + 0xdc)
#define REG_DMA3CNT_L       (REG_BASE + 0xdc)
#define REG_DMA3CNT_H       (REG_BASE + 0xde)
#define REG_DMA3CNT_L       (REG_BASE + 0xdc)
#ifdef IRIS_TS 
#define REG_DMA0_CLR_DATA   (REG_BASE + 0xe0)   // cl` NAf[^
#define REG_DMA1_CLR_DATA   (REG_BASE + 0xe4)
#define REG_DMA2_CLR_DATA   (REG_BASE + 0xe8)
#define REG_DMA3_CLR_DATA   (REG_BASE + 0xec)
#else
#define REG_DMA0_CLR_DATA   (DMA_CLEAR_DATA_BUF + 0x0)
#define REG_DMA1_CLR_DATA   (DMA_CLEAR_DATA_BUF + 0x4)
#define REG_DMA2_CLR_DATA   (DMA_CLEAR_DATA_BUF + 0x8)
#define REG_DMA3_CLR_DATA   (DMA_CLEAR_DATA_BUF + 0xc)
#endif


#define REG_TM0CNT          (REG_BASE + 0x100)  // ^C}[O
#define REG_TM0CNT_L        (REG_BASE + 0x100)
#define REG_TM0CNT_H        (REG_BASE + 0x102)
#define REG_TM1CNT          (REG_BASE + 0x104)  // ^C}[P
#define REG_TM1CNT_L        (REG_BASE + 0x104)
#define REG_TM1CNT_H        (REG_BASE + 0x106)
#define REG_TM2CNT          (REG_BASE + 0x108)  // ^C}[Q
#define REG_TM2CNT_L        (REG_BASE + 0x108)
#define REG_TM2CNT_H        (REG_BASE + 0x10a)
#define REG_TM3CNT          (REG_BASE + 0x10c)  // ^C}[R
#define REG_TM3CNT_L        (REG_BASE + 0x10c)
#define REG_TM3CNT_H        (REG_BASE + 0x10e)


#define REG_KEYINPUT        (REG_BASE + 0x130)  // L[
#define REG_KEYCNT          (REG_BASE + 0x132)  // L[Rg[

#define REG_R0CNT           (REG_BASE + 0x134)  // ėp|[gO
#define REG_R1CNT           (REG_BASE + 0x138)  //           P


//----------------------------------------------------------------------
//                      WX^EItZbg
//----------------------------------------------------------------------

#define OFFSET_REG_IME              0x208       // 荞݃}X^Cl[u
#define OFFSET_REG_IE               0x210       // 荞݋
#define OFFSET_REG_IF               0x214       // 荞ݗv

#define OFFSET_REG_SUBPINTF         0x180       // TuvZbTC^tF[X
#define OFFSET_REG_SUBP_FIFO_CNT    0x184       // botԂehenRg[
#define OFFSET_REG_SEND_FIFO        0x188       //     Mehen
#define OFFSET_REG_RECV_FIFO        0x100000    //     Mehen

#define OFFSET_REG_EXMEMCNT         0x204       // ORg[

#define OFFSET_REG_POWCNT           0x304       // p[Rg[


#define OFFSET_REG_DIVCNT           0x280       // Z Rg[
#define OFFSET_REG_DIV_NUMER        0x290       // 폜
#define OFFSET_REG_DIV_DENOM        0x298       // 
#define OFFSET_REG_DIV_RESULT       0x2a0       // 
#define OFFSET_REG_DIVREM_RESULT    0x2a8       // ]

#define OFFSET_REG_SQRTCNT          0x2b0       // Z Rg[
#define OFFSET_REG_SQRT_RESULT      0x2b4       // 
#define OFFSET_REG_SQRT_PARAM       0x2b8       // p[^


#define OFFSET_REG_DISPCNT          0x0         // \Rg[
#define OFFSET_REG_DISPCNT_L        0x0
#define OFFSET_REG_DISPCNT_H        0x2
#define OFFSET_REG_DISP2DCNT        0x0         // Qc\Rg[
#define OFFSET_REG_DISP3DCNT        0x60        // Rc\Rg[

#define OFFSET_REG_DISPSTAT         0x4         // \Xe[^X
#define OFFSET_REG_VCOUNT           0x6         // uJE^
#define OFFSET_REG_GXSTAT           0x600       // WIgGWXe[^X


#define OFFSET_REG_VRAMCNT          0x240       // uq`lRg[
#define OFFSET_REG_WRAMCNT          0x247       // [Nq`lRg[
#define OFFSET_REG_WVRAMCNT         0x244       // uq`l d`f { [Nq`l Rg[
#define OFFSET_REG_VRAM_A_CNT       0x240       // uq`l `
#define OFFSET_REG_VRAM_B_CNT       0x241       // uq`l a
#define OFFSET_REG_VRAM_C_CNT       0x242       // uq`l b
#define OFFSET_REG_VRAM_D_CNT       0x243       // uq`l c
#define OFFSET_REG_VRAM_E_CNT       0x244       // uq`l d
#define OFFSET_REG_VRAM_F_CNT       0x245       // uq`l e
#define OFFSET_REG_VRAM_G_CNT       0x246       // uq`l f
#define OFFSET_REG_VRAM_H_CNT       0x248       // uq`l g
#define OFFSET_REG_VRAM_I_CNT       0x249       // uq`l h
#define OFFSET_REG_VRAM_AB_CNT      0x240       // uq`l `a
#define OFFSET_REG_VRAM_CD_CNT      0x242       // uq`l bc
#define OFFSET_REG_VRAM_EF_CNT      0x244       // uq`l de
#define OFFSET_REG_VRAM_G_W_CNT     0x246       // uq`l f     { [Nq`l
#define OFFSET_REG_VRAM_ABCD_CNT    0x240       // uq`l ``c
#define OFFSET_REG_VRAM_EFG_W_CNT   0x244       // uq`l d`f { [Nq`l
#define OFFSET_REG_VRAM_HI_CNT      0x248       // uq`l gh


#define OFFSET_REG_MASTER_BRIGHT    0x6c        // }X^[Px Rg[
#define OFFSET_REG_DISPCAPCNT       0x64        // \Lv` Rg[
#define OFFSET_REG_DISP_MMEM_FIFO   0x68        // C\ehen
#define OFFSET_REG_TVOUTCNT         0x70        // ero̓Rg[


#define OFFSET_REG_MOSAIC           0x4c        // UCN TCY

#define OFFSET_REG_BLDCNT           0x50        // uh[h Rg[
#define OFFSET_REG_BLDALPHA         0x52        //    p[^
#define OFFSET_REG_BLDY             0x54        // PxύX p[^

#define OFFSET_REG_WINCNT           0x40        // EChE  Rg[
#define OFFSET_REG_WIN0H            0x40        // EChEÖ
#define OFFSET_REG_WIN1H            0x42        // EChEP̈
#define OFFSET_REG_WIN0V            0x44        // EChEÖ
#define OFFSET_REG_WIN1V            0x46        // EChEP̈
#define OFFSET_REG_WININ            0x48        // EChERg[
#define OFFSET_REG_WIN0             0x48        // EChEORg[
#define OFFSET_REG_WIN1             0x49        // EChEPRg[
#define OFFSET_REG_WIN01            0x48        // EChEOEPRg[
#define OFFSET_REG_WINOUT           0x4a        // EChEORg[
#define OFFSET_REG_OBJWIN           0x4b        // naiEChERg[
#define OFFSET_REG_WINOUTOBJ        0x4a        // EChEOEnaiEChERg[


#define OFFSET_REG_BGCNT            0x8         // afRg[
#define OFFSET_REG_BG0CNT           0x8         // afORg[
#define OFFSET_REG_BG1CNT           0xa         // afPRg[
#define OFFSET_REG_BG2CNT           0xc         // afQRg[
#define OFFSET_REG_BG3CNT           0xe         // afRRg[
#define OFFSET_REG_BGOFS            0x10        // afItZbg
#define OFFSET_REG_BG0HOFS          0x10        // afOgItZbg
#define OFFSET_REG_BG0VOFS          0x12        // afOuItZbg
#define OFFSET_REG_BG1HOFS          0x14        // afPgItZbg
#define OFFSET_REG_BG1VOFS          0x16        // afPuItZbg
#define OFFSET_REG_BG2HOFS          0x18        // afQgItZbg
#define OFFSET_REG_BG2VOFS          0x1a        // afQuItZbg
#define OFFSET_REG_BG3HOFS          0x1c        // afRgItZbg
#define OFFSET_REG_BG3VOFS          0x1e        // afRuItZbg
#define OFFSET_REG_BG2AFFINE        0x20        // afQAtBϊp[^Q
#define OFFSET_REG_BG2PA            0x20        // afQCwW
#define OFFSET_REG_BG2PB            0x22        // afQ  wW
#define OFFSET_REG_BG2PC            0x24        // afQCxW
#define OFFSET_REG_BG2PD            0x26        // afQ  xW
#define OFFSET_REG_BG2X             0x28        // afQX^[gwW
#define OFFSET_REG_BG2Y             0x2c        // afQX^[gxW
#define OFFSET_REG_BG3AFFINE        0x30        // afRAtBϊp[^Q
#define OFFSET_REG_BG3PA            0x30        // afRCwW
#define OFFSET_REG_BG3PB            0x32        // afR  wW
#define OFFSET_REG_BG3PC            0x34        // afRCxW
#define OFFSET_REG_BG3PD            0x36        // afR  xW
#define OFFSET_REG_BG3X             0x38        // afRX^[gwW
#define OFFSET_REG_BG3Y             0x3c        // afRX^[gxW



#define OFFSET_REG_GXFIFO           0x400       // WIgehen

#define OFFSET_REG_LISTRAM_COUNT    0x604       // |SXgq`lJE^
#define OFFSET_REG_VTXRAM_COUNT     0x606       // _q`lJE^
#define OFFSET_REG_RDLINES_COUNT    0x320       // _Oς݃CJE^


#define OFFSET_REG_SWAP_BUFFERS     0x540       // _OGWQƃf[^Q̃Xbv

#define OFFSET_REG_VIEWPORT         0x580       // E

#define OFFSET_REG_MTX_MODE         0x440       // s񃂁[h

#define OFFSET_REG_MTX_PUSH         0x444       // svbV
#define OFFSET_REG_MTX_POP          0x448       // s|bv
#define OFFSET_REG_MTX_STORE        0x44c       // sXgA
#define OFFSET_REG_MTX_RESTORE      0x450       // s񃊃XgA

#define OFFSET_REG_MTX_IDENTITY     0x454       // Pʍs 
#define OFFSET_REG_MTX_LOAD_4x4     0x458       // s񃍁[hiSSj
#define OFFSET_REG_MTX_LOAD_4x3     0x45c       //           iSRj
#define OFFSET_REG_MTX_MULT_4x4     0x460       // sZ    iSSj
#define OFFSET_REG_MTX_MULT_4x3     0x464       //             iSRj
#define OFFSET_REG_MTX_MULT_3x3     0x468       //             iRRj
#define OFFSET_REG_MTX_SCALE        0x46c       // XP[sZiPRj
#define OFFSET_REG_MTX_TRANS        0x470       // ړsZiPRj

#define OFFSET_REG_CLIPMTX_RESULT   0x640       // JgNbvWs ǂݍ
#define OFFSET_REG_VECMTX_RESULT    0x680       // JgxNgs ǂݍ


#define OFFSET_REG_LIGHT_VECTOR     0x4c8       // CgxNg
#define OFFSET_REG_LIGHT_COLOR      0x4cc       // CgJ[

#define OFFSET_REG_MATERIAL_COLOR   0x4c0       // }eAJ[
#define OFFSET_REG_DIF_AMB          0x4c0       // gU  
#define OFFSET_REG_SPE_EMI          0x4c4       // ˌ  ˌ
#define OFFSET_REG_SHININESS        0x4d0       // ʔˋPx


#define OFFSET_REG_POLYGON_ATTR     0x4a4       // |S

#define OFFSET_REG_TEX_PARAM        0x4a8       // eNX`p[^
#define OFFSET_REG_TEXIMAGE_PARAM   0x4a8
#define OFFSET_REG_TEXPLTT_BASE     0x4ac

#define OFFSET_REG_BEGIN_VTXS       0x500       // _Xg X^[g
#define OFFSET_REG_END_VTXS         0x504       // _Xg Gh

#define OFFSET_REG_COLOR            0x480       // _J[
#define OFFSET_REG_NORMAL           0x484       // _@
#define OFFSET_REG_TEXCOORD         0x488       // _eNX`W
#define OFFSET_REG_VTX_16           0x48c       // _16bitW
#define OFFSET_REG_VTX_10           0x490       // _10bitW
#define OFFSET_REG_VTX_XY           0x494       // _16bitXYW
#define OFFSET_REG_VTX_XZ           0x498       // _16bitXZW
#define OFFSET_REG_VTX_YZ           0x49c       // _16bitYZW
#define OFFSET_REG_VTX_DIFF         0x4a0       // _16bitWl

#define OFFSET_REG_BOX_TEST         0x5c0       // {bNXeXg
#define OFFSET_REG_POS_TEST         0x5c4       // ʒueXg
#define OFFSET_REG_VEC_TEST         0x5c8       // xNgeXg

#define OFFSET_REG_POS_RESULT       0x620       // ʒueXg
#define OFFSET_REG_VEC_RESULT       0x630       // xNgeXg


#define OFFSET_REG_CLEAR_COLOR_ATTR 0x350       // J[obt@ NAl
#define OFFSET_REG_CLEAR_DEPTH      0x354       // yobt@ NAl
#define OFFSET_REG_CLRIMAGE_OFFSET  0x356       // NAC[W ItZbg

#define OFFSET_REG_EDGE_COLOR       0x330       // GbWJ[

#define OFFSET_REG_FOG_COLOR        0x358       // tHO J[
#define OFFSET_REG_FOG_OFFSET       0x35c       // tHO ItZbg
#define OFFSET_REG_FOG_TABLE        0x360       // tHOZxe[u

#define OFFSET_REG_TOON_TABLE       0x380       // gD[VF[fBOEe[u

#define OFFSET_REG_ALPHA_TEST_REF   0x340       // At@eXgQƒl

#define OFFSET_REG_DISP_1DOT_DEPTH  0x610       // Phbg|S`Jnyl



#define OFFSET_REG_DMA0             0xb0        // cl`O
#define OFFSET_REG_DMA0SAD          0xb0
#define OFFSET_REG_DMA0DAD          0xb4
#define OFFSET_REG_DMA0CNT          0xb8
#define OFFSET_REG_DMA0CNT_L        0xb8
#define OFFSET_REG_DMA0CNT_H        0xba
#define OFFSET_REG_DMA1             0xbc        // cl`P
#define OFFSET_REG_DMA1SAD          0xbc
#define OFFSET_REG_DMA1DAD          0xc0
#define OFFSET_REG_DMA1CNT          0xc4
#define OFFSET_REG_DMA1CNT_L        0xc4
#define OFFSET_REG_DMA1CNT_H        0xc6
#define OFFSET_REG_DMA2             0xc8        // cl`Q
#define OFFSET_REG_DMA2SAD          0xc8
#define OFFSET_REG_DMA2DAD          0xcc
#define OFFSET_REG_DMA2CNT          0xd0
#define OFFSET_REG_DMA2CNT_L        0xd0
#define OFFSET_REG_DMA2CNT_H        0xd2
#define OFFSET_REG_DMA3             0xd4        // cl`R
#define OFFSET_REG_DMA3SAD          0xd4
#define OFFSET_REG_DMA3DAD          0xd8
#define OFFSET_REG_DMA3CNT          0xdc
#define OFFSET_REG_DMA3CNT_L        0xdc
#ifdef IRIS_TS 
#define OFFSET_REG_DMA0_CLR_DATA    0xe0        // cl` NAf[^
#define OFFSET_REG_DMA1_CLR_DATA    0xe4
#define OFFSET_REG_DMA2_CLR_DATA    0xe8
#define OFFSET_REG_DMA3_CLR_DATA    0xec
#endif


#define OFFSET_REG_TM0CNT           0x100       // ^C}[O
#define OFFSET_REG_TM0CNT_L         0x100
#define OFFSET_REG_TM0CNT_H         0x102
#define OFFSET_REG_TM1CNT           0x104       // ^C}[P
#define OFFSET_REG_TM1CNT_L         0x104
#define OFFSET_REG_TM1CNT_H         0x106
#define OFFSET_REG_TM2CNT           0x108       // ^C}[Q
#define OFFSET_REG_TM2CNT_L         0x108
#define OFFSET_REG_TM2CNT_H         0x10a
#define OFFSET_REG_TM3CNT           0x10c       // ^C}[R
#define OFFSET_REG_TM3CNT_L         0x10c
#define OFFSET_REG_TM3CNT_H         0x10e


#define OFFSET_REG_KEYINPUT         0x130       // L[
#define OFFSET_REG_KEYCNT           0x132       // L[Rg[

#define OFFSET_REG_R0CNT            0x134       // ėp|[gO
#define OFFSET_REG_R1CNT            0x138       //           P


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_MEMORY_MAP_H
