//======================================================================
//          IrisQUAT.h
//            NH[^jICu
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_QUAT_H
#define _IRIS_QUAT_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisTypes.h>
#include <IrisSinTable.h>


#define QM_S_SFT    14            // NH[^jIsւ̕ϊ̐x萔


//----------------------------------------------------------------------
//          xNgƉ]pNH[^jIւ̕ϊ
//
//ExNgƉ]p狁߂NH[^jIdstpwNH[^jI֊i[܂B
//
//EF
//  axisp   ]xNg̃|C^
//  theta   ]pxm256b1024b4096iKn
//  dstp    NH[^jIi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

#define VEC_Conv2Quat(axisp, theta, dstp)			VEC_Conv2QuatPriv(SIN_NDIV_DEFAULT, axisp, theta, dstp)

void VEC_Conv2Quat256(const Vec *axisp, u32 theta, Quat *dstp);
void VEC_Conv2Quat1024(const Vec *axisp, u32 theta, Quat *dstp);
void VEC_Conv2Quat4096(const Vec *axisp, u32 theta, Quat *dstp);

// ԃ}NiL̃}N͒ڎgpȂŉj

#define VEC_Conv2QuatPriv(ndiv, axisp, theta, dstp)		VEC_Conv2QuatNDiv(ndiv, axisp, theta, dstp)
#define VEC_Conv2QuatNDiv(ndiv, axisp, theta, dstp)		VEC_Conv2Quat##ndiv(    axisp, theta, dstp)

//----------------------------------------------------------------------
//          NH[^jI̓
//
//EQ̃NH[^jI̓ς߂܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//
//E߂lF
//----------------------------------------------------------------------

s32  QUAT_DotProduct(const Quat *a, const Quat *b);

//----------------------------------------------------------------------
//          NH[^jI̐K
//
//EsrcpwNH[^jI𐳋KdstpwNH[^jI֊i[܂B
//
//EF
//  srcp    KNH[^jĨ|C^
//  dstp    KNH[^jIi[obt@̃|C^
//
//E߂lFȂ
//
//ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void QUAT_Normalize(Quat *srcp, Quat *dstp);

//----------------------------------------------------------------------
//          NH[^jI̋tit]j
//
//EsrcpwNH[^jI̋t߁AdstpwNH[^jI֊i[܂B
//
//EF
//  srcp    ̃NH[^jĨ|C^
//  dstp    tNH[^jIi[obt@̃|C^
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void QUAT_Inverse(Quat *srcp, Quat *dstp);

//----------------------------------------------------------------------
//          NH[^jȈZ
//
//EQ̃NH[^jIZaxbwNH[^jI֊i[܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//  axb     ZNH[^jIi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void QUAT_Multiply(Quat *a, Quat *b, Quat *axb);

//----------------------------------------------------------------------
//          NH[^jỈZ
//
//EQ̃NH[^jIZʂa_bwNH[^jI֊i[܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//  a_b     Z̃NH[^jIi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void QUAT_Add(Quat *a, Quat *b, Quat *a_b);

//----------------------------------------------------------------------
//          NH[^jǏZ
//
//EsrcpwNH[^jIXP[OʂdstpwNH[^jI֊i[܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//  a_b     Z̃NH[^jIi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void QUAT_Sub(Quat *a, Quat *b, Quat *a_b);

//----------------------------------------------------------------------
//          NH[^jĨXP[O
//
//EQ̃NH[^jIXP[Oʂa_bwNH[^jI֊i[܂B
//
//EF
//  srcp    XP[OÕNH[^jĨ|C^
//  dstp    XP[ÕNH[^jIi[obt@̃|C^
//  scale   XP[Op[^
//
//E߂lFȂ
//----------------------------------------------------------------------

void QUAT_Scale(Quat *srcp, Quat *dstp, s32 scale);

//----------------------------------------------------------------------
//          NH[^jI̐`
//
//EQ̃NH[^jI`ԂʂdwNH[^jI֊i[܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//  d       ԃNH[^jIi[obt@̃|C^
//  t       ԃp[^
//
//E߂lFȂ
//----------------------------------------------------------------------

void QUAT_Lerp( Quat *p, Quat *q, Quat *d, s32 t);

//----------------------------------------------------------------------
//          NH[^jI̋ʐ`
//
//EQ̃NH[^jIʐ`ԂʂdwNH[^jI֊i[܂B
//
//EF
//  a       PNH[^jĨ|C^
//  b       QNH[^jĨ|C^
//  d       ԃNH[^jIi[obt@̃|C^
//  t       ԃp[^
//
//E߂lFȂ
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void QUAT_Slerp(Quat *p, Quat *q, Quat *d, s32 t);



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_QUAT_H
