//======================================================================
//          IrisSystemCall.h
//            IRIS VXeR[
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SYSTEM_CALL_H
#define _IRIS_SYSTEM_CALL_H

#ifdef __cplusplus
extern "C" {
#endif

#include <IrisTarget.h>
#include <IrisTypes.h>
#include <IrisSystemCallDefine.h>


#ifdef  __MWERKS__
#ifndef CODE32
#define SystemCall(No)   asm { SWI    No }
#else
#define SystemCall(No)   asm { SWI    No << 16 }
#endif
#elif   defined( __GNUC__ )
#ifndef CODE32
#define SystemCall(No)   asm ("SWI    "#No)
#else
#define SystemCall(No)   asm ("SWI    "#No" << 16")
#endif
#elif   defined( __CC_ARM )
#ifndef CODE32
#define SystemCall(No) __asm { SWI    No }
#else
#define SystemCall(No) __asm { SWI    No << 16 }
#endif
#endif


//----------------------------------------------------------------------
//                  J[hǂݍ
//----------------------------------------------------------------------

#if     defined(IRIS_TS)
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 _SVC_ReadCard(dmaNo, (void *)(srcp), (void *)(destp), size)

void _SVC_ReadCard(s32 dmaNo, void *srcp, void *destp, s32 size);

#elif   defined(IRIS_TEG) 
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 _SVC_TEG_ReadCard(dmaNo, (void *)(srcp), (void *)(destp), size)

void _SVC_TEG_ReadCard(s32 dmaNo, void *srcp, void *destp, s32 size);

#else
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 ((void) 0)
#endif

//EJ[hf[^ǂݍ݂܂B
//EJ[h̃AhX512ByteEA{̑̃AhX4ByteE
//  킹Kv܂B
//
//EF
//    s32   dmaNo       DMAԍi0`3 ȊO̒lnꂽCPUœǂݍ݂܂j
//                     iTEG{[hł͖ACPUɂē]܂j
//    void *srcp        J[h̃\[XAhX
//    void *destp       {̑̃fXeBl[VAhX
//    s32   size        ]TCY

//----------------------------------------------------------------------
//                  荞݃EFCg
//----------------------------------------------------------------------

void SVC_WaitIntr(u32 clearEnable, u32 intrFlags);

//EIntrFlagsŎw肵荞݂܂HaltԂő҂܂B
//E荞ݏɂINTR_CHECK_BUF (DTCM_END - 0x8) ֊YtOZbgĉB
//E̊荞݂𕹗pAOS_Halt()JԂĂяoꍇƔׂ
//  VXeR[ĂяõI[o[wbhy邱Ƃł܂B
//
//EF
//    u32 clearEnable   ɊYtOZbgĂꍇɃNA邩ǂ̎w
//    u32 intrFlags     EFCg銄荞݂̎wiIrisSystemCallDefine.hQƁj

//----------------------------------------------------------------------
//                  uuN荞݃EFCg
//----------------------------------------------------------------------

void SVC_WaitVBlankIntr(void);

//EuuN荞݂܂HaltԂő҂܂B
//E荞ݏɂINTR_CHECK_BUF (DTCM_END - 0x8) ֊YtOZbgĉB
//E̊荞݂𕹗pAOS_Halt()JԂĂяoꍇƔׂ
//  VXeR[ĂяõI[o[wbhy邱Ƃł܂B
//ESVC_WaitIntr(1, V_BLANK_INTR_FLAG)ƓłB

//----------------------------------------------------------------------
//                  botZbg
//----------------------------------------------------------------------

void SVC_CpuSet(const void *srcp, void *destp, u32 dmaCntData);

//EDmaSet}N݊̃p[^RAMNA܂̓Rs[܂B
//E32bit]ł͋I4ByteEɂăANZX܂A
//  16bit]ł͈2ByteE֍킹ēnKv܂B
//
//EF
//    void *srcp          \[XAhX
//    void *destp         fXeBl[VAhX
//    u32 dmaCntData      DMA_SRC_FIX^DMA_32BIT_BUS^DMA_COUNT_MASK̂ݗL
//          DMA_SRC_FIX(  0, 1) = (\[XAhXECNg, \[XAhXŒ)
//          DMA_32BIT_BUS(0, 1) = (16bit], 32bit])
//          DMA_COUNT_MASK & dmaCntData = ]
//
//Eʃ}NF
//  SVC_CpuClear, SVC_CpuClearArray, SVC_CpuCopy, SVC_CpuCopyArray

//----------------------------------------------------------------------
//                  botZbg
//----------------------------------------------------------------------

void SVC_CpuSetFast(const void *srcp, void *destp, u32 dmaCntData);

//EDmaSet}N݊̃p[^ōRAMNA܂̓Rs[܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕[h^XgA߂gp܂B
//E4ByteEȊOň^ĂI4ByteEɂăANZX܂B
//
//EF
//    void *srcp          \[XAhX
//    void *destp         fXeBl[VAhX
//    u32 dmaCntData      DMA_SRC_FIX^DMA_COUNT_MASK̂ݗL
//          DMA_SRC_FIX(0, 1) = (\[XAhXECNg, \[XAhXŒ)
//          DMA_COUNT_MASK & dmaCntData = ]
//
//Eʃ}NF
//  SVC_CpuClearFast, SVC_CpuClearArrayFast, SVC_CpuCopyFast, SVC_CpuCopyArrayFast

//----------------------------------------------------------------------
//                      bot NA
//----------------------------------------------------------------------

#define SVC_CpuClear(data, destp, size, bit)                \
{                                                           \
    vu##bit tmp = (vu##bit )(data);                         \
    SVC_CpuSet((u8 *)&(tmp), (u8 *)(destp), (               \
        DMA_SRC_FIX        |                                \
        DMA_##bit##BIT_BUS | ((size)/(bit/8) & 0x1fffff))); \
}

#define SVC_CpuClearArray(data, destp, bit)                 \
        SVC_CpuClear(     data, destp, sizeof(destp), bit)

//ECPURAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//ESVC_CpuClearArray̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                      bot Rs[
//----------------------------------------------------------------------

#define SVC_CpuCopy(srcp, destp, size, bit)                 \
                                                            \
    SVC_CpuSet((u8 *)(srcp), (u8 *)(destp),  (              \
        DMA_SRC_INC        |                                \
        DMA_##bit##BIT_BUS | ((size)/(bit/8) & 0x1fffff)))

#define SVC_CpuCopyArray(srcp, destp, bit)                  \
        SVC_CpuCopy(     srcp, destp, sizeof(srcp), bit)

//ECPUŃRs[VXeR[Ăяo܂B
//ESVC_CpuCopyArray̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                  bot NA
//----------------------------------------------------------------------

#define SVC_CpuClearFast(data, destp, size)                 \
{                                                           \
    vu32 tmp = (vu32 )(data);                               \
    SVC_CpuSetFast((u8 *)&(tmp), (u8 *)(destp), (           \
        DMA_SRC_FIX        | ((size)/(32/8) & 0x1fffff)));  \
}

#define SVC_CpuClearArrayFast(data, destp)                  \
        SVC_CpuClearFast(     data, destp, sizeof(destp))

//ECPUōRAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕XgA߂gp܂B
//ESVC_CpuClearArrayFast̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg

//----------------------------------------------------------------------
//                  bot Rs[
//----------------------------------------------------------------------

#define SVC_CpuCopyFast(srcp, destp, size)                  \
                                                            \
    SVC_CpuSetFast((u8 *)(srcp), (u8 *)(destp),  (          \
        DMA_SRC_INC           | ((size)/(32/8) & 0x1fffff)))

#define SVC_CpuCopyArrayFast(srcp, destp)                   \
        SVC_CpuCopyFast(     srcp, destp, sizeof(srcp))

//ECPUōɃRs[VXeR[Ăяo܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕[h^XgA߂gp܂B
//ESVC_CpuCopyArrayFast̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SYSTEM_CALL_H
