//======================================================================
//          IrisTypes.h
//            IRIS W^錾
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_TYPES_H
#define _IRIS_TYPES_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>


//----------------------------------------------------------------------
//                      f[^^CvĒ`
//----------------------------------------------------------------------

typedef     unsigned char           u8;
typedef     unsigned short int      u16;
typedef     unsigned int            u32;
typedef     unsigned long long int  u64;

typedef     signed char             s8;
typedef     signed short int        s16;
typedef     signed int              s32;
typedef     signed long long int    s64;

typedef     float                   f32;
typedef     double                  f64;


#define     vl                      volatile

typedef     vl u8                   vu8;
typedef     vl u16                  vu16;
typedef     vl u32                  vu32;
typedef     vl u64                  vu64;

typedef     vl s8                   vs8;
typedef     vl s16                  vs16;
typedef     vl s32                  vs32;
typedef     vl s64                  vs64;

typedef     vl f32                  vf32;
typedef     vl f64                  vf64;



// fBXvCXg
typedef     u32                     Gxl;
typedef     vl Gxl                  vGxl;


// CgxNg
typedef struct {
    s32 x:10;
    s32 y:10;
    s32 z:10;
    u32 no:2;
} LightVector;
typedef  vl LightVector  vLightVector;

// CgJ[
typedef struct {
    u16 r:5;
    u16 g:5;
    u16 b:5;
    u16 :0;

    u16 :14;
    u16 no:2;
} LightColor;
typedef  vl LightColor    vLightColor;


// 10bit 3DxNgieXgxNgj
typedef struct {
    s32 x:10;
    s32 y:10;
    s32 z:10;
} Vec10, Pos10, TestVec;
typedef  vl Pos10     vPos10;
typedef  vl Vec10     vVec10;
typedef  vl TestVec   vTestVec;

// 16bit 3DxNgiWxNgAeXgʒuWj
typedef struct {
    s16 x;
    s16 y;
    s16 z;
    s16 w;          // pbḧiR[h̍̂߂ɒǉj
} Vec16, Vec, Pos16, TestPos;
typedef  vl Pos16     vPos16;
typedef  vl Vec16     vVec16;
typedef  vl Vec       vVec;
typedef  vl TestPos   vTestPos;

// 32bit 3DxNgiWʒuWj
typedef struct {
	s32 x;
	s32 y;
	s32 z;
} Vec32, Pos32, Pos;
typedef  vl Vec32     vVec32;
typedef  vl Pos32     vPos32;
typedef  vl Pos       vPos;

// 16bit NH[^jIiWNH[^jIj
typedef struct {
    s16 x;
    s16 y;
    s16 z;
    s16 w;
} Quat16, Quat;
typedef  vl Quat16    vQuat16;
typedef  vl Quat      vQuat;

// 32bit NH[^jI
typedef struct {
	s32 x;
	s32 y;
	s32 z;
	s32 w;
} Quat32;
typedef  vl Quat32    vQuat32;


// 16bit 2DxNgiW2DxNgj
typedef struct {
    s16 x;
    s16 y;
} Vec2D16, Pos2D16, Vec2D;
typedef  vl Vec2D16    vVec2D16;
typedef  vl Pos2D16    vPos2D16;
typedef  vl Vec2D      vVec2D;

// 32bit 2DxNgiW2DʒuWj
typedef struct {
	s32 x;
	s32 y;
} Vec2D32, Pos2D32, Pos2D;
typedef  vl Vec2D32    vVec2D32;
typedef  vl Pos2D32    vPos2D32;
typedef  vl Pos2D      vPos2D;


// eNX`W

typedef struct {
    s16 s;
    s16 t;
} TexCoord, ST1616_t;
typedef  vl TexCoord    vTexCoord;
typedef  vl ST1616_t    vST1616_t;


// eXg{bNX
typedef struct {
    s16 x;
    s16 y;
    s16 z;
    s16 w;
    s16 h;
    s16 d;
} TestBox, Box16_t;
typedef  vl TestBox    vTestBox;
typedef  vl Box16_t    vBox16_t;


// 5bitJ[
typedef struct {
    u16 r:5;
    u16 g:5;
    u16 b:5;
    u16 a:1;
} Color5, RGBA5551_t;
typedef  vl Color5        vColor5;
typedef  vl RGBA5551_t    vRGBA5551_t;

// 8bitJ[
typedef struct {
    u8  r;
    u8  g;
    u8  b;
    u8  a;
} Color8, RGBA8888_t;
typedef  vl Color8        vColor8;
typedef  vl RGBA8888_t    vRGBA8888_t;



// 3vf̍s
typedef s32 MtxRow3_t[3];
typedef struct {
    MtxRow3_t r;
} MtxRow3;

typedef MtxRow3   MtxRow;
typedef MtxRow3   Mtx33Row;

typedef vl MtxRow    vMtxRow;
typedef vl MtxRow3   vMtxRow3;
typedef vl Mtx33Row  vMtx33Row;

// 4vf̍s
typedef s32 MtxRow4_t[4];
typedef struct {
    MtxRow4_t r;
} MtxRow4;

typedef MtxRow4   Mtx44Row;

typedef vl MtxRow4   vMtxRow4;
typedef vl Mtx44Row  vMtx44Row;

// 4x3s
typedef s32 Mtx_t[4][3];
typedef union {
    Mtx_t m;
} Mtx;
typedef  vl Mtx   vMtx;

// 3x3s
typedef s32 Mtx33_t[3][3];
typedef union {
    Mtx33_t m;
} Mtx33;
typedef  vl Mtx33   vMtx33;

// 4x4s
// used for projection matrix
typedef s32 Mtx44_t[4][4];
typedef union {
    Mtx44_t m;
} Mtx44;
typedef  vl Mtx44   vMtx44;



//----------------------------------------------------------------------
//                          \
//----------------------------------------------------------------------

// vOXe[^XWX^\
typedef struct {
    u32 cpuMode:5;              // bot[h
    u32 thumbState:1;           // sgtlaXe[g
    u32 fiq_disable:1;          // ehps
    u32 irq_disable:1;          // hqps
    u32 :19;
    u32 q:1;                    // XeBbL[I[o[t[
    u32 v:1;                    // I[o[t[
    u32 c:1;                    // L[^{[^g
    u32 z:1;                    // [
    u32 n:1;                    // ^
} PsrData;
typedef  vl PsrData    vPsrData;


// 荞ݗv^tO\
typedef struct {
    u16 blankV:1;               // uuN
    u16 blankH:1;               // guN
    u16 countV:1;               // uJE^v
    u16 timer0:1;               // ^C}[O
    u16 timer1:1;               // ^C}[P
    u16 timer2:1;               // ^C}[Q
    u16 timer3:1;               // ^C}[R
    u16 sio:1;                  // VAʐM
    u16 dma0:1;                 // cl`O
    u16 dma1:1;                 // cl`P
    u16 dma2:1;                 // cl`Q
    u16 dma3:1;                 // cl`R
    u16 key:1;                  // L[
    u16 cartridge:1;            // J[gbW
    u16 :2;

    u16 subp:1;                 // TuvZbT
    u16 subpSendFifoEmpty:1;    // TuvZbTԑMehenGveB
    u16 subpRecvFifoNotEmpty:1; // TuvZbTԎMehenmbgGveB
    u16 cardData:1;             // J[hf[^
    u16 cardIreq:1;             // J[hhqdp
    u16 gxfifo:1;               // WIgR}hehen
} IntrFlags;
typedef  vl IntrFlags    vIntrFlags;


// TuvZbTC^tF[X\
typedef struct {
    u16 recvStatus:4;           // MXe[^X
    u16 :4;
    u16 sendStatus:4;           // MXe[^X
    u16 :1;
    u16 sendIf:1;               // 荞ݗvM
    u16 recvIf_enable:1;        // 荞ݗvM 
    u16 subp_enable:1;          // TuvZbT Cl[ui폜\j
} SubpIntf;
typedef  vl SubpIntf      vSubpIntf;


// TuvZbTʐMehenRg[\
typedef struct {
    u16 sendEmpty:1;            // Mehen GveB
    u16 sendFull:1;             //              t
    u16 sendIf_enable:1;        //              荞ݗv 
    u16 sendClear:1;            //              NA
    u16 :4;
    u16 recvEmpty:1;            // Mehen GveB
    u16 recvFull:1;             //              t
    u16 recvIf_enable:1;        //              荞ݗv 
    u16 :4;
    u16 enable:1;               // ehenCl[u
} SubpFifoCnt;
typedef  vl SubpFifoCnt    vSubpFifoCnt;



// uq`lRg[\
typedef struct
{
    u8  mode:3;
    u8  offset:2;
    u8  :2;
    u8  enable:1;
} VramCnt;
typedef  vl VramCnt    vVramCnt;


// [Nq`lRg[\
typedef struct
{
    u8  block0:1;
    u8  block1:1;
} WramCnt;
typedef  vl WramCnt    vWramCnt;



// \Rg[\
typedef struct {
    u16 bgMode:3;               // af[hI
    u16 bg0_3D_on:1;            // afOւRc\
    u16 objCharMapType:1;       // naiLN^f[^   }bsO^Cv
    u16 objBmpMapType:2;        // nairbg}bvf[^ }bsO^Cv
    u16 lcdc_off:1;             // kbcb nee
    u16 bg0_on:1;               // afO nm
    u16 bg1_on:1;               // afP nm
    u16 bg2_on:1;               // afQ nm
    u16 bg3_on:1;               // afR nm
    u16 obj_on:1;               // nai nm
    u16 win0_on:1;              // EChEO nm
    u16 win1_on:1;              // EChEP nm
    u16 objwin_on:1;            // naiEChE nm

    u16 dispMode:2;             // \[h
    u16 dispVram:2;             // \uq`lI
    u16 objCharVramEx:2;        // naiLN^f[^uq`lg
    u16 objBmpVramEx:1;         // nairbg}bvf[^uq`lg
    u16 blankH_objOff:1;        // guNnai nee

    u16 bgCharBaseOffset:3;     // afLN^f[^x[XAhXEItZbg
    u16 bgScBaseOffset:3;       // afXN[f[^x[XAhXEItZbg
    u16 bgPlttEx:1;             //   afpbgg
    u16 objPlttEx:1;            // naipbgg
} DispCnt;
typedef  vl DispCnt   vDispCnt;


// Rc\Rg[\
typedef struct {
    u16 texMaster_on:1;         // eNX`}X^ nm
    u16 shadingEx:1;            // gVF[fBO[h
    u16 alphaTest_on:1;         // At@eXg nm
    u16 alphaBlend_on:1;        // At@uh nm
    u16 antiAliasing_on:1;      // A`GAVO nm
    u16 edgeMarking_on:1;       // GbW}[LO nm
    u16 fogMode:1;              // tHO[h
    u16 fogMaster_on:1;         // tHO}X^ nm

    u16 fogIndex:4;             // tHO CfbNX͈
    u16 render_over:1;          // _O I[o[t[
    u16 geometry_over:1;        // WIg I[o[t[
    u16 clearImage_on:1;        // v_OC[W nm
} Disp3DCnt;
typedef  vl Disp3DCnt   vDisp3DCnt;


// \Xe[^X\
typedef struct {
    u16 blankingV:1;            // uuNԒ
    u16 blankingH:1;            // guNԒ
    u16 countV:1;               // uJE^v
    u16 blankV_if_enable:1;     // uuN荞ݗv 
    u16 blankH_if_enable:1;     // guN荞ݗv 
    u16 countV_if_enable:1;     // uJE^v荞ݗv 
    u16 :1;
    u16 setV_d8:1;              // uJE^rlݒicWj
    u16 setV:8;                 //                     icV|Oj

    u16 readV:9;                // uJE^ݒl
    u16 :0;
} DispStat;
typedef  vl DispStat   vDispStat;


// \Lv`Rg[\
typedef struct {
    u16 gfxBlendWeight:8;       // OtBbNX̃uhW
    u16 ramBlendWeight:8;       // q`l̃uhW

    u16 destVram:2;             // ݂uq`lw
    u16 destVramOffset:2;       // ݂uq`lAhXEItZbg
    u16 size:2;                 // Lv`TCY
    u16 :2;
    u16 dispSrc:1;              // \ǂݍݎw
    u16 ramSrc:1;               // q`lǂݍݎw
    u16 srcVramOffset:2;        // ǂݍ݂uq`lAhXEItZbg
    u16 :1;
    u16 blendMode:2;            // uh[h
    u16 enable:1;               // Lv`Cl[u
} DispCapCnt;
typedef  vl DispCapCnt   vDispCapCnt;



// UCNRg[\
typedef struct {
    u16 sizeBgH:4;              //   afUCN gTCY
    u16 sizeBgV:4;              //   afUCN uTCY
    u16 sizeObjH:4;             // naiUCN gTCY
    u16 sizeObjV:4;             // naiUCN uTCY
} MosCnt;
typedef  vl MosCnt    vMosCnt;


// uhRg[\
typedef struct {
    u16 nearPixel_bg0_on:1;     // PsNZ
    u16 nearPixel_bg1_on:1;
    u16 nearPixel_bg2_on:1;
    u16 nearPixel_bg3_on:1;
    u16 nearPixel_obj_on:1;
    u16 nearPixel_bd_on:1;
    u16 blendMode:2;            // uh[h
    u16 farPixel_bg0_on:1;      // QsNZ
    u16 farPixel_bg1_on:1;
    u16 farPixel_bg2_on:1;
    u16 farPixel_bg3_on:1;
    u16 farPixel_obj_on:1;
    u16 farPixel_bd_on:1;
    u16 :2;
    u16 a:5;                    // p[^ `
    u16 :3;
    u16 b:5;                    // p[^ a
    u16 :3;
    u16 y:5;                    // p[^ x
    u16 :3;
} BlendCnt;
typedef  vl BlendCnt    vBlendCnt;


// EChERg[\
typedef struct {
    u8  bg0_on:1;               // afO nm
    u8  bg1_on:1;               // afP nm
    u8  bg2_on:1;               // afQ nm
    u8  bg3_on:1;               // afR nm
    u8  obj_on:1;               // nai nm
    u8  blend_on:1;             // J[ nm
    u8  :2;
} WindCnt;
typedef  vl WindCnt     vWindCnt;



// afRg[\
typedef struct {
    u16 priority:2;             // \D
    u16 charBasep:2;            // LN^ x[XAhX
    u16 :2;
    u16 mosaic:1;               // UCN
    u16 colorMode:1;            // PUF^QTUF I
    u16 scBasep:5;              // XN[ x[XAhX
    u16 loop:1;                 // [v
    u16 size:2;                 // XN[TCY
} BgCnt;
typedef  vl BgCnt    vBgCnt;

// pbggafRg[\
typedef struct {
    u16 priority:2;             // \D
    u16 charBasep:2;            // LN^ x[XAhX
    u16 :2;
    u16 mosaic:1;               // UCN
    u16 colorMode:1;            // PUF^QTUF I
    u16 scBasep:5;              // XN[ x[XAhX
    u16 exPlttSlot:1;           // gpbg̃Xbg蓖
    u16 size:2;                 // XN[TCY
} ExPlttBgCnt;
typedef  vl ExPlttBgCnt    vExPlttBgCnt;


// afItZbgRg[\
typedef struct {
    u16 h;
    u16 v;
} BgOffsetCnt;
typedef  vl BgOffsetCnt    vBgOffsetCnt;


// afXN[\
typedef struct {
    u16 charNo:10;              // LN^m
    u16 flipH:1;                // gtbv
    u16 flipV:1;                // utbv
    u16 pltt:4;                 // pbgm
} BgScData;
typedef  vl BgScData       vBgScData;


// afAtBϊ\[Xf[^\
typedef struct {
    s32 srcCenterX;             // f[^SW << 8
    s32 srcCenterY;
    s16 dispCenterX;            // \SW
    s16 dispCenterY;
    s16 ratioX;                 // gk << 8
    s16 ratioY;
    s16 theta;                  // ]pi-128 ` 127j<< 8
} BgAffineSrcData;
typedef  vl BgAffineSrcData    vBgAffineSrcData;

// afAtBϊfXeBl[Vf[^\
typedef struct {
    s16 h_diffX;                // CwW
    s16 v_diffX;                //   wW
    s16 h_diffY;                // CxW
    s16 v_diffY;                //   xW
    s32 startX;                 // X^[gwW
    s32 startY;                 // X^[gxW
} BgAffineDestData;
typedef  vl BgAffineDestData   vBgAffineDestData;


// n`l\
typedef struct {
    u16 posV:8;                 // xW
    u16 affineMode:2;           // AtB[h
    u16 objMode:2;              // nai[h
    u16 mosaic:1;               // UCN
    u16 colorMode:1;            // PUF/QTUF I
    u16 shape:2;                // nai`

    u16 posH:9;                 // wW
    u16 affineParamNo_lo:3;     // AtBϊp[^m ʂRrbg
    u16 flipH:1;                // gtbv
    u16 flipV:1;                // utbv
    u16 size:2;                 // naiTCY

    u16 charNo:10;              // LN^m
    u16 priority:2;             // \D
    u16 pltt:4;                 // pbgm
    u16 affineParam;            // AtBϊp[^
} OamData;
typedef  vl OamData    vOamData;

// rbg}bvnaipn`l\
typedef struct {
    u16 posV:8;                 // xW
    u16 affineMode:2;           // AtB[h
    u16 objMode:2;              // nai[h
    u16 mosaic:1;               // UCN
    u16 colorMode:1;            // PUF/QTUF I
    u16 shape:2;                // nai`

    u16 posH:9;                 // wW
    u16 affineParamNo_lo:3;     // AtBϊp[^m ʂRrbg
    u16 flipH:1;                // gtbv
    u16 flipV:1;                // utbv
    u16 size:2;                 // naiTCY

    u16 charNo:10;              // LN^m
    u16 priority:2;             // \D
    u16 alpha:4;                // At@l
    u16 affineParam;            // AtBϊp[^
} BmpObjOamData;
typedef  vl BmpObjOamData    vBmpObjOamData;


// naiAtBϊ\[Xf[^\
typedef struct {
    s16 ratioX;                 // gk
    s16 ratioY;
    s16 theta;                  // ]pi-128 ` 127j<< 8
} ObjAffineSrcData;
typedef  vl ObjAffineSrcData   vObjAffineSrcData;

// naiAtBϊfXeBl[Vf[^\
typedef struct {
    s16 h_diffX;                // CwW
    s16 v_diffX;                //   wW
    s16 h_diffY;                // CxW
    s16 v_diffY;                //   xW
} ObjAffineDestData;
typedef  vl ObjAffineDestData  vObjAffineDestData;


// J[pbg\
typedef struct {
    u16 red:5;                  // 
    u16 green:5;                // 
    u16 blue:5;                 // 
    u16 :1;
} PlttData;
typedef  vl PlttData    vPlttData;



// C[WItZbgRg[\
typedef struct
{
    u16 x:8;
    u16 y:8;
} ClearImageOffsetCnt;
typedef  vl ClearImageOffsetCnt    vClearImageOffsetCnt;


// r[|[g\
typedef struct
{
    u16 x1:8;
    u16 y1:8;
    u16 x2:8;
    u16 y2:8;
} ViewPortCnt;
typedef  vl ViewPortCnt    vViewPortCnt;


// WIgGWXe[^X\
typedef struct {
    u16 testBusy:1;             // eXg
    u16 boxInView:1;            // {bNẌꕔ̐ϓɂ邩
    u16 :6;
    u16 posvecStackLevel:5;     // ʒuxNg}gNX   X^bNx
    u16 projStackLevel:1;       // vWFNV}gNX X^bNx
    u16 mtxStackBusy:1;         // }gNXX^bN rW[
    u16 mtxStackError:1;        //                    I[o[t[ or A_[t[

    u16 fifoCount:8;            // WIgehen i[
    u16 fifoFull:1;             //                    t
    u16 fifoUnderHalf:1;        //                    n[tȉ
    u16 fifoEmpty:1;            //                    GveB
    u16 geometryBusy:1;         // WIgGW rW[
    u16 :2;
    u16 fifoIntrType:2;         // WIgehen 荞݃^Cv
} GxStat;
typedef  vl GxStat   vGxStat;


// s񃂁[h Rg[\
typedef struct {
    u16 mode;                   // s񃂁[h

    u16 pad;                    // pbḧ
} MtxModeCnt;
typedef  vl MtxModeCnt    vMtxModeCnt;


// |S Rg[\
typedef struct {
    u16 light0_on:1;            // CgO nm
    u16 light1_on:1;            // CgP nm
    u16 light2_on:1;            // CgQ nm
    u16 light3_on:1;            // CgR nm
    u16 renderMode:2;           // _O[h
    u16 backFace_on:1;          //  nm
    u16 frontFace_on:1;         // \ nm

    u16 :3;
    u16 xlu_depth_on:1;         // |S̃fvXobt@XV nm
    u16 farClipping_on:1;       // e`qNbsO nm
    u16 disp1Dot:1;             // Phbg\
    u16 depthTestMode:1;        // fvXeXg[h
    u16 fog_on:1;               // tHO nm

    u16 alpha:8;                // sx
    u16 id:8;                   // hc
} PolygonAttrCnt;
typedef  vl PolygonAttrCnt    vPolygonAttrCnt;


/// adfhm Rg[\
typedef struct {
    u16 primitiveType;          // v~eBu^Cv

    u16 pad;                    // pbḧ
} BeginCnt;
typedef  vl BeginCnt    vBeginCnt;


// eNX`p[^ Rg[\
typedef struct {
    u16 imageBasep;             // C[Wx[XAhX

    u16 repeatS:1;              // rs[g
    u16 repeatT:1;              // s
    u16 flipS:1;                // rtbv
    u16 flipT:1;                // s
    u16 sizeS:3;                // rTCY
    u16 sizeT:3;                // s
    u16 format:3;               // eNX`tH[}bg
    u16 pltt0_off:1;            // J[pbgO nee
    u16 coordGenSrc:2;          // Wϊ\[X

    u16 plttBasep;              // pbgx[XAhX

    u16 pad;                    // pbḧ
} TexParamCnt;
typedef  vl TexParamCnt    vTexParamCnt;

// eNX`C[Wp[^ Rg[\
typedef struct {
    u16 imageBasep;             // C[Wx[XAhX

    u16 repeatS:1;              // rs[g
    u16 repeatT:1;              // s
    u16 flipS:1;                // rtbv
    u16 flipT:1;                // s
    u16 sizeS:3;                // rTCY
    u16 sizeT:3;                // s
    u16 format:3;               // eNX`tH[}bg
    u16 pltt0_off:1;            // J[pbgO nee
    u16 coordGenSrc:2;          // Wϊ\[X
} TexImageParamCnt;
typedef  vl TexImageParamCnt  vTexImageParamCnt;

// eNX`pbgx[XAhX Rg[\
typedef struct {
    u16 plttBasep;              // pbgx[XAhX

    u16 pad;                    // pbḧ
} TexPlttBaseCnt;
typedef  vl TexPlttBaseCnt    vTexPlttBaseCnt;



// cl`Rg[\
typedef struct {
    u16 count;                  // ]
    u16 :5;
    u16 destpCnt:2;             // ]AhX Rg[
    u16 srcpCnt:2;              // ]AhX Rg[
    u16 continuous:1;           // ReBjAX[h
    u16 busSize:1;              // oXTCY PU/RQaI
    u16 timming:3;              // ^C~OI
    u16 if_enable:1;            // 荞ݗv 
    u16 enable:1;               // cl`
} DmaCnt;
typedef  vl DmaCnt    vDmaCnt;


// ^C}[Rg[\
typedef struct {
    u16 count;                  // JEg
    u16 prescaler:2;            // vXP[I
    u16 connect:1;              // ʃ^C}[ڑ
    u16 :3;
    u16 if_enable:1;            // 荞ݗv 
    u16 enable:1;               // ^C}[

    u16 pad:8;                  // pbḧ
} TimerCnt;
typedef  vl TimerCnt    vTimerCnt;


// L[f[^\
typedef struct {
    u16 a:1;                    // `
    u16 b:1;                    // a
    u16 select:1;               // ZNg
    u16 start:1;                // X^[g
    u16 plusR:1;                // E
    u16 plusL:1;                // 
    u16 plusU:1;                // 
    u16 plusD:1;                // 
    u16 r:1;                    // q
    u16 l:1;                    // k
    u16 :6;
} KeyData;
typedef  vl KeyData    vKeyData;

// L[Rg[\
typedef struct {
    u16 sel_a:1;                //       `{^ I
    u16 sel_b:1;                //       a{^ I
    u16 sel_select:1;           // ZNg{^ I
    u16 sel_start:1;            // X^[g{^ I
    u16 sel_plusR:1;            //         EL[ I
    u16 sel_plusL:1;            //         L[ I
    u16 sel_plusU:1;            //         L[ I
    u16 sel_plusD:1;            //         L[ I
    u16 sel_r:1;                //       q{^ I
    u16 sel_l:1;                //       k{^ I
    u16 :4;
    u16 if_enable:1;            // 荞ݗv 
    u16 intrType:1;             // 荞݃^Cv I
} KeyCnt;
typedef  vl KeyCnt    vKeyCnt;


// ORg[\
typedef struct {
    u16 ctrdgDt8_cycles:2;      // J[gbW  Wf[^oX ANZXTCN
    u16 ctrdgtAd16_1stCycles:2; //               `cPUoX PANZXTCN
    u16 ctrdgAd16_2ndCycles:1;  //                            QANZXTCN
    u16 ctrdgPhiClock:2;        //               Ӓ[qo̓NbN I
    u16 ctrdgAccess:1;          //               ANZXI
    u16 :3;
    u16 cardAccess:1;           // J[hANZXI
#ifdef IRIS_TS
    u16 mainmemByteAccess:1;    // CoCgANZXo
    u16 mainmemCE2:1;           //             bdQMo
#else
    u16 :2;
#endif
    u16 mainmemInterface:1;     //             C^tF[X
    u16 mainmemPriority:1;      //             D挠
} ExMemCnt;
typedef  vl ExMemCnt    vExMemCnt;


// Bitkf[^WJpp[^
typedef struct {
    u16 srcNum;                 // \[Xf[^EoCg
    u16 srcBitNum:8;            // P\[Xf[^Erbg
    u16 destBitNum:8;           // PfXeBl[Vf[^Erbg
    u32 destOffset:31;          // \[Xf[^ɉZ鐔
    u32 destOffset0_on:1;       // Õf[^ɃItZbgZ邩ۂ̃tO
} UnPackBitsParam;
typedef  vl UnPackBitsParam    vUnPackBitsParam;


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_TYPES_H
