//====================================================================
//          IrisUTL.h
//            [eBeBCu
//
//          Copyright (C) 2003 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_UTL_H
#define _IRIS_UTL_H


#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisTypes.h>



//======================================================================
//          NA  Rs[
//======================================================================

//----------------------------------------------------------------------
//          bot PUNA
//
//ECPUɂ16bitf[^ŃNA܂B
//
//EF
//  data    NAf[^
//  destp   fXeBl[VAhX
//  size    NATCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuClear16(u32 data, void *destp, s32 size);

//----------------------------------------------------------------------
//          bot PURs[
//
//ECPUɂ16bitŃRs[܂B
//
//EF
//  srcp    \[XAhX
//  destp   fXeBl[VAhX
//  size    ]TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuCopy16(const void *srcp, void *destp, s32 size);

//----------------------------------------------------------------------
//          bot RQNA
//
//ECPUɂ32bitf[^ŃNA܂B
//
//EF
//  data    NAf[^
//  destp   fXeBl[VAhX
//  size    NATCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuClear32(u32 data, void *destp, s32 size);

//----------------------------------------------------------------------
//          bot RQRs[
//
//ECPUɂ32bitŃRs[܂B
//
//EF
//  srcp    \[XAhX
//  destp   fXeBl[VAhX
//  size    ]TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuCopy32(const void *srcp, void *destp, s32 size);

//----------------------------------------------------------------------
//          bot NA
//
//ECPUɂ32bitf[^ōɃNA܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕XgA߂gp܂B
//
//EF
//  data    NAf[^
//  destp   fXeBl[VAhX
//  size    NATCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuClearFast(u32 data, void *destp, s32 size);

//----------------------------------------------------------------------
//          bot Rs[
//
//ECPUɂ32bitōɃRs[܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕[h^XgA߂gp܂B
//
//EF
//  srcp    \[XAhX
//  destp   fXeBl[VAhX
//  size    ]TCY
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_CpuCopyFast(const void *srcp, void *destp, s32 size);


//----------------------------------------------------------------------
//          f[^̃Xbvi[h^oCgj
//
//EsetDatadestpw̃f[^Xbv܂B
//EvZbTԂ⃂W[ԂŋL\[Xr䂷邽߂
//  XsbN邱Ƃł܂B
//
//EF
//  setData Zbgf[^
//  destp   Xbṽ|C^
//
//E߂lFXbv֒OɊi[Ăl
//
//AACɑ΂Ă̓LbVoRłȂ
//  oCgANZX͂łȂƂɒӂĉB
//  ł̂ŁACł͊{I UTL_SwapWord() gpĉB
//----------------------------------------------------------------------

s32 UTL_SwapWord(u32 setData, volatile u32 *destp);
u8  UTL_SwapByte(u32 setData, volatile u8  *destp);


//======================================================================
//          kf[^WJ
//======================================================================

//----------------------------------------------------------------------
//          akf[^WJ
//
//E0Œ̃rbgl߂f[^WJ܂B
//E\[XAhXɃCw肷ꍇ
//  f[^LbVLɂKv܂B
//EfXeBl[VAhX4ByteEɍ킹ĉB
//
//EF
//             void *srcp     \[XAhX
//             void *destp    fXeBl[VAhX
//  UnPackBitsParam *paramp   UnPackBitsParam\̃f[^̃AhX
//
//EUnPackBitsParam\
//    u16 srcNum              \[Xf[^EoCg
//    u8  srcBitNum           P\[Xf[^Erbg
//    u8  destBitNum          PfXeBl[Vf[^Erbg
//    u32 destOffset:31       \[Xf[^ɉZItZbg
//        destOffset0_On:1    Õf[^ɃItZbgZ邩ۂ̃tO
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnPackBits(const void *srcp, void *destp, UnPackBitsParam *paramp);


//----------------------------------------------------------------------
//          kyVVkf[^WWJ
//
//ELZ77kf[^WJA8bitPʂŏ݂܂B
//E\[XAhXAfXeBl[VAhXƂɁAC
//  w肷ꍇ̓f[^LbVLɂKv܂B
//EVRAMɒړWJ邱Ƃ͂ł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 1j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  flags               k^ktO
//                            i0, 1j = ikf[^, kf[^j
//ER[hf[^tH[}bgiBig Endianj
//    u16 length:4            WJf[^ - 3iv3Byteȏ㎞݈̂kj
//        offset:12           vf[^ItZbg - 1
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnCompLZ77Byte(const void *srcp, void *destp);


//----------------------------------------------------------------------
//          kyVVkf[^PUWJ
//
//ELZ77kf[^WJA16bitPʂŏ݂܂B
//Ef[^TCM⃁CɂWJł܂AUTL_UnCompLZ77Byte()
//  ᑬłB
//E\[XAhXɃCw肷ꍇ
//  f[^LbVLɂKv܂B
//Ekf[^͈v2ByteȑO茟̂ɂĉB
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 1j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  flags               k^ktO
//                            i0, 1j = ikf[^, kf[^j
//ER[hf[^tH[}bgiBig Endianj
//    u16 length:4            WJf[^ - 3iv3Byteȏ㎞݈̂kj
//        offset:12           vf[^ItZbgi >= 2j - 1
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnCompLZ77Short(const void *srcp, void *destp);


//----------------------------------------------------------------------
//          nt}kf[^WJ
//
//Ent}kf[^WJA32bitPʂŏ݂܂B
//E\[XAhXɃCw肷ꍇ
//  f[^LbVLɂKv܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 bitSize:4           Pf[^ErbgTCYiʏ 4|8j
//        compType:4          k^Cvi = 2j
//        destSize:24         WJ̃f[^TCY
//
//Ec[e[u
//    u8           treeSize        c[e[uTCY/2 - 1
//    TreeNodeData nodeRoot        [gm[h
//
//    TreeNodeData nodeLeft        [gm[h
//    TreeNodeData nodeRight       [gEm[h
//
//    TreeNodeData nodeLeftLeft    m[h
//    TreeNodeData nodeLeftRight   Em[h
//
//    TreeNodeData nodeRightLeft   Em[h
//    TreeNodeData nodeRightRight  EEm[h
//
//            E
//            E
//
//  ̌Ɉkf[^{
//
//ETreeNodeData\
//    u8  nodeNextOffset:6    m[hf[^ւ̃ItZbg - 1i2BytePʁj
//        rightEndFlag:1      Em[hItO
//        leftEndzflag:1       m[hItO
//                            ItOZbgĂꍇ
//                            m[hɃf[^
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnCompHuffman(const void *srcp, void *destp);


//----------------------------------------------------------------------
//          OXkf[^WWJ
//
//EOXkf[^WJA8bitPʂŏ݂܂B
//E\[XAhXAfXeBl[VAhXƂɁAC
//  w肷ꍇ̓f[^LbVLɂKv܂B
//EVRAMɒړWJ邱Ƃ͂ł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 3j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  length:7            WJf[^ - 1ikj
//                            WJf[^ - 3iA3Byteȏ㎞݈̂kj
//        flag:1              i0, 1j = ikf[^, kf[^j
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnCompRLByte(const void *srcp, void *destp);


//----------------------------------------------------------------------
//          OXkf[^PUWJ
//
//EOXkf[^WJA16bitPʂŏ݂܂B
//Ef[^TCM⃁CɂWJł܂AUTL_UnCompRLByte()
//  ᑬłB
//E\[XAhXɃCw肷ꍇ
//  f[^LbVLɂKv܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 3j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  length:7            WJf[^ - 1ikj
//                            WJf[^ - 3iA3Byteȏ㎞݈̂kj
//        flag:1              i0, 1j = ikf[^, kf[^j
//
//E߂lFȂ
//----------------------------------------------------------------------

void UTL_UnCompRLShort(const void *srcp, void *destp);



#ifdef __cplusplus
}
#endif

#endif  // _IRIS_UTL_H

