//======================================================================
//          IrisVEC.h
//            xNgCu
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_VEC_H
#define _IRIS_VEC_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisTarget.h>
#include <IrisTypes.h>


//----------------------------------------------------------------------
//          xNg̃Rs[
//
//EexNgԂŃTCYɍ킹ăRs[܂B
//EVEC_AlignPoint2Vec10() / VEC10_AlignPoint2Vec() 16bitxNg
//  10bitxNgԂł̌Œ菬_ʒu̒s܂B
//
//EF
//  srcp    ]xNg̃|C^
//  dstp    ]xNgobt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Copy2Vec10(const Vec   *srcp, Vec10 *dstp);
void VEC_Copy2Vec32(const Vec   *srcp, Vec32 *dstp);
void VEC32_Copy2Vec(const Vec32 *srcp, Vec   *dstp);

void VEC_AlignPoint2Vec10(const Vec   *srcp, Vec10 *dstp);
void VEC10_AlignPoint2Vec(const Vec10 *srcp, Vec   *dstp);

//----------------------------------------------------------------------
//          xNg̓
//
//EQ̃xNg̓ς߂܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//
//E߂lF
//----------------------------------------------------------------------

s32  VEC_DotProduct(      const Vec   *a, const Vec   *b);
s32  VEC32_DotProduct(    const Vec32 *a, const Vec32 *b);
s32  VEC32_DotProductFast(const Vec32 *a, const Vec32 *b);
s32  VEC32VEC_DotProduct( const Vec32 *a, const Vec   *b);
#define VEC2D_DotProduct(ax, ay, bx, by)		(((ax) * (bx) + (ay) * (by)) >>V_SFT)

//----------------------------------------------------------------------
//          xNg̊O
//
//EQ̃xNg̊OσxNg߁AaxbwxNg֊i[܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//  axb     OσxNgi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_CrossProduct(      Vec   *a, Vec   *b, Vec   *axb);
void VEC32_CrossProduct(    Vec32 *a, Vec32 *b, Vec32 *axb);
void VEC32_CrossProductFast(Vec32 *a, Vec32 *b, Vec32 *axb);
#define VEC2D_CrossProduct(ax, ay, bx, by)		(((ax) * (by) - (ay) * (bx)) >>V_SFT)

//----------------------------------------------------------------------
//          xNg̐K
//
//EsrcpwxNg𐳋KdstpwxNg֊i[܂B
//
//EF
//  srcp    KxNg̃|C^
//  dstp    KxNgi[obt@̃|C^
//
//E߂lFȂ
//
//ʏł͕ZƏZgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

void VEC_Normalize(      Vec   *srcp, Vec   *dstp);
void VEC32_Normalize(    Vec32 *srcp, Vec32 *dstp);
void VEC32_Normalize2Vec(Vec32 *srcp, Vec   *dstp);

//----------------------------------------------------------------------
//          xNg̉Z
//
//EQ̃xNgZʂa_bwxNg֊i[܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//  a_b     Z̃xNgi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Add(Vec *a, Vec *b, Vec *ab);

//----------------------------------------------------------------------
//          xNǧZ
//
//EQ̃xNgZʂa_bwxNg֊i[܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//  a_b     Z̃xNgi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Sub(Vec *a, Vec *b, Vec *a_b);

//----------------------------------------------------------------------
//          xNg̃XP[O
//
//EsrcpwxNgXP[OʂdstpwxNg֊i[܂B
//
//EF
//  srcp    XP[OÕxNg̃|C^
//  dstp    XP[ÕxNgi[obt@̃|C^
//  scale   XP[Op[^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Scale(Vec *srcp, Vec *dstp, s32 scale);

//----------------------------------------------------------------------
//          xNg̔]
//
//EsrcpwxNg𔽓]ʂdstpwxNg֊i[܂B
//
//EF
//  srcp    ]ÕxNg̃|C^
//  dstp    ]̃xNgi[obt@̃|C^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Reverse(const Vec *srcp, Vec *dstp);

//----------------------------------------------------------------------
//          xNg̑傫
//
//ExNg̑傫߂܂B
//
//EF
//  v       ̓xNg̃|C^
//
//E߂lF傫
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

u32  VEC_Magnitude(const Vec *v);

//----------------------------------------------------------------------
//          xNg̑傫̂Q
//
//ExNg̑傫̂Q߂܂B
//
//EF
//  v       ̓xNg̃|C^
//
//E߂lF傫̂Q
//----------------------------------------------------------------------

u32  VEC_SquareMagnitude(const Vec *v);

//----------------------------------------------------------------------
//          xNgԂ̋
//
//ExNgԂ̋߂܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//
//E߂lF
//
//Zgp邽߁ATCMŎsƂĂ
//  fBXvCXgDMA]ƃVXeoXŏՓ˂ꍇɂ
//  Xg[Ă܂܂B
//----------------------------------------------------------------------

u32  VEC_Distance(const Vec *a, const Vec *b);

//----------------------------------------------------------------------
//          xNgԂ̋̂Q
//
//ExNgԂ̋̂Q߂܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//
//E߂lF̂Q
//----------------------------------------------------------------------

u32  VEC_SquareDistance(const Vec *a, const Vec *b);

//----------------------------------------------------------------------
//          xNg̐`
//
//EQ̃xNg`ԂʂdwxNg֊i[܂B
//
//EF
//  a       PxNg̃|C^
//  b       QxNg̃|C^
//  d       ԃxNgi[obt@̃|C^
//  t       ԃp[^
//
//E߂lFȂ
//----------------------------------------------------------------------

void VEC_Lerp(Vec *a, Vec *b, Vec *d, s32 t);
void VEC32_Lerp(Vec32 *a, Vec32 *b, Vec32 *d, s32 t);
void VEC32_LerpFast(Vec32 *a, Vec32 *b, Vec32 *d, s32 t);



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_VEC_H
