//====================================================================
//          IrisCardDefine.h
//            IRIS J[h萔
//
//          Copyright (C) 2003,2004 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_CARD_DEFINE_H
#define _IRIS_CARD_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif



// J[hANZXERg[WX^\
typedef struct {
    u16 latency1:13;        // CeVP̃TCN
    u16 dataScramble_on:1;  // f[^XNu nm
    u16 scrambleUnit_on:1;  // XNuH nm
    u16 initScramblePN:1;   // XNuomf[^

    u16 latency2:6;         // CeVQ̃TCN
    u16 cmdScramble_on:1;   // R}hXNu nm
    u16 dataReady:1;        // f[^ fB

    u16 pages:3;            // y[W
    u16 clockType:1;        // NbN^CviPTO^QSOj
    u16 clockInLatency:1;   // CeVԂɃNbN
    u16 reset:1;            // ZbgM
    u16 accessMode:1;       // ANZX[h
    u16 start:1;            // X^[g
} CardCnt;


// J[hRg[Ep[^\
typedef struct {
    u32 dmaNo;              // DMAԍ
    u32 cardCnt;            // J[hRg[
    u32 op[2];              // R}h
} CardCtrlParam;


// J[h񓯊ǂݍ݊֐^錾
typedef void (* ReadCardAsyncFuncp)(void *romp, void *ramp, s32 size, CardCtrlParam *paramp);

// J[h荞݊֐^錾
typedef void (* CardIntrFuncp)(void);

// J[h荞݃[N\
typedef struct {
    u8   *romp;                     // ROMAhX
    u8   *ramp;                     // RAMAhX
    s32  restSize;                  // cTCY
    s32  blockSize;                 // ubNTCY
    CardCtrlParam  param;           // J[hANZXEp[^\
	ReadCardAsyncFuncp  AsyncFuncp; // J[hǂݍ݊֐
//	u32  pad;						// \
} CardIntrWork;



//----------------------------------------------------------------------
//                  J[hcl`
//----------------------------------------------------------------------

#define DmaReadCard(dmaNo, destp)                           \
                                                            \
    DmaSet(dmaNo, REG_CARD_DATA, destp,  (                  \
        DMA_ENABLE         | DMA_TIMMING_CARD |             \
        DMA_SRC_FIX        | DMA_DEST_INC     |             \
		DMA_CONTINUOUS_ON  |								\
        DMA_32BIT_BUS      | (1)))

#define DmaWriteCard(dmaNo, srcp)                           \
                                                            \
    DmaSet(dmaNo, srcp, REG_CARD_DATA,  (                   \
        DMA_ENABLE         | DMA_TIMMING_CARD |             \
        DMA_SRC_INC        | DMA_DEST_FIX     |             \
		DMA_CONTINUOUS_ON  |								\
        DMA_32BIT_BUS      | (1)))

//EJ[h|ԂDMA]s܂B
//
//EF
//  dmaNo       DMAԍ
//  srcp        \[XAhX
//  destp       fXeBl[VAhX


//----------------------------------------------------------------------
//                      J[h̃f[^]̓fBH
//----------------------------------------------------------------------

#define IsCardDataReady()                                   \
                                                            \
    (*(vu32 *)REG_CARDCNT & CARD_DATA_READY)

//EJ[h̃f[^]̓fBǂԂ܂B

//----------------------------------------------------------------------
//                      J[hf[^҂
//----------------------------------------------------------------------

#define WaitCardData()                                      \
{                                                           \
    while (!IsCardDataReady())    ;                         \
}

//EJ[hf[^]̏I҂܂B


//----------------------------------------------------------------------
//                      J[h̓rW[H
//----------------------------------------------------------------------

#define IsCardBusy()                                        \
                                                            \
    (*(vu32 *)REG_CARDCNT & CARD_START)

//EJ[hrW[ǂԂ܂B

//----------------------------------------------------------------------
//                      J[h҂
//----------------------------------------------------------------------

#define WaitCard()                                          \
{                                                           \
    while (IsCardBusy())   ;                                \
}

//EJ[h̏I҂܂B


//----------------------------------------------------------------------
//                      Rg[p[^liNORMAL[hj
//----------------------------------------------------------------------

#define GetCardCnt4Normal()                                 \
                                                            \
    (GetCardCnt4Game() & CARD_SCRAMBLE_CLEAR_MASK)

//ENORMAL[h̃Rg[p[^l܂B
//EXNu̐ݒ̓NA܂B

//----------------------------------------------------------------------
//                      Rg[p[^liSECURE[hj
//----------------------------------------------------------------------

#define GetCardCnt4Secure()                                 \
                                                            \
    (*(vu32 *)MROMCNT_SECURE_BUF & (CARD_CLOCK_TYPE | CARD_LATENCY_MASK))

//ESECURE[h̃Rg[p[^l܂B

//----------------------------------------------------------------------
//                      Rg[p[^liGAME[hj
//----------------------------------------------------------------------

#define GetCardCnt4Game()                                   \
                                                            \
    (*(vu32 *)MROMCNT_GAME_BUF)

//EGAME[h̃Rg[p[^l܂B


//----------------------------------------------------------------------
//                      Rg[p[^ ZbgiNORMAL[hj
//----------------------------------------------------------------------

#define SetCardCnt4Normal(param)                            \
                                                            \
    (*(vu32 *)MROMCNT_GAME_BUF = param)

//EGAME[h̃Rg[p[^Zbg܂B


//----------------------------------------------------------------------
//                      Rg[p[^ ZbgiSECURE[hj
//----------------------------------------------------------------------

#define SetCardCnt4Secure(param)                            \
                                                            \
    (*(vu32 *)MROMCNT_SECURE_BUF = param)

//ESECURE[h̃Rg[p[^Zbg܂B

//----------------------------------------------------------------------
//                      Rg[p[^ ZbgiGAME[hj
//----------------------------------------------------------------------

#define SetCardCnt4Game(param)                              \
                                                            \
    (*(vu32 *)MROMCNT_GAME_BUF = param)

//EGAME[h̃Rg[p[^Zbg܂B


//----------------------------------------------------------------------
//                      CeVQCeVP։Z
//----------------------------------------------------------------------

#define AddLatency2ToLatency1(param)                                \
                                                                    \
    ( (((param) &  CARD_LATENCY2_CYCLES_MASK)                       \
                >> CARD_LATENCY2_CYCLES_SHIFT)                      \
    +  ((param) & ~CARD_LATENCY2_CYCLES_MASK)                       \
    )

//EJ[h̏I҂܂B


//----------------------------------------------------------------------
//                      qnlGAE}bv
//----------------------------------------------------------------------

#define MROM_SECURE_AREA    0x4000              // SECUREGA
#define MROM_GAME_AREA      0x8000              //   GAMEGA

//----------------------------------------------------------------------
//                      qnlGAETCY
//----------------------------------------------------------------------

#define MROM_SEGMENT_SIZE   0x1000              // ZOgTCY
#define MROM_SECURE_SIZE    0x4000              // SECUREGATCY


//----------------------------------------------------------------------
//                      E}bv
//----------------------------------------------------------------------

#define MROMCNT_GAME_BUF    (ROM_HEADER_BUF + 0x60) //   GAME[hERg[f[^
#define MROMCNT_SECURE_BUF  (ROM_HEADER_BUF + 0x64) // SECURE[hERg[f[^


//----------------------------------------------------------------------
//                      WX^EAhX
//----------------------------------------------------------------------

#define REG_CARDMST_SPI_CNT (REG_BASE + 0x1a0)  // J[h}X^[rohRg[

#define REG_CARD_MASTER_CNT (REG_BASE + 0x1a1)  // J[h}X^[Rg[

#define REG_CARD_SPI_CNT    (REG_BASE + 0x1a0)  // J[hrohRg[
#define REG_CARD_SPI_DATA   (REG_BASE + 0x1a2)  //             f[^

#define REG_CARDCNT         (REG_BASE + 0x1a4)  // J[hRg[
#define REG_CARD_CMD        (REG_BASE + 0x1a8)  //       R}hݒ
#define REG_CARD_DATA       (REG_BASE + 0x100010) //     f[^

#define REG_CARD_PN_INIT    (REG_BASE + 0x1b0)  // J[homf[^l
#define REG_CARD_PNA_INIT_L (REG_BASE + 0x1b0)
#define REG_CARD_PNB_INIT_L (REG_BASE + 0x1b4)
#define REG_CARD_PNA_INIT_H (REG_BASE + 0x1b8)
#define REG_CARD_PNB_INIT_H (REG_BASE + 0x1ba)


//----------------------------------------------------------------------
//                      J[h }X^[Rg[
//----------------------------------------------------------------------

#define CARDMST_SEL_DEVICE          0x20        // foCXI
#define CARDMST_SEL_ROM             0x00        // }XNqnl^RcI
#define CARDMST_SEL_SPI             0x20        // rohI

#define CARDMST_IF_ENABLE           0x40        // 荞ݗv 
#define CARDMST_ENABLE              0x80        // J[hCl[u


//----------------------------------------------------------------------
//                      J[hroh Rg[
//----------------------------------------------------------------------

#define CARDSPI_SCK_MASK            0x03        // VtgNbN

#define CARDSPI_SCK_SHIFT           0

#define CARDSPI_SCK_4M              0x00        // VtgNbN SlgI
#define CARDSPI_SCK_2M              0x01        //                QlgI
#define CARDSPI_SCK_1M              0x02        //                PlgI
#define CARDSPI_SCK_524K            0x03        //            TQSjgI

#define CARDSPI_INV_CS              0x40        // ʐMIɁ^br_Eێ
#define CARDSPI_BUSY                0x80        // rW[


//----------------------------------------------------------------------
//                      J[hANZX Rg[
//----------------------------------------------------------------------

#define CARD_LATENCY1_CYCLES_MASK   0x00001fff  // CeVP̃TCN
#define CARD_LATENCY2_CYCLES_MASK   0x003f0000  // CeVQ̃TCN
#define CARD_LATENCY_MASK           0x003f1fff  // L킹}XN
#define CARD_PAGE_COUNT_MASK        0x07000000  // y[W

#define CARD_LATENCY1_CYCLES_SHIFT  0
#define CARD_LATENCY2_CYCLES_SHIFT  16
#define CARD_PAGE_COUNT_SHIFT       24

                                                // XNutOQ̃Zbg
#define CARD_SCRAMBLE_SET_MASK      ( CARD_SCRAMBLE_UNIT_ON | CARD_DATA_SCRAMBLE_ON \
                                    | CARD_CMD_SCRAMBLE_ON)
                                                // XNutOQ̃NA
#define CARD_SCRAMBLE_CLEAR_MASK    ( ~(CARD_INIT_SCRAMBLE_PN  \
                                      | CARD_SCRAMBLE_SET_MASK \
                                      | CARD_CLOCK_IN_LATENCY  \
                                      | CARD_WRITE_MODE))

#define CARD_DATA_SCRAMBLE_ON       0x00002000  // f[^XNu nm
#define CARD_SCRAMBLE_UNIT_ON       0x00004000  // XNuH nm
#define CARD_INIT_SCRAMBLE_PN       0x00008000  // XNuomf[^
#define CARD_CMD_SCRAMBLE_ON        0x00400000  // R}hXNu nm

#define CARD_DATA_READY             0x00800000  // f[^ fB

#define CARD_0_PAGE                 0x00000000  //   Oy[W
#define CARD_1_PAGE                 0x01000000  //   Py[W
#define CARD_2_PAGES                0x02000000  //   Qy[W
#define CARD_4_PAGES                0x03000000  //   Sy[W
#define CARD_8_PAGES                0x04000000  //   Wy[W
#define CARD_16_PAGES               0x05000000  // PUy[W
#define CARD_32_PAGES               0x06000000  // RQy[W
#define CARD_STATUS                 0x07000000  // Xe[^X[h

#define CARD_CLOCK_TYPE             0x08000000  // NbN ^Cv
#define CARD_CLOCK_150NS            0x00000000  // NbNTCN PTO
#define CARD_CLOCK_240NS            0x08000000  //                  QSO
#define CARD_CLOCK_IN_LATENCY       0x10000000  // CeVԂɃNbN
#define CARD_RESET_LO               0x00000000  // ZbgMx k
#define CARD_RESET_HI               0x20000000  //                    g
#define CARD_ACCESS_MODE            0x40000000  // ANZX [h
#define CARD_READ_MODE              0x00000000  // [h[h
#define CARD_WRITE_MODE             0x40000000  // Cg[h
#define CARD_START                  0x80000000  // X^[g

// \̃op萔

#define ST_CARD_0_PAGE              0           //   Oy[W
#define ST_CARD_1_PAGE              1           //   Py[W
#define ST_CARD_2_PAGES             2           //   Qy[W
#define ST_CARD_4_PAGES             3           //   Sy[W
#define ST_CARD_8_PAGES             4           //   Wy[W
#define ST_CARD_16_PAGES            5           // PUy[W
#define ST_CARD_32_PAGES            6           // RQy[W
#define ST_CARD_STATUS              7           // Xe[^X[h

#define ST_CARD_CLOCK_150NS         0           // NbNTCN PTO
#define ST_CARD_CLOCK_240NS         1           //                  QSO

#define ST_CARD_READ_MODE           0           // [h[h
#define ST_CARD_WRITE_MODE          1           // Cg[h


//----------------------------------------------------------------------
//                      }XNqnlR}h
//----------------------------------------------------------------------

// NORMAL[h

#define MROMOP_N_OP_MASK              0xff000000  // R}h}XN

#define MROMOP_N_READ_ID              0x90000000  // hcǂݍ
#define MROMOP_N_READ_PAGES           0x00000000  // y[WQǂݍ
#define MROMOP_N_LOAD_TABLE           0x9f000000  // tbVEe[uݒ
#define MROMOP_N_CHANGE_MODE          0x3c000000  // SECURE[h֑J

#define MROMOP_N_READ_ID_PAD_L        0xffffffff
#define MROMOP_N_READ_ID_PAD_H        0x00ffffff
#define MROMOP_N_READ_PAGES_PAD_L     0xffffffff
#define MROMOP_N_READ_PAGES_PAD_H     0x00ffffff
#define MROMOP_N_READ_PAGES_ADDR_MASK 0x000ffffe
#define MROMOP_N_CHANGE_SECURE_PAD_L  0xf00000ff
#define MROMOP_N_CHANGE_SECURE_PAD_H  0x00000000

#define MROMOP_N_VAE_MASK_H           0x00ffffff

#define MROMOP_N_VBI_SHIFT_L          8

// SECURE[h

#define MROM_S_LATENCY1_CYCLES_MIN    0x00008f8   // CeVP̍ŏTCN
#define MROM_S_LATENCY2_CYCLES_MIN    0x0000018   // CeVQ̍ŏTCN

#define MROMOP_S_OP_MASK              0xf0000000  // R}h}XN

#define MROMOP_S_READ_ID              0x10000000  // hcǂݍ
#define MROMOP_S_READ_SEGMENT         0x20000000  // ÍZOgǂݍ
#define MROMOP_S_PNG_ON               0x40000000  // omWFl[^ nm
#define MROMOP_S_PNG_OFF              0x60000000  // omWFl[^ nee
#define MROMOP_S_CHANGE_MODE          0xa0000000  // GAME[h֑J

#define MROMOP_S_VA_MASK_L            0xfff00000
#define MROMOP_S_VA_MASK_H            0x00000fff
#define MROMOP_S_VB_MASK_L            0x000fffff
#define MROMOP_S_VC_MASK_H            0x0ffff000
#define MROMOP_S_VD_MASK_L            0xfff00000
#define MROMOP_S_VD_MASK_H            0x00000fff

#define MROMOP_S_VA_SHIFT_L           20
#define MROMOP_S_VA_SHIFT_H           12
#define MROMOP_S_VC_SHIFT_H           12
#define MROMOP_S_VD_SHIFT_L           20
#define MROMOP_S_VD_SHIFT_H           12

// GAME[h

#define MROMOP_G_OP_MASK              0xff000000  // R}h}XN

#define MROMOP_G_READ_ID              0xb8000000  // hcǂݍ
#define MROMOP_G_READ_PAGE            0xb7000000  // y[Wǂݍ

#define MROMOP_G_READ_PAGE_PAD_L      0x00ffffff
#define MROMOP_G_READ_PAGE_PAD_H      0x00f00000
#define MROMOP_G_READ_PAGE_MASK_L     0x00ffffff
#define MROMOP_G_READ_PAGE_MASK_H     0xfffffffe
#define MROMOP_G_READ_PAGE_ADDR_MASK  0x000ffffe



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_CARD_DEFINE_H
