//======================================================================
//					hqhrj^vOL̈`
//======================================================================
#ifndef	_IRIS_MON_SHARED_AREA_H
#define	_IRIS_MON_SHARED_AREA_H


#include "IrisSubpMonTarget.h"
#include <IrisCardDefine.h>


typedef void (*IntrFuncp)(void);


// ROMwb_Eu[gp[^\
typedef struct {
	u8 *romAddr;				// ROMAhX
	u8 *entryAddr;				// GgAhX
	u8 *ramAddr;				// RAMAhX
	s32 romSize;				// ROMTCY
} BootUsrParam;

// ROMwb_\
typedef struct {
	s8  titleName[12];			// \tg^Cg
	u32 initialCode;			// CjVR[h

	u16 makerCode;				// [J[R[h
	u8  machineCode;			// {̃R[h
	u8  deviceType;				// foCX^Cv

	u8  nonVerReserved[4];		// \i4oCgj
	u8  verDepReserved[4];		// \io[WˑA4oCgj
	u16 wirelessSerialNo;		// VANo
	u16 softVersion:8;			// \tgo[W

	u16 compArm9BootArea:1;		// ARM9u[gGAktO
	u16 compArm7BootArea:1;		// ARM7u[gGAktO
	u16 :0;

	BootUsrParam arm9;			// ARM9u[gp[^
	BootUsrParam arm7;			// ARM7u[gp[^

	u32 fileSysReserved[8];		// t@CVXe\i32oCgj

	CardCnt romCtrl4Game;		// ROMRg[iNORMAL & GAME[hj
	CardCnt romCtrl4Secure;		//                    iSECURE[hj
	u8  romCtrlReserved_l[4];	// \
	u16 secureCRC16;			// ZLÄCRC16bit
	u16 romTimerLatency;		// ^C}[CeVi(TCN/256) - 2A3Dpj
	u8  romReserved_h[8];		// \
	u32 romNormalModeKey[2];	// NORMAL[hL[

	u8  reserved[64];			// \̈i64oCgj

	u16 nintendoLogo[0x9c/2];	// NINTENDOSi156oCgj
	u16 ninLogoCRC16;			// NINTENDOSCRC16
	u16 headerCRC16;			// wb_CRC16

	u8 *dbgRomAddr;				// fobKj^ROMAhX
	s32 dbgRomSize;				// fobKj^ROMTCY
	u8 *dbgArm9RamAddr;			// fobKj^ARM9-RAMAhX
	u8 *dbgArm7RamAddr;			// fobKj^ARM7-RAMAhX
} RomHeader;


// tbVwb_\
typedef struct {
	u32 macAddr_l;				// MACAhX Low
	u16 macAddr_h;				//             High
	u16 crc16;					// CRC16bit
	u32 blowfishKey;			// BLOWFISHL[
	u16 arm9RomOffset;			// ARM9-tbVItZbg
	u16 arm9RamInvOffset;		// ARM9-RAMItZbg

	u16 arm7RomOffset;			// ARM7-tbVItZbg
	u16 arm7RamInvOffset;		// ARM7-RAMItZbg

	u16 arm9RomAlign:3;			// ARM9-tbVItZbgE
	u16 arm9RamAlign:3;			// ARM9-RAMItZbgE
	u16 arm7RomAlign:3;			// ARM7-tbVItZbgE
	u16 arm7RamAlign:3;			// ARM7-RAMItZbgE
	u16 arm7PlaceMmem:1;		// ARM7-RAMCzutO
	u16 :0;						// \3bit

	u16 rsv2Byte;				// \

	u32 unScrambleKey[2];		// XNuL[i8oCgj
} FlashHeader;


// ZLA[N\
typedef struct {
	u8  recvRtcBuf[8];			// RTCf[^Mobt@iv4oCgEj

	u16 flashCrc16;				// tbVCRC16
	u16 flashCount;				// tbV 8oCgJEg
	u32 flashBuf[2];			// tbVMobt@iv4oCgEj
	u32 flashKeyBuf[3];			// tbVL[Ee|obt@
    u32 unScrambleKey[2];		// XNuL[i8oCgAMakeBlowfishTable() ŎZoj
	s16 isGenUnScrambleKey;		// XNuL[iMakeBlowfishTable() Őݒj

	u32 va;						// 24biti24bitMj
	u32 vb;						// 20biti+`4bitAVBI: 32bitMj
	u32 vc_dummy;				// 16biti16bitMj
	u32 vd;						// 24biti24bitMj

	CardCnt cardCntBak4Secure;	// SECURER}hp[^EobNAbv
	s16 enableReadSecure;		// SECURË惊[hECl[uiLoadSecure4Card() Őݒj
	u32 cardNormalModeKey[2];	// NORMAL[hL[iMakeBlowfishTable() ŎZoj
	u32 cardKeyBuf[3];			// J[hL[Ee|obt@
	s32 secureSize;				// SECURËTCY
	s16 sequenceNo4Secure;		// V[PXԍiSECUREpj
	s16 segmentTblShift;		// ZOgԍe[uVtgliSECUREpj
	u8  *segmentTblp;			// ZOge[u|C^iSECUREpj
	s16 numSecureSegment;		// SECUREZOgiSECUREpj
	s16 segmentOffset;			// ZOgItZbgiSECUREpj
	s16 blockOffset;			// ubNItZbgiSECUREpj

    CardCtrlParam paramBak;		// J[hp[^ ÍOobNAbviSECUREpj

#ifdef TEST_HUFFMAN 

	u8  huffTableBuf[512];		// nt}e[uobt@

#endif

#ifdef TRACE_SECURE_OP 

	s16 traceSecureOp;			// SECURER}h̃g[X
	s16 traceOpCount;
    							// J[hp[^ g[XiSECUREpj
    CardCtrlParam paramTrace[64];

#endif

	BLOWFISH_CTX  blowfishCardTable;	// J[hpBlowfishe[u
	BLOWFISH_CTX  blowfishFlashTable;	// tbVpBlowfishe[u

	u8 bufEnd[4];				// ZLA[NŏIf[^
} SecureWork;


// L[N\
typedef struct {
	u32 nCardID;				// NORMALJ[hIDiLoadCardHeader() Ŏ擾j
	u32 sCardID;				// SECUREJ[hIDiCardTimerIntr4Secure() Ŏ擾j
	u16 cardHeaderCrc16;		// J[hwb_CRC16iLoadCardHeader() ŎZoj
	u16 cardSecureCrc16;		// J[hSECURËCRC16iLoadSecure4Card() ŎZoj
	s16 cardHeaderError;		// J[hwb_G[iCheckCardHeader() Őݒj
	s16 disableEncryptedCardData;// J[hSECURËÍf[^iDecryptObjectFile() Őݒj

	s16 cardSequenceNo;			// J[hǂݍ݃V[PXԍ
	s16 enableCardNormalOnly;	// J[hNORMAL[ĥݗLiLoadFlashDemo() Őݒj

	s16 isOnDebugger;			// fobKœ쒆
	s16 rtcError;				// RTCG[

	u32 recvRtc[2];				// RTCXe[^X1^C}[f[^iv4oCgEj

	u8 *flashArm9RamAddr;		// tbVARM9-RAMAhX
	u8 *flashArm7RamAddr;		// tbVARM7-RAMAhX
	s16 flashArm9HeaderError;	// tbVEARM9wb_G[
	s16 flashArm7HeaderError;	//                   ARM7wb_G[
	s16 flashCrcError;			// tbVCRCG[
	s16 flashReserved;			// tbV\̈
	FlashHeader  flashHeader;	// tbVwb_

	u16 sysromCrc16;			// VXeROMCRC16
} SharedWork;


//----------------------------------------------------------------------
//                      L[N̈̃AhXl
//----------------------------------------------------------------------

#define GetSharedWorkAddr()                                 \
                                                            \
    ((SharedWork *)0x027ff800)

//EL[N̈̃AhXl܂B
//E 2KB

//----------------------------------------------------------------------
//                      ZLA[N̈̃AhXl
//----------------------------------------------------------------------

#if !defined(MOVE_TRACE_SECURE_BUF) && !defined(TEST_AGB_MODE)

#define GetSecureWorkAddr()                                 \
                                                            \
    ((SecureWork *)0x037f8000)
#else

#define GetSecureWorkAddr()                                 \
                                                            \
    ((SecureWork *)0x0380d000)
//    ((SecureWork *)0x027fc000)

#endif

//EZLA[N̈̃AhXl܂B
//E 9KB

//----------------------------------------------------------------------
//                      J[h荞݃[N̈̃AhXl
//----------------------------------------------------------------------

#define GetCardIntrWorkAddr()                               \
                                                            \
    ((CardIntrWork *)0x0380fc00)
//    ((CardIntrWork *)0x027ff880)
//    ((CardIntrWork *)((u32 )GetSecureWorkAddr() + sizeof(SecureWork)))
//    (&GetSharedWorkAddr()->cardIntrWork)

//EJ[h荞݃[N̈̃AhXl܂B

//----------------------------------------------------------------------
//                      tbVwb_AhXl
//----------------------------------------------------------------------

#define GetFlashHeaderAddr()                                \
                                                            \
    (&GetSharedWorkAddr()->flashHeader)

//EtbVwb_̃AhXl܂B

//----------------------------------------------------------------------
//                      }XNROMwb_AhXl
//----------------------------------------------------------------------

#define GetRomHeaderAddr()                                  \
                                                            \
    ((RomHeader *)ROM_HEADER_BUF)

//E}XNROM̃wb_AhXl܂B



#endif	// _IRIS_MON_SHARED_AREA_H
