//*******************************************************************
//			    	IRIS-SUBPj^vO
//*******************************************************************
#include "IrisSubpMon.h"



//----------------------------------------------------------------------
//     					C[`
//----------------------------------------------------------------------

extern u8 SecureAreaEndp[];

CardIntrWork  *cardIntrWorkp;
RomHeader     *romHeaderp;

void Iris2Agb(void);

s32 CalledFormIPL2(void);

s32 CheckCardHeader(void);
s32 CheckCartridgeHeader(void);
void LoadCardHeader(void);
void LoadSecure4Card(void);


#define CARD_DMA_NO			3


void IrisSubpMonMain()
{
	SharedWork *shwp = GetSharedWorkAddr();

	NotifyMainpIntf(0);										// u[gEnhVFCN

#ifdef NDEBUG

	WaitMainpIntf(1);
	NotifyMainpIntf(1);

#endif  // NDEBUG

	InitReg();												// WX^
	PreInitRam();											// 

	WaitMainpIntf(2);										// ARM9 ҂ǐŏLWX^ݒ肪LɂȂj

	*(vu32 *)REG_CARDCNT = CARD_RESET_HI;					// J[h X^[giZbgMAINPōsĂAOݒj
	*(vu8 *)REG_CARD_MASTER_CNT = CARDMST_SEL_ROM | CARDMST_ENABLE;	// J[h}X^[Cl[u

	PostInitRam();											// ip[NRAMNAA
															//				 J[hZbgHIԂɊ܂܂j
	InitRtc();												// RTC & [hip[NRAMgpA
															//					   J[hZbgHIԂɊ܂܂j

	*(u32 *)REG_TM0CNT = TMR_PRESCALER_256CK | TMR_ENABLE;  // ^C}[ X^[g
	*(u32 *)REG_TM1CNT = TMR_CONNECT | TMR_ENABLE;

	sharedWorkp = GetSharedWorkAddr();						// L[N̈fobOp
	secureWorkp = GetSecureWorkAddr();						// ZLA[N̈fobOp
	cardIntrWorkp = GetCardIntrWorkAddr();					// J[h荞݃[N̈
	romHeaderp    = GetRomHeaderAddr();						// ROMwb_̈

	shwp->sysromCrc16 = GetInvCRC16(NULL, BIOS_SIZE);		// VXeROMCRCZoiCNAA
															//						 J[hZbgHIԂɊ܂܂j
	NotifyMainpIntf(2);										// ̒ʒm

	intrTable[0] = CardIntr;								// J[h荞݊֐ Zbg

	LoadCardHeader();										// J[hwb_̈̃[h

	LoadFlashHeader();										// tbVwb_̃[h

#ifndef NDEBUG 

	WaitMainpIntf(15);										// fobOʐM

#endif  // NDEBUG

	LoadSecure4Card();										// J[hZLÄi+FLASHfj̃[h

	*(vu16 *)REG_TM0CNT_H = 0;								// ^C}[~
	*(vu16 *)REG_TM1CNT_H = 0;

#ifdef DISP_READY_CARD_4_IPL2

	NotifyMainpIntf(9);										// IPL2J[hǂݍݏʒm
	while(1)	;

#endif	// DISP_READY_CARD_4_IPL2

#ifdef DISABLE_BOOT_IPL2

	intrTable[0] = CardIntr;								// J[h荞݊֐ ăZbg

	while (CalledFormIPL2() != -1) {						// IPL2Ăяo
		WaitVBlank(1);
	}

#endif	// DISABLE_BOOT_IPL2

    *(vu32 *)REG_IME = 0;									// IME NA
    *(vu32 *)REG_IE = 0;									// IE  NA
    *(vu32 *)REG_IF = -1;									// IF  NA

	NotifyMainpIntf(3);										// _E[h̒ʒm
	WaitMainpIntf(3);
}


//----------------------------------------------------------------------
//     					ROMwb_̈̃[h
//----------------------------------------------------------------------

void LoadCardHeader(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();

	*(vu8 *)REG_CARD_MASTER_CNT = CARDMST_SEL_ROM						// J[h}X^[Cl[u
								| CARDMST_ENABLE | CARDMST_IF_ENABLE;

   	LoadCardTable();													// tbVEe[uݒ

	ReadCardHeader();													// ROMwb_ǂݍ

	shwp->cardHeaderCrc16 = GetInvCRC16((u16 *)rmhp, 0x15e);			// ROMwb_CRCZo

																		// NbN^CvƃCeVݒȊO NA
	SetCardCnt4Normal(GetCardCnt4Normal() & (CARD_CLOCK_TYPE | CARD_LATENCY_MASK));

	shwp->nCardID = ReadCardID4Normal();								// J[hIDi[
}


#ifdef BOOT_FROM_CARTRIDGE

void LoadHeader4Cartridge(void)
{
    *(vu32 *)REG_EXMEMCNT = CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC;	// 10-6ANZXiC/J[h֌W̓[hI[j

    CpuCopy16_32(CTRDG_AD16_BANK0, ROM_HEADER_BUF, 0x170, 32);			// ROMwb_ǂݍ
}

#endif	// BOOT_FROM_CARTRIDGE


//----------------------------------------------------------------------
//     					J[hwb_̃`FbN
//----------------------------------------------------------------------

#define IS_EXIST_CARD_WORD	0xcf56	// 0x2e03

s32 CheckCardHeader(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();
	u32 retval;

	*(vu16 *)(MAIN_MEM_EX_END - 0x4) = 1;						// wb_ǂݍݎstO 
	shwp->cardHeaderError = 1;

	if (shwp->cardHeaderCrc16 != rmhp->headerCRC16)	return  1;	// ROMwb_CRC`FbN

	if (rmhp->ninLogoCRC16 != IS_EXIST_CARD_WORD)	return  1;

	*(vu16 *)(MAIN_MEM_EX_END - 0x4) = 0;						// wb_ǂݍݐtO Zbg
	shwp->cardHeaderError = 0;

	return  0;
}


//----------------------------------------------------------------------
//     					J[gbWwb_̃`FbN
//----------------------------------------------------------------------

#ifdef BOOT_FROM_CARTRIDGE

s32 CheckCartridgeHeader(void)
{
	if ((*(u32 *)(ROM_HEADER_BUF + 0) != *(vu32 *)"NINT")
	 || (*(u32 *)(ROM_HEADER_BUF + 4) != *(vu32 *)"ENDO")) {
		return  1;
	}

	*(vu16 *)(MAIN_MEM_EX_END - 0x4) = 0;						// wb_ǂݍݐtO Zbg

	return  0;
}

#endif	// BOOT_FROM_CARTRIDGE


//----------------------------------------------------------------------
//     					ROMZLÄ̃[h
//----------------------------------------------------------------------
extern u32 png_off_key[];

void LoadSecure4Card(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();
	FlashHeader *fhp = GetFlashHeaderAddr();
	u8  *loadStartp = (void *)((u32 )rmhp->arm9.romAddr & ~(MROM_SEGMENT_SIZE - 1));
	u8  *loadDestp  = rmhp->arm9.ramAddr;
	s32  loadSize   = rmhp->arm9.romSize;
	s32  secureSize = MROM_GAME_AREA - (s32 )loadStartp;

	if (secureSize < 0)		secureSize = 0;							// SECURËTCY␳
	scwp->secureSize = secureSize;

	ClearMmemSecureArea();											// ZLeB̂߃C擪64KBONA

	InitSecureParamFook();											// SECURE[hp[^ 

	if (!CheckCardHeader()											// J[hEwb_̃`FbN
	 && !shwp->enableCardNormalOnly									// NORMALJ[hE`FbN
	 && !shwp->rtcError												// RTCG[`FbN
	 && (secureSize > 0)											// AhX̃`FbN
	 && ((loadStartp >= (u8 *)MROM_SECURE_AREA) && (loadStartp < (u8 *)MROM_GAME_AREA))
	 && ((loadDestp  >= (u8 *)MAIN_MEM)         && (loadDestp  < (u8 *)MON_MMEM_LOAD_LIMIT)))
		scwp->enableReadSecure = 1;									// SECURË惊[hECl[u

	CheckDebugger();												// fobKN`FbN

																	// ARM9擪16KBGA]
#ifndef DISABLE_SECURE_CODE

	if (shwp->enableCardNormalOnly) {								// NORMALJ[hgpiSECURË͓ǂ܂Ȃj

	    LoadFlashDemo();												// FLASHfvOǂݍ

	} else

#endif	// DISABLE_SECURE_CODE

	if ((shwp->isOnDebugger == 1) && IsMmem8MB()) {					// fobKN

		if (scwp->enableReadSecure)
			SetCardIntr4Normal(loadStartp, loadDestp, secureSize);		// NORMAL[hǂݍ

	    LoadFlashDemo();												// FLASHfvOǂݍ

		if (scwp->enableReadSecure)
			WaitCardIntr();												// NORMAL[hǂݍݏI҂

	   	ChangeCardMode4Normal();										// GAME[hJ

#ifndef DISABLE_SECURE_CODE

	} else {														// SECUREJ[hgp

	   	ChangeCardMode4Normal();										// SECURE[hJ

		intrTable[0] = CardIntr4Secure;									// J[h荞݊֐ Zbg
		intrTable[1] = CardTimerIntr4Secure;							// J[h^C}[荞݊֐ Zbg

		InitCardParam4Secure();											// SECURER}hp[^
		SetCardIntr4Secure(loadStartp, loadDestp, secureSize);			// SECURE[hǂݍ

		LoadFlashDemo();												// FLASHfvOǂݍ

		WaitCardIntr();													// SECURE[hǂݍݏI҂
		TerminateCardParam4Secure();									// SECURER}hp[^

		if ((scwp->unScrambleKey[0] != png_off_key[0])					// XNuL[
		 || (scwp->unScrambleKey[1] != png_off_key[1])) {
  			SetCardCnt4Game(GetCardCnt4Game() | CARD_SCRAMBLE_SET_MASK);// XNuݒ
		}

#endif	// DISABLE_SECURE_CODE

	}

	if (scwp->enableReadSecure)										// SECURËCRCZo
		shwp->cardSecureCrc16 = GetInvCRC16((u16 *)loadDestp, secureSize);

	DecryptObjectFileFook();										// ÍIuWFNg̕

#ifndef DISABLE_SECURE_CODE

	*(vu32 *)REG_BIOS_PROTECT_ADDR = (u32 )&SecureAreaEndp;			// BIOSZLeBAhX Zbg

#endif	// DISABLE_SECURE_CODE

#ifndef TRACE_SECURE_OP 

	CpuClearFast32(0, GetSecureWorkAddr(), sizeof(SecureWork));		// ZLA[N NA

#endif  // TRACE_SECURE_OP

	if (shwp->flashCrcError)										// IPL2CRCsvASECURË NA
		ClearMmemSecureArea();
}


#ifdef BOOT_FROM_CARTRIDGE

void LoadSecure4Cartridge(void)
{
    LoadFlashDemo();													// FLASHfvOǂݍ

	{	u32 loadStartp = *(u32 *)(ROM_HEADER_BUF + 0x20)  | CTRDG_AD16_BANK0;
		u32 loadSize   = *(u32 *)(ROM_HEADER_BUF + 0x2c) & (MAIN_MEM_SIZE - 1);
		u32 loadDestp  = *(u32 *)(ROM_HEADER_BUF + 0x28);

		while (!loadStartp || !loadDestp)		;

	    CpuCopy16_32(loadStartp, loadDestp, loadSize, 32);				// ARM9sC[Wǂݍ
	}
}

#endif	// BOOT_FROM_CARTRIDGE


//----------------------------------------------------------------------
//     					IPL2Ăяo
//----------------------------------------------------------------------
void LoadGame4Card(void);
void LoadHeader4Cartridge(void);
void LoadSecure4Cartridge(void);
void LoadGame4Cartridge(void);
void LoadDebugger(void);

#ifndef  DISABLE_READ_CARD_4_IPL2

s32 CalledFormIPL2(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();
	s16 *sequenceNop = &shwp->cardSequenceNo;

	if (*(vu8 *)REG_PAUSE & 1)	return -2;

	switch (*sequenceNop) {
		case 0:	if (!shwp->cardHeaderError) {							// J[hEwb_̃`FbN
					u8  *arm9LoadStartp = rmhp->arm9.romAddr;
					u8  *arm9LoadDestp  = rmhp->arm9.ramAddr;
					u8  *arm9LoadDestEndp;
					s32  arm9LoadSize   = rmhp->arm9.romSize;
					s32  arm9SecureSize = (u8 *)MROM_GAME_AREA - arm9LoadStartp;	// ZLeB ČvZ

					if (arm9SecureSize < 0)		arm9SecureSize = 0;
					arm9LoadStartp += arm9SecureSize;
					arm9LoadDestp  += arm9SecureSize;
					arm9LoadSize   -= arm9SecureSize;

					if ((arm9LoadDestp >= (u8 *)MAIN_MEM) && (arm9LoadDestp < (u8 *)MON_MMEM_LOAD_LIMIT)) {
						arm9LoadDestEndp = arm9LoadDestp + arm9LoadSize;
						if (arm9LoadDestEndp > (u8 *)MON_MMEM_LOAD_LIMIT)
							arm9LoadSize -= (arm9LoadDestEndp - (u8 *)MON_MMEM_LOAD_LIMIT);

						if (arm9LoadSize > 0) {							// GAME[hǂݍ
							SetCardIntr4Game(arm9LoadStartp, arm9LoadDestp, arm9LoadSize);
							*sequenceNop = 1;
						} else {
							*sequenceNop = 2;
						}
					} else {
						*sequenceNop = 2;
					}
				} else {
					*sequenceNop = 6;
				}
				break;
		case 1: if (*(vu32 *)INTR_CHECK_BUF & CARD_DATA_INTR_FLAG) {
					TerminateCardIntr();
					*sequenceNop = 2;
				}
				break;
		case 2:

#ifdef TEST_CARD_BY_MAINP
				NotifyMainpIntf(5);										// J[hoX؂芷؂̒ʒm
				WaitMainpIntf(5);
#endif	// TEST_CARD_BY_MAINP

				{	u8  *arm7LoadStartp = rmhp->arm7.romAddr;
					u8  *arm7LoadDestp  = rmhp->arm7.ramAddr;
					u8  *arm7LoadDestEndp = NULL;
					s32  arm7LoadSize   = rmhp->arm7.romSize;
																		// [NRAM [hTCY
					if ((arm7LoadDestp >= (u8 *)CPU_WRAM) && (arm7LoadDestp < (u8 *)MON_WRAM_LOAD_LIMIT)) {
						arm7LoadDestEndp = arm7LoadDestp + arm7LoadSize;
						if (arm7LoadDestEndp > (u8 *)MON_WRAM_LOAD_LIMIT)
							arm7LoadSize -= (arm7LoadDestEndp - (u8 *)MON_WRAM_LOAD_LIMIT);
					}
																		// C [hTCY
					if ((arm7LoadDestp >= (u8 *)MAIN_MEM) && (arm7LoadDestp < (u8 *)MON_MMEM_LOAD_LIMIT)) {
						arm7LoadDestEndp = arm7LoadDestp + arm7LoadSize;
						if (arm7LoadDestEndp > (u8 *)MON_MMEM_LOAD_LIMIT)
							arm7LoadSize -= (arm7LoadDestEndp - (u8 *)MON_MMEM_LOAD_LIMIT);
					}

					if (arm7LoadDestEndp) {
						if (arm7LoadSize > 0) {							// ARM7sC[Wǂݍ
							SetCardIntr4Game(arm7LoadStartp, arm7LoadDestp, arm7LoadSize);
							*sequenceNop = 3;
						} else {
							*sequenceNop = 4;
						}
					} else {
						*sequenceNop = 4;
					}
				}
				break;
		case 3: if (*(vu32 *)INTR_CHECK_BUF & CARD_DATA_INTR_FLAG) {
					TerminateCardIntr();
					*sequenceNop = 4;
				}
				break;
		case 4:

#ifdef TEST_CARD_BY_MAINP
				NotifyMainpIntf(6);										// J[hoX؂芷؂̒ʒm
				WaitMainpIntf(6);
#endif	// TEST_CARD_BY_MAINP

				if ((shwp->isOnDebugger == 1) && IsMmem8MB()) {
					u8  *dbgLoadStartp = rmhp->dbgRomAddr;
					u8  *dbgLoadDestp  = rmhp->dbgArm9RamAddr;
					u8  *dbgLoadDestEndp;
					s32  dbgLoadSize   = rmhp->dbgRomSize;

					if ((dbgLoadDestp >= (u8 *)MAIN_MEM_END) && (dbgLoadDestp < (u8 *)MON_DBG_LOAD_LIMIT)) {
						dbgLoadDestEndp = dbgLoadDestp + dbgLoadSize;
						if (dbgLoadDestEndp > (u8 *)MON_DBG_LOAD_LIMIT)
							dbgLoadSize -= (dbgLoadDestEndp - (u8 *)MON_DBG_LOAD_LIMIT);

						if (dbgLoadSize > 0) {							// fobKj^ǂݍ
							(u32 )dbgLoadStartp &= 0x7fffffff;			// AhXC
						    SetCardIntr4Game(dbgLoadStartp, dbgLoadDestp, dbgLoadSize);
							*sequenceNop = 5;
						} else {
							*sequenceNop = 6;
						}
					} else {
						*sequenceNop = 6;
					}
				} else {
					*sequenceNop = 6;
				}
				break;
		case 5: if (*(vu32 *)INTR_CHECK_BUF & CARD_DATA_INTR_FLAG) {
					TerminateCardIntr();
					*sequenceNop = 6;
				}
				break;
		case 6:	SetPauseCheckFlag();									// `FbNtO Zbg
				*sequenceNop = -1;
				break;
	}

	return  *sequenceNop;
}


#else // DISABLE_READ_CARD_4_IPL2


s32 CalledFormIPL2(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	s16 *sequenceNop = &shwp->cardSequenceNo;

	if (!shwp->cardHeaderError) {							// J[hEwb_̃`FbN
		LoadGame4Card();									// J[hQ[̈
	} else {

#ifdef BOOT_FROM_CARTRIDGE

		WaitVBlank(20);										// UICANZXx

		LoadHeader4Cartridge();								// J[gbWEwb_̈̃[h
		if (!CheckCartridgeHeader()) {						// J[gbWEwb_̃`FbN
			LoadSecure4Cartridge();							// J[gbWEZLÄ̃[h
			LoadGame4Cartridge();							// J[gbWEQ[̈
		} else {

#endif	// BOOT_FROM_CARTRIDGE

#ifdef TEST_AGB_MODE

			ReadNintendoLogo4AGB();							// AGBJ[gbW̃Sǂݍ
			if (!CheckNintendoLogo(&NinLogoBak[36/2])) { //(u16 *)(CARTRIDGE + 4)))
				Iris2Agb();									// AGB[hJ
#ifdef DISP_AGB_HEADER_ERROR
			 } else {
				NotifyMainpIntf(8);							// AGBwb_G[ʒm
				WaitMainpIntf(8);							// AGBwb_G[\҂
				Iris2Agb();									// AGB[hJ
#endif	// DISP_AGB_HEADER_ERROR
			}
#else
			while(1)	;									// AGB[hΉ [v

#endif	// TEST_AGB_MODE

#ifdef BOOT_FROM_CARTRIDGE

		}

#endif	// BOOT_FROM_CARTRIDGE

	}

//	ReadNintendoLogo4AGB();									// AGBJ[gbW̃Sǂݍ
															//iIRIS[hAGBJ[gbWANZXł悤ɂ邽߁j

//	LoadDebugger();											// fobK̈

	TerminateIntr(CARD_DATA_INTR_FLAG);

	*sequenceNop = -1;

	return  *sequenceNop;
}

#endif // DISABLE_READ_CARD_4_IPL2



//----------------------------------------------------------------------
//     					ROMC[W㔼̃[h
//----------------------------------------------------------------------

#ifdef DISABLE_READ_CARD_4_IPL2

void LoadGame4Card(void)
{
	{	u8  *Arm9LoadStartp = *(u8  **)(ROM_HEADER_BUF + 0x20);
		u8  *Arm9LoadDestp  = *(u8  **)(ROM_HEADER_BUF + 0x28);
		s32  Arm9LoadSize   = *(s32 * )(ROM_HEADER_BUF + 0x2c) & (MAIN_MEM_SIZE - 1);
		s32  Arm9SecureSize = (u8 *)MROM_GAME_AREA - Arm9LoadStartp;

		if (Arm9SecureSize < 0)		Arm9SecureSize = 0;

		SetCardIntr4Game(Arm9LoadStartp + Arm9SecureSize,			// GAME[hǂݍ
		   				 Arm9LoadDestp  + Arm9SecureSize,
						 Arm9LoadSize   - Arm9SecureSize);
		WaitCardIntr();
	}

	{	u8  *Arm7LoadStartp = *(u8  **)(ROM_HEADER_BUF + 0x30);
		u8  *Arm7LoadDestp  = *(u8  **)(ROM_HEADER_BUF + 0x38);
		s32  Arm7LoadSize   = *(s32 * )(ROM_HEADER_BUF + 0x3c) & (CPU_WRAM_SIZE - 1);

		while (!Arm7LoadSize)		;

	    SetCardIntr4Game(Arm7LoadStartp, Arm7LoadDestp, Arm7LoadSize);// ARM7sC[Wǂݍ
		WaitCardIntr();
	}
}


#ifdef BOOT_FROM_CARTRIDGE

void LoadGame4Cartridge(void)
{
	{	u32 Arm7LoadStartp = *(u32 *)(ROM_HEADER_BUF + 0x30)  | CTRDG_AD16_BANK0;
		u32 Arm7LoadSize   = *(u32 *)(ROM_HEADER_BUF + 0x3c) & (MAIN_MEM_SIZE - 1);
		u32 Arm7LoadDestp  = *(u32 *)(ROM_HEADER_BUF + 0x38);

		while (!Arm7LoadStartp || !Arm7LoadDestp)		;

	    CpuCopy16_32(Arm7LoadStartp, Arm7LoadDestp, Arm7LoadSize, 32);	// ARM7sC[Wǂݍ
	}
}

#endif	// BOOT_FROM_CARTRIDGE

#endif  // DISABLE_READ_CARD_4_IPL2


//----------------------------------------------------------------------
//     					fobKj^̃[h
//----------------------------------------------------------------------

#ifdef DISABLE_READ_CARD_4_IPL2

void LoadDebugger(void)
{
	if (IsMmem8MB()) {
		u8  *DbgLoadStartp = *(u8  **)(ROM_HEADER_BUF + 0x160);
		u8  *DbgLoadDestp  = *(u8  **)(ROM_HEADER_BUF + 0x168);
		s32  DbgLoadSize   = *(u32 * )(ROM_HEADER_BUF + 0x164) & (MAIN_MEM_SIZE - 1);

		if (DbgLoadSize > 0 && DbgLoadSize < (MAIN_MEM_SIZE - 512)) {

			if ((s32 )DbgLoadStartp < 0) {								// fobKj^ǂݍ
				(u32 )DbgLoadStartp &= 0x7fffffff;						// AhXC
			    SetCardIntr4Game(DbgLoadStartp, DbgLoadDestp, DbgLoadSize);
				WaitCardIntr();
			} else {
			    CpuCopy16_32(DbgLoadStartp, DbgLoadDestp, DbgLoadSize, 32);
			}
		}
	}
}

#endif  // DISABLE_READ_CARD_4_IPL2


//----------------------------------------------------------------------
//     					CvZbTEC^tF[Xʒm
//----------------------------------------------------------------------

void NotifyMainpIntf(u32 param)
{
	*(vu16 *)REG_MAINPINTF = param <<MAINP_SEND_STATUS_SHIFT;
}

//----------------------------------------------------------------------
//     					CvZbTEC^tF[XM҂
//----------------------------------------------------------------------

void WaitMainpIntf(u32 param)
{
	while (RecvMainpIntf() != param)	;
}


