//*******************************************************************
//			    	IRIS-SUBPj^vO J[h֐
//*******************************************************************
#include "IrisSubpMon.h"




//--------------------- O[o ϐ  -------------------------------



//----------------------------------------------------------------------
//     					SECURER}hp[^
//----------------------------------------------------------------------

void InitCardParam4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();
	CardCnt  hdCntTmp = rmhp->romCtrl4Secure;

	scwp->cardCntBak4Secure = hdCntTmp;

	if (hdCntTmp.latency1 < MROM_S_LATENCY1_CYCLES_MIN)		hdCntTmp.latency1 = MROM_S_LATENCY1_CYCLES_MIN;
	if (hdCntTmp.latency2 < MROM_S_LATENCY2_CYCLES_MIN)		hdCntTmp.latency2 = MROM_S_LATENCY2_CYCLES_MIN;

	rmhp->romCtrl4Secure = hdCntTmp;

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					SECURER}hp[^
//----------------------------------------------------------------------

void TerminateCardParam4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();

	rmhp->romCtrl4Secure = scwp->cardCntBak4Secure;

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					R}hݒ
//----------------------------------------------------------------------

void SetCardOp(const CardCtrlParam *paramp)
{
	int  i;

	WaitCardDma(paramp->dmaNo);										// J[h]I҂

	*(vu8 *)REG_CARD_MASTER_CNT = CARDMST_SEL_ROM					// }X^[Cl[u
								| CARDMST_ENABLE | CARDMST_IF_ENABLE;
#ifdef TRACE_SECURE_OP 

	{	SecureWork *scwp = GetSecureWorkAddr();

		if (scwp->traceSecureOp) {
			scwp->paramTrace[scwp->traceOpCount] = *paramp;			// ÍÕg[X
			DecryptByBlowfish(&scwp->blowfishCardTable, &scwp->paramTrace[scwp->traceOpCount].op[1], &scwp->paramTrace[scwp->traceOpCount].op[0]);
			scwp->traceOpCount++;
		}
	}

#endif  // TRACE_SECURE_OP

	for (i=0; i<2; i++) {											// R}hݒ
		u32	opTmp = paramp->op[1 - i];
		vu8 *opDestBasep = (vu8 *)(REG_CARD_CMD + i*4);

		opDestBasep[0] = opTmp >>24;
		opDestBasep[1] = opTmp >>16;
		opDestBasep[2] = opTmp >>8;
		opDestBasep[3] = opTmp >>0;
	}
}


//----------------------------------------------------------------------
//     					J[h҂  DMA~
//----------------------------------------------------------------------

void WaitCardDma(u32 dmaNo)
{
	WaitCard();

	if (dmaNo <= 3)		StopDma(dmaNo);
}


//----------------------------------------------------------------------
//     					J[hǂݍ݁iDMA񓯊j
//----------------------------------------------------------------------

void ReadCardAsync(void *romp, void *ramp, s32 size, CardCtrlParam *paramp)
{
	SetCardOp(paramp);											// R}hݒ

	if (paramp->dmaNo <= 3) {
		DmaReadCard(paramp->dmaNo, ramp);						// DMAݒiőݒ DMA0-2: 64KB / DMA3: 256KBj
		*(vu32 *)REG_CARDCNT = paramp->cardCnt;					// Rg[ݒ & DMAX^[g
	} else {
		void *ramEndp;
		u32 cardCntTmp;

		*(vu32 *)REG_CARDCNT = paramp->cardCnt;					// Rg[ݒ 

		ramEndp = (u8 *)ramp + size;							// i[IAhXZo

		do {													// CPUǂݍ
			cardCntTmp = *(vu32 *)REG_CARDCNT;

			if (cardCntTmp & CARD_DATA_READY) {
				u32 dataTmp = *(vu32 *)REG_CARD_DATA;

				if (ramp < ramEndp)	
					*((vu32 *)ramp) = dataTmp;					// wTCY܂Ŋi[i㑱f[^͓ǂݎ̂āj
				((vu32 *)ramp)++;
			}
		} while (cardCntTmp & CARD_START);
	}
}

//----------------------------------------------------------------------
//     					J[h]ubNTCY l
//----------------------------------------------------------------------

s32 GetBlockSizeFromCardCnt(CardCnt *paramp)
{
	s32  blockSize = 0;
	s32  pages = paramp->pages;

	if (pages == ST_CARD_STATUS)		blockSize = 4;
	else if (pages >= ST_CARD_1_PAGE)	blockSize = 512 <<(pages - 1);

	return  blockSize;
}


//----------------------------------------------------------------------
//     					J[hR}hM̂݁ij
//----------------------------------------------------------------------

void SendOnlyCardOp(CardCtrlParam *paramp)
{
	u32 cardCnt;
	paramp->dmaNo = -1;											// DMAsgpw

	SetCardOp(paramp);											// R}hݒ

	cardCnt = paramp->cardCnt & ~CARD_PAGE_COUNT_MASK			// Rg[ݒ 
			| CARD_READ_MODE | CARD_0_PAGE
			| CARD_START | CARD_RESET_HI;

	*(vu32 *)REG_CARDCNT = cardCnt;

#ifdef TRACE_SECURE_OP 

	TraceCardCnt(cardCnt);										// Rg[ݒ̃g[X

#endif  // TRACE_SECURE_OP

	WaitCard();
}

//----------------------------------------------------------------------
//     					Rg[ݒ g[X
//----------------------------------------------------------------------

#ifdef TRACE_SECURE_OP 

void TraceCardCnt(u32 cardCnt)
{
	{	SecureWork *scwp = GetSecureWorkAddr();

		if (scwp->traceSecureOp) {
			scwp->paramTrace[scwp->traceOpCount - 1].cardCnt = cardCnt;	// Rg[ݒ̃obvAbv
		}
	}

}

#endif  // TRACE_SECURE_OP


//----------------------------------------------------------------------
//     					J[hR}hM̂݁iSECURE[hp^j
//----------------------------------------------------------------------

void SendOnlyCardOp4Secure(CardCtrlParam *paramp, u32 scrambleON)
{

#ifndef DISABLE_SECURE_CODE

	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();

	paramp->dmaNo = -1;											// DMAsgpw
	paramp->cardCnt = AddLatency2ToLatency1(GetCardCnt4Secure())// CeVQCeVP։Z
					| CARD_READ_MODE | CARD_0_PAGE
					| CARD_START | CARD_RESET_HI;
	if (scrambleON)
		paramp->cardCnt	|= CARD_SCRAMBLE_UNIT_ON | CARD_DATA_SCRAMBLE_ON;// f[^XNuݒ

	if (!(shwp->nCardID & 0x80000000))
		paramp->cardCnt |= CARD_CLOCK_IN_LATENCY;				//  }XNROMpݒF CeVԂɃNbN

	SetDummyVC(paramp);											// _~[VC Zbg

	Encrypt2SetTimer4Secure(paramp);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					J[hIDǂݍ݁ij
//----------------------------------------------------------------------

u32 ReadCardID(CardCtrlParam *paramp)
{
	u32 cardCnt;
	paramp->dmaNo = -1;											// DMAsgpw

	SetCardOp(paramp);											// R}hݒ


	cardCnt = paramp->cardCnt & ~CARD_PAGE_COUNT_MASK			// Rg[ݒ 
			| CARD_READ_MODE | CARD_STATUS
			| CARD_START | CARD_RESET_HI;

	*(vu32 *)REG_CARDCNT = cardCnt;

#ifdef TRACE_SECURE_OP 

	TraceCardCnt(cardCnt);										// Rg[ݒ̃g[X

#endif  // TRACE_SECURE_OP

	WaitCardData();

	return  *(vu32 *)REG_CARD_DATA;
}


//----------------------------------------------------------------------
//     					tbVEe[uݒ
//----------------------------------------------------------------------

void LoadCardTable(void)
{
	CardCtrlParam param;
	CardCtrlParam *paramp = &param;
 
	paramp->cardCnt = CARD_READ_MODE | CARD_16_PAGES				// Rg[ݒ
					| 0 <<CARD_LATENCY1_CYCLES_SHIFT | 0x18 <<CARD_LATENCY2_CYCLES_SHIFT
					| CARD_CLOCK_240NS
					| CARD_START | CARD_RESET_HI;
	paramp->dmaNo = -1;											// DMAsgpw
	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_N_LOAD_TABLE;

	ReadCardAsync(NULL, NULL, 0, paramp);						// CPUɂǂ
}


//----------------------------------------------------------------------
//     					ROMwb_ǂݍ݁iNORMAL[hj
//----------------------------------------------------------------------

void ReadCardHeader(void)
{
	CardCtrlParam param;
	CardCtrlParam *paramp = &param;
 
	paramp->cardCnt = CARD_READ_MODE | CARD_1_PAGE				// Rg[ݒ 
					| CARD_LATENCY1_CYCLES_MASK | CARD_LATENCY2_CYCLES_MASK
					| CARD_CLOCK_240NS
					| CARD_START | CARD_RESET_HI;
	paramp->dmaNo = -1;											// DMAsgpw

	ReadCardAsync4Normal(NULL, (void *)ROM_HEADER_BUF, 0x170, paramp);
	WaitCardDma(paramp->dmaNo);
}


//----------------------------------------------------------------------
//     					J[hIDǂݍ݁iNORMAL[hj
//----------------------------------------------------------------------

u32 ReadCardID4Normal(void)
{
	CardCtrlParam param;
	CardCtrlParam *paramp = &param;

	paramp->cardCnt = GetCardCnt4Normal();						// Rg[ݒiXNuݒNAj
	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_N_READ_ID;

	return  ReadCardID(paramp);
}

//----------------------------------------------------------------------
//     					J[h[hJځiNORMAL[hj
//----------------------------------------------------------------------

void ChangeCardMode4Normal(void)
{
	CardCtrlParam param;
	CardCtrlParam *paramp = &param;

	paramp->cardCnt = GetCardCnt4Normal();						// Rg[ݒiXNuݒNAj
	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_N_CHANGE_MODE;

	SetVAE(paramp);												// VAE Zbg
	SetVBI(paramp);												// VBI Zbg

	SendOnlyCardOp(paramp);
}

//----------------------------------------------------------------------
//     					J[hIDǂݍ݁iSECURE[hj
//----------------------------------------------------------------------

void ReadCardID4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	CardCtrlParam *paramp = &ciwp->param;

	paramp->dmaNo = -1;											// DMAsgpw

	paramp->cardCnt = AddLatency2ToLatency1(GetCardCnt4Secure())// CeVQCeVP։Z
					| CARD_SCRAMBLE_UNIT_ON | CARD_DATA_SCRAMBLE_ON// f[^XNuݒ
					| CARD_READ_MODE | CARD_0_PAGE
					| CARD_START | CARD_RESET_HI;
	if (!(shwp->nCardID & 0x80000000))
		paramp->cardCnt |= CARD_CLOCK_IN_LATENCY;				//  }XNROMpݒF CeVԂɃNbN


	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_S_READ_ID;
	SetVA(paramp);												// VA Zbg
	SetDummyVC(paramp);											// _~[VC Zbg

	Encrypt2SetTimer4Secure(paramp);

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[hւPNG_ONMiVDMjiSECURE[hj
//----------------------------------------------------------------------

void SendCardPNG_ON(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	CardCtrlParam *paramp = &ciwp->param;

	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_S_PNG_ON;

	SetVD(paramp);												// VD Zbg

#ifdef TRACE_SECURE_OP 

	scwp->traceSecureOp = 1;

#endif  // TRACE_SECURE_OP

	SendOnlyCardOp4Secure(paramp, 0);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					J[hւPNG_OFFMiSECURE[hj
//----------------------------------------------------------------------

void SendCardPNG_OFF(void)
{

#ifndef DISABLE_SECURE_CODE

	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	CardCtrlParam *paramp = &ciwp->param;

	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_S_PNG_OFF;

	SetVA(paramp);												// VA Zbg

	SendOnlyCardOp4Secure(paramp, 1);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					J[h[hJځiSECURE[hj
//----------------------------------------------------------------------

void ChangeCardMode4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	CardCtrlParam *paramp = &ciwp->param;

	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_S_CHANGE_MODE;

	SetVA(paramp);												// VA Zbgi_~[j

	SendOnlyCardOp4Secure(paramp, 1);

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[hf[^ǂݍ݁iNORMAL[h^񓯊j
//----------------------------------------------------------------------

void ReadCardAsync4Normal(void *romp, void *ramp, s32 size, CardCtrlParam *paramp)
{
	paramp->op[0] = (u32 )romp <<24;								// R}hݒ
	paramp->op[1] = MROMOP_N_READ_PAGES | (u32 )romp >>8;

	ReadCardAsync(romp, ramp, size, paramp);
}

//----------------------------------------------------------------------
//     					J[hf[^ǂݍ݁iGAME[h^񓯊j
//----------------------------------------------------------------------

void ReadCardAsync4Game(void *romp, void *ramp, s32 size, CardCtrlParam *paramp)
{
	paramp->op[0] = (u32 )romp <<24;							// R}hݒ
	paramp->op[1] = MROMOP_G_READ_PAGE | (u32 )romp >>8;

	*(vu32 *)REG_CARDCNT = CARD_RESET_HI;

	ReadCardAsync(romp, ramp, size, paramp);
}


//----------------------------------------------------------------------
//     					J[hZOgǂݍ݁iSECURE[h^񓯊^荞݌j
//----------------------------------------------------------------------

void ReadCardSegmentAsync4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	s16 *blockOffsetp = &scwp->blockOffset;
	s16 *segmentOffsetp = &scwp->segmentOffset;
	s16 *tblShiftp = &scwp->segmentTblShift;
	s32 diffSegmentNo;
	s32 readID_enable;

															// SECURË𒴂Ȃ悤ɒ
	while ((diffSegmentNo = ((*scwp->segmentTblp) >>*tblShiftp) & 0x3) >= scwp->numSecureSegment)
			*tblShiftp += 2;

	*segmentOffsetp = MROM_SEGMENT_SIZE * diffSegmentNo;	// ZOgItZbg Zbg
	*blockOffsetp = 0;										// ubNItZbg NA

	{	s32 offset = *segmentOffsetp + *blockOffsetp;

		ReadCardAsync4Secure(ciwp->romp + offset, &ciwp->param);

		*tblShiftp += 2;
		*tblShiftp &= 0x7;
	}

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					J[hf[^ǂݍ݁iSECURE[h^񓯊j
//----------------------------------------------------------------------

void ReadCardAsync4Secure(void *romp, CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();

	if (!(shwp->nCardID & 0x80000000))						// }XNROMpݒF CeVԂɃNbN
			paramp->cardCnt = CARD_8_PAGES | CARD_CLOCK_IN_LATENCY;
	else	paramp->cardCnt = CARD_1_PAGE;					// 3Dpݒilj

	paramp->cardCnt |= GetCardCnt4Secure()					// Rg[ݒ
					| CARD_READ_MODE
					| CARD_SCRAMBLE_UNIT_ON | CARD_DATA_SCRAMBLE_ON
					| CARD_START | CARD_RESET_HI;
	paramp->dmaNo = 3;

	paramp->op[0] = 0;											// R}hݒ
	paramp->op[1] = MROMOP_S_READ_SEGMENT | ((u32 )romp & MROMOP_S_VC_MASK_H);

	ciwp->blockSize = GetBlockSizeFromCardCnt((CardCnt *)&ciwp->param.cardCnt);

	SetVA(paramp);												// VA Zbg

	Encrypt2SetTimer4Secure(paramp);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     			3DpCeV^C}[NiSECURE[hp^j
//----------------------------------------------------------------------

void Encrypt2SetTimer4Secure(CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	SharedWork *shwp = GetSharedWorkAddr();
	RomHeader  *rmhp = GetRomHeaderAddr();
	s32 timerCount;

	SetVB(paramp);												// VB Zbg

	scwp->paramBak = *paramp;									// ÍÕobvAbv
																// R}hÍ
	EncryptByBlowfish(&scwp->blowfishCardTable, &paramp->op[1], &paramp->op[0]);

	{	u32 lastIme = *(vu32 *)REG_IME;

		*(vu32 *)REG_IME = 0;									// NeBJZNV	

		if (shwp->nCardID & 0x80000000)							// 3DpvR}hs
			SendOnlyCardOp(paramp);

		*(vu32 *)REG_IE |=  TIMER3_INTR_FLAG;					// J[h^C}[荞݋
		*(vu32 *)REG_IE &= ~CARD_DATA_INTR_FLAG;				// J[h荞ݕs
		*(vu32 *)REG_IF  =  CARD_DATA_INTR_FLAG | TIMER3_INTR_FLAG;
																// J[h`FbN NA
		*(vu32 *)INTR_CHECK_BUF &= (CARD_DATA_INTR_FLAG ^ TIMER3_INTR_FLAG ^ -1);

		*(vu32 *)REG_IME = lastIme;
	}

	timerCount = rmhp->romTimerLatency;							// J[h^C}[ X^[g
	if (shwp->cardHeaderError)		timerCount &= 0x1fff;		
	else							timerCount &= 0x3fff;

    *(u16 *)REG_TM3CNT_L = (0x10000 - (timerCount + 2));
    *(u16 *)REG_TM3CNT_H = (TMR_PRESCALER_256CK | TMR_IF_ENABLE | TMR_ENABLE) >>16;

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[h荞 ݒ
//----------------------------------------------------------------------

void SetCardIntr(void *romp, void *ramp, s32 size, CardIntrWork *ciwp)
{
	ciwp->restSize  = size;
	ciwp->blockSize = GetBlockSizeFromCardCnt((CardCnt *)&ciwp->param.cardCnt);

	WaitCardDma(ciwp->param.dmaNo);

	EnableCardIntr();
}

//----------------------------------------------------------------------
//     					J[h荞 ݒiNORMAL[hj
//----------------------------------------------------------------------

void SetCardIntr4Normal(void *romp, void *ramp, s32 size)
{
	CardIntrWork *ciwp = GetCardIntrWorkAddr();

	ciwp->param.cardCnt = GetCardCnt4Normal()				// Rg[ݒiXNuݒNAj
						| CARD_READ_MODE | CARD_1_PAGE
						| CARD_START | CARD_RESET_HI;
	ciwp->param.dmaNo = 3;

	ciwp->AsyncFuncp = ReadCardAsync4Normal;				// f[^ǂݍ݊֐ Zbg

	ciwp->romp = romp;
	ciwp->ramp = ramp;

	SetCardIntr(romp, ramp, size, ciwp);

	ciwp->AsyncFuncp(ciwp->romp, ciwp->ramp, ciwp->blockSize, &ciwp->param);
}

//----------------------------------------------------------------------
//     					J[h荞 ݒiGAME[hj
//----------------------------------------------------------------------

void SetCardIntr4Game(void *romp, void *ramp, s32 size)
{
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();

	ciwp->param.cardCnt = GetCardCnt4Game()					// Rg[ݒ 
						| CARD_READ_MODE | CARD_1_PAGE
						| CARD_START | CARD_RESET_HI;
	ciwp->param.dmaNo = 3;

	ciwp->AsyncFuncp = ReadCardAsync4Game;					// f[^ǂݍ݊֐ Zbg

	ciwp->romp = romp;
	ciwp->ramp = ramp;

	SetCardIntr(romp, ramp, size, ciwp);

	ciwp->AsyncFuncp(ciwp->romp, ciwp->ramp, ciwp->blockSize, &ciwp->param);
}


//----------------------------------------------------------------------
//     					J[h荞 ݒiSECURE[hj
//----------------------------------------------------------------------
extern u8 segmentIndexTable4Secure[];

void SetCardIntr4Secure(void *romp, void *ramp, s32 size)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	s32  secureSize = (u8 *)MROM_GAME_AREA - (u8 *)romp;

	scwp->segmentTblp = &segmentIndexTable4Secure[scwp->vd >>28];	// ZOge[uݒ
	scwp->numSecureSegment = secureSize/MROM_SEGMENT_SIZE;			// SECUREZOg

	(void *)ciwp->AsyncFuncp = (void *)ReadCardSegmentAsync4Secure;	// f[^ǂݍ݊֐ Zbg

	ciwp->romp = romp;
	ciwp->ramp = ramp;

	SetCardIntr(romp, ramp, size, ciwp);

	SendCardPNG_ON();												// PNG_ONM

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[h^C}[荞݁iSECURE[hj
//----------------------------------------------------------------------

void CardTimerIntr4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	CardCtrlParam *paramp = &ciwp->param;

    *(u16 *)REG_TM3CNT_H = 0;								// J[h^C}[ ~

	*(vu32 *)REG_IE &= ~TIMER3_INTR_FLAG;					// J[h^C}[荞ݕs
	*(vu32 *)REG_IE |=  CARD_DATA_INTR_FLAG;				// J[h荞݋
	*(vu32 *)REG_IF  =  CARD_DATA_INTR_FLAG | TIMER3_INTR_FLAG;

	switch (scwp->paramBak.op[1] & MROMOP_S_OP_MASK) {

		case MROMOP_S_PNG_ON:		SendOnlyCardOp(paramp);
									InitCardPN_Intf();										// J[hPNC^tF[X 
									break;
		case MROMOP_S_PNG_OFF:
		case MROMOP_S_CHANGE_MODE:	SendOnlyCardOp(paramp);
									break;
		case MROMOP_S_READ_ID:		shwp->sCardID = ReadCardID(paramp);
									break;
		case MROMOP_S_READ_SEGMENT:	{	s32 blockSize = ciwp->blockSize;
										s32 offset = scwp->segmentOffset + scwp->blockOffset;

																							// ZOgEɂ
										ReadCardAsync(NULL, ciwp->ramp + offset, blockSize, paramp);

										ciwp->restSize    -= blockSize;
										scwp->blockOffset += blockSize;

										if (!(ciwp->restSize & (MROM_SEGMENT_SIZE - 1))) {	// J[h荞ݐ؂芷
											intrTable[0] = CardIntr4Secure;
										} else{
											intrTable[0] = CardTimerIntr4Secure;
#ifdef TRACE_SECURE_OP 
											OverWriteTestVB(paramp);						// VBeXgXV

#endif  // TRACE_SECURE_OP
										}
									}
									break;

	}

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[h荞݁iSECURE[hj
//----------------------------------------------------------------------
extern u32 png_off_key[];

void CardIntr4Secure(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	s16 *sequenceNop = &scwp->sequenceNo4Secure;

	if (*(vu8 *)REG_PAUSE & 1)	return;

	switch (*sequenceNop) {
		case 0:
				*sequenceNop = 1;
				if (shwp->cardHeaderError)				goto  changeCardMode;	// ROMwb_G[		

				ReadCardID4Secure();											// J[hIDmF
				break;
		case 1:
				*sequenceNop = 2;
				if (shwp->sCardID != shwp->nCardID)		goto  changeCardMode;	// J[hID`FbN

				if (scwp->vd >>31)												// J[hID_s
						ReadCardID4Secure();
				else	goto  readCard;
				break;
		case 2:
readCard:		if (shwp->sCardID != shwp->nCardID)		goto  changeCardMode;	// J[hID`FbN
				if (!scwp->enableReadSecure)			goto  isPngOFF;			// [hEfBZ[u		

				if (ciwp->restSize > 0) {
					ReadCardSegmentAsync4Secure();
				} else {
					goto  isPngOFF;
				}
				break;
		case 3:
isPngOFF:		*sequenceNop = 4;
				if  (!scwp->isGenUnScrambleKey)			goto  changeCardMode;	// XNuL[Zo`FbNivCeVݒj

				if ((scwp->unScrambleKey[0] == png_off_key[0])					// XNuL[L
				 && (scwp->unScrambleKey[1] == png_off_key[1])) {
					SendCardPNG_OFF();											// PNG_OFFM
				} else {
					goto  changeCardMode;
				}

				break;
		case 4:
changeCardMode:	*sequenceNop = 5;
				ChangeCardMode4Secure();
				break;
		case 5:

#ifdef TRACE_SECURE_OP 

				scwp->traceSecureOp = 0;

#endif  // TRACE_SECURE_OP

				*(vu32 *)INTR_CHECK_BUF |= CARD_DATA_INTR_FLAG;		// J[h`FbÑZbg
				break;
	}

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					J[h荞݁iNORMAL & GAME[hj
//----------------------------------------------------------------------

void CardIntr(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();
	s32  blockSize = ciwp->blockSize;

	if (*(vu8 *)REG_PAUSE & 1)	return;

	// ubNǂݍ

	ciwp->restSize -= blockSize;
	ciwp->romp += blockSize;
	ciwp->ramp += blockSize;

	if (ciwp->restSize > 0) {
		ciwp->AsyncFuncp(ciwp->romp, ciwp->ramp, blockSize, &ciwp->param);
	} else {
		*(vu32 *)INTR_CHECK_BUF |= CARD_DATA_INTR_FLAG;	// J[h`FbÑZbg
	}
}


//----------------------------------------------------------------------
//     					J[h荞 
//----------------------------------------------------------------------

void EnableCardIntr(void)
{
	*(vu32 *)REG_IME = 0;
	*(vu32 *)INTR_CHECK_BUF &= ~CARD_DATA_INTR_FLAG;		// J[h`FbÑNA

	*(vu32 *)REG_IF  = CARD_DATA_INTR_FLAG;
	*(vu32 *)REG_IE |= CARD_DATA_INTR_FLAG;					// J[h荞݋
	*(vu32 *)REG_IME = 1;
}


//----------------------------------------------------------------------
//     					J[h荞 I
//----------------------------------------------------------------------

void TerminateCardIntr(void)
{
	{	CardIntrWork *ciwp = GetCardIntrWorkAddr();

		WaitCardDma(ciwp->param.dmaNo);
	}

	TerminateIntr(CARD_DATA_INTR_FLAG | CARD_IREQ_INTR_FLAG); // J[h荞݋֎~
}


//----------------------------------------------------------------------
//     					J[h荞 I҂
//----------------------------------------------------------------------

void WaitCardIntr(void)
{

	WaitIntr(0, CARD_DATA_INTR_FLAG);

	TerminateCardIntr();
}


//----------------------------------------------------------------------
//     					J[hANZX
//----------------------------------------------------------------------

#ifndef TS_MON

void AccessCard(u32 dmaNo, s32 *srcp, s32 *destp, s32 size)
{
	int  i;

//    *(vu8 *)REG_EXMEMCNT = CTRDG_ACCESS_MAINP | CTRDG_AD16_1ST_10CYC | CTRDG_AD16_2ND_6CYC;  // 10-6ANZX

	CpuCopy16_32(srcp, destp, size, 32);							// J[gbW̓]
}

#endif	// TS_MON


//----------------------------------------------------------------------
//     					SECURE[hp[^ 
//----------------------------------------------------------------------
extern u32 normal_mode_key[];

void InitSecureParam(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork  *scwp = GetSecureWorkAddr();

	InitCardOpBlowfish();						// J[hR}hÍ 
	InitVA_VB_VD();								// VA & VB & VD 

#ifndef DISABLE_SECURE_CODE
												// NORMAL[ĥ݂ł̓삪Ă邩H
	if ((scwp->cardNormalModeKey[0] == normal_mode_key[0])
	 && (scwp->cardNormalModeKey[1] == normal_mode_key[1]))
		shwp->enableCardNormalOnly = 1;

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					J[hR}hÍ 
//----------------------------------------------------------------------

void InitCardOpBlowfish(void)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();
	RomHeader  *rmhp  = GetRomHeaderAddr();

	MakeBlowfishCardTable(&scwp->blowfishCardTable, &rmhp->initialCode, scwp->cardKeyBuf);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					VA & VB & VD 
//----------------------------------------------------------------------

void InitVA_VB_VD(void)
{

#ifndef DISABLE_SECURE_CODE

	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();
	u8 getSP[4];

	EncryptByBlowfishFook1(&scwp->blowfishCardTable, (u32 *)scwp->recvRtcBuf);

	scwp->va = *(u32 *)&scwp->recvRtcBuf[4] ^  (u32 )&scwp->bufEnd[2];
	scwp->vb = *(u32 *)&scwp->recvRtcBuf[4] ^ *(u32 *)&scwp->recvRtcBuf[0];
	scwp->vd = *(u32 *)&scwp->recvRtcBuf[4] ^  (u32  )&getSP[2];
	scwp->vc_dummy = *(u16 *)&scwp->recvRtcBuf[0] ^ *(u16 *)&scwp->recvRtcBuf[2]
				   ^ *(u16 *)&scwp->recvRtcBuf[4] ^ *(u16 *)&scwp->recvRtcBuf[6]
				   ^  (u32 )InitVA_VB_VD;

	EncryptByBlowfishFook0(&scwp->blowfishCardTable, &scwp->vd, &scwp->vb);

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					PNXNuH
//----------------------------------------------------------------------
extern u8  default_pnA_l_0_table[8];
extern u8  default_pnA_l_1;
extern u32 default_pnB_l;
extern u8  default_pnB_h;

void InitCardPN_Intf(void)
{
	u32  pnA_l, pnA_h;

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();

	pnA_l = scwp->vd <<15 | default_pnA_l_0_table[(*(vu16 *)PNA_INDEX & 0x0700) >>8] | default_pnA_l_1 <<8;
	pnA_h = (scwp->vd >>(32-15)) & 0x7f;

	WaitCard();													// J[h~҂

	*(vu32 *)REG_CARD_PNA_INIT_L = pnA_l;
	*(vu16 *)REG_CARD_PNA_INIT_H = pnA_h;

	*(vu32 *)REG_CARD_PNB_INIT_L = default_pnB_l;
	*(vu16 *)REG_CARD_PNB_INIT_H = default_pnB_h; 

	*(vu32 *)REG_CARDCNT = CARD_INIT_SCRAMBLE_PN				// omlݒ
						 | CARD_SCRAMBLE_UNIT_ON | CARD_DATA_SCRAMBLE_ON
						 | CARD_RESET_HI;

#endif	// DISABLE_SECURE_CODE

}


//----------------------------------------------------------------------
//     					VAE ZbgiNORMAL[hj
//----------------------------------------------------------------------

void SetVAE(CardCtrlParam *paramp)
{
	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[1] |= scwp->va & MROMOP_N_VAE_MASK_H;
}

//----------------------------------------------------------------------
//     					VBI ZbgiNORMAL[hj
//----------------------------------------------------------------------

void SetVBI(CardCtrlParam *paramp)
{
	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[0] |= scwp->vb;
	scwp->vb >>= MROMOP_N_VBI_SHIFT_L;
}


//----------------------------------------------------------------------
//     					VA ZbgiSECURE[hj
//----------------------------------------------------------------------

void SetVA(CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[0] |= (scwp->va <<MROMOP_S_VA_SHIFT_L) & MROMOP_S_VA_MASK_L;
	paramp->op[1] |= (scwp->va >>MROMOP_S_VA_SHIFT_H) & MROMOP_S_VA_MASK_H;

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					VB ZbgiSECURE[hj
//----------------------------------------------------------------------

void SetVB(CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[0] |= scwp->vb & MROMOP_S_VB_MASK_L;
	scwp->vb++;

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					VB eXgZbgiSECURE[hj
//----------------------------------------------------------------------

#ifdef TRACE_SECURE_OP 

void OverWriteTestVB(CardCtrlParam *paramp)
{
	SecureWork *scwp = GetSecureWorkAddr();
	CardIntrWork *ciwp = GetCardIntrWorkAddr();

	*(u64 *)&paramp->op = *(u64 *)&scwp->paramBak.op;					// R}h

	paramp->op[0] &= (MROMOP_S_VB_MASK_L ^ -1);
	SetVB(paramp);

	scwp->paramBak = *paramp;											// R}hobvAbv
																		// R}hÍ
	EncryptByBlowfish(&scwp->blowfishCardTable, &paramp->op[1], &paramp->op[0]);
}

#endif  // TRACE_SECURE_OP


//----------------------------------------------------------------------
//     					VCiZOgAhXj ZbgiSECURE[hj
//----------------------------------------------------------------------

void SetDummyVC(CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[1] |= (scwp->vc_dummy <<MROMOP_S_VC_SHIFT_H) & MROMOP_S_VC_MASK_H;

#endif	// DISABLE_SECURE_CODE

}

//----------------------------------------------------------------------
//     					VD ZbgiSECURE[hj
//----------------------------------------------------------------------

void SetVD(CardCtrlParam *paramp)
{

#ifndef DISABLE_SECURE_CODE

	SecureWork *scwp = GetSecureWorkAddr();

	paramp->op[0] |= (scwp->vd <<MROMOP_S_VD_SHIFT_L) & MROMOP_S_VD_MASK_L;
	paramp->op[1] |= (scwp->vd >>MROMOP_S_VD_SHIFT_H) & MROMOP_S_VD_MASK_H;

#endif	// DISABLE_SECURE_CODE

}


