//======================================================================
//					IRIS-SUBP}bv`
//======================================================================
#ifndef	_IRIS_SUBP_MON_MEMORY_MAP_H
#define	_IRIS_SUBP_MON_MEMORY_MAP_H


#include "IrisSubpMonTarget.h"


//----------------------------------------------------------------------
//                      E}bv
//----------------------------------------------------------------------

#define MON_CPU_WRAM             CPU_WRAM                   // bot[Nq`l
#define MON_CPU_WRAM_END        (MON_CPU_WRAM + 0x18000)

#ifdef  ENABLE_DEBUGGER_ON_4MB
#define MON_MMEM_LOAD_LIMIT		(MAIN_MEM_END     - (0x100000 + MROM_PAGE_SIZE - 1))
#else
#define MON_MMEM_LOAD_LIMIT		(MAIN_MEM_END     - (0x40000  + MROM_PAGE_SIZE - 1))
#endif
#define MON_WRAM_LOAD_LIMIT		(MON_CPU_WRAM_END - (0x8000   + MROM_PAGE_SIZE - 1))
#define MON_DBG_LOAD_LIMIT		(MAIN_MEM_EX_END  - (0x40000  + MROM_PAGE_SIZE - 1))

#define FLH_MMEM_LOAD_LIMIT		(MAIN_MEM_EX_END  - (0x1000 + 0x20)) // LZ17oCg]ɓWJꍇւ̑Ή
#define FLH_WRAM_LOAD_BASE		(MON_CPU_WRAM     +  0x2200)		 // ZLA[N̈̕ی
#define FLH_WRAM_LOAD_LIMIT		(MON_CPU_WRAM_END - (0x400  + 0x20)) // LZ17oCg]ɓWJꍇւ̑Ή

#define PNA_INDEX               (ROM_HEADER_BUF + 0x12)     // PNAe[uECfbNX

#define MMEM_CHK_SIZE_READ_BUF  (MAIN_MEM_END    - 0x6)     // CETCY`FbN݃obt@
#define MMEM_CHK_SIZE_WRITE_BUF (MAIN_MEM_EX_END - 0x6)     //                             ǂݍ݃obt@

#define AGB_ROM_HEADER          0x08000004                  // AGB-ROMo^f[^

#define MON_NINLOGO             (AGB_ROM_HEADER + 0x0     ) // NINTENDOSEf[^
#define MON_FIQ_FLAG            (AGB_ROM_HEADER + 0x9c - 4) // ehptO
#define MON_KEY_GROUP_NO        (AGB_ROM_HEADER + 0x9e - 4) // L[O[vm
#define MON_SOFT_NAME           (AGB_ROM_HEADER + 0xa0 - 4) // \tg
#define MON_COMPLEMENT          (AGB_ROM_HEADER + 0xbd - 4) // ␔`FbNEf[^

#define AGB_DACS_KEY_REG0       0x09fe2000 - 32             // c`brL[WX^
#define AGB_DACS_KEY_REG1       0x0a000000 - 32

#define REG_PAUSE               (REG_BASE + 0x300)          // o`trd
#define REG_BIOS_PROTECT_ADDR   (REG_BASE + 0x308)          // ahnrveNgAhX


//----------------------------------------------------------------------
//                      ETCY
//----------------------------------------------------------------------

#define BIOS_SIZE                0x4000                         // VXeROM

#define ROM_HEADER_SIZE         (0xc0 - 4 + OFFSET_MON_NINLOGO) // ROMo^f[^
#define MON_NINLOGO_SIZE        (MON_SOFT_NAME - MON_NINLOGO)   // NINTENDOSEf[^


//----------------------------------------------------------------------
//                      o^f[^EItZbg
//----------------------------------------------------------------------

#define OFFSET_MON_NINLOGO      (MON_NINLOGO      - MON_NINLOGO)  // NINTENDOSEf[^
#define OFFSET_MON_FIQ_FLAG     (MON_FIQ_FLAG     - MON_NINLOGO)  // ehptO
#define OFFSET_MON_KEY_GROUP_NO (MON_KEY_GROUP_NO - MON_NINLOGO)  // L[O[vm
#define OFFSET_MON_SOFT_NAME    (MON_SOFT_NAME    - MON_NINLOGO)  // \tg
#define OFFSET_MON_COMPLEMENT   (MON_COMPLEMENT   - MON_NINLOGO)  // ␔`FbNEf[^

#define OFFSET_REG_PAUSE        0x300                             // o`trd


#endif	// _IRIS_SUBP_MON_MEMORY_MAP_H
