//*******************************************************************
//			    	IRIS-SUBPj^vO RTC֐
//*******************************************************************
#include "IrisSubpMon.h"




//--------------------- O[o ϐ  -------------------------------




//======================================================================
//     					RTC & [hip[NRAMgpj
//======================================================================

void InitRtc(void)
{
	SharedWork *shwp = GetSharedWorkAddr();
	SecureWork *scwp = GetSecureWorkAddr();
	u8 rtcInitBuf[8];
	u8 rtcSendIPL2Buf[8];

	rtcInitBuf[0] = ReadRtcStatus1();							// RTCXe[^X1 `FbN
	SendRtcOp(RTCOP_READ | RTCOP_YEAR | RTCOP_FIX_BITS);		// RTCiNFFFjFFFbjǂݍ
	RecvRtcDataBuf(&rtcInitBuf[1], 7);

	if (rtcInitBuf[0] & (RTCSTAT1_RESET_REQUEST | RTCSTAT1_BATTERY_DOWN)) {
		rtcInitBuf[0] |= RTCSTAT1_RESET;						// RTCZbgvp[_EΉ

		SendRtcOp(RTCOP_WRITE | RTCOP_STAT1 | RTCOP_FIX_BITS);
		SendRtcDataBuf(&rtcInitBuf[0], 1);
	}

	rtcSendIPL2Buf[0] = rtcInitBuf[0];							// RTCXe[^X1 Rs[
	SendRtcOp(RTCOP_READ | RTCOP_YEAR | RTCOP_FIX_BITS);		// RTCiNFFFjFFFbjǂݍ
	RecvRtcDataBuf(&rtcSendIPL2Buf[1], 7);
																// RTCG[`FbNiXe[^X1 & f[^j
	if ((ReadRtcStatus1() & (RTCSTAT1_RESET_REQUEST | RTCSTAT1_RESET))
	 || !rtcSendIPL2Buf[2])
		shwp->rtcError = 1;
																// RTC[hf[^ IPL2 ֒ʒm
	CpuCopyFast32(&rtcSendIPL2Buf, &shwp->recvRtc, sizeof(rtcSendIPL2Buf));

																// RTCf[^ ZLA[NփRs[
	CpuCopyFast32(&rtcInitBuf, &scwp->recvRtcBuf, sizeof(rtcInitBuf));
}


//----------------------------------------------------------------------
//     					R1WX^EANZXEFCg
//----------------------------------------------------------------------

__inline void WaitRtcFor5us(void)
{
	WaitByLoop(200/4);
}


//----------------------------------------------------------------------
//     					R}hM
//----------------------------------------------------------------------
void SendRtcData(u32 data);
u8 RecvRtcData(void);

void SendRtcOp(u32 op)
{
	int  i;

	*(vu8 *)REG_R1_CNT = 1								// NbNHI
					   | R1_RTC_DATA_DIR_OUT
					   | R1_RTC_SCK;

	WaitRtcFor5us();

	*(vu8 *)REG_R1_CNT = 1								// `bvCl[u
					   | R1_RTC_DATA_DIR_OUT
					   | R1_RTC_CS | R1_RTC_SCK;

	WaitRtcFor5us();

	SendRtcData(op);
}


//----------------------------------------------------------------------
//     					f[^Mi1Bytej
//----------------------------------------------------------------------

void SendRtcData(u32 data)
{
	int  i;

	for (i=0; i<8; i++) {
		u32 dataBit = (data >>7) & R1_RTC_DATA_BIT;

		*(vu8 *)REG_R1_CNT = dataBit
						   | R1_RTC_DATA_DIR_OUT
						   | R1_RTC_CS;
		WaitRtcFor5us();

		*(vu8 *)REG_R1_CNT = dataBit
						   | R1_RTC_DATA_DIR_OUT
						   | R1_RTC_CS | R1_RTC_SCK;
		WaitRtcFor5us();

		data <<= 1;
	}
}

//----------------------------------------------------------------------
//     					f[^obt@M
//----------------------------------------------------------------------

void SendRtcDataBuf(u8 *srcp, s32 count)
{
	u8  *srcEndp = srcp + count;

	while (srcp < srcEndp) {
		SendRtcData(*srcp++);
	}

	*(vu8 *)REG_R1_CNT = R1_RTC_DATA_DIR_IN				// `bvfBZ[u
					   | R1_RTC_SCK;
	WaitRtcFor5us();
}

//----------------------------------------------------------------------
//     					f[^obt@M
//----------------------------------------------------------------------

void RecvRtcDataBuf(u8 *destp, s32 count)
{
	u8  *destEndp = destp + count;

	while (destp < destEndp) {
		u8  data = 0;
		int  i;

		for (i=0; i<8; i++) {
			*(vu8 *)REG_R1_CNT = R1_RTC_DATA_DIR_IN
							   | R1_RTC_CS;

			WaitRtcFor5us();

			*(vu8 *)REG_R1_CNT = R1_RTC_DATA_DIR_IN
							   | R1_RTC_CS | R1_RTC_SCK;
			WaitRtcFor5us();

			data |= (*(vu8 *)REG_R1_CNT & R1_RTC_DATA_BIT) <<i;
		}
		*destp++ = data;
	}

	*(vu8 *)REG_R1_CNT = R1_RTC_DATA_DIR_IN				// `bvfBZ[u
					   | R1_RTC_SCK;
	WaitRtcFor5us();
}


//======================================================================
//     					RTCXe[^Xǂݍ
//======================================================================

u8 ReadRtcStatusBase(u32 op)
{
	u8 status;

	SendRtcOp(op |RTCOP_READ | RTCOP_FIX_BITS);			// RTCXe[^X `FbN
	RecvRtcDataBuf(&status, 1);

	return  status;
}

u8 ReadRtcStatus1(void)
{
	return  ReadRtcStatusBase(RTCOP_STAT1);
}

