//======================================================================
//          IrisSubpDefine.h
//            IRISTuvZbT W萔
//
//          Copyright (C) 2002-2004 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SUBP_DEFINE_H
#define _IRIS_SUBP_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisSubpTarget.h>


//----------------------------------------------------------------------
//                            萔
//----------------------------------------------------------------------

#define SYSTEM_CLOCK            33513982    // VXeNbN

#define MAINP                   0           // CvZbT
#define SUBP                    1           // TuvZbT


#define ON                      1
#define OFF                     0
#define ENABLE                  1
#define DISABLE                 0
#define TRUE                    1
#define FALSE                   0



//**********************************************************************
//              hqhrTuvZbTWX^ERg[rbg
//**********************************************************************

//----------------------------------------------------------------------
//                  vOXe[^XWX^
//----------------------------------------------------------------------

#define PSR_CPU_MODE_MASK       0x1f        // bot[h

#define PSR_USER_MODE           0x10        // [U
#define PSR_FIQ_MODE            0x11        // ehp
#define PSR_IRQ_MODE            0x12        // hqp
#define PSR_SVC_MODE            0x13        // X[poCU
#define PSR_ABORT_MODE          0x17        // A{[givtFb`^f[^j
#define PSR_UNDEF_MODE          0x1b        // `
#define PSR_SYS_MODE            0x1f        // VXe

#define PSR_THUMB_STATE         0x20        // sgtlaXe[g
#define PSR_FIQ_DISABLE         0x40        // ehps
#define PSR_IRQ_DISABLE         0x80        // hqps
#define PSR_IRQ_FIQ_DISABLE     0xc0        // hqpehps

#define PSR_V_FLAG              0x10000000  // I[o[t[
#define PSR_C_FLAG              0x20000000  // L[^{[^g
#define PSR_Z_FLAG              0x40000000  // [
#define PSR_N_FLAG              0x80000000  // ^

// \̃op萔

#define ST_PSR_USER_MODE        0x10        // [U
#define ST_PSR_FIQ_MODE         0x11        // ehp
#define ST_PSR_IRQ_MODE         0x12        // hqp
#define ST_PSR_SVC_MODE         0x13        // X[poCU
#define ST_PSR_ABORT_MODE       0x17        // A{[givtFb`^f[^j
#define ST_PSR_UNDEF_MODE       0x1b        // `
#define ST_PSR_SYS_MODE         0x1f        // VXe


//----------------------------------------------------------------------
//                  荞ݗv^tO
//----------------------------------------------------------------------

#define V_BLANK_INTR_FLAG       0x00000001  // uuN荞
#define H_BLANK_INTR_FLAG       0x00000002  // guN荞
#define V_COUNT_INTR_FLAG       0x00000004  // uJE^v荞
#define TIMER0_INTR_FLAG        0x00000008  // ^C}[O荞
#define TIMER1_INTR_FLAG        0x00000010  // ^C}[P荞
#define TIMER2_INTR_FLAG        0x00000020  // ^C}[Q荞
#define TIMER3_INTR_FLAG        0x00000040  // ^C}[R荞
#define SIO_INTR_FLAG           0x00000080  // VAʐM荞
#define DMA0_INTR_FLAG          0x00000100  // cl`O荞
#define DMA1_INTR_FLAG          0x00000200  // cl`P荞
#define DMA2_INTR_FLAG          0x00000400  // cl`Q荞
#define DMA3_INTR_FLAG          0x00000800  // cl`R荞
#define KEY_INTR_FLAG           0x00001000  // L[荞
#define CARTRIDGE_INTR_FLAG     0x00002000  // J[gbW荞

#define MAINP_INTR_FLAG         0x00010000  // CvZbT荞
#define MPFIFO_SEND_INTR_FLAG   0x00020000  // CvZbTԑMehenGveB荞
#define MPFIFO_RECV_INTR_FLAG   0x00040000  // CvZbTԎMehenmbgGveB荞
#define CARD_DATA_INTR_FLAG     0x00080000  // J[hf[^]I荞
#define CARD_IREQ_INTR_FLAG     0x00100000  // J[hhqdp荞
#define PMIC_RTC_INTR_FLAG      0x00400000  // p[}l[Wghb荞  qsb荞
#define SPI_INTR_FLAG           0x00800000  // roh荞
#define WIRELESS_INTR_FLAG      0x01000000  // ʐM荞


//----------------------------------------------------------------------
//                  CvZbT C^tF[X
//----------------------------------------------------------------------

#define MAINP_RECV_STATUS_MASK  0x000f      // MXe[^X
#define MAINP_SEND_STATUS_MASK  0x0f00      // MXe[^X

#define MAINP_RECV_STATUS_SHIFT 0
#define MAINP_SEND_STATUS_SHIFT 8

#define MAINP_SEND_IF           0x2000      // 荞ݗvM
#define MAINP_RECV_IF_ENABLE    0x4000      // 荞ݗvM 

//----------------------------------------------------------------------
//                  CʐMvZbTehen Rg[
//----------------------------------------------------------------------

#define MPFIFO_SEND_EMPTY       0x0001      // Mehen GveB
#define MPFIFO_SEND_FULL        0x0002      //              t
#define MPFIFO_SEND_IF_ENABLE   0x0004      //              荞ݗv 
#define MPFIFO_SEND_CLEAR       0x0008      //              NA
#define MPFIFO_RECV_EMPTY       0x0100      // Mehen GveB
#define MPFIFO_RECV_FULL        0x0200      //              t
#define MPFIFO_RECV_IF_ENABLE   0x0400      //              荞ݗv 
#define MPFIFO_ENABLE           0x8000      // h^nvZbTehen Cl[u


//----------------------------------------------------------------------
//                      p[Rg[
//----------------------------------------------------------------------

#define POW_SOUND_ON            0x0001      // TEh nm
#define POW_WIRELESS_ON         0x0002      // ʐM nm
#define POW_ALL_ON              0x0003      // S nm


//----------------------------------------------------------------------
//                      uq`l Xe[^X
//----------------------------------------------------------------------

#define VRAM_MAINP_ALL          0x00        // uq`l|bEc  CvZbT
#define VRAM_MAINP_D_SUBP_C     0x01        //               c  CvZbT
                                            //               b  TuvZbT
#define VRAM_MAINP_C_SUBP_D     0x02        //               b  CvZbT
                                            //               c  TuvZbT
#define VRAM_SUBP_ALL           0x03        //           bEc  TuvZbT

//----------------------------------------------------------------------
//                      [Nq`l Xe[^X
//----------------------------------------------------------------------

#define WRAM_MAINP_ALL          0x00        // L[Nq`lubNOEP  CvZbT
#define WRAM_MAINP_B1_SUBP_B0   0x01        //                     ubNP  CvZbT
                                            //                     ubNO  TuvZbT
#define WRAM_MAINP_B0_SUBP_B1   0x02        //                     ubNO  CvZbT
                                            //                     ubNP  TuvZbT
#define WRAM_SUBP_ALL           0x03        //                     ubNOEP  TuvZbT


//----------------------------------------------------------------------
//                      \Xe[^X
//----------------------------------------------------------------------

#define DPSTAT_V_SET_LO_MASK     0xff00     // uJE^rlݒ
#define DPSTAT_V_SET_D8          0x0080     // uJE^rlݒWrbg

#define DPSTAT_V_SET_LO_SHIFT    8

#define DPSTAT_V_BLANK           0x0001     // uuNԒ
#define DPSTAT_H_BLANK           0x0002     // guNԒ
#define DPSTAT_V_COUNT           0x0004     // uJE^v
#define DPSTAT_V_BLANK_IF_ENABLE 0x0008     // uuN荞ݗv 
#define DPSTAT_H_BLANK_IF_ENABLE 0x0010     // guN荞ݗv 
#define DPSTAT_V_COUNT_IF_ENABLE 0x0020     // uJE^v荞ݗv 


//----------------------------------------------------------------------
//                      TEh}X^ Rg[
//----------------------------------------------------------------------

#define SOUND_VOLUME_MASK       0x007f      // }X^o̓x

#define SOUND_VOLUME_SHIFT      0

#define SOUND_LOUT_MIXER        0x0000      // kŏIio ~LT[
#define SOUND_LOUT_CH1          0x0100      //                `lP
#define SOUND_LOUT_CH3          0x0200      //                `lR
#define SOUND_LOUT_CH1_CH3      0x0300      //                `lP{R
#define SOUND_ROUT_MIXER        0x0000      // qŏIio ~LT[
#define SOUND_ROUT_CH1          0x0400      //                `lP
#define SOUND_ROUT_CH3          0x0800      //                `lR
#define SOUND_ROUT_CH1_CH3      0x0C00      //                `lP{R
#define SOUND_CH1_MIXOFF        0x1000      // `lPE~bNX nee
#define SOUND_CH1_MIX           0x0000      //                        nm
#define SOUND_CH3_MIXOFF        0x2000      // `lRE~bNX nee
#define SOUND_CH3_MIX           0x0000      //                        nm
#define SOUND_MIC_MIXOFF        0x0000      // }CNE~bNX nee
#define SOUND_MIC_MIX           0x4000      //                  nm
#define SOUND_ENABLE            0x8000      // Cl[u


//----------------------------------------------------------------------
//                      TEh`l Rg[
//----------------------------------------------------------------------

#define SOUND_CHAN_VOLUME_MASK  0x000000ff  // o̓x
#define SOUND_SHIFT_MASK        0x00000300  // f[^Vtg
#define SOUND_PANPOT_MASK       0x00ff0000  // p|bg
#define SOUND_DUTY_MASK         0x07000000  // f[eB
#define SOUND_PEPEAT_TYPE_MASK  0x18000000  // s[g@
#define SOUND_FORMAT_MASK       0x60000000  // tH[}bg

#define SOUND_CHAN_VOLUME_SHIFT 0
#define SOUND_SHIFT_SHIFT       8
#define SOUND_PANPOT_SHIFT      16
#define SOUND_DUTY_SHIFT        24
#define SOUND_PEPEAT_TYPE_SHIFT 27
#define SOUND_FORMAT_SHIFT      29

#define SOUND_OUTPUT_HOLD       0x00008000  // fBZ[ȕo͕ێ

#define SOUND_DUTY_1_8          0x00000000  // f[eB P^W
#define SOUND_DUTY_2_8          0x01000000  //            Q^W
#define SOUND_DUTY_3_8          0x02000000  //            R^W
#define SOUND_DUTY_4_8          0x03000000  //            S^W
#define SOUND_DUTY_5_8          0x04000000  //            T^W
#define SOUND_DUTY_6_8          0x05000000  //            U^W
#define SOUND_DUTY_7_8          0x06000000  //            V^W
#define SOUND_DUTY_XX           0x07000000  //            ݒ֎~

#define SOUND_LINEAR            0x00000000  // jAĐ
#define SOUND_REPEAT            0x08000000  // s[gĐ
#define SOUND_1SHOT             0x10000000  // PVbgĐ

#define SOUND_PCM8              0x00000000  // oblW
#define SOUND_PCM16             0x20000000  // oblPU
#define SOUND_ADPCM             0x40000000  // `cobl
#define SOUND_PSG_NOISE         0x60000000  // orfiW`PRj܂ mCYiPS`PTj

#define SOUND_CHAN_ENABLE       0x80000000  // Cl[u

// \̃op萔

#define ST_SOUND_PCM8           0           // oblW
#define ST_SOUND_PCM16          1           // oblPU
#define ST_SOUND_ADPCM          2           // `cobl
#define ST_SOUND_PSG_NOISE      3           // orfiW`PRj܂ mCYiPS`PTj

#define ST_SOUND_DUTY_1_8       0           // f[eB P^W
#define ST_SOUND_DUTY_2_8       1           //            Q^W
#define ST_SOUND_DUTY_3_8       2           //            R^W
#define ST_SOUND_DUTY_4_8       3           //            S^W
#define ST_SOUND_DUTY_5_8       4           //            T^W
#define ST_SOUND_DUTY_6_8       5           //            U^W
#define ST_SOUND_DUTY_7_8       6           //            V^W
#define ST_SOUND_DUTY_XX        7           //            ݒ֎~


//----------------------------------------------------------------------
//                      TEhLv` Rg[
//----------------------------------------------------------------------

#define SNDCAP_PREMIXING_ON     0x01        // ~LT[O nm
#define SNDCAP_SRC              0x02        // Lv`I
#define SNDCAP_MIXER            0x00        // ~LT[o̓f[^Lv`
#define SNDCAP_CHAN             0x02        // P`lLv`
#define SNDCAP_REPEAT_OFF       0x04        // s[g nee
#define SNDCAP_FORMAT           0x08        // Lv`tH[}bg
#define SNDCAP_PCM16            0x00        //                        PUobl
#define SNDCAP_PCM8             0x08        //                        Wobl
#define SNDCAP_ENABLE           0x80        // Cl[u


//----------------------------------------------------------------------
//                      rohRg[
//----------------------------------------------------------------------

#define SPI_SCK_MASK            0x0003      // VtgNbN
#ifdef IRIS_TS
#define SPI_TARGET_MASK         0x0300      // ʐM^[Qbgw
#else
#define SPI_TARGET_MASK         0x2000
#endif

#define SPI_SCK_SHIFT           0

#define SPI_SCK_4M              0x0000      // VtgNbN SlgI
#define SPI_SCK_2M              0x0001      //                Qlg
#define SPI_SCK_1M              0x0002      //                Plg
#define SPI_SCK_524K            0x0003      //            TQSjg

#define SPI_BUSY                0x0080      // rW[
#define SPI_8BIT_MODE           0x0000      //   Wrbg[h
#ifdef IRIS_TS
#define SPI_16BIT_MODE          0x0400      // PUrbg[h
#define SPI_CONTINUOUS_ON       0x0800      // ReBjAX[h nm
#define SPI_TARGET_PMIC         0x0000      // olhbI
#define SPI_TARGET_FLASH        0x0100      // tbVI
#define SPI_TARGET_TOUCHPANEL   0x0200      // ^b`plI
#else
#define SPI_CONTINUOUS_ON       0x1000      // ReBjAX[h nm
#define SPI_TARGET_PMIC         0x0000      // olhbI
#define SPI_TARGET_FLASH        0x2000      // tbVI
#endif
#define SPI_IF_ENABLE           0x4000      // 荞ݗv 
#define SPI_ENABLE              0x8000      // roh

// \̃op萔

#define ST_SPI_SCK_4M             0         // VtgNbN SlgI
#define ST_SPI_SCK_2M             1         //                Qlg
#define ST_SPI_SCK_1M             2         //                Plg
#define ST_SPI_SCK_524K           3         //            TQSjg

#ifdef IRIS_TS
#define ST_SPI_TARGET_PMIC        0         // olhbI
#define ST_SPI_TARGET_FLASH       1         // tbVI
#define ST_SPI_TARGET_TOUCHPANEL  2         // ^b`plI
#else
#define ST_SPI_TARGET_PMIC        0         // olhbI
#define ST_SPI_TARGET_FLASH       1         // tbVI
#endif


//----------------------------------------------------------------------
//                      ėpo̓Rg[
//----------------------------------------------------------------------

#define R_SIO_MODE_MASTER_MASK  0xc000      // rhn[hE}X^

#define R_SIO_MODE_MASTER_SHIFT 14

#define R_SIO_MASTER_MODE       0x0000      // rhn}X^E[h
#define R_DIRECT_MODE           0x8000      // ėpo͒ʐM[h

#define R_SC                    0x0001      // f[^
#define R_SD                    0x0002
#define R_SI                    0x0004
#define R_SO                    0x0008
#define R_SC_I_O                0x0010      // h/nI
#define R_SD_I_O                0x0020
#define R_SI_I_O                0x0040
#define R_SO_I_O                0x0080
#define R_SC_IN                 0x0000      // ͐ݒ
#define R_SD_IN                 0x0000
#define R_SI_IN                 0x0000
#define R_SO_IN                 0x0000
#define R_SC_OUT                0x0010      // o͐ݒ
#define R_SD_OUT                0x0020
#define R_SI_OUT                0x0040
#define R_SO_OUT                0x0080
#define R_IF_ENABLE             0x0100      // 荞ݗv 

// \̃op萔

#define ST_R_SIO_MASTER_MODE    0           // rhn}X^E[h
#define ST_R_DIRECT_MODE        2           // ėpo͒ʐM[h

#define ST_R_IN                 0           // ͑I
#define ST_R_OUT                1           // o͑I


//----------------------------------------------------------------------
//                      cl`Rg[
//----------------------------------------------------------------------

#define DMA_TIMMING_MASK        0x30000000  // Jn^C~O
#define DMA_COUNT_MASK          0x0000ffff  // ]

#define DMA_TIMMING_SHIFT       30
#define DMA_COUNT_SHIFT         0

#define DMA_ENABLE              0x80000000  // cl`
#define DMA_IF_ENABLE           0x40000000  // 荞ݗv 
#define DMA_TIMMING_IMM         0x00000000  // ɋN
#define DMA_TIMMING_V_BLANK     0x10000000  // uuNN
#define DMA_TIMMING_CARD        0x20000000  // J[h
#define DMA_TIMMING_WIRELESS    0x30000000  // ʐM
#define DMA_TIMMING_CARTRIDGE   0x30000000  // J[gbW
#define DMA_16BIT_BUS           0x00000000  // oXTCYPUaI
#define DMA_32BIT_BUS           0x04000000  // oXTCYRQaI
#define DMA_CONTINUOUS_ON       0x02000000  // ReBjAX[h nm
#define DMA_SRC_INC             0x00000000  // ] CNg I
#define DMA_SRC_DEC             0x00800000  // ] fNg   I
#define DMA_SRC_FIX             0x01000000  // ] Œ I
#define DMA_DEST_INC            0x00000000  // ] CNg I
#define DMA_DEST_DEC            0x00200000  // ] fNg   I
#define DMA_DEST_FIX            0x00400000  // ] Œ I
#define DMA_DEST_RELOAD         0x00600000  // ] CNg/[h I

// \̃op萔

#define ST_DMA_TIMMING_IMM        0         // ɋN
#define ST_DMA_TIMMING_V_BLANK    1         // uuNN
#define ST_DMA_TIMMING_CARD       2         // J[h
#define ST_DMA_TIMMING_CARTRIDGE  3         // J[gbW
#define ST_DMA_16BIT_BUS          0         // oXTCYPUI
#define ST_DMA_32BIT_BUS          1         // oXTCYRQI
#define ST_DMA_INC                0         // AhXECNg I
#define ST_DMA_DEC                1         // AhXEfNg   I
#define ST_DMA_FIX                2         // AhXŒ I
#define ST_DMA_RELOAD             3         // AhXECNg/[h I


//----------------------------------------------------------------------
//                      ^C}[ Rg[
//----------------------------------------------------------------------

#define TMR_PRESCALER_MASK      0x00030000  // vXP[ NbN

#define TMR_PRESCALER_SHIFT     16

#define TMR_PRESCALER_1CK       0x00000000  // vXP[ P
#define TMR_PRESCALER_64CK      0x00010000  //            US
#define TMR_PRESCALER_256CK     0x00020000  //          QTU
#define TMR_PRESCALER_1024CK    0x00030000  //        POQS
#define TMR_CONNECT             0x00040000  // ʃ^C}[ڑ
#define TMR_IF_ENABLE           0x00400000  // 荞ݗv 
#define TMR_ENABLE              0x00800000  // ^C}[N

// \̃op萔

#define ST_TMR_PRESCALER_1CK    0           // vXP[ P
#define ST_TMR_PRESCALER_64CK   1           //            US
#define ST_TMR_PRESCALER_256CK  2           //          QTU
#define ST_TMR_PRESCALER_1024CK 3           //        POQS


//----------------------------------------------------------------------
//                          L[
//----------------------------------------------------------------------

#define BUTTON_MASK             0x030f      // {^
#define PLUS_KEY_MASK           0x00f0      // \L[
#define ALL_KEY_MASK            0x03ff      // SẴL[

#define A_BUTTON                0x0001      // `{^
#define B_BUTTON                0x0002      // a{^
#define SELECT_BUTTON           0x0004      // ZNg{^
#define START_BUTTON            0x0008      // X^[g{^
#define R_KEY                   0x0010      // E{^
#define L_KEY                   0x0020      // {^
#define U_KEY                   0x0040      // {^
#define D_KEY                   0x0080      // {^
#define R_BUTTON                0x0100      // q{^
#define L_BUTTON                0x0200      // k{^
#define KEY_IF_ENABLE           0x4000      // 荞ݗv 
#define KEY_OR_INTR             0x0000      //   ʏL[荞
#define KEY_AND_INTR            0x8000      // `mcL[荞

// \̃op萔

#define ST_KEY_OR_INTR          0            //   ʏL[荞
#define ST_KEY_AND_INTR         1            // `mcL[荞


//----------------------------------------------------------------------
//                      O Rg[
//----------------------------------------------------------------------

#define CTRDG_DT8_10CYC         0x0000      // J[gbW Wf[^oX  POTCN
#define CTRDG_DT8_8CYC          0x0001      //                                    WTCN
#define CTRDG_DT8_6CYC          0x0002      //                                    UTCN
#define CTRDG_DT8_18CYC         0x0003      //                                  PWTCN
#define CTRDG_AD16_1ST_10CYC    0x0000      // J[gbW `cPUoX P POTCN
#define CTRDG_AD16_1ST_8CYC     0x0004      //                                    WTCN
#define CTRDG_AD16_1ST_6CYC     0x0008      //                                    UTCN
#define CTRDG_AD16_1ST_18CYC    0x000c      //                                  PWTCN
#define CTRDG_AD16_2ND_6CYC     0x0000      //                           Q   UTCN
#define CTRDG_AD16_2ND_4CYC     0x0010      //                                    STCN

#define CTRDG_PHI_OUT_NONE      0x0000      // Ӓ[qo̓NbN kŒ
#define CTRDG_PHI_OUT_4MCK      0x0020      //                    Slg
#define CTRDG_PHI_OUT_8MCK      0x0040      //                    Wlg
#define CTRDG_PHI_OUT_16MCK     0x0060      //                  PUlg

#define CTRDG_ACCESS            0x0080      // J[gbWANZX
#define CTRDG_ACCESS_MAINP      0x0000      //           CvZbT
#define CTRDG_ACCESS_SUBP       0x0080      //           TuvZbT

#define CARD_ACCESS             0x0800      // J[hANZX
#define CARD_ACCESS_MAINP       0x0000      //           CvZbT
#define CARD_ACCESS_SUBP        0x0800      //           TuvZbT

#define MMEM_CE2_OUT            0x2000      //             bdQMmF

#define MMEM_INTF               0x4000      // CC^tF[Xisdfł͏ɃZbgē[hɂj
#define MMEM_INTF_ASYNC         0x0000      //                           񓯊[h
#define MMEM_INTF_SYNC          0x4000      //                             [h

#define MMEM_PRIORITY           0x8000      // CD挠
#define MMEM_PRIORITY_MAINP     0x0000      //           CvZbT
#define MMEM_PRIORITY_SUBP      0x8000      //           TuvZbT

// \̃op萔

#define ST_CTRDG_DT8_10CYC      0           // J[gbW Wf[^oX  POTCN
#define ST_CTRDG_DT8_8CYC       1           //                                    WTCN
#define ST_CTRDG_DT8_6CYC       2           //                                    UTCN
#define ST_CTRDG_DT8_18CYC      3           //                                  PWTCN
#define ST_CTRDG_AD16_1ST_10CYC 0           // J[gbW `cPUoX P POTCN
#define ST_CTRDG_AD16_1ST_8CYC  1           //                                    WTCN
#define ST_CTRDG_AD16_1ST_6CYC  2           //                                    UTCN
#define ST_CTRDG_AD16_1ST_18CYC 3           //                                  PWTCN
#define ST_CTRDG_AD16_2ND_6CYC  0           //                           Q   UTCN
#define ST_CTRDG_AD16_2ND_4CYC  1           //                                    STCN

#define ST_CTRDG_PHI_OUT_NONE   0           // Ӓ[qo̓NbN kŒ
#define ST_CTRDG_PHI_OUT_4MCK   1           //                    Slg
#define ST_CTRDG_PHI_OUT_8MCK   2           //                    Wlg
#define ST_CTRDG_PHI_OUT_16MCK  3           //                  PUlg


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SUBP_DEFINE_H
