//======================================================================
//          IrisSubpMacro.h
//            IRISTuvZbT W}N֐
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SUBP_MACRO_H
#define _IRIS_SUBP_MACRO_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisSubpTarget.h>
#include <IrisSubpTypes.h>
#include <IrisSubpSystemCall.h>


//----------------------------------------------------------------------
//                      f[^ǂݍ
//----------------------------------------------------------------------

#define ReadData(readp, bit)    (*(vu##bit *)(readp))

//----------------------------------------------------------------------
//                      f[^
//----------------------------------------------------------------------

#define WriteData(writep, data, bit)                    \
                                                        \
    (*(vu##bit *)(writep) = (data))

//----------------------------------------------------------------------
//                      f[^ Rs[
//----------------------------------------------------------------------

#define CopyData(readp, writep, bit)                    \
                                                        \
    (*(vu##bit *)(writep) = *(vu##bit *)(readp))


//----------------------------------------------------------------------
//                  AhXEobt@̗L
//----------------------------------------------------------------------

#ifdef  __CC_ARM
#define EnableAlignBuf(alignBuf)                        \
{                                                       \
    vu16 alignBufTmp = *(vu16 *)alignBuf;               \
}
#else
#define EnableAlignBuf(alignBuf) 	((void) 0)
#endif


//----------------------------------------------------------------------
//                  荞݃AhX Zbg
//----------------------------------------------------------------------

#define SetIntrAddr(intrp)                              \
                                                        \
    (*(vu32 *)INTR_VECTOR_BUF = (vu32 )intrp)

//E荞ݏ̃AhXZbg܂B


//----------------------------------------------------------------------
//                      cl` Zbg
//----------------------------------------------------------------------

//#define SIMULATOR
#ifndef SIMULATOR
#define DmaSet(dmaNo, srcp, destp, dmaCntData)                       \
{                                                                    \
    vu32 *dmaCntp = &((vu32 *)REG_DMA0)[dmaNo * 3];                  \
    dmaCntp[0] = (vu32 )(srcp);                                      \
    dmaCntp[1] = (vu32 )(destp);                                     \
    dmaCntp[2] = (vu32 )(dmaCntData);                                \
    {u32 dummy = dmaCntp[2];}                                        \
}
#define DmaSetAsync(dmaNo, srcp, destp, dmaCntData)                  \
{                                                                    \
    vu32 *dmaCntp = &((vu32 *)REG_DMA0)[dmaNo * 3];                  \
    dmaCntp[0] = (vu32 )(srcp);                                      \
    dmaCntp[1] = (vu32 )(destp);                                     \
    dmaCntp[2] = (vu32 )(dmaCntData);                                \
}
#else
#define DmaSet(dmaNo, srcp, destp, dmaCntData)                       \
{                                                                    \
    int    i;                                                        \
    for (i=0; i<(dmaCntData & 0x1ffff); i++)                         \
        if ((dmaCntData) & DMA_SRC_FIX) {                            \
            if ((dmaCntData) & DMA_32BIT_BUS)                        \
                    ((vu32 *)(destp))[i] = ((vu32 *)(srcp))[0];      \
            else    ((vu16 *)(destp))[i] = ((vu16 *)(srcp))[0];      \
         } else {                                                    \
            if ((dmaCntData) & DMA_32BIT_BUS)                        \
                ((vu32 *)(destp))[i] = ((vu32 *)(srcp))[i];          \
            else    ((vu16 *)(destp))[i] = ((vu16 *)(srcp))[i];      \
        }                                                            \
}
#define DmaSetAsync(dmaNo, srcp, destp, dmaCntData)                  \
        DmaSet(     dmaNo, srcp, destp, dmaCntData)
#endif

//EDMARg[Ƀp[^Zbg܂B
//ESIMULATER`CPUŃV~[g܂B
//  GDBŃfobOꍇȂǂɗLłB
//EŌDMAN҂̂߂"LDR"߂}܂B
//
//EF
//  dmaNo       DMAԍ
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  dmaCntData  p[^f[^
//
//CPURAM̃vOɂDMAN
//  ̖̎߂Ɏs܂B
//  āADMAɓ]CPUɂĕύX悤ƂꍇA
//  ǂݍ݁^߂̊ԂDMANĂ܂܂̂ŁA
//  DMA̓]̃f[^Ӑ}ĂȂlɂȂꍇ܂B
//  ̏ꍇɂWaitDma()𒼌ɑ}āADMAI
//  ǂ`FbNƑR[hւ̉emɉł܂B


//----------------------------------------------------------------------
//                      cl` NA
//----------------------------------------------------------------------

#define DmaClear(dmaNo, data, destp, size, bit)             \
{                                                           \
    vu##bit tmp = (data);                                   \
    DmaSet(dmaNo, &tmp, destp, (                            \
        DMA_ENABLE         | DMA_TIMMING_IMM |              \
        DMA_SRC_FIX        | DMA_DEST_INC    |              \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))));            \
}

#define DmaClearIf(dmaNo, data, destp, size, bit)           \
{                                                           \
    vu##bit tmp = (data);                                   \
    DmaSet(dmaNo, &tmp, destp, (                            \
        DMA_ENABLE         | DMA_TIMMING_IMM |              \
        DMA_IF_ENABLE      |                                \
        DMA_SRC_FIX        | DMA_DEST_INC    |              \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))));            \
}

#define DmaClearArray(  dmaNo, data, destp, bit)            \
        DmaClear(       dmaNo, data, destp, sizeof(destp), bit)

#define DmaClearArrayIf(dmaNo, data, destp, bit)            \
        DmaClearIf(     dmaNo, data, destp, sizeof(destp), bit)

//EDMARAMNA܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//EDmaClearIf^DmaClearArrayIf͏IɊ荞ݗv𔭐܂B
//EDmaClearArray^DmaClearArrayIf̓fXeBl[VzŜNA܂B
//
//EF
//  dmaNo       DMAԍ
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg
//  bit         ]rbgi16|32j
//
//
//CPURAM̃vOɂDMAN
//  ̖̎߂Ɏs܂B
//  āADMAɓ]CPUɂĕύX悤ƂꍇA
//  ǂݍ݁^߂̊ԂDMANĂ܂܂̂ŁA
//  DMA̓]̃f[^Ӑ}ĂȂlɂȂꍇ܂B
//  ̏ꍇɂWaitDma()𒼌ɑ}āADMAI
//  ǂ`FbNƑR[hւ̉emɉł܂B

//----------------------------------------------------------------------
//                      cl` Rs[
//----------------------------------------------------------------------

#define DmaCopy(dmaNo, srcp, destp, size, bit)              \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_IMM |              \
        DMA_SRC_INC        | DMA_DEST_INC    |              \
        DMA_##bit##BIT_BUS | ((size)/((bit)/8))))

#define DmaCopyIf(dmaNo, srcp, destp, size, bit)            \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_IMM |              \
        DMA_IF_ENABLE      |                                \
        DMA_SRC_INC        | DMA_DEST_INC    |              \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))))

#define DmaCopyArray(  dmaNo, srcp, destp, bit)             \
        DmaCopy(       dmaNo, srcp, destp, sizeof(srcp), bit)

#define DmaCopyArrayIf(dmaNo, srcp, destp, bit)             \
        DmaCopyIf(     dmaNo, srcp, destp, sizeof(srcp), bit)

//EDMAŃRs[܂B
//EDmaCopyIf^DmaCopyArrayIf͏IɊ荞ݗv𔭐܂B
//EDmaCopyArray^DmaCopyArrayIf̓\[XzŜRs[܂B
//
//EF
//  dmaNo       DMAԍ
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j
//
//
//CPURAM̃vOɂDMAN
//  ̖̎߂Ɏs܂B
//  āADMAɓ]CPUɂĕύX悤ƂꍇA
//  ǂݍ݁^߂̊ԂDMANĂ܂܂̂ŁA
//  DMA̓]̃f[^Ӑ}ĂȂlɂȂꍇ܂B
//  ̏ꍇɂWaitDma()𒼌ɑ}āADMAI
//  ǂ`FbNƑR[hւ̉emɉł܂B

//----------------------------------------------------------------------
//                  guNcl` Rs[
//----------------------------------------------------------------------

#define H_DmaCopy(dmaNo, srcp, destp, size, bit)            \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_H_BLANK |          \
        DMA_SRC_INC        | DMA_DEST_RELOAD     |          \
        DMA_CONTINUOUS_ON  |                                \
        DMA_##bit##BIT_BUS | ((size)/((bit)/8))))

#define H_DmaCopyIf(dmaNo, srcp, destp, size, bit)          \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_H_BLANK |          \
        DMA_IF_ENABLE      |                                \
        DMA_SRC_INC        | DMA_DEST_RELOAD     |          \
        DMA_CONTINUOUS_ON  |                                \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))))

#define H_DmaCopyArray(  dmaNo, srcp, destp, bit)           \
        H_DmaCopy(       dmaNo, srcp, destp, sizeof(srcp), bit)

#define H_DmaCopyArrayIf(dmaNo, srcp, destp, bit)           \
        H_DmaCopyIf(     dmaNo, srcp, destp, sizeof(srcp), bit)

//EHuNɓDMAŃRs[܂B
//EH_DmaCopyIf^H_DmaCopyArrayIf͏IɊ荞ݗv𔭐܂B
//EH_DmaCopyArray^H_DmaCopyArrayIf̓\[XzŜRs[܂B
//
//EF
//  dmaNo       DMAԍ
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                  uuNcl` Rs[
//----------------------------------------------------------------------

#define V_DmaCopy(dmaNo, srcp, destp, size, bit)            \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_V_BLANK |          \
        DMA_SRC_INC        | DMA_DEST_INC        |          \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))))

#define V_DmaCopyIf(dmaNo, srcp, destp, size, bit)          \
                                                            \
    DmaSet(dmaNo, srcp, destp,  (                           \
        DMA_ENABLE         | DMA_TIMMING_V_BLANK |          \
        DMA_IF_ENABLE      |                                \
        DMA_SRC_INC        | DMA_DEST_INC        |          \
        DMA_##bit##BIT_BUS | ((size)/(bit/8))))

#define V_DmaCopyArray(  dmaNo, srcp, destp, bit)           \
        V_DmaCopy(       dmaNo, srcp, destp, sizeof(srcp), bit)

#define V_DmaCopyArrayIf(dmaNo, srcp, destp, bit)           \
        V_DmaCopyIf(     dmaNo, srcp, destp, sizeof(srcp), bit)

//EVuNɓDMAŃRs[܂B
//EV_DmaCopyIf^V_DmaCopyArrayIf͏IɊ荞ݗv𔭐܂B
//EV_DmaCopyArray^V_DmaCopyArrayIf̓\[XzŜRs[܂B
//
//EF
//  dmaNo       DMAԍ
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                      cl` I҂
//----------------------------------------------------------------------

#define WaitDma(dmaNo)                                      \
{                                                           \
    vu32 *(dmaCntp) = (vu32 *)REG_DMA##dmaNo;               \
    while (dmaCntp[2] & DMA_ENABLE) ;                       \
}

//EDMȀI҂܂B
//
//EF
//  dmaNo       DMAԍ


//----------------------------------------------------------------------
//                      cl` Xgbv
//----------------------------------------------------------------------

#define StopDma(dmaNo)                                      \
{                                                           \
    vu16 *(dmaCntp) = &((vu16 *)REG_DMA0)[dmaNo * 6];       \
    dmaCntp[5] &= ~((DMA_TIMMING_MASK | DMA_CONTINUOUS_ON)  \
                   >> 16);                                  \
    dmaCntp[5] &= ~( DMA_ENABLE   >> 16);                   \
    {u32 dummy = dmaCntp[5];}                               \
}

//EDMA~܂B
//EAADMA̎N|ꍇ͈xDMAs܂B
//
//EF
//  dmaNo       DMAԍ


//----------------------------------------------------------------------
//                      bot NA
//----------------------------------------------------------------------

#define CpuClear(data, destp, size, bit)        SVC_CpuClear(data, (void *)(destp), size, bit)

#define CpuClearArray(data, destp, bit)                     \
        CpuClear(     data, destp, sizeof(destp), bit)

//ECPURAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//ECpuClearArray̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                      bot Rs[
//----------------------------------------------------------------------

#define CpuCopy(srcp, destp, size, bit)         SVC_CpuCopy((void *)(srcp), (void *)(destp), size, bit)

#define CpuCopyArray(srcp, destp, bit)                      \
        CpuCopy(     srcp, destp, sizeof(srcp), bit)

//ECPUŃRs[VXeR[Ăяo܂B
//ECpuCopyArray̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                  bot NA
//----------------------------------------------------------------------

#define CpuClearFast(data, destp, size)         SVC_CpuClearFast(data, (void *)(destp), size)

#define CpuClearArrayFast(data, destp)                      \
        CpuClearFast(     data, destp, sizeof(destp))

//ECPUōRAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//ECpuClearArrayFast̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg

//----------------------------------------------------------------------
//                  bot Rs[
//----------------------------------------------------------------------

#define CpuCopyFast(srcp, destp, size)          SVC_CpuCopyFast((void *)(srcp), (void *)(destp), size)

#define CpuCopyArrayFast(srcp, destp)                       \
        CpuCopyFast(     srcp, destp, sizeof(srcp))

//ECPUōɃRs[VXeR[Ăяo܂B
//ECpuCopyArrayFast̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SUBP_MACRO_H
