//======================================================================
//          IrisSubpSystemCall.h
//            IRISTuvZbT VXeR[
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SUBP_SYSTEM_CALL_H
#define _IRIS_SUBP_SYSTEM_CALL_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisSubpTarget.h>
#include <IrisSubpTypes.h>
#include <IrisSubpSystemCallDefine.h>


#ifdef  __MWERKS__
#ifndef CODE32
#define SystemCall(No)   asm { SWI    No }
#else
#define SystemCall(No)   asm { SWI    No << 16 }
#endif
#elif   defined( __GNUC__ )
#ifndef CODE32
#define SystemCall(No)   asm ("SWI    "#No)
#else
#define SystemCall(No)   asm ("SWI    "#No" << 16")
#endif
#elif   defined( __CC_ARM )
#ifndef CODE32
#define SystemCall(No) __asm { SWI    No }
#else
#define SystemCall(No) __asm { SWI    No << 16 }
#endif
#endif


//----------------------------------------------------------------------
//                  J[hǂݍ
//----------------------------------------------------------------------

#if     defined(IRIS_TS)
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 _SVC_ReadCard(dmaNo, (void *)(srcp), (void *)(destp), size)

void _SVC_ReadCard(s32 dmaNo, void *srcp, void *destp, s32 size);

#elif   defined(IRIS_TEG) 
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 _SVC_TEG_ReadCard(dmaNo, (void *)(srcp), (void *)(destp), size)

void _SVC_TEG_ReadCard(s32 dmaNo, void *srcp, void *destp, s32 size);

#else
#define SVC_ReadCard(dmaNo, srcp, destp, size)	 ((void) 0)
#endif

//EJ[hf[^ǂݍ݂܂B
//EJ[h̃AhX512ByteEA{̑̃AhX4ByteE
//  킹Kv܂B
//
//EF
//    s32   dmaNo       DMAԍi0`3 ȊO̒lnꂽCPUœǂݍ݂܂j
//                     iTEG{[hł͖ACPUɂē]܂j
//    void *srcp        J[h̃\[XAhX
//    void *destp       {̑̃fXeBl[VAhX
//    s32   size        ]TCY

//----------------------------------------------------------------------
//                  [vEFCg
//----------------------------------------------------------------------

void SVC_WaitByLoop(s32 count);

//EVXeROMŎw񐔃[vs܂B
//E1̃[v4TCN܂B
//ETuvZbTCւ̗D挠ĂꍇɁA
//  CŃvO𓮍삳邱Ƃ
//  CvZbTXg[錻ۂy邱Ƃł܂B
//
//EF
//    s32   count       [v

//----------------------------------------------------------------------
//                  荞݃EFCg
//----------------------------------------------------------------------

void SVC_WaitIntr(u32 clearEnable, u32 intrFlags);

//EIntrFlagsŎw肵荞݂܂HaltԂő҂܂B
//E荞ݏɂINTR_CHECK_BUF(0x3007ff8)֊YtOZbgĉB
//E̊荞݂𕹗pASVC_Halt()JԂĂяoꍇƔׂ
//  VXeR[ĂяõI[o[wbhy邱Ƃł܂B
//
//EF
//    u8  clearEnable   ɊYtOZbgĂꍇɃNA邩ǂ̎w
//    u16 intrFlags     EFCg銄荞݂̎wiIrisSubpSystemCallDefine.hQƁj

//----------------------------------------------------------------------
//                  uuN荞݃EFCg
//----------------------------------------------------------------------

void SVC_WaitVBlankIntr(void);

//EuuN荞݂܂HaltԂő҂܂B
//E荞ݏɂINTR_CHECK_BUF(0x3007ff8)֊YtOZbgĉB
//E̊荞݂𕹗pASVC_Halt()JԂĂяoꍇƔׂ
//  VXeR[ĂяõI[o[wbhy邱Ƃł܂B
//ESVC_WaitIntr(1, V_BLANK_INTR_FLAG)ƓłB

//----------------------------------------------------------------------
//                  botZbg
//----------------------------------------------------------------------

void SVC_CpuSet(const void *srcp, void *destp, u32 dmaCntData);

//EDmaSet}N݊̃p[^RAMNA܂̓Rs[܂B
//E32bit]ł͋I4ByteEɂăANZX܂A
//  16bit]ł͈2ByteE֍킹ēnKv܂B
//
//EF
//    void *srcp          \[XAhX
//    void *destp         fXeBl[VAhX
//    u32 dmaCntData      DMA_SRC_FIX^DMA_32BIT_BUS^DMA_COUNT_MASK̂ݗL
//          DMA_SRC_FIX(  0, 1) = (\[XAhXECNg, \[XAhXŒ)
//          DMA_32BIT_BUS(0, 1) = (16bit], 32bit])
//          DMA_COUNT_MASK & dmaCntData = ]
//
//Eʃ}NF
//  SVC_CpuClear, SVC_CpuClearArray, SVC_CpuCopy, SVC_CpuCopyArray

//----------------------------------------------------------------------
//                  botZbg
//----------------------------------------------------------------------

void SVC_CpuSetFast(const void *srcp, void *destp, u32 dmaCntData);

//EDmaSet}N݊̃p[^ōRAMNA܂̓Rs[܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕[h^XgA߂gp܂B
//E4ByteEȊOň^ĂI4ByteEɂăANZX܂B
//
//EF
//    void *srcp          \[XAhX
//    void *destp         fXeBl[VAhX
//    u32 dmaCntData      DMA_SRC_FIX^DMA_COUNT_MASK̂ݗL
//          DMA_SRC_FIX(0, 1) = (\[XAhXECNg, \[XAhXŒ)
//          DMA_COUNT_MASK & dmaCntData = ]
//
//Eʃ}NF
//  SVC_CpuClearFast, SVC_CpuClearArrayFast, SVC_CpuCopyFast, SVC_CpuCopyArrayFast

//----------------------------------------------------------------------
//                      bot NA
//----------------------------------------------------------------------

#define SVC_CpuClear(data, destp, size, bit)                \
{                                                           \
    vu##bit tmp = (vu##bit )(data);                         \
    SVC_CpuSet((u8 *)&(tmp), (u8 *)(destp), (               \
        DMA_SRC_FIX        |                                \
        DMA_##bit##BIT_BUS | ((size)/(bit/8) & 0x1fffff))); \
}

#define SVC_CpuClearArray(data, destp, bit)                 \
        SVC_CpuClear(     data, destp, sizeof(destp), bit)

//ECPURAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//ESVC_CpuClearArray̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                      bot Rs[
//----------------------------------------------------------------------

#define SVC_CpuCopy(srcp, destp, size, bit)                 \
                                                            \
    SVC_CpuSet((u8 *)(srcp), (u8 *)(destp),  (              \
        DMA_SRC_INC        |                                \
        DMA_##bit##BIT_BUS | ((size)/(bit/8) & 0x1fffff)))

#define SVC_CpuCopyArray(srcp, destp, bit)                  \
        SVC_CpuCopy(     srcp, destp, sizeof(srcp), bit)

//ECPUŃRs[VXeR[Ăяo܂B
//ESVC_CpuCopyArray̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg
//  bit         ]rbgi16|32j

//----------------------------------------------------------------------
//                  bot NA
//----------------------------------------------------------------------

#define SVC_CpuClearFast(data, destp, size)                 \
{                                                           \
    vu32 tmp = (vu32 )(data);                               \
    SVC_CpuSetFast((u8 *)&(tmp), (u8 *)(destp), (           \
        DMA_SRC_FIX        | ((size)/(32/8) & 0x1fffff)));  \
}

#define SVC_CpuClearArrayFast(data, destp)                  \
        SVC_CpuClearFast(     data, destp, sizeof(destp))

//ECPUōRAMNAVXeR[Ăяo܂B
//ENAf[^̓X^bNɒuAfXeBl[VփRs[܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕XgA߂gp܂B
//ESVC_CpuClearArrayFast̓fXeBl[VzŜNA܂B
//
//EF
//  data        NAf[^
//  destp       fXeBl[VAhX
//  size        NAoCg

//----------------------------------------------------------------------
//                  bot Rs[
//----------------------------------------------------------------------

#define SVC_CpuCopyFast(srcp, destp, size)                  \
                                                            \
    SVC_CpuSetFast((u8 *)(srcp), (u8 *)(destp),  (          \
        DMA_SRC_INC           | ((size)/(32/8) & 0x1fffff)))

#define SVC_CpuCopyArrayFast(srcp, destp)                   \
        SVC_CpuCopyFast(     srcp, destp, sizeof(srcp))

//ECPUōɃRs[VXeR[Ăяo܂B
//EI[o[t[Ȃ͈͂ł32BytePʂ̕[h^XgA߂gp܂B
//ESVC_CpuCopyArrayFast̓\[XzŜRs[܂B
//
//EF
//  srcp        \[XAhX
//  destp       fXeBl[VAhX
//  size        ]oCg


//----------------------------------------------------------------------
//                  akf[^WJ
//----------------------------------------------------------------------

void SVC_UnPackBits(const void *srcp, void *destp, UnPackBitsParam *paramp);

//E0Œ̃rbgl߂f[^WJ܂B
//ETEGo[Wł̓fXeBl[VAhX̂
//  Cw肷邱Ƃł܂B
//EfXeBl[VAhX4ByteEɍ킹ĉB
//
//EF
//             void *srcp     \[XAhX
//             void *destp    fXeBl[VAhX
//  UnPackBitsParam *paramp   UnPackBitsParam\̃f[^̃AhX
//
//EUnPackBitsParam\
//    u16 srcNum              \[Xf[^EoCg
//    u8  srcBitNum           P\[Xf[^Erbg
//    u8  destBitNum          PfXeBl[Vf[^Erbg
//    u32 destOffset:31       \[Xf[^ɉZItZbg
//        destOffset0_On:1    Õf[^ɃItZbgZ邩ۂ̃tO
//
//E߂lFȂ

//----------------------------------------------------------------------
//                  kyVVkf[^WWJ
//----------------------------------------------------------------------

void SVC_UnCompLZ77Byte(const void *srcp, void *destp);

//ELZ77kf[^WJA8bitPʂŏ݂܂B
//EC֒ړWJ邱Ƃ͂ł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 1j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  flags               k^ktO
//                            i0, 1j = ikf[^, kf[^j
//ER[hf[^tH[}bgiBig Endianj
//    u16 length:4            WJf[^ - 3iv3Byteȏ㎞݈̂kj
//        offset:12           vf[^ItZbg - 1
//
//E߂lFȂ

//----------------------------------------------------------------------
//                  kyVVkf[^PUWJ
//----------------------------------------------------------------------

void SVC_UnCompLZ77Short(const void *srcp, void *destp);

//ELZ77kf[^WJA16bitPʂŏ݂܂B
//ECɂ[NRAMɂWJł܂A
//  SVC_UnCompLZ77Byte()ᑬłB
//ETEGo[Wł̓fXeBl[VAhX̂
//  Cw肷邱Ƃł܂B
//Ekf[^͈v2ByteȑO茟̂ɂĉB
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 1j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  flags               k^ktO
//                            i0, 1j = ikf[^, kf[^j
//ER[hf[^tH[}bgiBig Endianj
//    u16 length:4            WJf[^ - 3iv3Byteȏ㎞݈̂kj
//        offset:12           vf[^ItZbgi >= 2j - 1
//
//E߂lFȂ

//----------------------------------------------------------------------
//                  nt}kf[^WJ
//----------------------------------------------------------------------

void SVC_UnCompHuffman(const void *srcp, void *destp);

//Ent}kf[^WJA32bitPʂŏ݂܂B
//ETEGo[Wł̓fXeBl[VAhX̂
//  Cw肷邱Ƃł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 bitSize:4           Pf[^ErbgTCYiʏ 4|8j
//        compType:4          k^Cvi = 2j
//        destSize:24         WJ̃f[^TCY
//
//Ec[e[u
//    u8           treeSize        c[e[uTCY/2 - 1
//    TreeNodeData nodeRoot        [gm[h
//
//    TreeNodeData nodeLeft        [gm[h
//    TreeNodeData nodeRight       [gEm[h
//
//    TreeNodeData nodeLeftLeft    m[h
//    TreeNodeData nodeLeftRight   Em[h
//
//    TreeNodeData nodeRightLeft   Em[h
//    TreeNodeData nodeRightRight  EEm[h
//
//            E
//            E
//
//  ̌Ɉkf[^{
//
//ETreeNodeData\
//    u8  nodeNextOffset:6    m[hf[^ւ̃ItZbg - 1i2BytePʁj
//        rightEndFlag:1      Em[hItO
//        leftEndzflag:1       m[hItO
//                            ItOZbgĂꍇ
//                            m[hɃf[^
//
//E߂lFȂ

//----------------------------------------------------------------------
//                  OXkf[^WWJ
//----------------------------------------------------------------------

void SVC_UnCompRLByte(const void *srcp, void *destp);

//EOXkf[^WJA8bitPʂŏ݂܂B
//EC֒ړWJ邱Ƃ͂ł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 3j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  length:7            WJf[^ - 1ikj
//                            WJf[^ - 3iA3Byteȏ㎞݈̂kj
//        flag:1              i0, 1j = ikf[^, kf[^j
//
//E߂lFȂ

//----------------------------------------------------------------------
//                  OXkf[^PUWJ
//----------------------------------------------------------------------

void SVC_UnCompRLShort(const void *srcp, void *destp);

//EOXkf[^WJA16bitPʂŏ݂܂B
//ECɂ[NRAMɂWJł܂A
//  SVC_UnCompRLByte()ᑬłB
//ETEGo[Wł̓fXeBl[VAhX̂
//  Cw肷邱Ƃł܂B
//Ekf[^̃TCY4̔{ɂȂȂꍇ
//  o邾0ŋl߂ĒĉB
//E\[XAhX4ByteEɍ킹ĉB
//
//EF
//    void *srcp              \[XAhX
//    void *destp             fXeBl[VAhX
//
//Ef[^wb_
//    u32 :4                  \
//        compType:4          k^Cvi = 3j
//        destSize:24         WJ̃f[^TCY
//
//EtOf[^tH[}bg
//    u8  length:7            WJf[^ - 1ikj
//                            WJf[^ - 3iA3Byteȏ㎞݈̂kj
//        flag:1              i0, 1j = ikf[^, kf[^j
//
//E߂lFȂ



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SUBP_SYSTEM_CALL_H
