//======================================================================
//          IrisSubpTypes.h
//            IRISTuvZbT W^錾
//
//          Copyright (C) 2002-2003 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SUBP_TYPES_H
#define _IRIS_SUBP_TYPES_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisSubpTarget.h>


//----------------------------------------------------------------------
//                      f[^^CvĒ`
//----------------------------------------------------------------------

typedef     unsigned char           u8;
typedef     unsigned short int      u16;
typedef     unsigned int            u32;
typedef     unsigned long long int  u64;

typedef     signed char             s8;
typedef     signed short int        s16;
typedef     signed int              s32;
typedef     signed long long int    s64;

typedef     float                   f32;
typedef     double                  f64;


#define     vl                      volatile

typedef     vl u8                   vu8;
typedef     vl u16                  vu16;
typedef     vl u32                  vu32;
typedef     vl u64                  vu64;

typedef     vl s8                   vs8;
typedef     vl s16                  vs16;
typedef     vl s32                  vs32;
typedef     vl s64                  vs64;

typedef     vl f32                  vf32;
typedef     vl f64                  vf64;


//----------------------------------------------------------------------
//                          \
//----------------------------------------------------------------------

// vOXe[^XWX^\
typedef struct {
    u32 cpuMode:5;              // bot[h
    u32 thumbState:1;           // sgtlaXe[g
    u32 fiq_disable:1;          // ehps
    u32 irq_disable:1;          // hqps
    u32 :20;
    u32 v:1;                    // I[o[t[
    u32 c:1;                    // L[^{[^g
    u32 z:1;                    // [
    u32 n:1;                    // ^
} PsrData;
typedef  vl PsrData    vPsrData;


// 荞ݗv^tO\
typedef struct {
    u16 blankV:1;               // uuN
    u16 blankH:1;               // guN
    u16 countV:1;               // uJE^v
    u16 timer0:1;               // ^C}[O
    u16 timer1:1;               // ^C}[P
    u16 timer2:1;               // ^C}[Q
    u16 timer3:1;               // ^C}[R
    u16 sio:1;                  // VAʐM
    u16 dma0:1;                 // cl`O
    u16 dma1:1;                 // cl`P
    u16 dma2:1;                 // cl`Q
    u16 dma3:1;                 // cl`R
    u16 key:1;                  // L[
    u16 cartridge:1;            // J[gbW
    u16 :2;

    u16 mainp:1;                // CvZbT
    u16 mainpSendFifoEmpty:1;   // CvZbTԑMehenGveB
    u16 mainpRecvFifoNotEmpty:1;// CvZbTԎMehenmbgGveB
    u16 cardData:1;             // J[hf[^
    u16 cardIreq:1;             // J[hhqdp
    u16 :1;
    u16 pmic_rtc:1;             // p[}l[Wghb  qsb
    u16 spi:1;                  // roh
    u16 wireless:1;             // ʐM
} IntrFlags;
typedef  vl IntrFlags    vIntrFlags;


// CvZbTC^tF[X\
typedef struct {
    u16 recvStatus:4;           // MXe[^X
    u16 :4;
    u16 sendStatus:4;           // MXe[^X
    u16 :1;
    u16 sendIf:1;               // 荞ݗvM
    u16 recvIf_enable:1;        // 荞ݗvM 
    u16 :1;
} MainpIntf;
typedef  vl MainpIntf    vMainpIntf;


// CvZbTʐMehenRg[\
typedef struct {
    u16 sendEmpty:1;            // Mehen GveB
    u16 sendFull:1;             //              t
    u16 sendIf_enable:1;        //              荞ݗv 
    u16 sendClear:1;            //              NA
    u16 :4;
    u16 recvEmpty:1;            // Mehen GveB
    u16 recvFull:1;             //              t
    u16 recvIf_enable:1;        //              荞ݗv 
    u16 :4;
    u16 enable:1;               // ehenCl[u
} MainpFifoCnt;
typedef  vl MainpFifoCnt  vMainpFifoCnt;



// uq`lXe[^X\
typedef struct
{
    u8  mode:3;
    u8  offset:2;
    u8  :2;
    u8  enable:1;
} VramStat;
typedef  vl VramStat    vVramStat;


// [Nq`lXe[^X\
typedef struct
{
    u8  bank;
} WramStat;
typedef  vl WramStat    vWramStat;



// \Xe[^X\
typedef struct {
    u16 blankingV:1;            // uuNԒ
    u16 blankingH:1;            // guNԒ
    u16 countV:1;               // uJE^v
    u16 blankV_if_enable:1;     // uuN荞ݗv 
    u16 blankH_if_enable:1;     // guN荞ݗv 
    u16 countV_if_enable:1;     // uJE^v荞ݗv 
    u16 :1;
    u16 setV_d8:1;              // uJE^rlݒicWj
    u16 setV:8;                 //                     icV|Oj

    u16 readV:9;                // uJE^ݒl
    u16 :0;
} DispStat;
typedef  vl DispStat   vDispStat;



// TEh}X^Rg[\
typedef struct {
    u16 volume:8;               // }X^o̓x
    u16 outL:2;                 // kŏIio
    u16 outR:2;                 // qŏIio
    u16 ch1Mixing_off:1;        // `lP nee
    u16 ch3Mixing_off:1;        // `lR nee
    u16 :1;
    u16 enable:1;               // Cl[u
} SoundMasterCnt;
typedef  vl SoundMasterCnt     vSoundMasterCnt;


// TEh`lRg[\
typedef struct {
    u16 volume:8;               // `lo̓x
    u16 shift:2;                // f[^Vtg
    u16 :5;
    u16 outputHold:1;           // fBZ[ȕo͕ێ

    u16 panpot:8;               // p|bg
    u16 duty:3;                 // f[eB
    u16 repeatType:2;           // s[g@
    u16 format:2;               // tH[}bg
    u16 enable:1;               // Cl[u

    u32 srcp;                   // \[XAhX

    u16 timerCount;             // ^C}[JEg
    u16 repeatPoint;            // s[gʒu
    u32 repeatLength;           // s[g
} SoundChannelCnt;
typedef  vl SoundChannelCnt     vSoundChannelCnt;


// TEhLv`Rg[\
typedef struct {
    u8  premixing_on:1;         // ~LT[O nm
    u8  src:1;                  // Lv`I
    u8  repeat_off:1;           // s[g nee
    u8  format:1;               // Lv`tH[}bgioblW^PUj
    u8  :3;
    u8  enable:1;               // Cl[u
} SoundCapCnt;
typedef  vl SoundCapCnt     vSoundCapCnt;


// TEhLv`p[^Rg[\
typedef struct {
    u32 destp;                  // fXeBl[VAhX
    u16 length;                 // Lv`
} SoundCapParamCnt;
typedef  vl SoundCapParamCnt     vSoundCapParamCnt;



// rohRg[\
typedef struct {
    u16 sck:2;                  // VtgNbNI
    u16 :5;
    u16 busy:1;                 // rW[
    u16 :4;
    u16 continuous:1;           // ReBjAX[h
    u16 target:1;               // ʐM^[Qbgw
    u16 if_enable:1;            // 荞ݗv 
    u16 enable:1;               // roh

    u16 data:8;                 // f[^
    u16 pad:8;
} SpiCnt;
typedef  vl SpiCnt    vSpiCnt;


// ėpo̓Rg[\
typedef struct {
    u16 sc:1;                   // f[^
    u16 sd:1;
    u16 si:1;
    u16 so:1;
    u16 sc_i_o:1;               // h/nI
    u16 sd_i_o:1;
    u16 si_i_o:1;
    u16 so_i_o:1;
    u16 if_enable:1;            // 荞ݗv 
    u16 :5;
    u16 sioModeMaster:2;        // rhn[hE}X^
} RCnt;
typedef  vl RCnt      vRCnt;


// cl`Rg[\
typedef struct {
    u16 count;                  // ]
    u16 :5;
    u16 destpCnt:2;             // ]AhX Rg[
    u16 srcpCnt:2;              // ]AhX Rg[
    u16 continuous:1;           // ReBjAX[h
    u16 busSize:1;              // oXTCY PU^RQI
    u16 dataRequest:1;          // f[^v[h
    u16 timming:2;              // ^C~OI
    u16 if_enable:1;            // 荞ݗv 
    u16 enable:1;               // cl`
} DmaCnt;
typedef  vl DmaCnt    vDmaCnt;


// ^C}[Rg[\
typedef struct {
    u16 count;                  // JEg
    u16 prescaler:2;            // vXP[I
    u16 connect:1;              // ʃ^C}[ڑ
    u16 :3;
    u16 if_enable:1;            // 荞ݗv 
    u16 enable:1;               // ^C}[
    u16 pad:8;
} TimerCnt;
typedef  vl TimerCnt    vTimerCnt;


// L[f[^\
typedef struct {
    u16 a:1;                    // `
    u16 b:1;                    // a
    u16 select:1;               // ZNg
    u16 start:1;                // X^[g
    u16 plusR:1;                // E
    u16 plusL:1;                // 
    u16 plusU:1;                // 
    u16 plusD:1;                // 
    u16 r:1;                    // q
    u16 l:1;                    // k
    u16 :6;
} KeyData;
typedef  vl KeyData    vKeyData;

// L[Rg[\
typedef struct {
    u16 sel_a:1;                //       `{^ I
    u16 sel_b:1;                //       a{^ I
    u16 sel_select:1;           // ZNg{^ I
    u16 sel_start:1;            // X^[g{^ I
    u16 sel_plusR:1;            //         EL[ I
    u16 sel_plusL:1;            //         L[ I
    u16 sel_plusU:1;            //         L[ I
    u16 sel_plusD:1;            //         L[ I
    u16 sel_r:1;                //       q{^ I
    u16 sel_l:1;                //       k{^ I
    u16 :4;
    u16 if_enable:1;            // 荞ݗv 
    u16 intrType:1;             // 荞݃^Cv I
} KeyCnt;
typedef  vl KeyCnt    vKeyCnt;


// ORg[\
typedef struct {
    u16 ctrdgDt8_cycles:2;      // J[gbW  Wf[^oX ANZXTCN
    u16 ctrdgtAd16_1stCycles:2; //               `cPUoX PANZXTCN
    u16 ctrdgAd16_2ndCycles:1;  //                            QANZXTCN
    u16 ctrdgPhiClock:2;        //               Ӓ[qo̓NbN I
    u16 ctrdgAccess:1;          //               ANZX
    u16 :3;
    u16 cardAccess:1;           // J[hANZX
#ifdef IRIS_TS
    u16 mainmemByteAccess:1;    // CoCgANZXo
    u16 mainmemCE2:1;           //             bdQMmF
#else
    u16 :2;
#endif
    u16 mainmemInterface:1;     // CC^tF[X
    u16 mainmemPriority:1;      //             D挠
} ExMemCnt;
typedef  vl ExMemCnt    vExMemCnt;


// Bitkf[^WJpp[^
typedef struct {
    u16 srcNum;                 // \[Xf[^EoCg
    u16 srcBitNum:8;            // P\[Xf[^Erbg
    u16 destBitNum:8;           // PfXeBl[Vf[^Erbg
    u32 destOffset:31;          // \[Xf[^ɉZ鐔
    u32 destOffset0_on:1;       // Õf[^ɃItZbgZ邩ۂ̃tO
} UnPackBitsParam;
typedef  vl UnPackBitsParam    vUnPackBitsParam;


#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SUBP_TYPES_H
