//====================================================================
//          IrisRtcDefine.h
//            IRIS RTC萔
//
//          Copyright (C) 2004 NINTENDO Co.,Ltd.
//====================================================================
#ifndef _IRIS_RTC_DEFINE_H
#define _IRIS_RTC_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <IrisSubpMacro.h>



//----------------------------------------------------------------------
//                      E}bv
//----------------------------------------------------------------------

#define REG_R1_CNT          (REG_BASE + 0x138)  // qsbRg[


//----------------------------------------------------------------------
//                      qsbRg[
//----------------------------------------------------------------------

#define R1_RTC_DATA_BIT             0x01        // f[^rbg
#define R1_RTC_SCK                  0x02        // VtgNbN
#define R1_RTC_CS                   0x04        // `bvZNg

#define R1_RTC_DATA_BIT_IN          0x00        // f[^rbg
#define R1_RTC_DATA_BIT_OUT         0x10
#define R1_RTC_SCK_IN               0x00        // VtgNbN
#define R1_RTC_SCK_OUT              0x20
#define R1_RTC_CS_IN                0x00        // `bvZNg
#define R1_RTC_CS_OUT               0x40

#define R1_RTC_DATA_DIR_IN          ( R1_RTC_DATA_BIT_IN \
                                    | R1_RTC_SCK_OUT \
                                    | R1_RTC_CS_OUT)  // f[^

#define R1_RTC_DATA_DIR_OUT         ( R1_RTC_DATA_BIT_OUT \
                                    | R1_RTC_SCK_OUT \
                                    | R1_RTC_CS_OUT)  // f[^o


//----------------------------------------------------------------------
//                      qsbR}h
//----------------------------------------------------------------------

#define RTCOP_FIX_BITS              0x60        // ʃrbgŒl

#define RTCOP_MASK                  0x0e        // R}h}XN

#define RTCOP_STAT1                 0x00        // Xe[^XP
#define RTCOP_STAT2                 0x02        // Xe[^XQ
#define RTCOP_YEAR                  0x04        // N
#define RTCOP_TIME                  0x06        // 
#define RTCOP_INT1                  0x08        // 荞ݐݒP
#define RTCOP_INT2                  0x0a        //         ݒQ
#define RTCOP_ADJUST_CLOCK          0x0c        // NbN
#define RTCOP_FREE_REGISTER         0x0e        // t[WX^

#define RTCOP_WRITE                 0x00        // 
#define RTCOP_READ                  0x01        // ǂݍ


//----------------------------------------------------------------------
//                      qsbXe[^XP
//----------------------------------------------------------------------

#define RTCSTAT1_RESET              0x01        // Zbg
#define RTCSTAT1_SEL_12H            0x00        // PQԕ\ I
#define RTCSTAT1_SEL_24H            0x02        // QS
#define RTCSTAT1_USR_BIT3           0x04        // [UrbgR
#define RTCSTAT1_INTR1              0x10        // 荞݂P
#define RTCSTAT1_INTR2              0x20        // 荞݂Q
#define RTCSTAT1_BATTERY_DOWN       0x40        // obe[ _E
#define RTCSTAT1_RESET_REQUEST      0x80        // d̃Zbgv

//----------------------------------------------------------------------
//                      qsbXe[^XQ
//----------------------------------------------------------------------

#define RTCSTAT2_NONE_INTR          0x00        // 荞ݖ
#define RTCSTAT2_SEL_FREQ_INTR      0x02        // Ig튄荞
#define RTCSTAT2_MIN_EDGE_INTR      0x04        // PʃGbW荞
#define RTCSTAT2_MIN_CK1_INTR       0x06        // Pʒ튄荞݂P
#define RTCSTAT2_ALERM_INTR         0x08        // A[荞
#define RTCSTAT2_MIN_CK2_INTR       0x0e        // Pʒ튄荞݂Q
#define RTCSTAT2_USR_BIT4           0x10        // [UrbgS
#define RTCSTAT2_USR_BIT5           0x20        //             T
#define RTCSTAT2_INTR2              0x40        // 荞݂Q
#define RTCSTAT2_TEST               0x80        // eXg



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_RTC_DEFINE_H
