//======================================================================
//          IrisSioDefine.h
//            IRIS SIO萔
//
//          Copyright (C) 2004 NINTENDO Co.,Ltd.
//======================================================================
#ifndef _IRIS_SIO_DEFINE_H
#define _IRIS_SIO_DEFINE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <IrisSubpTarget.h>


// m[}rhnRg[\
typedef struct {
    u16 sck_i_o:1;          // NbNh/nI
    u16 sck:1;              // NbNI
    u16 ackRecv:1;          // ]tOM
    u16 ackSend:1;          // ]tOM
    u16 dummy_6_4:3;
    u16 enable:1;           // rhn
    u16 dummy_11_8:4;
    u16 mode:2;             // ʐM[hI
    u16 if_enable:1;        // 荞ݗv 
    u16 sck_up:1;			// VtgNbN{
    u8  data;               // f[^
    u8  dummy_31_24;
} SioNormalCnt;
typedef  vl SioNormalCnt    vSioNormalCnt;


//----------------------------------------------------------------------
//                      VAʐM̓rW[H
//----------------------------------------------------------------------

#define IsSioBusy()                                         \
                                                            \
    (*(vu16 *)REG_SIOCNT & SIO_ENABLE)

//EVAʐMrW[ǂԂ܂B

//----------------------------------------------------------------------
//                      VAʐM͑MԂH
//----------------------------------------------------------------------

#define IsSioSendEnable()                                   \
                                                            \
    (!(*(vu16 *)REG_SIOCNT & SIO_ACK_RECV))

//EVAʐMMԂǂԂ܂B

//----------------------------------------------------------------------
//                      VAʐMX^[g
//----------------------------------------------------------------------

#define StartSio()                                          \
                                                            \
    (*(vu16 *)REG_SIOCNT |= SIO_START)

//EVAʐMJn܂B


//----------------------------------------------------------------------
//                      VAʐMI҂
//----------------------------------------------------------------------

#define WaitSio()                                           \
{                                                           \
    while (IsSioBusy())   ;                                 \
}

//EVAʐM̏I҂܂B


//----------------------------------------------------------------------
//                      WX^EAhX
//----------------------------------------------------------------------

#define REG_RCNT        (REG_BASE + 0x134)  // ėpo̓Rg[

#define REG_SIOCNT      (REG_BASE + 0x128)  // VAʐMRg[
#define REG_SIODATA8    (REG_BASE + 0x12a)  //  8bitVAʐMf[^
#define REG_SIODATA32   (REG_BASE + 0x120)  // 32bitVAʐMf[^


//----------------------------------------------------------------------
//                      rhnRg[
//----------------------------------------------------------------------

#define SIO_MODE_MASK           0x3000      // ʐM[h
#define SIO_BAUD_RATE_MASK      0x0003      // {[[g
#define SIO_ID_NO_MASK          0x0030      // ʐMhc

#define SIO_MODE_SHIFT          12
#define SIO_BAUD_RATE_SHIFT     0
#define SIO_ID_NO_SHIFT         4

#define SIO_8BIT_MODE           0x0000      // m[}WrbgʐM[h
#define SIO_32BIT_MODE          0x1000      // m[}RQrbgʐM[h

#define SIO_SCK_OUT             0x0000      // ONbNI
#define SIO_SCK_IN              0x0001      // NbNI
#define SIO_IN_SCK_256K         0x0000      // NbN QTUjgI
#define SIO_IN_SCK_2M           0x0002      //                  QlgI
#define SIO_ACK_RECV            0x0004      // ]v
#define SIO_ACK_SEND            0x0008      // ]
#define SIO_START               0x0080      // ]X^[g
#define SIO_ENABLE              0x0080      // rhn
#define SIO_IF_ENABLE           0x4000      // 荞ݗv 
#define SIO_SCK_UP              0x8000      // VtgNbN{

// \̃op萔

#define ST_SIO_8BIT_MODE            0       // m[}WrbgʐM[h
#define ST_SIO_32BIT_MODE           1       // m[}RQrbgʐM[h

#define ST_SIO_SCK_OUT              0       // ONbNI
#define ST_SIO_SCK_IN               1       // NbNI
#define ST_SIO_IN_SCK_256K          0       // NbN QTUjgI
#define ST_SIO_IN_SCK_2M            1       //                  QlgI



#ifdef __cplusplus
}       // extern "C"
#endif

#endif  // _IRIS_SIO_DEFINE_H
